/* ================================= pwg.pjt.pdp.3.finishings.col.h ======================================= */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_3_FINISHINGS_COL_H__
#define __PWG_PJT_PDP_3_FINISHINGS_COL_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pdp.3.finishing.template.h"
#include "pwg.pjt.xxx.3.stitching.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Finishings Collection                                                                                    */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.2: [page 19] FinishingsCol DataType                                                            */
/* -----------------                                                                                        */
/* The FinishingsCol datatype is used for FinishingsCol and JobFinishingsCol.  It  allows a finer           */
/* granularity specification of finishings than is possible with the Finishings and JobFinishings elements. */
/* Figure 6 shows its constituent elements.                                                                 */
/*                                                                                                          */
/*                                                                                                          */
/*    +~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+      */
/*                                                                                                          */
/*   /---------------+     +------------+                                                                   */
/*   | FinishingsCol |--+--| attributes |                                                                   */
/*   \---------------+  |  +------------+                                                                   */
/*                      |                                                                                   */
/*                      |  /---------\      + - - - - - - - - - -+                                          */
/*                      +--| -o-o-o- |- + - ! Finishing Template !                                          */
/*                         \---------/  !   S - - - - - - - - - -M                                          */
/*                                      !                                                                   */
/*                                      !                 + . . . . . . . . . . . . . . . . . . . . . .  +  */
/*                                      !                 .  StitchingType                               .  */
/*                                      !                 .                                              .  */
/*                                      !                 .    +------------+                            .  */
/*                                      !                 . +--| attributes |                            .  */
/*                                      !                 . |  +------------+                            .  */
/*                                      !   + - - - - - + . |                   + - - - - - - - - - - -+ .  */
/*                                      + - ! Stitching !-.-+               + - !StitchingReferenceEdge! .  */
/*                                      !   C - - - - - M . |               !   K - - - - - - - - - - -M .  */
/*                                      !                 . |               !                            .  */
/*                                      !                 . |  /- - - - -\  !   + - - - - - - - - +      .  */
/*                                      !                 . +--! -o-o-o- !- + - ! StitchingOffset !      .  */
/*                                      !                 .    \- - - - -/  !   I - - - - - - - - M      .  */
/*                                      !                 .                 !                            .  */
/*                                      !                 .                 !   + - - - - - - - - - -+   .  */
/*                                      !                 .                 + - ! StitchingLocation  !   .  */
/*                                      !                 .                 !   L - - - - - - - - - -M   .  */
/*                                      !                 .                 !             0..infinite    .  */
/*                                      !                 .                 !                            .  */
/*                                      !                 .                 !   / - - - - - - -\         .  */
/*                                      !                 .                 + - ! any ##other  !         .  */
/*                                      !                 .                     \ - - - - - - -/         .  */
/*                                      !                 .                         0..infinite          .  */
/*                                      !                 .                                              .  */
/*                                      !                 + . . . . . . . . . . . . . . . . . . . . . .  +  */
/*                                      !                                                                   */
/*                                      !   / - - - - - - -\                                                */
/*                                      + - ! any ##other  !                                                */
/*                                          \ - - - - - - -/                                                */
/*                                              0..infinite                                                 */
/*                                                                                                          */
/*                                     Figure 6 FinishingsCol DataType                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 46] FinishingsCol                  */
/* -----------------                                                                                        */
/* Enables an end user to specify detailed finishing options not possible with the "Finishings" element for */
/* the Output Document.                                                                                     */
/* [PWG5100.3] §3.2                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*      §3.2 [page 22-27] finishings-col (collection) - augments IPP "finishings"                       */
    /* -----------------                                                                                    */
    /* This attribute augments the IPP "finishings" Job Template attribute (defined in [RFC2911] section    */
    /* 4.2.6).  This "finishings-col" Job Template collection attribute enables a client end user to        */
    /* specify detailed finishing operations that cannot be specified using simple enumerated finishing     */
    /* values of the IPP "finishings" Job Template attribute.  Figure 6 shows the general finishing         */
    /* coordinate system used by the member attributes of the "finishing-col" collection attribute and      */
    /* relates to the general coordinate system defined in section 2.3 for all Job Template attributes.  A  */
    /* Printer MAY support the "finishings" attribute without supporting the "finishings-col" attribute.    */
    /* However, if a Printer supports the "finishings-col" attribute, it MUST also support the "finishings" */
    /* attribute.  Otherwise, clients that support only the IPP/1.0 or IPP/1.1 "finishings" Job Template    */
    /* attribute would not be able to interoperate with a Printer that supports only the "finishings-col"   */
    /* Job Template attribute.                                                                              */
    /*                                                                                                      */
    /* Note: The "finishings-col" (and the IPP/1.1 "finishing" ) Job Template attribute MAY be applied to   */
    /*       page ranges using the "pages-per-subset" Job Template attribute (see [ipp-override]) in order  */
    /*       to achieve so-called "subset finishing".                                                       */
    /*                                                                                                      */
    /* Figure 6 - General Finishing Coordinate System                                                       */
    /*                                                                                                      */
    /*                  Reference Edge     ---->!     ! <-- Process Axis                                    */
    /*                                          !     ! <-- Process Offset                                  */
    /*                                          |-----!------------------------|                            */
    /*                                          |     !                        |                            */
    /*           Head Mechanisms --------->[==========O=]                      |                            */
    /*                                   /      |     !                        |    Y                       */
    /*                                  /       |     !                        |    ^                       */
    /*           Head Locations -------X-->[==========O=]                      |    !                       */
    /*           (in increasing         \       |     !                        |    !                       */
    /*            Y direction)           \      |     !                        |    !                       */
    /*                                    >[==========O=]                      |    !__________> X          */
    /*                                          |     !                        |                            */
    /*                                          |     !                        |                            */
    /*                                    RCS   |-----!------------------------|                            */
    /*                                                                                                      */
    /* Table 3 lists the member attributes of the "finishings-col" (collection) attribute.  Some of these   */
    /* member attributes are themselves collection attributes.                                              */
    /*                                                                                                      */
    /*                               Table 3 - The "finishings-col" member attributes                       */
    /*                   |--------------------------------|-------------|---------------------|             */
    /*                   | Attribute    	                |   request   |   Printer Support   |             */
    /*                   |================================|=============|=====================|             */
    /*                   | finishing-template (name(MAX)) |     MAY     |         MAY         |             */
    /*                   | stitching (collection)         |     MAY     |         MAY         |             */
    /*                   |--------------------------------|-------------|---------------------|             */
    /*                                                                                                      */
    /* Note: Other collection member attributes will be defined in the future, such as: "binding",          */
    /*       "drilling", "folding", "trimming", and "offsetting", etc.  There may also be some future       */
    /*       non-collection member attributes that are simply 'keyword | name'.                             */
    /*                                                                                                      */
    /* 3.2.1	finishing-template (name(MAX))                                                                */
    /* The "finishing-template" member attribute contains a string value that specifies some particular     */
    /* finishing operation.  The value MAY be a list of parameters used by some implementation defined      */
    /* finishing software or finishing device, e.g. a third party finisher. Alternatively, the value MAY be */
    /* the name of a file containing finishing parameters.                                                  */
    /*                                                                                                      */
    /* The "finishing-template-supported" (1setOf name(MAX)) Printer attribute identifies the values of     */
    /* this "finishing-template" member attribute that the Printer supports, i.e., the                      */
    /* implementation-specific parameter values supported.                                                  */
    /*                                                                                                      */
    /* 3.2.2	stitching (collection)                                                                        */
    /* The "stitching" member attribute is used to specify that each copy of each document in the job MUST  */
    /* be stitched or stapled using the detailed stitching parameters provided in the collection.  The      */
    /* stitching member attribute is used whether the implementation uses wire stitches or staples. Table 4 */
    /* lists the member attributes of the "stitching" (collection) attribute.                               */
    /*                                                                                                      */
    /*                                  Table 4 - The "stitching" member attributes                         */
    /*            |---------------------------------------------|-------------|---------------------|       */
    /*            | Attribute    	                              |   request   |   Printer Support   |       */
    /*            |=============================================|=============|=====================|       */
    /*            | stitching-reference-edge (type2 keyword))   |     MUST    |         MUST        |       */
    /*            |---------------------------------------------|-------------|---------------------|       */
    /*            | stitching-offset (integer(0:MAX))           |     MUST    |         MUST        |       */
    /*            |---------------------------------------------|-------------|---------------------|       */
    /*            | stitching-locations (1setOf integer(0:MAX)) |     MUST    |         MUST        |       */
    /*            |---------------------------------------------|-------------|---------------------|       */
    /*                                                                                                      */
    /* While the "stitching-reference-edge," "stitching-offset", and "stitching-locations" member           */
    /* attributes are required to completely specify all possible stitching locations, it may not be        */
    /* possible to specify all of these (or to specify all of them independently) for every stitching       */
    /* device.                                                                                              */
    /*                                                                                                      */
    /* A Printer that chooses to support the "stitching" collection attribute MUST support the              */
    /* "stitching-reference-edge", the "stitching-offset", and the "stitching-locations" member attributes  */
    /* (in order to provide programmable stitching capability beyond that available through the IPP         */
    /* "finishings" Job Template attribute - see [RFC2911] section 4.2.6) A client that chooses to request  */
    /* custom stitching using the "stitching" collection attribute MUST specify the                         */
    /* "stitching-reference-edge", the  "stitching-offset", and the "stitching-locations".  If the client   */
    /* supplies a mal-formed request by not supplying all three member attributes, the Printer MUST         */
    /* (depending on implementation) either (1) reject the request and return the                           */
    /* "client-error-bad-request" (see [RFC2911] section 13.1.4.1) or (2) default the omitted member        */
    /* attributes, independent of the value of the "ipp-attribute-fidelity" attribute supplied by the       */
    /* client.                                                                                              */
    /*                                                                                                      */
    /* 3.2.2.1	stitching-reference-edge (type2 keyword)                                                    */
    /* The "stitching-reference-edge" member attribute specifies the Stitching Reference Edge of the output */
    /* media relative to which the stapling or stitching MUST be applied.  The individual staples or        */
    /* stitches will be situated along a line or axis parallel to the Stitching Reference Edge that is      */
    /* called the Stitching Axis.                                                                           */
    /*                                                                                                      */
    /* Notice that the "stitching-reference-edge" member attribute is single valued, and thus prohibits     */
    /* specification of location by a combination of values (e.g., top-left is not allowed).                */
    /*                                                                                                      */
    /* The standard keyword values are:                                                                     */
    /* |---------------------|---------------------------------------------------------------------|        */
    /* | Keyword	           |  Description                                                        |        */
    /* |=====================|=====================================================================|        */
    /* | bottom              | The bottom edge coincides with the x-axis of the coordinate system. |        */
    /* | top                 | The top edge is opposite and parallel to the bottom edge.           |        */
    /* | left                | The left edge coincides with the y-axis of the coordinate system.   |        */
    /* | right               | The right edge is opposite and parallel to the left edge.           |        */
    /* |---------------------|---------------------------------------------------------------------|        */
    /*                                                                                                      */
    /* A Printer MUST support this member attribute and at least the 'left' value, however, which           */
    /* additional values depend on implementation.                                                          */
    /*                                                                                                      */
    /* Note that the 'left' value works with 'portrait' and 'landscape' documents, since 'landscape'        */
    /* documents are rotated anti-clock-wise 90 degrees, i.e., plus 90 degrees, with respect to 'portrait'  */
    /* documents, if landscape documents are stapled along the long edge (which becomes the top edge when   */
    /* the human reader orients the 'landscape' document for reading).  If the documents to be stapled are  */
    /* two-sided, then the client supplies the 'two-sided-long' and 'two-sided-short' values for the        */
    /* "sides" attribute for the 'portrait' and 'landscape' documents, respectively.  Note:  the client can */
    /* supply the proper value for the "sides" attribute for the user, by knowing whether the document is   */
    /* portrait or landscape, thereby relieving the user of having to distinguish between the two values    */
    /* for two-sided printing.                                                                              */
    /*                                                                                                      */
    /* If the 'landscape' documents are to be stapled on the short edge (which becomes the left edge when   */
    /* the human reader orients the 'landscape' document for reading), the client supplies the 'bottom' and */
    /* 'two-sided-short' values for the "stitching-reference-edge" and "sides" attributes, respectively.    */
    /*                                                                                                      */
    /* For 'reverse-landscape' documents (ones rotated clock-wise 90 degrees, i.e., minus 90 degrees, the   */
    /* client supplies 'right' and 'two-sided-long' values for the "stitching-reference-edge" and "sides"   */
    /* attributes, respectively, if landscape documents are stapled along the long edge (which becomes the  */
    /* top edge when the human reader orients the 'landscape' document for reading).  If the                */
    /* 'reverse-landscape' documents are to be stapled on the short edge (which becomes the left edge when  */
    /* the human reader orients the 'landscape' document for reading), the client supplies the 'top' and    */
    /* 'two-sided-short' values for the "stitching-reference-edge" and "sides" attributes, respectively.    */
    /*                                                                                                      */
    /* The "stitching-reference-edge-supported" (1setOf type2 keyword) Printer attribute identifies the     */
    /* values of this "stitching-reference-edge" member attribute that the Printer supports, i.e., the      */
    /* stitching reference edges supported.                                                                 */
    /*                                                                                                      */
    /* 3.2.2.2	stitching-offset (integer (0:MAX))                                                          */
    /* The "stitching-offset" member attribute specifies the perpendicular distance of the Stitching Axis   */
    /* from the Stitching Reference Edge.  Since the "stitching-offset" member attribute is positive or     */
    /* zero, the offset is always in the direction that is both away from the Stitching Reference Edge and  */
    /* toward the center of the media sheet.                                                                */
    /*                                                                                                      */
    /* The unit of measure for the "stitching-locations" member attribute is one hundredth of a millimeter. */
    /* This unit is equivalent to 1/2540 th of an inch resolution.                                          */
    /*                                                                                                      */
    /* If the client specifies a "stitching-offset" then the Printer MUST produce a stitch (or stitches)    */
    /* along a line that is the specified number of hundreds of millimeters specified by the                */
    /* "stitching-offset" attribute away from the "stitching-reference-edge".                               */
    /*                                                                                                      */
    /* The "stitching-offset-supported" (1setOf (integer (0:MAX) | rangeOfInteger(0:MAX))) Printer          */
    /* attribute identifies the values of this "stitching-offset" member attribute that the Printer         */
    /* supports, i.e., the stitching offsets supported which can be a series of discrete numbers and/or     */
    /* ranges.  No relationship between values of this attribute and the number of stitching locations that */
    /* the device supports can be inferred.                                                                 */
    /*                                                                                                      */
    /* 3.2.2.3	stitching-locations (1setOf integer(0:MAX))                                                 */
    /* Each value of "stitching-locations" specifies an absolute offset along the Stitching Axis at which   */
    /* a stitch MUST occur.  Each value in the 1setOf MUST be in order of increasing distance.              */
    /*                                                                                                      */
    /* If the "stitching-reference-edge" is either 'top' or 'bottom', then each value in the                */
    /* "stitching-locations" represents an offset in hundreds of millimeters from the left edge along the   */
    /* Stitching Axis toward the center of the medium. If the "stitching-reference-edge" is either 'left'   */
    /* or 'right, then each value in the "stitching-locations" represents an offset in hundreds of          */
    /* millimeters from the bottom edge along the Stitching Axis toward the center of the medium.           */
    /*                                                                                                      */
    /* The unit of measure for the "stitching-locations" member attribute is one hundredth of a millimeter. */
    /* This unit is equivalent to 1/2540 th of an inch resolution.                                          */
    /*                                                                                                      */
    /* The "stitching-locations-supported" (1setOf (integer(0:MAX) | rangeOfInteger(0:MAX))) Printer        */
    /* attribute identifies the values of this "stitching-locations" member attribute that the Printer      */
    /* supports, i.e., the stitching locations supported which can be a series of discrete numbers and/or   */
    /* ranges.  No relationship between values of this attribute and the number of stitching locations that */
    /* the device supports can be inferred.                                                                 */
    /*                                                                                                      */
    /* The "max-stitching-locations-supported" (integer(1:MAX)) Printer Description attribute indicates     */
    /* the maximum number of stitches or staples that the implementation is capable of inserting into an    */
    /* Output Document, even if that number would require human intervention in order to configure the      */
    /* (manual configured) stitcher.  See section 5.2.  In other words, "max-stitching-locations-supported" */
    /* attribute specifies the maximum number of values that the client can supply in the                   */
    /* "stitching-locations" member attribute.                                                              */
    /*                                                                                                      */
    /* 3.2.2.4	stitching-supported (1setOf type2 keyword)                                                  */
    /* The "stitching-supported" Printer attribute identifies the keyword names of the member attributes    */
    /* supported in the "stitching" collection member attribute, i.e., the keyword names of the member      */
    /* attributes in Table 4 that the Printer supports.                                                     */
    /*                                                                                                      */
    /* 3.2.3	finishings-col-default (collection)                                                           */
    /* The "finishings-col-default" Printer attribute specifies the finishing that the Printer uses, if     */
    /* any, if the client omits the "finishings-col" Job Template attribute in the Job Creation operation   */
    /* (and the PDL doesn't include a finishing specification).  The member attributes are defined in       */
    /* Table 3.  A Printer MUST support the same member attributes for this default collection attribute as */
    /* it supports for the corresponding "finishings-col" Job Template attribute.                           */
    /*                                                                                                      */
    /* 3.2.4	finishings-col-ready (1setOf collection)                                                      */
    /* The "finishings-col-ready" Printer attribute identifies the finishings configurations that do not    */
    /* require human intervention in order to be used.  Table 5 lists the member attributes, their          */
    /* attribute syntaxes, and the corresponding "xxx-supported" Printer attributes.  The member attributes */
    /* have the same names as the member attributes that the client can supply in the "finishing-col"       */
    /* collection attribute (see Table 4), but have the attribute syntaxes of the corresponding             */
    /* "xxx-supported" Printer attributes.  The member attribute values will differ from the corresponding  */
    /* "xxx-supported" Printer attribute values to the extent that human intervention is needed, such as    */
    /* running out of staples (or stitching wire) and/or a stapler that requires manual position setting.   */
    /* The rangeOfInteger value is used to indicate the range that can be selected by the client without    */
    /* human intervention, if the finisher is programmable.                                                 */
    /*                                                                                                      */
    /*                        Table 5 - The "finishings-col-ready" member attributes                        */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*          | member attribute    	         | section | corresponding supported attribute   |          */
    /*          |================================|=========|=====================================|          */
    /*          | finishing-template             |   3.2.1 | finishing-template-supported        |          */
    /*          |  (1setOf name(MAX))            |         |    (1setOf name(MAX))               |          */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*          | stitching                      |   3.2.2 | stitching-supported                 |          */
    /*          |  (1setOf collection)           |         |    (1setOf type2 keyword)           |          */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*                which contains:                                                                       */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*          |    stitching-reference-edge    | 3.2.2.1 | stitching-reference-edge-supported  |          */
    /*          |      (1setOf type2 keyword)    |         |    (1setOf type2 keyword)           |          */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*          |    stitching-offset            | 3.2.2.2 | stitching-offset-supported"         |          */
    /*          |      (1setOf (integer (0:MAX)| |         |    (1setOf (integer (0:MAX)|        |          */
    /*          |       rangeOfInteger(0:MAX)))  |         |     rangeOfInteger(0:MAX)))         |          */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*          |    stitching-locations         | 3.2.2.3 | stitching-locations-supported       |          */
    /*          |      (1setOf (integer (0:MAX)| |         |    (1setOf (integer(0:MAX)|         |          */
    /*          |       rangeOfInteger(0:MAX)))  |         |     rangeOfInteger(0:MAX)))         |          */
    /*          |--------------------------------|---------|-------------------------------------|          */
    /*                                                                                                      */
    /* 3.2.5	finishings-col-supported (1setOf type2 keyword)                                               */
    /* The "finishings-col-supported" Printer attribute identifies the keyword names of the member          */
    /* attributes supported in the "finishings-col" collection Job Template attribute, i.e., the keyword    */
    /* names of the member attributes in Table 3 that the Printer supports.                                 */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*      §5.2 [page 66] max-stitching-locations-supported (integer(1:MAX))                           */
        /* -----------------                                                                                */
        /* This attribute indicates the maximum number of stitches or staples that the implementation is    */
        /* capable of inserting into an Output Document, even if that number would require human            */
        /* intervention in order to configure the (manual configured) stitcher.  In other words,            */
        /* "max-stitching-locations-supported" attribute specifies the maximum number of values that the    */
        /* client can supply in the "stitching-locations" member attribute (see section 3.2.2.3).           */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §13.1.4.1 [page 180] client-error-bad-request (0x0400)                                      */
        /* -----------------                                                                                */
        /* The request could not be understood by the IPP object due to malformed syntax (such as the       */
        /* value of a fixed length attribute whose length does not match the prescribed length for that     */
        /* attribute - see the Implementer's Guide [IPP-IIG] ).  The IPP application SHOULD NOT repeat the  */
        /* request without modifications.                                                                   */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef struct {
                   pwgCHAR  FininshingsTemplate[1024];/* Value for some particular finishing operation      */
    pwgStitchingCollection  stitching;                /* Details of how documents to be stitched or stapled */

                    VND_FIN_COL_STRUCT

} pwgFinsihingsCollecton;

typedef struct {

               pwgINFO_DEF* finTemplate;              /* Value for some particular finishing operation      */
             pwgSTRUCT_DEF* stitching;                /* Details of how documents to be stitched or stapled */

            VND_FIN_COL_DEF_STRUCT

                   pwgVOID* last;
} pwgFinColDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgFinColDefLst  pwgFinishingsColDefElem;
extern pwgSTRUCT_DEF    pwgDef_FinishingsCol;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_3_FINISHINGS_COL_H__                                                               */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================= pwg.pjt.pdp.3.finishings.col.h ======================================= */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
