/* =================================== pwg.pjt.pdp.3.insert.sheet.h ======================================= */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_3_INSERT_SHEET_H__
#define __PWG_PJT_PDP_3_INSERT_SHEET_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pdp.3.insert.after.page.number.h"
#include "pwg.pjt.pdp.3.insert.count.h"
#include "pwg.pjt.xxx.N.media.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Insert Sheet                                                                                             */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.3: [page 20] InsertSheet DataType                                                              */
/* -----------------                                                                                        */
/* Figure 7 shows the constituent elements of the InsertSheet element.                                      */
/*                                                                                                          */
/*                              +  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*                              . InsertSheetType                                                      .    */
/*                              .                                                                      .    */
/*                              .     +------------+                                                   .    */
/*                              . +---| attributes |                                                   .    */
/*                              . |   +------------+                                                   .    */
/*                              . |                                                                    .    */
/*                              . |                  + - - - - - - - - - - - +                         .    */
/*                              . |              + - ! InsertAfterPageNumber !                         .    */
/*                              . |              !   I - - - - - - - - - - - M                         .    */
/*                              . |              !                                                     .    */
/*                              . |              !   + - - - - - - +                                   .    */
/*                              . |              + - ! InsertCount !                                   .    */
/*                              . |              !   I - - - - - - M                                   .    */
/*                              . |              !                                                     .    */
/*                              . |              !                                 + - - - +           .    */
/*                              . |              !                             + - ! Media !+          .    */
/*                              . |              !                /- - - - -\  !   K - - - M           .    */
/*                              . |              !   / - - \  + - ! -o-o-o- !- +                       .    */
/*             /-------------+  . | /---------\  !   !   o !  !   \- - - - -/  !   + - - - - - +       .    */
/*             | InsertSheet |--.-+-| -o-o-o- |- + - !__/o !- +                + - ! MediaType !+      .    */
/*             \-------------+  .   \---------/  !   !   o !  !                    K - - - - - M       .    */
/*                              .                !   \ - - /  !   + - - - - - +                        .    */
/*                              .                !            + - ! MediaCol  !+                       .    */
/*                              .                !                C - - - - - M                        .    */
/*                              .                !                                                     .    */
/*                              .                !                                                     .    */
/*                              .                !   / - - - - - - -\                                  .    */
/*                              .                + - ! any ##other  !                                  .    */
/*                              .                    \ - - - - - - -/                                  .    */
/*                              .                        0..infinite                                   .    */
/*                              .                                                                      .    */
/*                              +  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*                                                                                                          */
/*                                    Figure 7 InsertSheet DataType                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 47] InsertSheet                    */
/* -----------------                                                                                        */
/* Specifies how Insert Sheets are to be inserted into the sequence of media sheets that are produced for   */
/* each copy of the documents.                                                                              */
/* [PWG5100.3] §3.5                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*      §3.5 [page 28-31] insert-sheet (1setOf collection)                                              */
    /* -----------------                                                                                    */
    /* This attribute specifies how Insert-Sheets are to be inserted into the sequence of media sheets that */
    /* are produced for each copy of each printed document in the job.  Insert-Sheets are sheets on which   */
    /* no Input-Pages from the Input-Document are imaged.  However, the media specified for Insert-Sheets   */
    /* can be pre-printed media.  How the sheet is inserted is implementation dependent, and could be as    */
    /* sophisticated as insertion hardware, or as simple as using media from an existing input-tray.        */
    /*                                                                                                      */
    /* The order of the values of the "insert-sheet" attribute is important.  In the case where more than   */
    /* one value refers to the same page (i.e., multiple values contain the same value for the              */
    /* "insert-after-page-number" member attribute), the values of "insert-sheet" are to be applied in the  */
    /* order that they occur.                                                                               */
    /*                                                                                                      */
    /* This attribute is affected by the "multiple-document-handling" attribute.  For values of             */
    /* 'single-document' and 'single-document-new-sheet', the sheet is inserted in the composite (single)   */
    /* document created by the concatenation of all the print-stream pages in all of the documents.  In the */
    /* case of 'separate-documents-collated-copies' and 'separate-documents-uncollated-copies', the         */
    /* inserted sheets are applied to the print-stream in each document separately.  The collection         */
    /* consists of:                                                                                         */
    /*                                                                                                      */
    /*                            Table 6 - "insert-sheet" member attributes                                */
    /* |--------------------------|----------------------------|------------------|-----------------------| */
    /* | Attribute name           |  attribute syntax          |     request      |   Printer Support     | */
    /* |==========================|============================|==================|=======================| */
    /* | insert-after-page-number |  integer (0:MAX)           |  MUST            |   MUST                | */
    /* |--------------------------|----------------------------|------------------|-----------------------| */
    /* | insert-count             |  integer (0:MAX)           |  MAY             |   MUST                | */
    /* |--------------------------|----------------------------|------------------|-----------------------| */
    /* | media                    |  type3 keyword | name(MAX) |  MAY be neither  |   MUST                | */
    /* |--------------------------|----------------------------|  or one of, but  |-----------------------| */
    /* | media-col                |  collection                |  NOT both        |   MAY                 | */
    /* |                          |                            |                  |                       | */
    /* |--------------------------|----------------------------|------------------|-----------------------| */
    /*                                                                                                      */
    /* 3.5.1 insert-after-page-number (integer(0:MAX))                                                      */
    /* The "insert-after-page-number" member attribute specifies the page in the Input-Document (see        */
    /* sections 2.2 and 2.5) print-stream after which the Insert-Sheet(s) is(are) to be placed. The         */
    /* inserted sheet(s) does not affect the numbering of print-stream pages.  For-example, to insert a     */
    /* single sheet after both pages 2 and 3 of a given document, the value of "input-after-page-number"    */
    /* would be 2 and 3 respectively (not 2 and 4, as it would be if the inserted sheet affected the        */
    /* Input-Document print-stream page count).  For a complete description of the enumeration of           */
    /* print-stream pages see section 2.5.                                                                  */
    /*                                                                                                      */
    /* If the value of the "insert-after-page-number" member attribute is 0, then the sheet is inserted     */
    /* before the first page.  If the value is MAX, then the sheet is inserted after the last sheet in the  */
    /* document.                                                                                            */
    /*                                                                                                      */
    /* If the "insert-after-page-number" member attribute is not a valid input document page reference in   */
    /* the print-stream, then the IPP Printer SHOULD ignore the request.  For example, (1) the page number  */
    /* is beyond the last page of the document AND is not MAX or (2) the "page-ranges" Job Template         */
    /* attribute does not include the specified page number (see section 2.5).  There is no way to validate */
    /* the "insert-after-page-number" attribute with the Validate-Job operation, since the validation       */
    /* cannot occur until the pages of the documents have arrived at the printer.                           */
    /*                                                                                                      */
    /* Since the "insert-after-page-number" member attribute refers to a specific Input-Document            */
    /* print-stream page, it is possible to specify a page that would not be the last page on a sheet, e.g. */
    /* an insertion occurs after the page that is on the front side of a two sided document. In this case,  */
    /* the Printer MUST force a new Sheet after the specified page, insert the specified sheet, place the   */
    /* following pages starting on the first side of the next Sheet, and issue a warning by adding          */
    /* 'job-warnings-detected' to the "job-state-reasons" and by increasing the value of  the               */
    /* "job-warnings-count" Job Description attribute by 1.  See [ipp-override] for this error handling     */
    /* specification under "Common Behavior for Sheet Attributes".                                          */
    /*                                                                                                      */
    /* The "insert-after-page-number-supported" (rangeOfInteger(0:MAX)) Printer attribute indicates the     */
    /* range of page numbers supported in the "insert-after-page-number" member attribute, i.e., the        */
    /* minimum (SHOULD be 0) and the maximum (SHOULD be MAX) page numbers supported.                        */
    /*                                                                                                      */
    /* 3.5.2 insert-count (integer(0:MAX))                                                                 */
    /* The "insert-count" member attribute indicates how many sheets to insert.  If the "insert-count"      */
    /* attribute is omitted, then the printer assumes a value of 1.  The value 0 indicates that no inserts  */
    /*  sheets are to be inserted.                                                                          */
    /*                                                                                                      */
    /* The "insert-count-supported" (rangeOfInteger(0:MAX)) Printer attribute specifies the range of values */
    /* that the Printer supports, i.e., the minimum number and the maximum number of pages.                 */
    /*                                                                                                      */
    /* 3.5.3 media (type3 keyword | name(MAX)) or media-col (collection)                                   */
    /* Either the "media" (defined in [RFC2911] section 4.2.11) or the "media-col" member attribute is used */
    /* to indicate the media that the Printer MUST use for the insert sheet.   The member attributes are    */
    /* the same as those for the "media-col" attribute shown in Table 10.                                   */
    /*                                                                                                      */
    /* The client MUST supply either the "media" or the "media-col" member attribute, but NOT both.  If the */
    /* client supplies such a mal-formed request by supplying neither or both, the Printer MUST (depending  */
    /* on implementation) either (1) reject the request and return the 'client-error-bad-request' status    */
    /* code (see [RFC2911] section 13.1.4.1) or (2) use either the "media" or the "media-col" member        */
    /* attribute, independent of the value of the "ipp-attribute-fidelity" attribute supplied by the client.*/
    /*                                                                                                      */
    /* Since this "media" member attribute has the same name as the "media" Job Template attribute defined  */
    /* in [RFC2911] section 4.2.11), the "media-supported" (1setOf (type3 keyword | name(MAX))) Printer     */
    /* attribute (also defined in [RFC2911] section 4.2.11) identifies the values of this "media" member    */
    /* attribute (as well as the values of the "media" Job Template attribute) that the Printer supports,   */
    /* i.e., the names of the supported media.                                                              */
    /*                                                                                                      */
    /* Since this "media-col" member attribute has the same name as the "media-col" Job Template attribute  */
    /* defined in section 3.13), the "media-col-supported" Printer attribute (defined in section 3.13.14)   */
    /* identifies the keyword names of the member attributes supported in this "media-col" member attribute */
    /* (as well as the keyword names of the "media-col" Job Template attribute), i.e., the names of the     */
    /* member attributes in Table 10 that the Printer supports.                                             */
    /*                                                                                                      */
    /* 3.5.4 insert-sheet-default (1setOf collection)                                                      */
    /* The "insert-sheet-default" Printer attributes specify the insert sheet(s) that the Printer MUST      */
    /* provide, if any, if the client omits the "insert-sheet" Job Template attribute.  The member          */
    /* attributes are defined in Table 6.  A Printer MUST support the same member attributes for this       */
    /* default collection attribute as it supports for the corresponding "insert-sheet" Job Template        */
    /* attribute.                                                                                           */
    /*                                                                                                      */
    /* 3.5.5 insert-sheet-supported (1setOf type2 keyword)                                                 */
    /* The "insert-sheet-supported" attribute identifies the keyword names of the member attributes         */
    /* supported in the "insert-sheet" collection Job Template attribute, i.e., the keyword names of the    */
    /* member attributes in Table 6 that the Printer supports.                                              */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*      §2.5 [page 15-16] Enumeration and Ordering of print-stream pages                            */
        /* -----------------                                                                                */
        /* A print-stream page is a page according to the definition of pages in the language used to       */
        /* express the document data (see section of 13.2.4 of the IPP Model and Semantics Document).  The  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note                                     ^^^^^^ == 12.2.4 print-stream page of rfc2911          */
/*                which states: A "print-stream page" is a page according to the definition of pages in the */
/*                language used to express the document data.                                               */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /* document data included in an IPP request is typically a PDL representation of a document         */
        /* composed by a user.  For the remainder of this description we will use the term document data to */
        /* mean the typical PDL representation sent with an IPP request (e.g., a PostScript File), and the  */
        /* term original document to mean the document composed by the user (e.g., a Word97 document).  The */
        /* print-stream page numbering is with respect to the Input-Document, not the Output-Document (see  */
        /* [ipp-override]).  Furthermore, the page numbers are ordinal numbers starting at 1 and are        */
        /* independent of the page numbers that may be printed on the pages.                                */
        /*                                                                                                  */
        /* The order of the print-stream pages in the document data is either the same as the order of the  */
        /* original document, known as 1-N (read "one to N"), or the reverse of that order, known as N-1.   */
        /* There are no assumptions on the order of the original document, other than it is ordered.        */
        /*                                                                                                  */
        /* The enumeration of print-stream pages begins with 1 and increments by 1 for each additional      */
        /* print-stream page.  The enumeration is based on the order of the original document, not the      */
        /* document data supplied with the IPP request.  In other words, if the document data is supplied   */
        /* in N-1 order (reverse of the original document order), then print-stream page number '1' in the  */
        /* enumeration is actually the N th print-stream page defined in the document data  (see the        */
        /* "page-order-received" attribute in section 3.16).  Similarly, print-stream page number '2' is    */
        /* defined by the (N-1) th print-stream page defined in the document data.  Suppose the document    */
        /* data is supplied in the 1-N order (same as the original document order), then print-stream page  */
        /* number '1' in the enumeration is the 1 st print-stream page defined in the document data.        */
        /* Similarly, print-stream page number '2' is defined by the 2 nd print-stream page defined in the  */
        /* document data.  The enumeration of print-stream pages is only relevant when applying attributes  */
        /* or operations that act on a page, or range of page basis (e.g., the "insert-sheet" attribute in  */
        /* section 3.5).                                                                                    */
        /*                                                                                                  */
        /* The enumeration of print-stream pages is affected by the "multiple-document-handling" attribute. */
        /* When the "multiple-document-handling" attribute is 'single-document' or                          */
        /* 'single-document-new-sheet', the enumeration is based on the concatenation of all the            */
        /* print-stream pages in the job.  In the case of 'separate-documents-collated-copies' and          */
        /* 'separate-documents-uncollated-copies,' the enumeration of print-stream pages applies to each    */
        /* document.  For example, for a job with eight documents, referring to print-stream page number    */
        /* '1' actually refers to print-stream page number '1' in each of the eight documents included with */
        /* the job.                                                                                         */
        /*                                                                                                  */
        /* The enumeration of print-stream pages is NOT affected by the "page-ranges" Job Template          */
        /* attribute, if supplied.  The "page-ranges" attribute merely affects which Input-Document pages   */
        /* are actually printed.  For example, if an insert sheet is to be inserted after print-stream page */
        /* number is 5 of a 10-page document, the insert page will be inserted after page 5 with respect to */
        /* the Input-Document as long as page 5 is included in the "page-ranges" attribute.  If the         */
        /* "page-ranges" attribute does not include Input-Document page 5, then the insert sheet will not   */
        /* be inserted.  Thus a user can supply the "page-ranges" attribute without having to change any    */
        /* other attributes in order to print a part of a document.                                         */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §4.2.11 [page 104-105] media (type3 keyword | name(MAX))                                    */
        /* -----------------                                                                                */
        /*  This attribute identifies the medium that the Printer uses for all impressions of the Job.      */
        /*                                                                                                  */
        /* The values for "media" include medium-names, medium-sizes, input-trays and electronic forms so   */
        /* that one attribute specifies the media.  If a Printer object supports a medium name as a value   */
        /* of this attribute, such a medium name implicitly selects an input-tray that contains the         */
        /* specified medium.  If a Printer object supports a medium size as a value of this attribute, such */
        /* a medium size implicitly selects a medium name that in turn implicitly selects an input-tray     */
        /* that contains the medium with the specified size.  If a Printer object supports an input-tray as */
        /* the value of this attribute, such an input-tray implicitly selects the medium that is in that    */
        /* input-tray at the time the job prints.  This case includes manual-feed input-trays.  If a        */
        /* Printer object supports an electronic form as the value of this attribute, such an electronic    */
        /* form implicitly selects a medium-name that in turn implicitly selects an input-tray that         */
        /* contains the medium specified by the electronic form.  The electronic form also implicitly       */
        /* selects an image that the Printer MUST merge with the document data as its prints each page.     */
        /*                                                                                                  */
        /* Standard keyword values are taken from ISO DPA [ISO10175], the Printer MIB [RFC1759], and        */
        /* ASME-Y14.1M [ASME-Y14.1M] and are listed in section 14.  An administrator MAY define additional  */
        /* values using the 'name' or 'keyword' attribute syntax, depending on implementation.              */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: DUE TO THE SIZE AND CHANGES OF THE MEDIA TABLE INFO IN RFC2911, IT HAS NOT BEEN INCLUDED  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /* There is also an additional Printer attribute named "media-ready" which differs from             */
        /* "media-supported" in that legal values only include the subset of "media-supported" values that  */
        /* are physically loaded and ready for printing with no operator intervention required. If an IPP   */
        /* object supports "media-supported", it NEED NOT support "media-ready".                            */
        /*                                                                                                  */
        /* The relationship of this attribute and the other attributes that control document processing is  */
        /* described in section 15.3.                                                                       */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §13.1.4.1 [page 180] client-error-bad-request (0x0400)                                      */
        /* -----------------                                                                                */
        /* The request could not be understood by the IPP object due to malformed syntax (such as the       */
        /* value of a fixed length attribute whose length does not match the prescribed length for that     */
        /* attribute - see the Implementer's Guide [IPP-IIG] ).  The IPP application SHOULD NOT repeat the  */
        /* request without modifications.                                                                   */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*      §3.13.14 [page 48] media-col-supported (1setOf type2 keyword)                               */
        /* -----------------                                                                                */
        /* The "media-col-supported" Printer attribute identifies the keyword names of the member           */
        /* attributes supported in the "media-col" collection Job Template attribute, i.e., the keyword     */
        /* names of the member attributes in Table 10 that the Printer supports.                            */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef struct {
                pwgBIT32  insertAfterPageNum;         /* The input page after which the Insert Sheet        */
                pwgBIT32  insertCount;                /* Specifies the number of Insert Sheet to insert.    */
    pwgMediaDescTypeEnum	mediaDescType;              /* The type of media description used                 */
    pwgMediaSizeNameEnum  media;                      /* Media (size)                                       */
        pwgMediaTypeEnum  mediaType;                  /* Media Type                                         */
       pwgMediaCollecton  mediaCol;                   /* Actual media description information               */

                 VND_INSERT_SHEET_STRUCT

} pwgInsertSheetCollection;

typedef struct {
              pwgNUM_DEF* insertAfterPageNum;         /* The input page after which the Insert Sheet        */
              pwgNUM_DEF* insertCount;                /* Specifies the number of Insert Sheet to insert.    */
          pwgNUM_RNG_DEF* mediaDescTypeDef;           /* Type of media description used                     */
          pwgNUM_RNG_DEF* mediaSizeNameDef;           /* Media (size)                                       */
          pwgNUM_RNG_DEF* mediaTypeDef;               /* Media Type                                         */
           pwgSTRUCT_DEF* mediaCollectionDef;         /* Actual media description information               */

          VND_INSERT_SHEET_DEF_STRUCT

                 pwgVOID* last;
} pwgInsertSheetDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern  pwgInsertSheetDefLst  pwgDef_InsertSheetDefElem;
extern  pwgSTRUCT_DEF         pwgDef_InsertSheet;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_3_INSERT_SHEET_H__                                                                 */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* =================================== pwg.pjt.pdp.3.insert.sheet.h ======================================= */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
