/* =================================== pwg.pjt.pdp.3.pdl.init.file.h ====================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_3_PDL_INIT_FILE_H__
#define __PWG_PJT_PDP_3_PDL_INIT_FILE_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Pdl Init File(s)                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.6: [page 22-23] PdlInitFiles DataType                                                          */
/* -----------------                                                                                        */
/* Figure 10 shows the constituent elements of the PdlInitFiles element.                                    */
/*                                                                                                          */
/*                    + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +     */
/*                    . PdlInitFilesType(extension)                                                   .     */
/*                    .                                                                               .     */
/* +--------------+   .     +------------+                                                            .     */
/* | PdlInitFiles |---.--+--| attributes |                                                            .     */
/* +--------------+   .  |  +------------+                                                            .     */
/*                    .  |                                                 + - - - - - - - - - - +    .     */
/*                    .  |                                             + - ! PdlInitFileLocation !    .     */
/*                    .  |                                             !   S - - - - - - - - - - M    .     */
/*                    .  |                                             !                              .     */
/*                    .  |                                             !   +-----------------+        .     */
/*                    .  |                                             +---| PdlInitFileName |        .     */
/*                    .  |  /---------\  +-------------+  /---------\  |   S-----------------M        .     */
/*                    .  +--| -o-o-o- |--| PdlInitFile |--| -o-o-o- |--+                              .     */
/*                    .     \---------/  C-------------M  \---------/  !   + - - - - - - - - - +      .     */
/*                    .                                                + - ! PdlInitFileEntry  !      .     */
/*                    .                                                !   S - - - - - - - - - M      .     */
/*                    .                                                !                              .     */
/*                    .                                                !   / - - - - - - -\           .     */
/*                    .                                                + - ! any ##other  !           .     */
/*                    .                                                    \ - - - - - - -/           .     */
/*                    .                                                        0..infinite            .     */
/*                    .                                                                               .     */
/*                    + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +     */
/*                                                                                                          */
/*                                            Figure 10 PdlInitFiles                                        */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 56] PdlInitFile                    */
/* -----------------                                                                                        */
/* Controls initialization of the PrintService's Page Description Language (PDL) interpreter.               */
/* [PWG5100.11] §7.10                                                                                       */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 56] PdlInitFileLocation            */
/* -----------------                                                                                        */
/* Contains a URL that specifies the path to the directory where the initialization file for the            */
/* PrintService's PDL interpreter will be found.                                                            */
/* [PWG5100.11] §7.10                                                                                       */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 57] PdlInitFileName                */
/* -----------------                                                                                        */
/* Specifies the name of the PDL interpreter's initialization file within the directory specified by the    */
/* PdlInitFileLocation element.                                                                             */
/* [PWG5100.11] §7.10                                                                                       */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 56] PdlInitFileEntry               */
/* -----------------                                                                                        */
/* Specifies an entry point within the init file at which the PDL interpreter starts.                       */
/* [PWG5100.11] §7.10                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                      */
    /*                           Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
    /*      §7.10     [page 48-50] pdl-init-file  (1setOf collection)                                       */
    /*      §7.10.1.1 [page 49] pdl-init-file-location (uri)                                                */
    /*      §7.10.1.2 [page 49] pdl-init-file-name (name(MAX))                                              */
    /*      §7.10.1.3 [page 50] pdl-init-file-entry (name(MAX))                                             */
    /* -----------------                                                                                    */
    /* The OPTIONAL "pdl-init-file" Job Template attribute controls initialization of the Printer's Page    */
    /* Description Language (PDL) interpreter. This attribute specifies the files that the Printer uses to  */
    /* initialize the PDL interpreter before it starts interpreting each Input Document (i.e. file) in a    */
    /* Job with one exception. When the value of "multiple-document-handling" is 'single-document' or       */
    /* 'single-document-new-sheet', a PDL interpreter processes all of  the Input-Documents of a Job as if  */
    /* the Input Documents were a single file.  In this case, the PDL interpreter is initialized just       */
    /* before processing the first Input Document only.                                                     */
    /*                                                                                                      */
    /* Some PDLs (i.e. PostScript and HP PCL) have the ability to define reusable macros, code fragments,   */
    /* fonts, and other resources.  These components may reside either within the body of the document file */
    /* to be printed or within files that can be sent to the Printer's PDL interpreter separately.  Having  */
    /* the ability to send these "pre-initialization" (prep) files separately from the main body of the job */
    /* to be printed, enables an application to "pre-condition" the PDL interpreter with these definitions  */
    /* ahead of time.  This in turn makes it possible to reduce the size of a given document data file to   */
    /* be printed and to reuse the components on other jobs.                                                */
    /*                                                                                                      */
    /* The exact mechanism by which an initialization file (or list of initialization files) is installed   */
    /* on the Printer is implementation dependent and outside of the current scope of IPP.                  */
    /*                                                                                                      */
    /* Upon receipt of the "pdl-init-file" collection attribute(s) the Printer will send the initialization */
    /* file (or list of files) referenced to the Printer's PDL interpreter for processing BEFORE starting   */
    /* to process the document(s) attached to the job (in the Print-Job request) or referenced by the job   */
    /* (in the Print-URI request).                                                                          */
    /*                                                                                                      */
    /* If the Printer receives more than one "pdl-init-file" collection in a given print request, then the  */
    /* list of initialization files will be sent to the Printer's PDL interpreter in the order that they    */
    /* are encountered in the Job Template attributes.                                                      */
    /*                                                                                                      */
    /* 7.10.1 Member Attributes for the "pdl-init-file" Job Template Attribute                              */
    /* Table 11 lists the member attributes of the "pdl-init-file" Job Template attribute and specifies     */
    /* whether Clients MUST supply them in collection values and whether Printers MUST support them if      */
    /* supporting this collection attribute.  The following sub-sections define these member attributes.    */
    /*                                                                                                      */
    /*                            Table 11 - "pdl-init-file" member attributes                              */
    /*          |-------------------------|-------------------|---------|-----------------|                 */
    /*          | Member Attribute Name   | Attribute Syntax  | Request | Printer Support |                 */
    /*          |=========================|===================|=========|=================|                 */
    /*          | pdl-init-file-location  | uri               | MAY     | MUST            |                 */
    /*          |-------------------------|-------------------|---------|-----------------|                 */
    /*          | pdl-init-file-name      | name(MAX)         | MUST    | MUST            |                 */
    /*          |-------------------------|-------------------|---------|-----------------|                 */
    /*          | pdl-init-file-entry     | name(MAX)         | MAY     | MAY             |                 */
    /*          |-------------------------|-------------------|---------|-----------------|                 */
    /*                                                                                                      */
    /* 7.10.1.1 pdl-init-file-location (uri)                                                                */
    /* This member attribute must be an Absolute URI [RFC 2396] that specifies the path to the directory    */
    /* where the initialization file to be sent to the Printer's PDL interpreter will be found.  According  */
    /* to RFC 2396, an Absolute URI MUST have a URI scheme, MAY have an authority (host name) component,    */
    /* and MUST have an absolute path (e.g.,'ftp://printhost.printco.com/var/spool/jobinitfiledir/initfile1'*/
    /* or 'file:///jobinitfiledir/initfile1').                                                              */
    /*                                                                                                      */
    /* 7.10.1.1.1 pdl-init-file-location-supported (1setOf uri)                                             */
    /* The "pdl-init-file-location-supported (1setOf uri)" Printer attribute specifies the path(s) to the   */
    /* directory (directories) of the supported initialization file(s) that the client MAY ask the Printer  */
    /* to send to its PDL interpreter prior to processing the document.                                     */
    /*                                                                                                      */
    /* 7.10.1.2 pdl-init-file-name (name(MAX))                                                              */
    /* This member attribute specifies the name of the initialization file within the directory specified   */
    /* by the "pdl-init-file-location" member attribute that the Printer MUST send to its PDL interpreter   */
    /* prior to processing the document.   The "pdl-init-file-subdirectory-supported" Printer Description   */
    /* attribute indicates whether or not the Printer supports a FORWARD-SLASH ("/") in the                 */
    /* "pdl-init-file-name" value.  Whether the FORWARD SLASH when supported is actually implemented as a   */
    /* sub-directory is IMPLEMENTATION DEPENDENT.                                                           */
    /*                                                                                                      */
    /* A well-formed request MUST include at least the name of the initialization file to be used  (i.e.    */
    /* the "pdl-init-file-location" or directory containing the initialization file need not be supplied by */
    /* the client and in fact, might not be known to the client).  The client can supply a                  */
    /* "pdl-init-file-name" attribute value that is either a simple file name or a relative path where      */
    /* each component of the path is separated by a FORWARD SLASH ("/") character.  The                     */
    /* "pdl-init-file-name" member attribute value  concatenated with the "pdl-init-file-location"          */
    /* attribute value (supplying a "/" between them, if necessary) specifies the initialization file to be */
    /* used.  For example, if "pdl-init-file-location" is 'a/b' or 'a/b/' and   "pdl-init-file-name" is     */
    /* 'c/d', the resulting file path is: 'a/b/c/d'.                                                        */
    /*                                                                                                      */
    /* 7.10.1.2.1 pdl-init-file-name-supported (1setOf name(MAX))                                           */
    /* The "pdl-init-file-name-supported (1setOf name(MAX))" Printer attribute specifies the name(s) of the */
    /* supported initialization file(s) that the client MAY ask the Printer to send to its PDL interpreter  */
    /* prior to processing the document.                                                                    */
    /*                                                                                                      */
    /* 7.10.1.2.2 pdl-init-file-name-subdirectory-supported (boolean)                                       */
    /* The "pdl-init-file-name-subdirectory-supported" (boolean) Printer Description attribute indicates    */
    /* whether or not the Printer will accept a FORWARD SLASH ("/") character in the value of the           */
    /* "pdl-init-file-name" member attribute.  If the value is 'false' and the client supplies a            */
    /* FORWARD-SLASH ("/") in the "save-name" value, the Printer MUST reject the request and return the     */
    /* 'client-error-attributes-or-values-not-supported'.                                                   */
    /*                                                                                                      */
    /* 7.10.1.3 pdl-init-file-entry (name(MAX))                                                             */
    /* This member attribute is an optional member of the collection that if present specifies an entry     */
    /* point within the init file that the PDL interpreter starts at.                                       */
    /*                                                                                                      */
    /* 7.10.1.3.1 pdl-init-file-entry-supported (1setOf name(MAX))                                          */
    /* The "pdl-init-file-entry-supported (1setOf name(MAX))" Printer attribute specifies the name(s) of    */
    /* the supported initialization file(s) that the client MAY ask the Printer to send to its PDL          */
    /* interpreter prior to processing the document.                                                        */
    /*                                                                                                      */
    /* 7.10.2 pdl-init-file-default  (1setOf collection)                                                    */
    /* pdl-init-file-default (1setOf collection): The "pdl-init-file-default" Printer attribute collection  */
    /* specifies the default initialization file (or list of files) and related information that the        */
    /* Printer will use if the client omits the "pdl-init-file" Job Template attribute in a Job Creation    */
    /* operation.  The member attributes are defined in Table 11.  A Printer MUST support the same member   */
    /* attributes and values for this default collection attribute as it supports for the corresponding     */
    /* "pdl-init-file" Job Template attribute.                                                              */
    /*                                                                                                      */
    /* A "pdl-init-file-name" within "pdl-init-file-default" collection with a "0 length value" will be     */
    /* used to indicate that Printer has no default initialization file (see description of "none" values   */
    /* in Section 2.7 in [PWG5100.3]).                                                                      */
    /*                                                                                                      */
    /* 7.10.3 pdl-init-file-supported  (1setOf type2 keyword)                                               */
    /* pdl-init-file-supported (1setOf type2 keyword):  The "pdl-init-file-supported" Printer attribute     */
    /* identifies the keyword names of the member attributes supported in the "pdl-init-file" collection    */
    /* Job Template attribute, i.e., the keyword names of the member attributes in Table 11 that the        */
    /* Printer supports.                                                                                    */
    /*                                                                                                      */
    /* ==================================================================================================== */
typedef struct __pwgPdlInitFile {
    pwgCHAR   locationUri[pwgMAX_URI_SIZE];           /* Path to dir for init file of the PDL interpreter   */
    pwgCHAR   name[pwgMAX_PDL_INIT_FILE_NAME];        /* Name of the PDL interpreter's initialization file  */
    pwgCHAR   entry[pwgMAX_PDL_INIT_FILE_ENTRY];      /* Entry point in init file to start PDL interpreter  */

    VND_PDL_INIT_FIL_STRUCT

} pwgPdlInitFile;

typedef struct {
    pwgINFO_DEF*  locationUri;                        /* Path to dir for init file of the PDL interpreter   */
    pwgINFO_DEF*  name;                               /* Name of the PDL interpreter's initialization file  */
    pwgINFO_DEF*  entry;                              /* Entry point in init file to start PDL interpreter  */

    VND_PDL_INIT_FIL_DEF_STRUCT

        pwgVOID*  last;
} pwgPdlInitFileDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern  pwgINFO_DEF pwgDef_LocationUri;

extern  pwgINFO_DEF pwgDef_Name;

extern  pwgINFO_DEF pwgDef_Entry;

extern  pwgPdlInitFileDefLst pwgPdlInitFileDefElem;
extern  pwgSTRUCT_DEF        pwgDef_PdlInitFile;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_3_PDL_INIT_FILE_H__                                                                */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* =================================== pwg.pjt.pdp.3.pdl.init.file.h ====================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
