/* ========================= pwg.pjt.pdp.3.presentation.direction.number.up.h ============================= */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_3_PRESENTATION_DIRECTION_NUMBER_UP_H__
#define __PWG_PJT_PDP_3_PRESENTATION_DIRECTION_NUMBER_UP_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Presentation Direction Number Up                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 57] PresentationDirectionNumberUp  */
/* -----------------                                                                                        */
/* Specifies the placement order of the page images on a Finished-Page Image with the "number-up" element.  */
/* [PWG5100.3] §3.17                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*       §3.17 [page 51-54] presentation-direction-number-up (type2 keyword)                            */
    /* -----------------                                                                                    */
    /* This attribute specifies the order that the Printer places page images on a Finished-Page Image with */
    /* the "number-up" attribute. This attribute is especially useful to control the presentation direction */
    /* in languages or multi-lingual documents that have more than one presentation direction, but may be   */
    /* used with any language. For example of the former, in Japanese text on pages can have a presentation */
    /* direction that is either top-to-bottom-right-to-left or left-to-right-top-to-bottom.  For an example */
    /* of the latter, a mixed English and Hebrew document, text on pages can have a presentation direction  */
    /* that is either left-to-right-top-to-bottom or right-to-left-top-to-bottom.  This attribute allows    */
    /* the client to specify the placement of page images on Finished-Page Images to mirror the direction   */
    /* of the text on pages.                                                                                */
    /*                                                                                                      */
    /* Each keyword value that a client supplies for this attribute MUST be a value of the                  */
    /* "presentation-direction-number-up-supported (1setOf type2 keyword)" attribute. Table 13 below shows  */
    /* the standard values. A Printer MUST support at least one of value of Table 13. It MAY support any    */
    /* additional values from Table 13.                                                                     */
    /*                                                                                                      */
    /* Table 13 shows the 8 standard values for this attribute. The name of each attribute value suggests   */
    /* the order of laying out page images on a Finished-Page Image when a human reader is holding the      */
    /* sheet in the proper orientation (i.e., oriented so text is oriented for normal reading). For each    */
    /* ‘toxxx-toyyy’ value, the images are placed according to the ‘toxxx’ direction, and then according to   */
    /* the ‘toyyy’ direction, and the first image is placed in the corner diagonally opposite the ‘xxx-yyy’   */
    /* corner.  For example, 'toright-tobottom' starts in the upper-left corner (which is diagonally        */
    /* opposite the ‘right-bottom’ corner). The images are placed from left to right in a line, and the line */
    /* progression is from top to bottom.                                                                   */
    /*                                                                                                      */
    /* Table 13 has a separate column to show the order for each orientation. For example, if the           */
    /* orientation is 'landscape', then the order of pages appears to be the same as portrait if the viewer */
    /* rotates the sheet 90 degrees clockwise.  Note: the coordinate system for this attribute is relative  */
    /* to the orientation of the sheets, unlike other Job Template attributes, such as "finishings",        */
    /* "finishing-col" (see section 3.2), and the image shifting attributes (see section 3.19) which are    */
    /* absolute (i.e., as if the sheets were 'portrait' - see section 2.3).  The reason that this attribute */
    /* has a relative coordinate system, is that the client may not know what the orientation of the        */
    /* document actually is, especially if the client did not generate the document.                        */
    /*                                                                                                      */
    /* The Printer determines the orientation in the following way:                                         */
    /*                                                                                                      */
    /* 1)	The value of the "orientation-requested" attribute is determined as follows:                      */
    /*      a) If the client supplies the "orientation-requested" attribute, that attribute specifies the   */
    /*         orientation.                                                                                 */
    /*      b) If the client doesn't supply the "orientation-requested" attribute and the Printer is able   */
    /*         to determine the orientation by inspecting the document, that is the orientation.            */
    /*      c) If the client doesn't supply the "orientation-requested" attribute and the Printer is not    */
    /*         able to determine the orientation by inspecting the document, the orientation is the value   */
    /*         specified by the "orientation-requested-default" Printer attribute.                          */
    /* 2) The value of orientation used by the "presentation-direction-number-up" attribute for laying out  */
    /*    pages on the Finished-Page Image is as follows:                                                   */
    /*      a) If the value of the "number-up" attribute is a power of 4, e.g. 1 and 4, the value from      */
    /*         step 1 is the value.                                                                         */
    /*      b) If the value of the "number-up" attribute is 2 times the power of 4, e.g. 2 and 8, the value */
    /*         is:                                                                                          */
    /*            i)   'landscape'         if the value from step 1 is 'portrait'                           */
    /*            ii)  'portrait'          if the value from step 1 is 'landscape'                          */
    /*            iii) 'reverse-landscape' if the value from step 1 is 'reverse-portrait                    */
    /*            iv)  'reverse-portrait'  if the value from step 1 is 'reverse-landscape'                  */
    /*      c) If the value of "number-up" is any other value, e.g. 3, 6 or 12, the value is                */
    /*         IMPLEMENTATION DEFINED.                                                                      */
    /*                                                                                                      */
    /* When a Printer lays out page images for a Finished-Page Image, the "presentation-direction-number-up"*/
    /* attribute determines the order of laying out each page and the frame of reference for that order is  */
    /* specified by the  orientation determined from the above algorithm. For example, if the value of      */
    /* "presentation-direction-number-up" is 'toright-tobottom' (English order), the Printer lays out 4     */
    /* page images in the order of top-left, top-right, bottom-left and bottom-right in the frame of        */
    /* reference specified by the determined orientation. The top row of Table 13 shows this sample         */
    /* presentation direction.                                                                              */
    /*                                                                                                      */
    /* If the Printer supports the "page-order-received" attribute and the value of the attribute is        */
    /* 'n-to-1-order', then the Printer MUST place the pages in reverse order on each Finished-Page Image.  */
    /* For example, if the "number-up" attribute has the value of 4, the first page of each Finished-Page   */
    /* Image is placed in the position labeled "4" in Table 13. If a Printer knows the number of pages in   */
    /* the document, it MUST treat the first Finished-Page Image as the logical last Finished-Page Image    */
    /* and place the first page according to the following formula:                                         */
    /*                                                                                                      */
    /* P = ((N-1) mod n) + 1                                                                                */
    /*                                                                                                      */
    /* Where P is the number of pages on the logical last Finished-Page Image (first Finished-Page Image    */
    /* printed).                                                                                            */
    /* Where N is the number of pages in the document.                                                      */
    /* Where n is the value of the "number-up" attribute.                                                   */
    /*                                                                                                      */
    /* On the logical last Finished-Page Image (first Finished-Page Image printed), the Printer MUST put    */
    /* the first page at position ‘P’ on the Finished-Page Image.                                            */
    /*                                                                                                      */
    /* A pictorial representation of each "presentation-direction-number-up" value for a "number-up" value  */
    /* of 4 and the orientation as shown below:                                                             */
    /*                                                                                                      */
    /*          Table 13 - Standard Values for the "presentation direction" Attribute                       */
    /*                                                                                                      */
    /* +===================+===================+===================+===================+===================+*/
    /* | Value	           |  Portrait         | Landscape         | Reverse-Landscape |  Reverse-Portrait |*/
    /* +===================+===================+===================+===================+===================+*/
    /* |'toright-tobottom' | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   11  !  222  ! | !  2  2 !   4   ! | ! 3   3 !       ! | !  4    !  3333 ! |*/
    /* |                   | !  1 1  ! 2   2 ! | ! 2 2 2 ! 44444 ! | ! 3 3 3 !    1  ! | !  4    ! 3     ! |*/
    /* |                   | !    1  !    2  ! | ! 2  22 !  444  ! | ! 3 3 3 !     1 ! | ! 44444 !  333  ! |*/
    /* |                   | !    1  !  22   ! | ! 2  22 !   44  ! | ! 3 3 3 ! 11111 ! | !  444  ! 3     ! |*/
    /* |                   | !    1  ! 22222 ! | !  2  2 !    4  ! | !  3 3  !       ! | !  44   !  3333 ! |*/
    /* |                   | +,......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | ! 3333  !   44  ! | !       !  3 3  ! | !   4   ! 2  2  ! | ! 22222 !  1    ! |*/
    /* |                   | !     3 !  444  ! | ! 11111 ! 3 3 3 ! | !   44  ! 22  2 ! | !   22  !  1    ! |*/
    /* |                   | !  333  ! 44444 ! | ! 1     ! 3 3 3 ! | !   444 ! 22  2 ! | !  2    !  1    ! |*/
    /* |                   | !     3 !    4  ! | !  1    ! 3 3 3 ! | ! 44444 ! 2 2 2 ! | ! 2   2 !  1 1  ! |*/
    /* |                   | ! 3333  !    4  ! | !       ! 3   3 ! | !   4   ! 2  2  ! | !  222  !  11   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'tobottom-toright' | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   11  ! 3333  ! | !  3 3  !   4   ! | !  2  2 !       ! | !  4    ! 22222 ! |*/
    /* |                   | !  1 1  !     3 ! | ! 3 3 3 ! 44444 ! | ! 22  2 !    1  ! | !  4    !   22  ! |*/
    /* |                   | !    1  !  333  ! | ! 3 3 3 ! 444   ! | ! 22  2 !     1 ! | ! 44444 !  2    ! |*/
    /* |                   | !    1  !     3 ! | ! 3 3 3 !  44   ! | ! 2 2 2 ! 11111 ! | !  444  ! 2   2 ! |*/
    /* |                   | !    1  ! 3333  ! | ! 3   3 !   4   ! | ! 2  2  !       ! | !  44   !  222  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !  222  !   44  ! | !       !  2  2 ! | !   4   ! 3   3 ! | !  3333 !  1    ! |*/
    /* |                   | ! 2   2 !  444  ! | ! 11111 ! 2 2 2 ! | !   44  ! 3 3 3 ! | ! 3     !  1    ! |*/
    /* |                   | !    2  ! 44444 ! | ! 1     ! 2  22 ! | !   444 ! 3 3 3 ! | !  333  !  1    ! |*/
    /* |                   | !  22   !    4  ! | !   1   ! 2  22 ! | ! 44444 ! 3 3 3 ! | ! 3     !  1 1  ! |*/
    /* |                   | ! 22222 !    4  ! | !          2  2 ! | !   4   !  3 3  ! | !  3333 !  11   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'toleft-tobottom'  | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !  222  !   11  ! | !       !  3 3  ! | !   4   ! 2  2  ! | !  3333 !  4    ! |*/
    /* |                   | ! 2   2 !  1 1  ! | ! 11111 ! 3 3 3 ! | !   44  ! 22  2 ! | ! 3     !  4    ! |*/
    /* |                   | !    2  !    1  ! | ! 1     ! 3 3 3 ! | !   444 ! 22  2 ! | !  333  ! 44444 ! |*/
    /* |                   | !  22   !    1  ! | !  1    ! 3 3 3 ! | ! 44444 ! 2 2 2 ! | ! 3     !  444  ! |*/
    /* |                   | ! 22222 !    1  ! | !       ! 3   3 ! | !   4   ! 2  2  ! | !  3333 !  44   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   44  ! 3333  ! | !  2  2 !   4   ! | ! 3   3 !       ! | !  1    ! 22222 ! |*/
    /* |                   | !  444  !     3 ! | ! 2 2 2 ! 44444 ! | ! 3 3 3 !    1  ! | !  1    !   22  ! |*/
    /* |                   | ! 44444 ! 333   ! | ! 2  22 ! 444   ! | ! 3 3 3 !     1 ! | !  1    !  2    ! |*/
    /* |                   | !    4  !     3 ! | ! 2  22 !  44   ! | ! 3 3 3 ! 11111 ! | !  1 1  ! 2   2 ! |*/
    /* |                   | !    4  ! 3333  ! | !  2  2 !   4   ! | !  3 3  !       ! | !  11   !  222  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'tobottom-toleft'  | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | ! 3333  !   11  ! | !       !  2  2 ! | !   4   ! 2  2  ! | ! 22222 !  4    ! |*/
    /* |                   | !     3 !  1 1  ! | ! 11111 ! 2 2 2 ! | !   44  ! 22  2 ! | !   22  !  4    ! |*/
    /* |                   | !  333  !    1  ! | ! 1     ! 2  22 ! | !   444 ! 22  2 ! | !  2    ! 44444 ! |*/
    /* |                   | !     3 !    1  ! | !   1   ! 2  22 ! | ! 44444 ! 2 2 2 ! | ! 2   2 ! 444   ! |*/
    /* |                   | ! 3333  !    1  ! | !       !  2  2 ! | !  4    ! 2  2  ! | !  222  ! 44    ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   44  !  222  ! | !  3 3  !   4   ! | ! 3   3 !        ! | !  1   ! 3333  ! |*/
    /* |                   | !  444  ! 2   2 ! | ! 3 3 3 ! 44444 ! | ! 3 3 3 !    1   ! | !  1   !     3 ! |*/
    /* |                   | ! 44444 !    2  ! | ! 3 3 3 ! 444   ! | ! 3 3 3 !     1  ! | !  1   !  333  ! |*/
    /* |                   | !    4  !  22   ! | ! 3 3 3 !  44   ! | ! 3 3 3 ! 11111  ! | !  1 1 !     3 ! |*/
    /* |                   | !    4  ! 22222 ! | ! 3   3 !   4   ! | !  3 3  !        ! | !  11  ! 3333  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'toright-totop'    | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | ! 3333  !   44  ! | !   4   !  2  2 ! | !       ! 3   3 ! | ! 22222 !  1    ! |*/
    /* |                   | !     3 !  444  ! | ! 44444 ! 2 2 2 ! | !    1  ! 3 3 3 ! | !   22  !  1    ! |*/
    /* |                   | !  333  ! 44444 ! | ! 444   ! 2  22 ! | !     1 ! 3 3 3 ! | !  2    !  1    ! |*/
    /* |                   | !     3 !    4  ! | !  44   ! 2  22 ! | ! 11111 ! 3 3 3 ! | ! 2   2 !  1 1  ! |*/
    /* |                   | ! 3333  !    4  ! | !   4   !  2  2 ! | !       !  3 3  ! | !  222  !  11   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   11  !  222  ! | !  3 3  !       ! | ! 2  2  !   4   ! | !  4    ! 3333  ! |*/
    /* |                   | !  1 1  ! 2   2 ! | ! 3 3 3 ! 11111 ! | ! 22  2 !   44  ! | !  4    !     3 ! |*/
    /* |                   | !    1  !    2  ! | ! 3 3 3 ! 1     ! | ! 22  2 !   444 ! | ! 44444 !  333  ! |*/
    /* |                   | !    1  !  22   ! | ! 3 3 3 !  1    ! | ! 2 2 2 ! 44444 ! | !  444  !     3 ! |*/
    /* |                   | !    1  ! 22222 ! | ! 3   3 !       ! | ! 2  2  !   4   ! | !  44   ! 3333  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'totop-toright'    | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !  222  !   44  ! | !   4   !  3 3  ! | !       ! 2  2  ! | ! 3333  !  1    ! |*/
    /* |                   | ! 2   2 !  444  ! | ! 44444 ! 3 3 3 ! | !  1    ! 22  2 ! | !     3 !  1    ! |*/
    /* |                   | !    2  ! 44444 ! | ! 444   ! 3 3 3 ! | ! 1     ! 22  2 ! | !  333  !  1    ! |*/
    /* |                   | !  22   !    4  ! | !  44   ! 3 3 3 ! | ! 11111 ! 2 2 2 ! | !     3 !  1 1  ! |*/
    /* |                   | ! 22222 !    4  ! | !   4   ! 3   3 ! | !       ! 2  2  ! | ! 3333  !  11   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   11  ! 3333  ! | !  2  2 !       ! | ! 3   3 !   4   ! | !  4    ! 22222 ! |*/
    /* |                   | !  1 1  !     3 ! | ! 2 2 2 ! 11111 ! | ! 3 3 3 !   44  ! | !  4    !   22  ! |*/
    /* |                   | !    1  !  333  ! | ! 2  22 ! 1     ! | ! 3 3 3 !   444 ! | ! 44444 !  2    ! |*/
    /* |                   | !    1  !     3 ! | ! 2  22 !  1    ! | ! 3 3 3 ! 44444 ! | !  444  ! 2   2 ! |*/
    /* |                   | !    1  ! 3333  ! | !  2  2 !       ! | !  3 3  !   4   ! | !  44   !  222  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'toleft-totop'     | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   44  ! 3333  ! | !  3 3  !       ! | ! 2  2  !   4   ! | !  1    ! 22222 ! |*/
    /* |                   | !  444  !     3 ! | ! 3 3 3 ! 11111 ! | ! 22  2 !   44  ! | !  1    !   22  ! |*/
    /* |                   | ! 44444 !  333  ! | ! 3 3 3 ! 1     ! | ! 22  2 !   444 ! | !  1    !  2    ! |*/
    /* |                   | !    4  !     3 ! | ! 3 3 3 !  1    ! | ! 2 2 2 ! 44444 ! | !  1 1  ! 2   2 ! |*/
    /* |                   | !    4  ! 3333  ! | ! 3   3 !       ! | ! 2  2  !   4   ! | !  11   !  222  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !  222  !   11  ! | !   4   !  2  2 ! | !       ! 3   3 ! | ! 3333  !  4    ! |*/
    /* |                   | ! 2   2 !  1 1  ! | ! 44444 ! 2 2 2 ! | !  1    ! 3 3 3 ! | !     3 !  4    ! |*/
    /* |                   | !    2  !    1  ! | ! 444   ! 2  22 ! | ! 1     ! 3 3 3 ! | !  333  ! 44444 ! |*/
    /* |                   | !  22   !    1  ! | !  44   ! 2  22 ! | ! 11111 ! 3 3 3 ! | !     3 !  444  ! |*/
    /* |                   | ! 22222 !    1  ! | !   4   !  2  2 ! | !       !  3 3  ! | ! 3333  !  44   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /* |'totop-toleft'     | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | !   44  !  222  ! | !  2  2 !       ! | ! 3   3 !   4   ! | !  1    ! 3333  ! |*/
    /* |                   | !  444  ! 2   2 ! | ! 2 2 2 ! 11111 ! | ! 3 3 3 !   44  ! | !  1    !     3 ! |*/
    /* |                   | ! 44444 !    2  ! | ! 2  22 ! 1     ! | ! 3 3 3 !   444 ! | !  1    !  333  ! |*/
    /* |                   | !    4  !  22   ! | ! 2  22 !  1    ! | ! 3 3 3 ! 44444 ! | !  1 1  !     3 ! |*/
    /* |                   | !    4  ! 22222 ! | !  2  2 !       ! | !  3 3  !   4   ! | !  11   ! 3333  ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* |                   | ! 3333  !   11  ! | !   4   !  3 3  ! | !       ! 2  2  ! | ! 22222 !  4    ! |*/
    /* |                   | !     3 !  1 1  ! | ! 44444 ! 3 3 3 ! | !  1    ! 22  2 ! | !   22  !  4    ! |*/
    /* |                   | !  333  !    1  ! | ! 444   ! 3 3 3 ! | ! 1     ! 22  2 ! | !  2    ! 44444 ! |*/
    /* |                   | !     3 !    1  ! | !  44   ! 3 3 3 ! | ! 11111 ! 2 2 2 ! | ! 2   2 !  444  ! |*/
    /* |                   | ! 3333  !    1  ! | !   4   ! 3   3 ! | !       ! 2  2  ! | !  222  !  44   ! |*/
    /* |                   | +.......+.......+ | +.......+.......+ | +.......+.......+ | +.......+.......+ |*/
    /* +-------------------+-------------------+-------------------+-------------------+-------------------+*/
    /*                                                                                                      */
    /* ==================================================================================================== */
typedef enum {
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_RESERVED_0 = 0,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_RESERVED_1 = 1,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_UNKNOWN    = 2,

    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_RIGHT_TO_BOTTOM,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_BOTTOM_TO_RIGHT,

    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_LEFT_TO_BOTTOM,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_BOTTOM_TO_LEFT,

    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_RIGHT_TO_TOP,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_TOP_TO_RIGHT,

    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_LEFT_TO_TOP,
    PWG_PRESENTATION_DIRECTION_NUMBER_UP_TO_TOP_TO_LEFT,

    VND_PRES_DIR_NUM_UP_ENUM

    PWG_PRESENTATION_DIRECTION_NUMBER_UP_END
} pwgPresentationDirectionNumberUpEnum, pwgPresDirNumUpEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgPresentationDirectionNumberUp_Keywords[];
extern         pwgCHAR* pwgPresentationDirectionNumberUp_KWValues[];
extern         pwgBIT8  pwgPresentationDirectionNumberUp_KWVLevel[];
extern         pwgBOOL  pwgPresentationDirectionNumberUp_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_PresDirNumUp;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_3_PRESENTATION_DIRECTION_NUMBER_UP_H__                                             */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ========================= pwg.pjt.pdp.3.presentation.direction.number.up.h ============================= */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
