/* ============================= pwg.pjt.pjd.1.document.charset.supplied.h ================================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJD_1_DOCUMENT_CHARSET_SUPPLIED_H__
#define __PWG_PJT_PJD_1_DOCUMENT_CHARSET_SUPPLIED_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Document Charset Supplied                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* Reference Tree                                                                                           */
/*    SM20                                                                                                  */
/*      5100.7: 5.2.2                                                                                       */
/*        5100.7: 3.2.2                                                                                     */
/*          2911: 13.1.4.14                                                                                 */
/*            2911: 3.1.4.1                                                                                 */
/*              2911: 4.1.1                                                                                 */
/*                2911: 3.1.4                                                                               */
/*                2911: 4.3.20                                                                              */
/*                2911: 3.1.4 (dup)                                                                         */
/*              2911: 4.1.2                                                                                 */
/*              2911: 3.1.7                                                                                 */
/*                2911: 3.1.6.1                                                                             */
/*                  2911: 4.1                                                                               */
/*                    2911: 4.2                                                                             */
/*                       starting cyclic references.                                                        */
/*                    2911: 4.3                                                                             */
/*                       starting cyclic references.                                                        */
/*                    2911: 4.4                                                                             */
/*                       starting cyclic references.                                                        */
/*                  2911: 13.                                                                               */
/*                    2911: This is huge section; not possible to break down further.                       */
/*                  2911: 3.1.7 (dup)                                                                       */
/*                2911: 4.1 (dup)                                                                           */
/*                2911: 3.2.1.2 (dup)                                                                       */
/*                2911: 15.                                                                                 */
/*                    2911: This is huge section; not possible to break down further.                       */
/*              2911: 3.2.1.2                                                                               */
/*                2911: 13. (dup)                                                                           */
/*                2911: 3.1.6                                                                               */
/*                    2911: 4.1 (dup)                                                                       */
/*                    2911: 13. (dup)                                                                       */
/*                    2911: 3.17 (dup)                                                                      */
/*                    2911: 4.1.1 (dup)                                                                     */
/*                    2911: 3.1.4.1 (dup)                                                                   */
/*                    2911: 4.1.1 (dup)                                                                     */
/*                    2911: 3.1.6.4                                                                         */
/*                      2911: 3.2.2 (dup)                                                                   */
/*                2911: 3.1.4.2                                                                             */
/*                    2911: 3.1.4.1 (dup)                                                                   */
/*                    2911: 4.1.1.2                                                                         */
/*                      2910: 3.9                                                                           */
/*              2911: 4.4.18                                                                                */
/*                2911: 3.1.4.2 (dup)                                                                       */
/*              2911: 4.1.7                                                                                 */
/*              2911: 4.1.8                                                                                 */
/*              2911: 3.1.6 (dup)                                                                           */
/*              2911: 4.4.19                                                                                */
/*                2911: 3.1.4.1 (dup)                                                                       */
/*              2911: 4.1.1.2 (dup)                                                                         */
/*              2911: 4.1.2.2                                                                               */
/*                2911: 4.1.8 (dup)                                                                         */
/*                2910: 3.9 (dup)                                                                           */
/*              2911: 4.1.1 (dup)                                                                           */
/*              2911: 4.1.2 (dup)                                                                           */
/*              2911: 4.1.1.1                                                                               */
/*                2911: 4.1.7 (dup)                                                                         */
/*              2911: 4.1.2.1                                                                               */
/*              2911: 4.1.1.2 (dup)                                                                         */
/*              2911: 4.1.2.2 (dup)                                                                         */
/*              2911: 3.1.4.2 (dup)                                                                         */
/*                2911: 3.1.4.1 (dup)                                                                       */
/*                2911: 4.1.1.2 (dup)                                                                       */
/*                2911: 4.1.2.2 (dup)                                                                       */
/*            2911: 3.1.6.1 (dup)                                                                           */
/*            2911: 3.1.7 (dup)                                                                             */
/*          2911: 4.1.9                                                                                     */
/*          5100.7: 7.1                                                                                     */
/*          5100.7: 7.2                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
/* Reduced Reference Tree                                                                                   */
/*    SM20                                                                                                  */
/*      5100.7: 5.2.2                                                                                       */
/*        5100.7: 3.2.2                                                                                     */
/*          2911: 13.1.4.14                                                                                 */
/*            2911: 3.1.4.1                                                                                 */
/*              2911: 4.1.1                                                                                 */
/*                2911: 3.1.4                                                                               */
/*                2911: 4.3.20 xxx                                                                          */
/*              2911: 4.1.2 xxx                                                                             */
/*              2911: 3.1.7  xxx                                                                            */
/*                2911: 3.1.6.1 xxx                                                                         */
/*                  2911: 4.1   xxx                                                                         */
/*                    2911: 4.2 xxx                                                                         */
/*                    2911: 4.3 xxx                                                                         */
/*                    2911: 4.4 xxx                                                                         */
/*                  2911: 13.   xxx                                                                         */
/*                2911: 15. xxx                                                                             */
/*              2911: 3.2.1.2 xxx                                                                           */
/*                2911: 3.1.6  xxx                                                                          */
/*                    2911: 3.1.6.4 xxx                                                                     */
/*                2911: 3.1.4.2 xxx                                                                         */
/*                    2911: 4.1.1.2 xxx                                                                     */
/*                      2910: 3.9 xxx                                                                       */
/*              2911: 4.4.18                                                                                */
/*              2911: 4.1.7                                                                                 */
/*              2911: 4.1.8 xxx                                                                             */
/*              2911: 4.4.19 xxx                                                                            */
/*              2911: 4.1.2.2 xxx                                                                           */
/*              2911: 4.1.1.1 xxx                                                                           */
/*              2911: 4.1.2.1 xxx                                                                           */
/*          2911: 4.1.9                                                                                     */
/*          5100.7: 7.1                                                                                     */
/*          5100.7: 7.2                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
/* Final Reference Tree: Remove data not needed for understanding                                           */
/*    SM20                                                                                                  */
/*      5100.7: 5.2.2                                                                                       */
/*        5100.7: 3.2.2                                                                                     */
/*          2911: 13.1.4.14                                                                                 */
/*            2911: 3.1.4.1                                                                                 */
/*              2911: 4.1.1                                                                                 */
/*                2911: 3.1.4                                                                               */
/*              2911: 4.4.18                                                                                */
/*              2911: 4.1.7                                                                                 */
/*          2911: 4.1.9                                                                                     */
/*          5100.7: 7.1                                                                                     */
/*          5100.7: 7.2                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 43] DocumentCharsetSupplied        */
/* -----------------                                                                                        */
/* Default charset of the Documents content.                                                                */
/*        Values: CharsetWKV, StringExtensionPattern  (e.g., utf-8, iso-10646-unicode-latin1)               */
/* [PWG5100.7] §5.2.2                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                     */
    /*                                   Standard for The Internet Printing Protocol (IPP): Job Extensions  */
    /*          §5.2.2 [page 27] document-charset-supplied (charset)                                        */
    /* -----------------                                                                                    */
    /* This OPTIONAL Job Description attribute specifies the default charset used to represent this         */
    /* document (see section 3.2.2).  The Printer sets this Job Description attribute from the              */
    /* corresponding Operation attribute supplied by the client in the Job Creation operation.              */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                 */
        /*                               Standard for The Internet Printing Protocol (IPP): Job Extensions  */
        /*          §3.2.2 [page 13-14] document-charset (charset)                                          */
        /* -----------------                                                                                */
        /* This OPTIONAL Operation attribute identifies the charset of the Document Content.  This          */
        /* Operation attribute is intended to be supported by Printers that support a document-format in    */
        /* which the charset may be ambiguous in the Document content, such as 'application/vnd.hp-PCL',    */
        /* where the charset escape sequence MAY be omitted from the data.                                  */
        /*                                                                                                  */
        /* If a client supplies the "document-charset" Operation attribute in a Document Creation operation */
        /* with a value that the Printer doesn't support, the Printer MUST reject the job and return the    */
        /* status code: 'client-error-charset-not-supported' (see [rfc2911] section 3.1.4.14), since the    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                                                                   ^^^^^^^^ 13.1.4.14      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /* interpretation of the content will be misunderstood by the Printer.                              */
        /*                                                                                                  */
        /* The standard values for these attributes are Internet Media types (sometimes called MIME types). */
        /* For further details see the description of the 'mimeMediaType' attribute syntax in [rfc2911]     */
        /* section 4.1.9.                                                                                   */
        /*                                                                                                  */
        /* The Printer MUST support this attribute if it supports a document format for which the Document  */
        /* Content can be ambiguous with respect to the charset being used to encode the data.  For example,*/
        /* the 'application/vnd.hp-PCL' MAY omit the charset escape sequence.  Although [rfc2854] strongly  */
        /* RECOMMENDS that 'text/html', include a "; charset=charset" parameter in the MIME type itself     */
        /* (that is, explicitly in the value of the "document-format" attribute), often the                 */
        /* charset=parameter is not present in the MIME type and the Printer MUST assume a charset.  Thus a */
        /* Printer that supports the text/html MIME type MUST support the "dcument-charset" operation       */
        /* attributes.  Also many text files use the various 8-bit ISO 8859 charsets in which the lower     */
        /* half is US-ASCII and the upper half is various Latin sets (about 8 or 9), Greek, Cyrillic,       */
        /* Hebrew, and Arabic.  Shift JIS is another example where the left half is US-ASCII, but the right */
        /* half can be one of a number of things.  But if the data doesn't contain the charset escape       */
        /* sequences, this attribute can help the Printer know what the charset is in the Document.  Such   */
        /* document formats are called "charset-ambiguous" document formats.  Finally, even though          */
        /* [rfc2046] REQUIRES the "; charset=" MIME type parameter if the file contains other than US-ASCII,*/
        /* in practice, the "; charset=" MIME type parameter is often omitted, thus making 'text/plain' a   */
        /* charset-ambiguous document format.  See the discussion in [rfc2911] section 4.1.9 and [rfc2046]. */
        /*                                                                                                  */
        /* The Printer MAY also check the Document content while processing to see that the document data   */
        /* meets the coding requirements for the supplied charset.  If the data contains something that is  */
        /* outside the charset encoding, the Printer MUST either (1) hold the job or (2) abort, and         */
        /* SHOULD NOT continue printing square boxes for encoded characters that are outside the charset    */
        /* supplied by the client.                                                                          */
        /*                                                                                                  */
        /* Many other document formats, such as "application/postscript" and "application/pdf", are not     */
        /* charset-ambiguous, so that Printers that support only such formats MAY omit support of the       */
        /* "document-charset" Operation/ Description attributes.                                            */
        /*                                                                                                  */
        /* If the Printer supports the "document-charset" Operation attribute, it MUST also support the     */
        /* corresponding "document-charset-default" and "document-charset-supported" Printer Description    */
        /* attributes as well and vice versa (see sections 7.1 and 7.2).                                    */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §13.1.4.14 [page 183] client-error-charset-not-supported (0x040D)                       */
            /* -----------------                                                                            */
            /* For any operation, if the IPP Printer does not support the charset supplied by the client in */
            /* the "attributes-charset" operation attribute, the Printer MUST reject the operation and      */
            /* return this status and any 'text' or 'name' attributes using the 'utf-8' charset (see        */
            /* Section 3.1.4.1).  See sections 3.1.6.1 and  3.1.7.                                          */
            /*                                                                                              */
            /* ============================================================================================ */
                /* [rfc2911] September 2000: Standards Track                                                */
                /*                              Internet Printing Protocol/1.1: Model and Semantics         */
                /*      §3.1.4.1 [page 25-29] Request Operation Attributes                                  */
                /* -----------------                                                                        */
                /* The client MUST supply and the Printer object MUST support the following REQUIRED        */
                /* operation attributes in every IPP/1.1 operation request:                                 */
                /*                                                                                          */
                /* "attributes-charset" (charset):                                                          */
                /*      This operation attribute identifies the charset (coded character set and encoding   */
                /*      method) used by any 'text' and 'name' attributes that the client is supplying in    */
                /*      this request.  It also identifies the charset that the Printer object MUST use (if  */
                /*      supported) for all 'text' and 'name' attributes and status messages that the        */
                /*      Printer object returns in the response to this request. See Sections 4.1.1 and      */
                /*      4.1.2 for the definition of the 'text' and 'name' attribute syntaxes.               */
                /*                                                                                          */
                /*      All clients and IPP objects MUST support the 'utf-8' charset [RFC2279] and MAY      */
                /*      support additional charsets provided that they are registered with IANA [IANA-CS].  */
                /*      If the Printer object does not support the client supplied charset value, the       */
                /*      Printer object MUST reject the request, set the "attributes-charset" to 'utf-8' in  */
                /*      the response, and return the 'client-error-charset-not-supported' status code and   */
                /*      any 'text' or 'name' attributes using the 'utf-8' charset. The Printer NEED NOT     */
                /*      return any attributes in the Unsupported Attributes Group (See sections 3.1.7 and   */
                /*      3.2.1.2).  The Printer object MUST indicate the charset(s) supported as the values  */
                /*      of the "charset-supported" Printer attribute (see Section 4.4.18), so that the      */
                /*      client can query to determine which charset(s) are supported.                       */
                /*                                                                                          */
                /*      Note to client implementers: Since IPP objects are only required to support the     */
                /*      'utf-8' charset, in order to maximize interoperability with multiple IPP object     */
                /*      implementations, a client may want to supply 'utf-8' in the "attributes-charset"    */
                /*      operation attribute, even though the client is only passing and able to present a   */
                /*      simpler charset, such as US-ASCII [ASCII] or ISO-8859-1 [ISO8859-1].  Then the      */
                /*      client will have to filter out (or charset convert) those characters that are       */
                /*      returned in the response that it cannot present to its user.  On the other hand, if */
                /*      both the client and the IPP objects also support a charset in common besides utf-8, */
                /*      the client may want to use that charset in order to avoid charset conversion or     */
                /*      data loss.                                                                          */
                /*                                                                                          */
                /*      See the 'charset' attribute syntax description in Section 4.1.7 for the syntax and  */
                /*      semantic interpretation of the values of this attribute and for example values.     */
                /*                                                                                          */
                /* "attributes-natural-language" (naturalLanguage):                                         */
                /*      This operation attribute identifies the natural language used by any 'text' and     */
                /*      'name' attributes that the client is supplying in this request.  This attribute     */
                /*      also identifies the natural language that the Printer object SHOULD use for all     */
                /*      'text' and 'name' attributes and status messages that the Printer object returns in */
                /*      the response to this request.  See the 'naturalLanguage' attribute syntax           */
                /*      description in section 4.1.8 for the syntax and semantic interpretation of the      */
                /*      values of this attribute and for example values.                                    */
                /*                                                                                          */
                /*      There are no REQUIRED natural languages required for the Printer object to support. */
                /*      However, the Printer object's "generated-natural-language-supported" attribute      */
                /*      identifies the natural languages supported by the Printer object and any contained  */
                /*      Job objects for all text strings generated by the IPP object.  A client MAY query   */
                /*      this attribute to determine which natural language(s) are supported for generated   */
                /*      messages.                                                                           */
                /*                                                                                          */
                /*      For any of the attributes for which the Printer object generates text, i.e., for    */
                /*      the "job-state-message", "printer-state-message", and status messages (see          */
                /*      Section 3.1.6), the Printer object MUST be able to generate these text strings in   */
                /*      any of its supported natural languages.  If the client requests a natural language  */
                /*      that is not supported, the Printer object MUST return these generated messages in   */
                /*      the Printer's configured natural language as specified by the Printer's             */
                /*      "natural-language-configured" attribute" (see Section 4.4.19).                      */
                /*                                                                                          */
                /*      For other 'text' and 'name' attributes supplied by the client, authentication       */
                /*      system, operator, system administrator, or manufacturer (i.e., for                  */
                /*      "job-originating-user-name", "printer-name" (name), "printer-location" (text),      */
                /*      "printer-info" (text), and "printer-make-and-model" (text)), the Printer object is  */
                /*      only required to support the configured natural language of the Printer identified  */
                /*      by the Printer object's "natural-language-configured" attribute, though support of  */
                /*      additional natural languages for these attributes is permitted.                     */
                /*                                                                                          */
                /*      For any 'text' or 'name' attribute in the request that is in a different natural    */
                /*      language than the value supplied in the "attributes-natural-language" operation     */
                /*      attribute, the client MUST use the Natural Language Override mechanism (see         */
                /*      sections 4.1.1.2 and 4.1.2.2) for each such attribute value supplied.  The client   */
                /*      MAY use the Natural Language Override mechanism redundantly, i.e., use it even when */
                /*      the value is in the same natural language as the value supplied in the              */
                /*      "attributes-natural-language" operation attribute of the request.                   */
                /*                                                                                          */
                /*      The IPP object MUST accept any natural language and any Natural Language Override,  */
                /*      whether the IPP object supports that natural language or not (and independent of    */
                /*      the value of the "ipp-attribute-fidelity" Operation attribute).  That is the IPP    */
                /*      object accepts all client supplied values no matter what the values are in the      */
                /*      Printer object's "generated-natural-language-supported" attribute.  That attribute, */
                /*      "generated-natural-language-supported", only applies to generated messages, not     */
                /*      client supplied messages.  The IPP object MUST remember that natural language for   */
                /*      all client-supplied attributes, and when returning those attributes in response to  */
                /*      a query, the IPP object MUST indicate that natural language.                        */
                /*                                                                                          */
                /*      Each value whose attribute syntax type is 'text' or 'name' (see sections 4.1.1 and  */
                /*      4.1.2) has an Associated Natural-Language.  This document does not specify how this */
                /*      association is stored in a Printer or Job object.  When such a value is encoded in  */
                /*      a request or response, the natural language is either implicit or explicit:         */
                /*                                                                                          */
                /*            - In the implicit case, the value contains only the text/name value, and the  */
                /*              language is specified by the "attributes-natural-language" operation        */
                /*              attribute in the request or response                                        */
                /*              (see sections 4.1.1.1 textWithoutLanguage and  4.1.2.1 nameWithoutLanguage).*/
                /*                                                                                          */
                /*            - In the explicit case (also known as the Natural-Language Override case),    */
                /*              the value contains both the language and the text/name value (see           */
                /*              sections 4.1.1.2 textWithLanguage and 4.1.2.2 nameWithLanguage).            */
                /*                                                                                          */
                /*      For example, the "job-name" attribute MAY be supplied by the client in a create     */
                /*      request.  The text value for this attribute will be in the natural language         */
                /*      identified by the "attribute-natural-language" attribute, or if different, as       */
                /*      identified by the Natural Language Override mechanism.  If supplied, the IPP object */
                /*      will use the value of the "job-name" attribute to populate the Job object's         */
                /*      "job-name" attribute.  Whenever any client queries the Job object's "job-name"      */
                /*      attribute, the IPP object returns the attribute as stored and uses the Natural      */
                /*      Language Override mechanism to specify the natural language, if it is different     */
                /*      from that reported in the "attributes-natural-language" operation attribute of the  */
                /*      response.  The IPP object MAY use the Natural Language Override mechanism           */
                /*      redundantly, i.e., use it even when the value is in the same natural language as    */
                /*      the value supplied in the "attributes-natural-language" operation attribute of the  */
                /*      response.                                                                           */
                /*                                                                                          */
                /*      An IPP object MUST NOT reject a request based on a supplied natural language in an  */
                /*      "attributes-natural-language" Operation attribute or in any attribute that uses the */
                /*      Natural Language Override.                                                          */
                /*                                                                                          */
                /* Clients SHOULD NOT supply 'text' or 'name' attributes that use an illegal combination of */
                /* natural language and charset.  For example, suppose a Printer object supports charsets   */
                /* 'utf-8', 'iso-8859-1', and 'iso-8859-7'.  Suppose also, that it supports natural         */
                /* languages 'en'(English), 'fr' (French), and 'el' (Greek).  Although the Printer object   */
                /* supports the charset 'iso-8859-1' and natural language 'el', it probably does not        */
                /* support the combination of Greek text strings using the 'iso-8859-1' charset.  The       */
                /* Printer object handles this apparent incompatibility differently depending on the        */
                /* context in which it occurs:                                                              */
                /*                                                                                          */
                /*      - In a create request: If the client supplies a text or name attribute (for example,*/
                /*        the "job-name" operation attribute) that uses an apparently incompatible          */
                /*        combination, it is a client choice that does not affect the Printer object or its */
                /*        correct operation.  Therefore, the Printer object simply accepts the client       */
                /*        supplied value, stores it with the Job object, and responds back with the same    */
                /*        combination whenever the client (or any client) queries for that attribute.       */
                /*      - In a query-type operation, like Get-Printer-Attributes: If the client requests an */
                /*        apparently incompatible combination, the Printer object responds (as described in */
                /*        section 3.1.4.2) using the Printer's configured natural language rather than the  */
                /*        natural language requested by the client.                                         */
                /*                                                                                          */
                /* In either case, the Printer object does not reject the request because of the apparent   */
                /* incompatibility.  The potential incompatible combination of charset and natural language */
                /* can occur either at the global operation level or at the Natural Language Override       */
                /* attribute-by-attribute level.  In addition, since the response always includes explicit  */
                /* charset and natural language information, there is never any question or ambiguity in    */
                /* how the client interprets the response.                                                  */
                /*                                                                                          */
                /* ======================================================================================== */
                    /* [rfc2911] September 2000: Standards Track                                            */
                    /*                              Internet Printing Protocol/1.1: Model and Semantics     */
                    /*      §4.1.1 [page 79-80] 'text'                                                      */
                    /* -----------------                                                                    */
                    /* A text attribute is an attribute whose value is a sequence of zero or more           */
                    /* characters encoded in a maximum of 1023 ('MAX') octets.  MAX is the maximum length   */
                    /* for each value of any text attribute.  However, if an attribute will always contain  */
                    /* values whose maximum length is much less than MAX, the definition of that attribute  */
                    /* will include a qualifier that defines the maximum length for values of that          */
                    /* attribute.  For example:  the "printer-location" attribute is specified as           */
                    /* "printer-location (text(127))".  In this case, text values for "printer-location"    */
                    /* MUST NOT exceed 127 octets; if supplied with a longer text string via some external  */
                    /* interface (other than the protocol), implementations are free to truncate to this    */
                    /* shorter length limitation.                                                           */
                    /*                                                                                      */
                    /* In this document, all text attributes are defined using the 'text' syntax.  However, */
                    /* 'text' is used only for brevity; the formal interpretation of 'text' is:             */
                    /* 'textWithoutLanguage | textWithLanguage'.  That is, for any attribute defined in     */
                    /* this document using the 'text' attribute syntax, all IPP objects and clients MUST    */
                    /* support both the 'textWithoutLanguage' and 'textWithLanguage' attribute syntaxes.    */
                    /* However, in actual usage and protocol execution, objects and clients accept and      */
                    /* return only one of the two syntax per attribute.  The syntax 'text' never appears    */
                    /* "on-the-wire".                                                                       */
                    /*                                                                                      */
                    /* Both 'textWithoutLanguage' and 'textWithLanguage' are needed to support the real     */
                    /* world needs of interoperability between sites and systems that use different natural */
                    /* languages as the basis for human communication.  Generally, one natural language     */
                    /* applies to all text attributes in a given request or response. The language is       */
                    /* indicated by the "attributes-natural-language" operation attribute defined in        */
                    /* section 3.1.4 or "attributes-natural-language" job attribute defined in              */
                    /* section 4.3.20, and there is no need to identify the natural language for each text  */
                    /* string on a value-by-value basis.  In these cases, the attribute syntax              */
                    /* 'textWithoutLanguage' is used for text attributes.  In other cases, the client needs */
                    /* to supply or the Printer object needs to return a text value in a natural language   */
                    /* that is different from the rest of the text values in the request or response.  In   */
                    /* these cases, the client or Printer object uses the attribute syntax                  */
                    /* 'textWithLanguage' for text attributes (this is the Natural Language Override        */
                    /* mechanism described in section 3.1.4).                                               */
                    /*                                                                                      */
                    /* The 'textWithoutLanguage' and 'textWithLanguage' attribute syntaxes are described in */
                    /* more detail in the following sections.                                               */
                    /*                                                                                      */
                    /* ==================================================================================== */
                        /* [rfc2911] September 2000: Standards Track                                        */
                        /*                              Internet Printing Protocol/1.1: Model and Semantics */
                        /*      §3.1.4 [page 24-25] Character Set and Natural Language Operation Attributes */
                        /* -----------------                                                                */
                        /* Some Job and Printer attributes have values that are text strings and names      */
                        /* intended for human understanding rather than machine understanding (see the      */
                        /* 'text' and 'name' attribute syntax descriptions in section 4.1).  The following  */
                        /* sections describe two special Operation Attributes called "attributes-charset"   */
                        /* and "attributes-natural-language".  These attributes are always part of the      */
                        /* Operation Attributes group.  For most attribute groups, the order of the         */
                        /* attributes within the group is not important.  However, for these two attributes */
                        /* within the Operation Attributes group, the order is critical.  The               */
                        /* "attributes-charset" attribute MUST be the first attribute in the group and the  */
                        /* "attributes-natural-language" attribute MUST be the second attribute in the      */
                        /* group.  In other words, these attributes MUST be supplied in every IPP request   */
                        /* and response, they MUST come first in the group, and MUST come in the specified  */
                        /* order.  For job creation operations, the IPP Printer implementation saves these  */
                        /* two attributes with the new Job object as Job Description attributes.  For the   */
                        /* sake of brevity in this document, these operation attribute descriptions are not */
                        /* repeated with every operation request and response, but have a reference back to */
                        /* this section instead.                                                            */
                        /*                                                                                  */
                    /* ==================================================================================== */
                    /* [rfc2911] September 2000: Standards Track                                            */
                    /*                              Internet Printing Protocol/1.1: Model and Semantics     */
                    /*      §4.4.18 [page 137] charset-supported (1setOf charset)                           */
                    /* -----------------                                                                    */
                    /* This REQUIRED Printer attribute identifies the set of charsets that the Printer and  */
                    /* contained Job objects support in attributes with attribute syntax 'text' and 'name'. */
                    /* At least the value 'utf-8' MUST be present, since IPP objects MUST support the UTF-8 */
                    /* [RFC2279] charset.  If a Printer object supports a charset, it means that for all    */
                    /* attributes of syntax 'text' and 'name' the IPP object MUST (1) accept the charset in */
                    /* requests and return the charset in responses as needed.                              */
                    /*                                                                                      */
                    /* If more charsets than UTF-8 are supported, the IPP object MUST perform charset       */
                    /* conversion between the charsets as described in Section 3.1.4.2.                     */
                    /* ==================================================================================== */
                    /* [rfc2911] September 2000: Standards Track                                            */
                    /*                              Internet Printing Protocol/1.1: Model and Semantics     */
                    /*      §4.1.7 [page 86-87] 'charset'                                                   */
                    /* -----------------                                                                    */
                    /* The 'charset' attribute syntax is a standard identifier for a charset.  A charset is */
                    /* a coded character set and encoding scheme.  Charsets are used for labeling certain   */
                    /* document contents and 'text' and 'name' attribute values.  The syntax and semantics  */
                    /* of this attribute syntax are specified in RFC 2046 [RFC2046] and contained in the    */
                    /* IANA character-set Registry [IANA-CS] according to the IANA procedures [RFC2278].    */
                    /* Though RFC 2046 requires that the values be case-insensitive US-ASCII [ASCII], IPP   */
                    /* requires all lower case values in IPP attributes to simplify comparing by IPP        */
                    /* clients and Printer objects.  When a character-set in the IANA registry has more     */
                    /* than one name (alias), the name labeled as "(preferred MIME name)", if present, MUST */
                    /* be used.                                                                             */
                    /*                                                                                      */
                    /* The maximum length of 'charset' values used to represent IPP attribute values is 63  */
                    /* octets.                                                                              */
                    /*                                                                                      */
                    /* Some examples are:                                                                   */
                    /*                                                                                      */
                    /*    +--------------+------------------------------------------------------------+     */
                    /*    | charset      | Description                                                |     */
                    /*    +==============+============================================================+     */
                    /*    | 'utf-8'      | ISO 10646 Universal Multiple-Octet Coded Character Set     |     */
                    /*    |              | (UCS) represented as the UTF-8 [RFC2279] transfer          |     */
                    /*    |              | encoding scheme in which US-ASCII is a subset charset.     |     */
                    /*    +--------------+------------------------------------------------------------+     */
                    /*    | 'us-ascii'   |  7-bit American Standard Code for Information Interchange  |     */
                    /*    |              | (ASCII), ANSI X3.4-1986 [ASCII].  That standard defines    |     */
                    /*    |              | US-ASCII, but RFC 2045 [RFC2045] eliminates most of the    |     */
                    /*    |              | control characters from conformant usage in MIME and IPP.  |     */
                    /*    +--------------+------------------------------------------------------------+     */
                    /*    | 'iso-8859-1' |  8-bit One-Byte Coded Character Set, Latin Alphabet Nr 1   |     */
                    /*    |              | [ISO8859-1].  That standard defines a coded character set  |     */
                    /*    |              | that is used by Latin languages in the Western Hemisphere  |     */
                    /*    |              | and Western Europe.  US-ASCII is a subset charset.         |     */
                    /*    +--------------+------------------------------------------------------------+     */
                    /*                                                                                      */
                    /* Some attribute descriptions MAY place additional requirements on charset values that */
                    /* may be used, such as REQUIRED values that MUST be supported or additional            */
                    /* restrictions, such as requiring that the charset have US- ASCII as a subset charset. */
                    /*                                                                                      */
            /* ============================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §4.1.9 [page 87-88] 'mimeMediaType'                                                     */
            /* -----------------                                                                            */
            /* The 'mimeMediaType' attribute syntax is the Internet Media Type (sometimes called MIME type) */
            /* as defined by RFC 2046 [RFC2046] and registered according to the procedures of RFC 2048      */
            /* [RFC2048] for identifying a document format.  The value MAY include a charset, or other,     */
            /* parameter, depending on the specification of the Media Type in the IANA Registry [IANA-MT].  */
            /* Although most other IPP syntax types allow for only lower-cased values, this syntax type     */
            /* allows for mixed-case values which are case-insensitive.                                     */
            /*                                                                                              */
            /* Examples are:                                                                                */
            /*                                                                                              */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    |             MIME Type            |                Description                       |   */
            /*    +==================================+==================================================+   */
            /*    | 'text/html'                      | An HTML document                                 |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'text/plain'                     | A plain text document in US-ASCII (RFC 2046      |   */
            /*    |                                  | indicates that in the absence of the charset     |   */
            /*    |                                  | parameter MUST mean US-ASCII rather than simply  |   */
            /*    |                                  | unspecified) [RFC2046].                          |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'text/plain; charset=US-ASCII'   |  A plain text document in US-ASCII [52, 56].     |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'text/plain; charset=ISO-8859-1' |  A plain text document in ISO 8859-1 (Latin 1)   |   */
            /*    |                                  | [ISO8859-1].                                     |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'text/plain; charset=utf-8'      | A plain text document in ISO 10646 represented   |   */
            /*    |                                  | as UTF-8 [RFC2279]                               |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'application/postscript'         | A PostScript document [RFC2046]                  |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'application/vnd.hp-PCL'         | A PCL document [IANA-MT] (charset escape         |   */
            /*    |                                  | sequence embedded in the document data)          |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'application/pdf'                | Portable Document Format - see IANA MIME Media   |   */
            /*    |                                  | Type registry                                    |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*    | 'application/octet-stream'       | Auto-sense - see section 4.1.9.1                 |   */
            /*    +----------------------------------+--------------------------------------------------+   */
            /*                                                                                              */
            /* The maximum length of a 'mimeMediaType' value to represent IPP attribute values is 255       */
            /* octets.                                                                                      */
            /*                                                                                              */
            /* ============================================================================================ */
            /*   [PWG5100.7] October 31, 2003 -- Standard                                                   */
            /*                      Standard for The Internet Printing Protocol (IPP): Job Extensions       */
            /*          §7.1 [page 31] document-charset-default (charset)                                   */
            /* -----------------                                                                            */
            /* This OPTIONAL Printer Description attribute indicates the default charset that the Printer   */
            /* will assume for charset-ambiguous document formats when the client omits the                 */
            /* "document-charset" Operation attribute (section 3.2.2).  The Printer MUST support this       */
            /* attribute if it supports the corresponding "document-charset" Operation attribute            */
            /* (see section 3.2.2)                                                                          */
            /*                                                                                              */
            /* ============================================================================================ */
            /*   [PWG5100.7] October 31, 2003 -- Standard                                                   */
            /*                      Standard for The Internet Printing Protocol (IPP): Job Extensions       */
            /*          §7.2 [page 31] document-charset-supported (1setOf charset)                          */
            /* -----------------                                                                            */
            /* This OPTIONAL Printer Description attribute indicates the charsets that the Printer supports */
            /* in Document Content, that is, supports as values of the "document-charset" Operatio          */
            /* attribute (section 3.2.2).  The Printer MUST support this attribute if it supports the       */
            /* corresponding "document-charset" Operation attribute (see section 3.2.2).                    */
            /*                                                                                              */
            /* ============================================================================================ */
typedef enum {
     PWG_DOCUMENT_CHARSET_SUPPLIED_RESERVED_0              =  0,
     PWG_DOCUMENT_CHARSET_SUPPLIED_RESERVED_1              =  1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UNKNOWN                 =  2,

     PWG_DOCUMENT_CHARSET_SUPPLIED_ADOBE_STANDARD_ENCODING,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ADOBE_SYMBOL_ENCODING,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ANSI_X3_110_1983,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ASMO_449,
     PWG_DOCUMENT_CHARSET_SUPPLIED_BIG5,
     PWG_DOCUMENT_CHARSET_SUPPLIED_BIG5_HKSCS,
     PWG_DOCUMENT_CHARSET_SUPPLIED_BOCU_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_BS_4730,
     PWG_DOCUMENT_CHARSET_SUPPLIED_BS_VIEWDATA,
     PWG_DOCUMENT_CHARSET_SUPPLIED_CESU_8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_GR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_CSN_369103,
     PWG_DOCUMENT_CHARSET_SUPPLIED_DEC_MCS,
     PWG_DOCUMENT_CHARSET_SUPPLIED_DIN_66003,
     PWG_DOCUMENT_CHARSET_SUPPLIED_DK_US,
     PWG_DOCUMENT_CHARSET_SUPPLIED_DS_2089,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_AT_DE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_AT_DE_A,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_CA_FR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_DK_NO,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_DK_NO_A,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES_A,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES_S,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FI_SE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FI_SE_A,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_IT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_PT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_UK,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_US,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ECMA_CYRILLIC,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ES,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ES2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EUC_JP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EUC_KR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_EXTENDED_UNIX_CODE_FIXED_WIDTH_FOR_JAPANESE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GB18030,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GB_1988_80,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GB2312,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GB_2312_80,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GBK,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GOST_19768_74,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK7,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK7_OLD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK_CCITT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HP_DESKTOP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HP_LEGAL,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HP_MATH8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HP_PI_FONT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HP_ROMAN8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_HZ_GB_2312,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM00858,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM00924,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01140,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01141,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01142,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01143,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01144,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01145,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01146,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01147,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01148,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01149,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM037,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM038,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM1026,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM1047,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM273,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM274,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM275,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM277,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM278,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM280,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM281,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM284,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM285,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM290,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM297,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM420,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM423,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM424,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM437,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM500,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM775,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM850,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM851,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM852,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM855,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM857,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM860,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM861,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM862,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM863,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM864,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM865,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM866,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM868,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM869,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM870,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM871,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM880,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM891,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM903,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM904,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM905,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM918,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM_SYMBOLS,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IBM_THAI,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IEC_P27_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_INIS,
     PWG_DOCUMENT_CHARSET_SUPPLIED_INIS_8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_INIS_CYRILLIC,
     PWG_DOCUMENT_CHARSET_SUPPLIED_INVARIANT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10367_BOX,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_4,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_BASIC,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UNICODE_LATIN1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UTF_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_CN,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_CN_EXT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_JP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_JP_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_KR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2033_1983,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5427,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5427_1981,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5428_1980,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_646_BASIC_1983,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_646_IRV_1983,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_6937_2_25,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_6937_2_ADD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_10,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_13,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_14,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_15,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_16,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1_WINDOWS_3_0_LATIN_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1_WINDOWS_3_1_LATIN_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_2_WINDOWS_LATIN_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_3,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_4,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_5,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6_E,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6_I,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_7,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8_E,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8_I,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_9,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_9_WINDOWS_LATIN_5,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_SUPP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_IR_90,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1261,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1264,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1265,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1268,
     PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1276,
     PWG_DOCUMENT_CHARSET_SUPPLIED_IT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6220_1969_JP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6220_1969_RO,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6226_1978,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6226_1983,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_A,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_B,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_B_ADD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_HAND,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_HAND_ADD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_KANA,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_ENCODING,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_X0201,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_X0212_1990,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_002,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_003_MAC,
     PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_003_SERB,
     PWG_DOCUMENT_CHARSET_SUPPLIED_KOI8_R,
     PWG_DOCUMENT_CHARSET_SUPPLIED_KOI8_U,
     PWG_DOCUMENT_CHARSET_SUPPLIED_KS_C_5601_1987,
     PWG_DOCUMENT_CHARSET_SUPPLIED_KSC5636,
     PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_GREEK,
     PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_GREEK_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_LAP,
     PWG_DOCUMENT_CHARSET_SUPPLIED_MACINTOSH,
     PWG_DOCUMENT_CHARSET_SUPPLIED_MICROSOFT_PUBLISHING,
     PWG_DOCUMENT_CHARSET_SUPPLIED_MNEM,
     PWG_DOCUMENT_CHARSET_SUPPLIED_MNEMONIC,
     PWG_DOCUMENT_CHARSET_SUPPLIED_MSZ_7795_3,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_DANO,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_DANO_ADD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_SEFI,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_SEFI_ADD,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NC_NC00_10_81,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NF_Z_62_010,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NF_Z_62_010__1973_,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NS_4551_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_NS_4551_2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_PC8_DANISH_NORWEGIAN,
     PWG_DOCUMENT_CHARSET_SUPPLIED_PC8_TURKISH,
     PWG_DOCUMENT_CHARSET_SUPPLIED_PT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_PT2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_PTCP154,
     PWG_DOCUMENT_CHARSET_SUPPLIED_SCSU,
     PWG_DOCUMENT_CHARSET_SUPPLIED_SEN_850200_B,
     PWG_DOCUMENT_CHARSET_SUPPLIED_SEN_850200_C,
     PWG_DOCUMENT_CHARSET_SUPPLIED_SHIFT_JIS,
     PWG_DOCUMENT_CHARSET_SUPPLIED_T_101_G2,
     PWG_DOCUMENT_CHARSET_SUPPLIED_T_61_7BIT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_T_61_8BIT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_TIS_620,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UNICODE_1_1,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UNICODE_1_1_UTF_7,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UNKNOWN_8BIT,
     PWG_DOCUMENT_CHARSET_SUPPLIED_US_ASCII,
     PWG_DOCUMENT_CHARSET_SUPPLIED_US_DK,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16BE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16LE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32BE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32LE,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_7,
     PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_8,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_INTERNATIONAL,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_MATH,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_US,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VIDEOTEX_SUPPL,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VIQR,
     PWG_DOCUMENT_CHARSET_SUPPLIED_VISCII,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1250,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1251,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1252,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1253,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1254,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1255,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1256,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1257,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1258,
     PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_31J,

     VND_DOC_CHR_SET_ENUM

     PWG_DOCUMENT_CHARSET_SUPPLIED_END
} pwgDocumentCharsetSuppliedEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgDocumentCharsetSupplied_Keywords[];
extern         pwgCHAR* pwgDocumentCharsetSupplied_KWValues[];
extern         pwgBIT8  pwgDocumentCharsetSupplied_KWVLevel[];
extern         pwgBOOL  pwgDocumentCharsetSupplied_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_DocumentCharsetSupplied;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJD_1_DOCUMENT_CHARSET_SUPPLIED_H__                                                    */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================= pwg.pjt.pjd.1.document.charset.supplied.h ================================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
