/* ================================= pwg.pjt.pjd.1.job.collation.type.h =================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJD_1_JOB_COLLATION_TYPE_H__
#define __PWG_PJT_PJD_1_JOB_COLLATION_TYPE_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Collation Type                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 48] JobCollationType               */
/* -----------------                                                                                        */
/* Describes the sheet collation and document collation for the Job. Sheet collation is defined to be the   */
/* ordering of sheets within a document copy. Document collation is defined to be the ordering of document  */
/* copies within a multi-document job.                                                                      */
/* [RFC3381] §4.1 + Errata ID: 2983                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [rfc3381] September 2002: Standards Track                                                            */
    /*                        Internet Printing Protocol (IPP): Job Progress Attributes                     */
    /*      §4.1 [page 9-10] job-collation-type (type2 enum|other|unknown)                                  */
    /*           Errata ID: 2983 / Reported By: Michael Sweet / Date Reported: 2011-10-03                   */
    /* -----------------                                                                                    */
    /* Job Collation includes sheet collation and document collation.  Sheet collation is defined to be the */
    /* ordering of sheets within a document copy.  Document collation is defined to be the ordering of      */
    /* document copies within a multi-document job.  The value of the "job-collation-type" is affected by   */
    /* the value of the "sheet-collate" Job Template attribute (see section 3.1), if supplied and supported.*/
    /*                                                                                                      */
    /*    The Standard enum values are:                                                                     */
    /*                                                                                                      */
    /*        '3' 'uncollated-sheets':    No collation of the sheets within each document copy, i.e., each  */
    /*                                    sheet of a document that is to produce multiple copies, is        */
    /*                                    replicated before the next sheet in the document is processed and */
    /*                                    stacked.  If the device has an output bin collator, the           */
    /*                                    'uncollated-sheets(3)' value may actually produce collated sheets */
    /*                                    as far as the user is concerned (in the output bins).  However,   */
    /*                                    when the job collation is the 'uncollated-sheets(3)' value, job   */
    /*                                    progress is indistinguishable from a monitoring application       */
    /*                                    between a device that has an output bin collator and one that     */
    /*                                    does not.                                                         */
    /*                                                                                                      */
    /*        '4' 'collated-documents':   Collation of the sheets within each document copy is performed    */
    /*                                    within the printing device by making multiple passes over, either */
    /*                                    the source or an intermediate representation of the document.  In */
    /*                                    addition, when there are multiple documents per job, the i'th     */
    /*                                    copy of each document is stacked before the j'th copy of each     */
    /*                                    document, i.e., the documents are collated within each job copy.  */
    /*                                    For example, if a job is submitted with documents, A and B, the   */
    /*                                    job is made available to the end user as:                         */
    /*                                                                                                      */
    /*                                                          A, B, A, B, ....                            */
    /*                                                                                                      */
    /*                                    The 'collated-documents(4)' value corresponds to the IPP          */
    /*                                    [RFC2911] 'separate-documents-collated-copies' keyword value of   */
    /*                                    the "multiple-document-handling" attribute.                       */
    /*                                                                                                      */
    /*                                    If the job's "copies" attribute is '1' (or not supplied), then    */
    /*                                    the "job-collation-type" attribute is defined to be '4'.          */
    /*                                                                                                      */
    /*        '5' 'uncollated-documents': Collation of the sheets within each document copy is performed    */
    /*                                    within the printing device by making multiple passes over either  */
    /*                                    the source or an intermediate representation of the document.  In */
    /*                                    addition, when there are multiple documents per job, all copies   */
    /*                                    of the first document in the job are stacked before any copied of */
    /*                                    the next document in the job, i.e., the documents are uncollated  */
    /*                                    within the job.  For example, if a job is submitted with          */
    /*                                    documents, A and B, the job is made available to the end user as: */
    /*                                                                                                      */
    /*                                                          A, A, ..., B, B, ....                       */
    /*                                                                                                      */
    /*                                    The 'uncollated-documents(5)' value corresponds to the IPP        */
    /*                                    [RFC2911] 'separate-documents-uncollated-copies' keyword value of */
    /*                                    the "multiple-document-handling" attribute.                       */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [rfc3381] September 2002: Standards Track                                                        */
        /*                        Internet Printing Protocol (IPP): Job Progress Attributes                 */
        /*      §3.1 [page 3-6] sheet-collate (type2 keyword)                                               */
        /* -----------------                                                                                */
        /*                                                                                                  */
        /*  |-------------------|----------------------------------|-------------------------------------|  */
        /*  | Job Attribute     | Printer: Default Value Attribute | Printer: Supported Values Attribute |  */
        /*  |===================|==================================|=====================================|  */
        /*  | sheet-collate     | sheet-collate-default            | sheet-collate-supported             |  */
        /*  | (type2 keyword)   | (type2 keyword)                  | (1setOf type2 keyword)              |  */
        /*  |-------------------|----------------------------------|-------------------------------------|  */
        /*                                                                                                  */
        /* This attribute specifies whether or not the media sheets of each copy of each printed document   */
        /* in a job are to be in sequence, when multiple copies of the document are specified by the        */
        /* 'copies' attribute.                                                                              */
        /*                                                                                                  */
        /* Standard keyword values are:                                                                     */
        /*                                                                                                  */
        /* |------------|---------------------------------------------------------------------------------| */
        /* | uncollated | each print-stream sheet is printed a number of times in succession equal to the | */
        /* |            | value of the 'copies' attribute, followed by the next print-stream sheet.       | */
        /* |------------|---------------------------------------------------------------------------------| */
        /* | collated   | each copy of each document is printed with the print-stream sheets in sequence, | */
        /* |            | followed by the next document copy.                                             | */
        /* |------------|---------------------------------------------------------------------------------| */
        /*                                                                                                  */
        /* For example, suppose a document produces two media sheets as output, and "copies" is equal to    */
        /* '6'.  For the 'uncollated' case, six copies of the first media sheet are printed, followed by    */
        /* six copies of the second media sheet.  For the 'collated' case, one copy of each of the six      */
        /* sheets is printed, followed by another copy of each of the six media sheets.                     */
        /*                                                                                                  */
        /* Whether the effect of sheet collation is achieved by placing copies of a document in multiple    */
        /* output bins, or in the same output bin with implementation defined document separation, is       */
        /* implementation dependent.  Also whether it is achieved by making multiple passes over the job or */
        /* by using an output sorter, is implementation dependent.                                          */
        /*                                                                                                  */
        /* Note: IPP/1.0 [RFC2566] and IPP/1.1 [RFC2911] are silent on whether or not sheets within         */
        /*       documents are collated.  The "sheet-collate-supported" Printer attribute permits a Printer */
        /*       object to indicate whether or not it collates sheets with each document and whether it     */
        /*       allows the client to control sheet collation.  An implementation is able to indicate that  */
        /*       it supports uncollated sheets, collated sheets, or both, using the 'uncollated',           */
        /*       'collated', or both 'uncollated' and 'collated' values, respectively.                      */
        /*                                                                                                  */
        /* This attribute is affected by "multiple-document-handling".  The "multiple-document-handling"    */
        /* attribute describes the collation of documents, and the "sheet-collate" attribute describes the  */
        /* semantics of collating individual pages within a document.  To better explain the interaction    */
        /* between these two attributes, the term "set" is introduced.  A "set" is a logical boundary       */
        /* between the delivered media sheets of a printed job.  For example, in the case of a ten page     */
        /* single document with collated pages and a request for 50 copies, each of the 50 printed copies   */
        /* of the document constitutes a "set".  In the above example if the pages were uncollated, then 50 */
        /* copies of each of the individual pages within the document would represent each "set".           */
        /*                                                                                                  */
        /* The following table describes the interaction of "sheet-collate" with multiple document handling.*/
        /*                                                                                                  */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | "sheet-collate" | "multiple-document-handling"         | Semantics                           | */
        /* |=================|======================================|=====================================| */
        /* | collated        |     'single-document                 | Each copy of the concatenated       | */
        /* |                 |                                      | documents, with their pages in      | */
        /* |                 |                                      | sequence, represents a "set".       | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | collated        | single-document-new-sheet            | Each copy of the concatenated       | */
        /* |                 |                                      | documents, with their pages in      | */
        /* |                 |                                      | sequence, represents a "set".       | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | collated        | separate-documents-collated-copies   | Each copy of each separate document,| */
        /* |                 |                                      | with its pages in sequence,         | */
        /* |                 |                                      | represents a "set".                 | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | collated        | separate-documents-uncollated-copies | Each copy of each separate document,| */
        /* |                 |                                      | with its pages in sequence,         | */
        /* |                 |                                      | represents a "set".                 | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | uncollated      | single-document                      | Each media sheet of the document is | */
        /* |                 |                                      | printed a number of times equal to  | */
        /* |                 |                                      | the "copies" attribute; which       | */
        /* |                 |                                      | constitutes a "set".                | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | uncollated      | single-document-new-sheet            | Each media sheet of the             | */
        /* |                 |                                      | concatenated documents is printed a | */
        /* |                 |                                      | number of times equal to the        | */
        /* |                 |                                      | "copies" attribute; which           | */
        /* |                 |                                      | constitutes a "set".                | */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | uncollated      | separate-documents-collated-copies   | This is a degenerate case, and the  | */
        /* |                 |                                      | printer object MUST reject the job  | */
        /* |                 |                                      | and return the status,              | */
        /* |                 |                                      |"client-error-conflicting-attributes"| */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /* | uncollated      | separate-documents-uncollated-copies | This is a degenerate case, and the  | */
        /* |                 |                                      | printer object MUST reject the job  | */
        /* |                 |                                      | and return the status               | */
        /* |                 |                                      |"client-error-conflicting-attributes"| */
        /* |-----------------|--------------------------------------|-------------------------------------| */
        /*                                                                                                  */
        /* From the above table it is obvious that the implicit value of the "sheet-collate" attribute in a */
        /* printer that does not support the "sheet-collate" attribute, is 'collated.'  The semantics of    */
        /* "multiple-document-handling" are otherwise nonsensical in the case of separate documents.        */
        /*                                                                                                  */
        /* =================================================================================================*/
typedef enum {
    PWG_JOB_COLLATION_TYPE_RESERVED_0 = 0,
    PWG_JOB_COLLATION_TYPE_RESERVED_1 = 1,
    PWG_JOB_COLLATION_TYPE_UNKNOWN    = 2,

    PWG_JOB_COLLATION_TYPE_UNCOLLATED_SHEETS,
    PWG_JOB_COLLATION_TYPE_COLLATED_DOCUMENTS,
    PWG_JOB_COLLATION_TYPE_UNCOLLATED_DOCUMENTS,

    VND_JOB_COLT_TYP_ENUM

    PWG_JOB_COLLATION_TYPE_END
} pwgJobCollationTypeEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgJobCollationType_Keywords[];
extern         pwgCHAR* pwgJobCollationType_KWValues[];
extern         pwgBIT8  pwgJobCollationType_KWVLevel[];
extern         pwgBOOL  pwgJobCollationType_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_JobCollationType;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJD_1_JOB_COLLATION_TYPE_H__                                                           */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================= pwg.pjt.pjd.1.job.collation.type.h =================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
