/* ============================ pwg.pjt.pjd.2.document.source.os.name.h =================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJD_2_DOCUMENT_SOURCE_OS_NAME_H__
#define __PWG_PJT_PJD_2_DOCUMENT_SOURCE_OS_NAME_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Document Operating System Name                                                                           */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 45] DocumentSourceOsName           */
/* -----------------                                                                                        */
/* Name of the operating system, without version number, on which the document was generated.               */
/* [PWG5100.5] §9.1.13                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.5] October 31, 2003: Candidate Standard 5100.5-2003                                        */
    /*                              Standard for The Internet Printing Protocol (IPP): Document Object      */
    /*      §9.1.13 [page 4950] document-format-details (1setOf collection)                                 */
    /* -----------------                                                                                    */
    /* This CONDITIONALLY REQUIRED Document Description attribute specifies the details of the document     */
    /* format(s) of the Document Object content.  The Printer sets this Document Description attribute from */
    /* the corresponding "document-format-details" Operation attribute [PWG5100.7] §4.2.4 for the           */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                                                      ^^^^^^^^^^^^^^^ [PWG5100.7] §3.2.5.3 */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /* semantics), if supplied by the client in the Document Creation operation (see Table 3).  This        */
    /* attribute is REQUIRED for a Printer to support if the Printer supports a packaging MIME type         */
    /* document format, such as 'application/zip' or 'multipart/related'; otherwise, this attribute is      */
    /* OPTIONAL.  Note, however, that if a Printer supports the "document-format-details" Operation         */
    /* attribute, the Printer MUST support this "document-format-details" Document Description attribute.   */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                 */
        /*                               Standard for The Internet Printing Protocol (IPP): Job Extensions  */
        /*      §3.2.5.3 [page 17] document-source-os-name (name(40))                                       */
        /* -----------------                                                                                */
        /* This OPTIONAL member Operation attribute identifies the name of the operating system on which    */
        /* the document was generated.  Valid values are the operating system names defined in the IANA     */
        /* Operating System name registry [os-names] with the version number portion removed (see the       */
        /* "document-source-os-version" attribute).  IANA Operating System Names consist of up to 40        */
        /* uppercase US-ASCII letters, hyphen ("-"), period ("."), and slash ("/") characters.  The value   */
        /* MUST be all lowercase in order to facilitate matching.                                           */
        /*                                                                                                  */
        /* Possible example IANA OS Registry values: 'linux', 'macos', 'sun-os', 'unix', "unknown",         */
        /* 'windows'.                                                                                       */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* IANA: Assignments: 2010-02-12 Operating System Names                                             */
        /*      http://www.iana.org/assignments/operating-system-names/operating-system-names.txt           */
        /* -----------------                                                                                */
        /* A system name may be up to 40 characters taken from the set of uppercase letters, digits, and    */
        /* the three punctuation characters hyphen, period, and slash.  It must start with a letter, and    */
        /* end with a letter or digit.                                                                      */
        /*                                                                                                  */
        /* -----------------  List found on 2011.10.03                                                      */
        /*                                                                                                  */
        /* AEGIS            AMIGA-OS-1.2        AMIGA-OS-1.3        AMIGA-OS-2.0        AMIGA-OS-2.1        */
        /* AMIGA-OS-3.0     AMIGA-OS-3.1        AMIGA-OS-3.5        AMIGA-OS-3.9        APOLLO              */
        /* AIX/370          AIX-PS/2            BEOS-4.5.2          BEOS-5.0            BS-2000             */
        /* CEDAR            CGW                 CHORUS              CHRYSALIS           CMOS                */
        /* CMS              COS                 CPIX                CTOS                CTSS                */
        /* CYGWIN           DCN                 DDNOS               DOMAIN              DOS                 */
        /* EDX              ELF                 EMBOS               EMMOS               EPOS                */
        /* FOONEX           FREEBSD             FORTH               FUZZ                GCOS                */
        /* GPOS             HDOS                IMAGEN              INSTANT-INTERNET    INTERCOM            */
        /* IMPRESS          INTERLISP           IOS                 IRIX                ISI-68020           */
        /* ITS              KOSOS               LINUX               LINUX-1.0           LINUX-1.2           */
        /* LINUX-2.0        LINUX-2.2           LINUX-2.4           LINUX-2.6           LISP                */
        /* LISPM            LOCUS               MACOS               MINOS               MOS                 */
        /* MPE5             MPE/V               MPE/IX              MSDOS               MULTICS             */
        /* MUSIC            MUSIC/SP            MVS                 MVS/SP              NETBSD-1.0          */
        /* NETBSD-1.1       NETBSD-1.2          NETBSD-1.3          NETWARE-3           NETWARE-3.11        */
        /* NETWARE-4.0      NETWARE-4.1         NETWARE-5.0         NEXUS               NMS                 */
        /* NONSTOP          NOS-2               NTOS                OPENBSD             OPENVME             */
        /* OPENVMS          OS/DDP              OS/2                OS4                 OS86                */
        /* OSX              PCDOS               PERQ/OS             PLI                 PSDOS/MIT           */
        /* PSOS             PRIMOS              RISC-OS             RISC-OS-3.10        RISC-OS-3.50        */
        /* RISC-OS-3.60     RISC-OS-3.70        RISC-OS-4.00        RMX/RDOS            ROS                 */
        /* RSX11M           RTE-A               SATOPS              SINIX               SCO-OPEN-DESKTOP-1.0*/
        /* SCO-OPEN-DESKTOP-1.1                 SCO-OPEN-DESKTOP-2.0                    SCO-OPEN-DESKTOP-3.0*/
        /* SCO-OPEN-DESKTOP-LITE-3.0            SCO-OPEN-SERVER-3.0                     SCO-UNIX-3.2.0      */
        /* SCO-UNIX-3.2V2.0                     SCO-UNIX-3.2V2.1    SCO-UNIX-3.2V4.0    SCO-UNIX-3.2V4.1    */
        /* SCO-UNIX-3.2V4.2 SCO-XENIX-386-2.3.2 SCO-XENIX-386-2.3.3 SCO-XENIX-386-2.3.4 SCS                 */
        /* SIMP             SUN                 SUN-OS-3.5          SUN-OS-4.0          SWIFT               */
        /* TAC              TANDEM              TENEX               THE-MAJOR-BBS       TOPS10              */
        /* TOPS20           TOS                 TP3010              TRSDOS              ULTRIX              */
        /* UNIX             UNIX-BSD            UNIX-V1AT           UNIX-V              UNIX-V.1            */
        /* UNIX-V.2         UNIX-V.3            UNIX-PC             UNKNOWN             UT2D                */
        /* V                VM                  VM/370              VM/CMS              VM/SP               */
        /* VMS              VMS/EUNICE          VRTX                WAITS               WANG                */
        /* WIN32            WINDOWS-95          WINDOWS-95-OSR1     WINDOWS-95-OSR2     WINDOWS-98          */
        /* WINDOWS-CE       WINDOWS-NT          WINDOWS-NT-2        WINDOWS-NT-3        WINDOWS-NT-3.5      */
        /* WINDOWS-NT-3.51  WINDOWS-NT-4        WINDOWS-NT-5        WINDOWS-NT-5.1      WINDOWS-NT-6        */
        /* WINDOWS-NT-6.1   WORLDGROUP          WYSE-WYXWARE        X11R3               XDE                 */
        /* XENIX                                                                                            */
        /*                                                                                                  */
        /* ================================================================================================ */
  typedef enum {
    PWG_DOCUMENT_SOURCE_OS_NAME_NOT_SET = 0,
    PWG_DOCUMENT_SOURCE_OS_NAME_NONE,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNKNOWN,

    PWG_DOCUMENT_SOURCE_OS_NAME_AEGIS,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_1_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_1_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_2_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_2_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_5,
    PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_9,
    PWG_DOCUMENT_SOURCE_OS_NAME_APOLLO,
    PWG_DOCUMENT_SOURCE_OS_NAME_AIX_370,
    PWG_DOCUMENT_SOURCE_OS_NAME_AIX_PS_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_BEOS_4_5_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_BEOS_5_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_BS_2000,
    PWG_DOCUMENT_SOURCE_OS_NAME_CEDAR,
    PWG_DOCUMENT_SOURCE_OS_NAME_CGW,
    PWG_DOCUMENT_SOURCE_OS_NAME_CHORUS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CHRYSALIS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CMOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CMS,
    PWG_DOCUMENT_SOURCE_OS_NAME_COS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CPIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_CTOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CTSS,
    PWG_DOCUMENT_SOURCE_OS_NAME_CYGWIN,
    PWG_DOCUMENT_SOURCE_OS_NAME_DCN,
    PWG_DOCUMENT_SOURCE_OS_NAME_DDNOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_DOMAIN,
    PWG_DOCUMENT_SOURCE_OS_NAME_DOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_EDX,
    PWG_DOCUMENT_SOURCE_OS_NAME_ELF,
    PWG_DOCUMENT_SOURCE_OS_NAME_EMBOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_EMMOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_EPOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_FOONEX,
    PWG_DOCUMENT_SOURCE_OS_NAME_FREEBSD,
    PWG_DOCUMENT_SOURCE_OS_NAME_FORTH,
    PWG_DOCUMENT_SOURCE_OS_NAME_FUZZ,
    PWG_DOCUMENT_SOURCE_OS_NAME_GCOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_GPOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_HDOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_IMAGEN,
    PWG_DOCUMENT_SOURCE_OS_NAME_INSTANT_INTERNET,
    PWG_DOCUMENT_SOURCE_OS_NAME_INTERCOM,
    PWG_DOCUMENT_SOURCE_OS_NAME_IMPRESS,
    PWG_DOCUMENT_SOURCE_OS_NAME_INTERLISP,
    PWG_DOCUMENT_SOURCE_OS_NAME_IOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_IRIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_ISI_68020,
    PWG_DOCUMENT_SOURCE_OS_NAME_ITS,
    PWG_DOCUMENT_SOURCE_OS_NAME_KOSOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_1_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_1_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_4,
    PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_6,
    PWG_DOCUMENT_SOURCE_OS_NAME_LISP,
    PWG_DOCUMENT_SOURCE_OS_NAME_LISPM,
    PWG_DOCUMENT_SOURCE_OS_NAME_LOCUS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MACOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MINOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MPE5,
    PWG_DOCUMENT_SOURCE_OS_NAME_MPE_V,
    PWG_DOCUMENT_SOURCE_OS_NAME_MPE_IX,
    PWG_DOCUMENT_SOURCE_OS_NAME_MSDOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MULTICS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MUSIC,
    PWG_DOCUMENT_SOURCE_OS_NAME_MUSIC_SP,
    PWG_DOCUMENT_SOURCE_OS_NAME_MVS,
    PWG_DOCUMENT_SOURCE_OS_NAME_MVS_SP,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_3_11,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_4_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_4_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_5_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_NEXUS,
    PWG_DOCUMENT_SOURCE_OS_NAME_NMS,
    PWG_DOCUMENT_SOURCE_OS_NAME_NONSTOP,
    PWG_DOCUMENT_SOURCE_OS_NAME_NOS_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_NTOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_OPENBSD,
    PWG_DOCUMENT_SOURCE_OS_NAME_OPENVME,
    PWG_DOCUMENT_SOURCE_OS_NAME_OPENVMS,
    PWG_DOCUMENT_SOURCE_OS_NAME_OS_DDP,
    PWG_DOCUMENT_SOURCE_OS_NAME_OS_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_OS4,
    PWG_DOCUMENT_SOURCE_OS_NAME_OS86,
    PWG_DOCUMENT_SOURCE_OS_NAME_OSX,
    PWG_DOCUMENT_SOURCE_OS_NAME_PCDOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_PERQ_OS,
    PWG_DOCUMENT_SOURCE_OS_NAME_PLI,
    PWG_DOCUMENT_SOURCE_OS_NAME_PSDOS_MIT,
    PWG_DOCUMENT_SOURCE_OS_NAME_PSOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_PRIMOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_10,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_50,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_60,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_70,
    PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_4_00,
    PWG_DOCUMENT_SOURCE_OS_NAME_RMX_RDOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_ROS,
    PWG_DOCUMENT_SOURCE_OS_NAME_RSX11M,
    PWG_DOCUMENT_SOURCE_OS_NAME_RTE_A,
    PWG_DOCUMENT_SOURCE_OS_NAME_SATOPS,
    PWG_DOCUMENT_SOURCE_OS_NAME_SINIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_1_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_1_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_2_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_3_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_LITE_3_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_SERVER_3_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V2_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V2_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_4,
    PWG_DOCUMENT_SOURCE_OS_NAME_SCS,
    PWG_DOCUMENT_SOURCE_OS_NAME_SIMP,
    PWG_DOCUMENT_SOURCE_OS_NAME_SUN,
    PWG_DOCUMENT_SOURCE_OS_NAME_SUN_OS_3_5,
    PWG_DOCUMENT_SOURCE_OS_NAME_SUN_OS_4_0,
    PWG_DOCUMENT_SOURCE_OS_NAME_SWIFT,
    PWG_DOCUMENT_SOURCE_OS_NAME_TAC,
    PWG_DOCUMENT_SOURCE_OS_NAME_TANDEM,
    PWG_DOCUMENT_SOURCE_OS_NAME_TENEX,
    PWG_DOCUMENT_SOURCE_OS_NAME_THE_MAJOR_BBS,
    PWG_DOCUMENT_SOURCE_OS_NAME_TOPS10,
    PWG_DOCUMENT_SOURCE_OS_NAME_TOPS20,
    PWG_DOCUMENT_SOURCE_OS_NAME_TOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_TP3010,
    PWG_DOCUMENT_SOURCE_OS_NAME_TRSDOS,
    PWG_DOCUMENT_SOURCE_OS_NAME_ULTRIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_BSD,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V1AT,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_PC,
/*    PWG_DOCUMENT_SOURCE_OS_NAME_UNKNOWN,  */
    PWG_DOCUMENT_SOURCE_OS_NAME_UT2D,
    PWG_DOCUMENT_SOURCE_OS_NAME_V,
    PWG_DOCUMENT_SOURCE_OS_NAME_VM,
    PWG_DOCUMENT_SOURCE_OS_NAME_VM_370,
    PWG_DOCUMENT_SOURCE_OS_NAME_VM_CMS,
    PWG_DOCUMENT_SOURCE_OS_NAME_VM_SP,
    PWG_DOCUMENT_SOURCE_OS_NAME_VMS,
    PWG_DOCUMENT_SOURCE_OS_NAME_VMS_EUNICE,
    PWG_DOCUMENT_SOURCE_OS_NAME_VRTX,
    PWG_DOCUMENT_SOURCE_OS_NAME_WAITS,
    PWG_DOCUMENT_SOURCE_OS_NAME_WANG,
    PWG_DOCUMENT_SOURCE_OS_NAME_WIN32,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95_OSR1,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95_OSR2,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_98,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_CE,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_2,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3_5,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3_51,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_4,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_5,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_5_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_6,
    PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_6_1,
    PWG_DOCUMENT_SOURCE_OS_NAME_WORLDGROUP,
    PWG_DOCUMENT_SOURCE_OS_NAME_WYSE_WYXWARE,
    PWG_DOCUMENT_SOURCE_OS_NAME_X11R3,
    PWG_DOCUMENT_SOURCE_OS_NAME_XDE,
    PWG_DOCUMENT_SOURCE_OS_NAME_XENIX,
    PWG_DOCUMENT_SOURCE_OS_NAME_END

    VND_DOC_SRC_OS_NAM_ENUM

} pwgDocumentSourceOsNameEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgDocumentSourceOsName_Keywords[];
extern         pwgCHAR* pwgDocumentSourceOsName_KWValues[];
extern         pwgBIT8  pwgDocumentSourceOsName_KWVLevel[];
extern         pwgBOOL  pwgDocumentSourceOsName_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_DocumentSourceOsName;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJD_2_DOCUMENT_SOURCE_OS_NAME_H__                                                      */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================ pwg.pjt.pjd.2.document.source.os.name.h =================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
