/* ================================ pwg.pjt.pjp.1.job.error.action.h ====================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_1_JOB_ERROR_ACTION_H__
#define __PWG_PJT_PJP_1_JOB_ERROR_ACTION_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Error Action                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 48] JobErrorAction                 */
/* -----------------                                                                                        */
/* Specifies the action a Printer takes when an error is encountered in a document during processing of the */
/* job.                                                                                                     */
/* [PWG5100.13] §5.2.1                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §5.2.1 [page 27] job-error-action (type2 keyword)                                               */
    /* -----------------                                                                                    */
    /* The "job-error-action" Job Template attribute specifies the action a Printer takes when an error is  */
    /* encountered in a document during processing of the job. Standard keyword values are shown in Table 2.*/
    /*                                                                                                      */
    /*      Note: When a Printer stops processing a job, it MAY temporarily add the                         */
    /*            'processing-to-stop-point' keyword to the "job-state-reasons" Job                         */
    /*            Description attribute. See rule 1 in section 3.3.3 [RFC2911] for more information.        */
    /*                                                                                                      */
    /*                               Table 2 - "job-error-action" Keyword Values                            */
    /*    +---------------+-----------------------------------------------------------------------+         */
    /*    |    Keyword    |  Description                                                          |         */
    /*    +===============+=======================================================================+         */
    /*    | abort-job     | Stop processing the job and move it to the 'aborted' state.           |         */
    /*    |               | The 'aborted-by-system' keyword MUST be present in the                |         */
    /*    |               | "job-state-reasons" Job Description attribute.                        |         */
    /*    +---------------+-----------------------------------------------------------------------+         */
    /*    | cancel-job    | Stop processing the job as if the Printer had accepted a              |         */
    /*    |               | Cancel-Job request (section 3.3.3 [RFC2911]) from the                 |         */
    /*    |               | user. The 'job-canceled-by-user' keyword MUST be present              |         */
    /*    |               | in the "job-state-reasons" Job Description attribute.                 |         */
    /*    +---------------+-----------------------------------------------------------------------+         */
    /*    | continue-job  | Continue processing the next document in the job or, if this          |         */
    /*    |               | is the last document in the job, move the job to the 'completed'      |         */
    /*    |               | state.                                                                |         */
    /*    +---------------+-----------------------------------------------------------------------+         */
    /*    | suspend-job   | Stop processing the job and move it to the 'processing-stopped'       |         */
    /*    |               | state as if the Printer had accepted a Suspend-Current-Job request    |         */
    /*    |               | (section 4.3.1 [RFC3998]). The 'job-suspended-by-user' keyword        |         */
    /*    |               | MUST be present in the "job-state-reasons" Job Description attribute. |         */
    /*    +---------------+-----------------------------------------------------------------------+         */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §3.3.3 [page 66-68] Cancel-Job Operation                                                    */
        /* -----------------                                                                                */
        /* This REQUIRED operation allows a client to cancel a Print Job from the time the job is created   */
        /* up to the time it is completed, canceled, or aborted.  Since a Job might already be printing by  */
        /* the time a Cancel-Job is received, some media sheet pages might be printed before the job is     */
        /* actually terminated.                                                                             */
        /*                                                                                                  */
        /* The IPP object MUST accept or reject the request based on the job's current state and transition */
        /* the job to the indicated new state as follows:                                                   */
        /*                                                                                                  */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |                       |                       |      IPP object's response status       |   */
        /*    |  Current "job-state"  |    New "job-state"    |             code and action             |   */
        /*    +=======================+=======================+=========================================+   */
        /*    |       'pending'       |      'canceled'       | 'successful-ok'                         |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |     'pending-held'    |      'canceled'       | 'successful-ok'                         |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |      'processing'     |      'canceled'       | 'successful-ok'                         |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |      'processing'     |     'processing'      | 'successful-ok'  See Rule 1             |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |      'processing'     |     'processing'      | 'client-error-not-possible' See Rule 2  |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    | 'processing-stopped'  |      'canceled'       | 'successful-ok'                         |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    | 'processing-stopped'  | 'processing-stopped'  | 'successful-ok'  See Rule 1             |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    | 'processing-stopped'  | 'processing-stopped'  | 'client-error-not-possible' See Rule 2  |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |      'completed'      |      'completed'      | 'client-error-not-possible'             |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |      'canceled'       |      'canceled'       | 'client-error-not-possible'             |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*    |       'aborted'       |       'aborted'       | 'client-error-not-possible'             |   */
        /*    +-----------------------+-----------------------+-----------------------------------------+   */
        /*                                                                                                  */
        /*    Rule 1:  If the implementation requires some measurable time to cancel the job in the         */
        /*             'processing' or 'processing-stopped' job states, the IPP object MUST add the         */
        /*             'processing-to-stop-point' value to the job's "job-state-reasons" attribute          */
        /*             and then transition the job to the 'canceled' state when the processing ceases       */
        /*             (see section 4.3.8).                                                                 */
        /*                                                                                                  */
        /*    Rule 2:  If the Job object already has the 'processing-to-stop-point' value in its            */
        /*             "job-state-reasons" attribute, then the Printer object MUST reject a                 */
        /*             Cancel-Job operation.                                                                */
        /*                                                                                                  */
        /*    Access Rights: The authenticated user (see section 8.3) performing this operation             */
        /*                   must either be the job owner or an operator or administrator of the            */
        /*                   Printer object (see Sections 1 and 8.5). Otherwise, the IPP object             */
        /*                   MUST reject the operation and return:                                          */
        /*                                                                                                  */
        /*                                'client-error-forbidden',                                         */
        /*                                'client-error-not-authenticated', or                              */
        /*                                'client-error-not-authorized'                                     */
        /*                                                                                                  */
        /*                   as appropriate.                                                                */
        /*                                                                                                  */
        /*  3.3.3.1 Cancel-Job Request                                                                      */
        /*                                                                                                  */
        /*  The following groups of attributes are part of the Cancel-Job Request:                          */
        /*                                                                                                  */
        /*        Group 1: Operation Attributes                                                             */
        /*                                                                                                  */
        /*              Natural Language and Character Set:                                                 */
        /*                  The "attributes-charset" and "attributes-natural-language" attributes as        */
        /*                  described in section 3.1.4.1.                                                   */
        /*                                                                                                  */
        /*              Target:                                                                             */
        /*                  Either                                                                          */
        /*                         (1) the "printer-uri" (uri) plus "job-id" (integer(1:MAX))or             */
        /*                         (2) the "job-uri"     (uri) operation attribute(s) which define the      */
        /*                             target for this operation as described in section 3.1.5.             */
        /*                                                                                                  */
        /*              Requesting User Name:                                                               */
        /*                  The "requesting-user-name" (name(MAX)) attribute SHOULD be supplied by the      */
        /*                  client as described in section 8.3.                                             */
        /*                                                                                                  */
        /*              "message" (text(127)):                                                              */
        /*                  The client OPTIONALLY supplies this attribute.  The Printer object OPTIONALLY   */
        /*                  supports this attribute. It is a message to the operator.  This "message"       */
        /*                  attribute is not the same as the "job-message-from-operator" attribute.  That   */
        /*                  attribute is used to report a message from the operator to the end user that    */
        /*                  queries that attribute.  This "message" operation attribute is used to send a   */
        /*                  message from the client to the operator along with the operation request.  It   */
        /*                  is an implementation decision of how or where to display this message to the    */
        /*                  operator (if at all).                                                           */
        /*                                                                                                  */
        /*  3.3.3.2 Cancel-Job Response                                                                     */
        /*                                                                                                  */
        /*  The following sets of attributes are part of the Cancel-Job Response:                           */
        /*                                                                                                  */
        /*        Group 1: Operation Attributes                                                             */
        /*                                                                                                  */
        /*              Status Message:                                                                     */
        /*                  In addition to the REQUIRED status code returned in every response, the         */
        /*                  response OPTIONALLY includes a "status-message" (text(255)) and/or a            */
        /*                  "detailed-status-message" (text(MAX)) operation attribute as described          */
        /*                  in sections 13 and 3.1.6.                                                       */
        /*                                                                                                  */
        /*              Natural Language and Character Set:                                                 */
        /*                  The "attributes-charset" and "attributes-natural-language" attributes as        */
        /*                  described in section 3.1.4.2.                                                   */
        /*                                                                                                  */
        /*        Group 2: Unsupported Attributes                                                           */
        /*                                                                                                  */
        /*              See section 3.1.7 for details on returning Unsupported Attributes.                  */
        /*                                                                                                  */
        /* Once a successful response has been sent, the implementation guarantees that the Job will        */
        /* eventually end up in the 'canceled' state. Between the time of the Cancel-Job operation is       */
        /* accepted and when the job enters the 'canceled' job-state (see section 4.3.7), the               */
        /* "job-state-reasons" attribute SHOULD contain the 'processing-to-stop-point' value which          */
        /* indicates to later queries that although the Job might still be 'processing', it will eventually */
        /* end up in the 'canceled' state, not the 'completed' state.                                       */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §4.3.8 [page 113-117] job-state-reasons (1setOf type2 keyword)                              */
        /* -----------------                                                                                */
        /* This REQUIRED attribute provides additional information about the job's current state, i.e.,     */
        /* information that augments the value of the job's "job-state" attribute.                          */
        /*                                                                                                  */
        /* These values MAY be used with any job state or states for which the reason makes sense.  Some    */
        /* of these value definitions indicate conformance requirements; the rest are OPTIONAL.             */
        /* Furthermore, when implemented, the Printer MUST return these values when the reason applies and  */
        /* MUST NOT return them when the reason no longer applies whether the value of the Job's            */
        /* "job-state" attribute changed or not. When the Job does not have any reasons for being in its    */
        /* current state, the value of the Job's "job-state-reasons" attribute MUST be 'none'.              */
        /*                                                                                                  */
        /*    Note: While values cannot be added to the 'job-state' attribute without impacting             */
        /*          deployed clients that take actions upon receiving "job-state" values, it is             */
        /*          the intent that additional "job-state-reasons" values can be defined and                */
        /*          registered without impacting such deployed clients.  In other words, the                */
        /*          "job-state-reasons" attribute is intended to be extensible.                             */
        /*                                                                                                  */
        /* The following standard keyword values are defined.  For ease of understanding, the values are    */
        /* presented in the order in which the reasons are likely to occur (if implemented), starting with  */
        /* the 'job-incoming' value:                                                                        */
        /*                                                                                                  */
        /*      'none': There are no reasons for the job's current state.  This state reason is             */
        /*              semantically equivalent to "job-state-reasons" without any value and MUST           */
        /*              be used when there is no other value, since the 1setOf attribute syntax             */
        /*              requires at least one value.                                                        */
        /*                                                                                                  */
        /*      'job-incoming':  Either                                                                     */
        /*              (1) the Printer has accepted the Create-Job operation and is expecting              */
        /*                  additional Send-Document and/or Send-URI operations,                            */
        /*           or (2) the Printer is retrieving/accepting document data as a result of a              */
        /*                  Print-Job, Print-URI, Send-Document or Send-URI operation.                      */
        /*                                                                                                  */
        /*      'job-data-insufficient':  The Create-Job operation has been accepted by the                 */
        /*              Printer, but the Printer is expecting additional document data before               */
        /*              it can move the job into the 'processing' state.  If a Printer starts               */
        /*              processing before it has received all data, the Printer removes the                 */
        /*              'job-data-insufficient' reason, but the 'job-incoming' remains.  If a               */
        /*              Printer starts processing after it has received all data, the Printer               */
        /*              removes the 'job-data-insufficient' reason and the 'job-incoming' at                */
        /*              the same time.                                                                      */
        /*                                                                                                  */
        /*      'document-access-error':  After accepting a Print-URI or Send-URI request, the              */
        /*              Printer could not access one or more documents passed by reference.                 */
        /*              This reason is intended to cover any file access problem, including                 */
        /*              file does not exist and access denied because of an access control                  */
        /*              problem.  The Printer MAY also indicate the document access error                   */
        /*              using the "job-document-access-errors" Job Description attribute                    */
        /*              (see section 4.3.11).  Whether the Printer aborts the job and moves                 */
        /*              the job to the 'aborted' job state or prints all documents that are                 */
        /*              accessible and moves the job to the 'completed' job state and adds the              */
        /*              'completed-with-errors' value in the job's "job-state-reasons" attribute            */
        /*              depends on implementation and/or site policy.  This value SHOULD be                 */
        /*              supported if the Print-URI or Send-URI operations are supported.                    */
        /*                                                                                                  */
        /*      'submission-interrupted':  The job was not completely submitted for some                    */
        /*              unforeseen reason, such as:                                                         */
        /*              (1) the Printer has crashed before the job was closed by the client,                */
        /*              (2) the Printer or the document transfer method has crashed in some                 */
        /*                  non-recoverable way before the document data was entirely                       */
        /*                  transferred to the Printer,                                                     */
        /*              (3) the client crashed or failed to close the job before the time-out               */
        /*                  period.  See section 4.4.31.                                                    */
        /*                                                                                                  */
        /*      'job-outgoing':  The Printer is transmitting the job to the output device.                  */
        /*                                                                                                  */
        /*      'job-hold-until-specified':  The value of the job's "job-hold-until" attribute              */
        /*              was specified with a time period that is still in the future.  The job              */
        /*              MUST NOT be a candidate for processing until this reason is removed and             */
        /*              there are no other reasons to hold the job.  This value SHOULD be                   */
        /*              supported if the "job-hold-until" Job Template attribute is supported.              */
        /*                                                                                                  */
        /*      'resources-are-not-ready':  At least one of the resources needed by the job,                */
        /*              such as media, fonts, resource objects, etc., is not ready on any of                */
        /*              the physical printer's for which the job is a candidate.  This condition            */
        /*              MAY be detected when the job is accepted, or subsequently while the                 */
        /*              job is pending or processing, depending on implementation.  The job may             */
        /*              remain in its current state or be moved to the 'pending-held' state,                */
        /*              depending on implementation and/or job scheduling policy.                           */
        /*                                                                                                  */
        /*      'printer-stopped-partly':  The value of the Printer's "printer-state-reasons"               */
        /*              attribute contains the value 'stopped-partly'.                                      */
        /*                                                                                                  */
        /*      'printer-stopped':  The value of the Printer's "printer-state" attribute is 'stopped'.      */
        /*                                                                                                  */
        /*      'job-interpreting': Job is in the 'processing' state, but more specifically, the            */
        /*              Printer is interpreting the document data.                                          */
        /*                                                                                                  */
        /*      'job-queued': Job is in the 'processing' state, but more specifically, the Printer          */
        /*              has queued the document data.                                                       */
        /*                                                                                                  */
        /*      'job-transforming': Job is in the 'processing' state, but more specifically, the            */
        /*              Printer is interpreting document data and producing another electronic              */
        /*              representation.                                                                     */
        /*                                                                                                  */
        /*      'job-queued-for-marker': Job is in any of the 'pending-held', 'pending', or                 */
        /*              'processing' states, but more specifically, the Printer has completed               */
        /*              enough processing of the document to be able to start marking and the               */
        /*              job is waiting for the marker.  Systems that require human intervention             */
        /*              to release jobs using the Release-Job operation, put the job into the               */
        /*              'pending-held' job state.  Systems that automatically select a job to               */
        /*              use the marker put the job into the  'pending' job state or keep the                */
        /*              job in the 'processing' job state while waiting for the marker, depending           */
        /*              on implementation.  All implementations put the job into (or back into)             */
        /*              the 'processing' state when marking does begin.                                     */
        /*                                                                                                  */
        /*      'job-printing':  The output device is marking media. This value is useful for               */
        /*              Printers which spend a great deal of time processing                                */
        /*              (1) when no marking is happening and then want to show that marking                 */
        /*                  is now happening                                                                */
        /*           or (2) when the job is in the process of being canceled or aborted while               */
        /*                  the job remains in the 'processing' state, but the marking has                  */
        /*                  not yet stopped so that impression or sheet counts are still                    */
        /*                  increasing for the job.                                                         */
        /*                                                                                                  */
        /*      'job-canceled-by-user':  The job was canceled by the owner of the job using the             */
        /*              Cancel-Job request, i.e., by a user whose authenticated identity is the             */
        /*              same as the value of the originating user that created the Job object,              */
        /*              or by some other authorized end-user, such as a member of the job owner's           */
        /*              security group.  This value SHOULD be supported.                                    */
        /*                                                                                                  */
        /*      'job-canceled-by-operator':  The job was canceled by the operator using the                 */
        /*              Cancel-Job request, i.e., by a user who has been authenticated as                   */
        /*              having operator privileges (whether local or remote).  If the security              */
        /*              policy is to allow anyone to cancel anyone's job, then this value may               */
        /*              be used when the job is canceled by other than the owner of the job.                */
        /*              For such a security policy, in effect, everyone is an operator as far               */
        /*              as canceling jobs with IPP is concerned.  This value SHOULD be supported            */
        /*              if the implementation permits canceling by other than the owner of the job.         */
        /*                                                                                                  */
        /*      'job-canceled-at-device':  The job was canceled by an unidentified local user,              */
        /*              i.e., a user at a console at the device.  This value SHOULD be supported            */
        /*              if the implementation supports canceling jobs at the console.                       */
        /*                                                                                                  */
        /*      'aborted-by-system':  The job                                                               */
        /*              (1) is in the process of being aborted,                                             */
        /*              (2) has been aborted by the system and placed in the 'aborted' state,               */
        /*           or (3) has been aborted by the system and placed in the 'pending-held'                 */
        /*                  state, so that a user or operator can manually try the job again.               */
        /*                  This value SHOULD be supported.                                                 */
        /*                                                                                                  */
        /*      'unsupported-compression': The job was aborted by the system because the                    */
        /*              Printer determined while attempting to decompress the document-data's               */
        /*              that the compression is actually not among those supported by the Printer.          */
        /*              This value MUST be supported, since "compressions is a REQUIRED                     */
        /*              operation attribute.                                                                */
        /*                                                                                                  */
        /*      'compression-error': The job was aborted by the system because the Printer                  */
        /*              encountered an error in the document-data while decompressing it.                   */
        /*              If the Printer posts this reason, the document-data has already                     */
        /*              passed any tests that would have led to the 'unsupported-compression'               */
        /*              job-state-reason.                                                                   */
        /*                                                                                                  */
        /*      'unsupported-document-format': The job was aborted by the system because the                */
        /*              document-data's document-format is not among those supported by the                 */
        /*              Printer.  If the client specifies the document-format as                            */
        /*              'application/octet-stream', the printer MAY abort the job and post                  */
        /*              this reason even though the format is a member of the                               */
        /*              "document-format-supported" printer attribute, but not among the                    */
        /*              auto-sensed document-formats.  This value MUST be supported, since                  */
        /*              "document-format" is a REQUIRED operation attribute.                                */
        /*                                                                                                  */
        /*      'document-format-error': The job was aborted by the system because the Printer              */
        /*              encountered an error in the document-data while processing it.  If the              */
        /*              Printer posts this reason, the document-data has already passed any                 */
        /*              tests that would have led to the 'unsupported-document-format'                      */
        /*              job-state-reason.                                                                   */
        /*                                                                                                  */
        /*      'processing-to-stop-point':  The requester has issued a Cancel-Job operation                */
        /*              or the Printer object has aborted the job, but is still performing                  */
        /*              some actions on the job until a specified stop point occurs or job                  */
        /*              termination/cleanup is completed.                                                   */
        /*                                                                                                  */
        /*              If the implementation requires some measurable time to cancel the                   */
        /*              job in the 'processing' or 'processing-stopped' job states, the IPP                 */
        /*              object MUST use this value to indicate that the Printer object is                   */
        /*              still performing some actions on the job while the job remains in                   */
        /*              the 'processing' or 'processing-stopped' state.                                     */
        /*                                                                                                  */
        /*              After all the job's job description attributes have stopped                         */
        /*              incrementing, the Printer object moves the job from the 'processing'                */
        /*              state to the 'canceled' or 'aborted' job states.                                    */
        /*                                                                                                  */
        /*      'service-off-line':  The Printer is off-line and accepting no jobs.  All                    */
        /*              'pending' jobs are put into the 'pending-held' state.  This                         */
        /*              situation could be true if the service's or document transform's                    */
        /*              input is impaired or broken.                                                        */
        /*                                                                                                  */
        /*      'job-completed-successfully':  The job completed successfully. This value                   */
        /*              SHOULD be supported.                                                                */
        /*                                                                                                  */
        /*      'job-completed-with-warnings':  The job completed with warnings. This                       */
        /*              value SHOULD be supported if the implementation detects warnings.                   */
        /*                                                                                                  */
        /*      'job-completed-with-errors':  The job completed with errors (and possibly                   */
        /*              warnings too).  This value SHOULD be supported if the                               */
        /*              implementation detects errors.                                                      */
        /*                                                                                                  */
        /*      'job-restartable' - This job is retained (see section 4.3.7.2) and is                       */
        /*              currently able to be restarted using the Restart-Job operation                      */
        /*              (see section 3.3.7).  If 'job-restartable' is a value of the                        */
        /*              job's 'job-state-reasons' attribute, then the IPP object MUST                       */
        /*              accept a Restart-Job operation for that job.  This value SHOULD                     */
        /*              be supported if the Restart-Job operation is supported.                             */
        /*                                                                                                  */
        /*      'queued-in-device': The job has been forwarded to a device or print                         */
        /*              system that is unable to send back status.  The Printer sets                        */
        /*              the job's "job-state " attribute to 'completed'  and adds the                       */
        /*              'queued-in-device' value to the job's "job-state-reasons" attribute                 */
        /*              to indicate that the Printer has no additional information about                    */
        /*              the job and never will have any better information.  See section 4.3.7.1.           */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef enum {
    PWG_JOB_ERROR_ACTION_RESERVED_0 = 0,
    PWG_JOB_ERROR_ACTION_RESERVED_1 = 1,
    PWG_JOB_ERROR_ACTION_UNKNOWN    = 2,

    PWG_JOB_ERROR_ACTION_ABORT_JOB,
    PWG_JOB_ERROR_ACTION_CANCEL_JOB,
    PWG_JOB_ERROR_ACTION_CONTINUE_JOB,
    PWG_JOB_ERROR_ACTION_SUSPEND_JOB,

      VND_JOB_ERR_ACT_ENUM

    PWG_JOB_ERROR_ACTION_END
} pwgJobErrorActionEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgJobErrorAction_Keywords[];
extern         pwgCHAR* pwgJobErrorAction_KWValues[];
extern         pwgBIT8  pwgJobErrorAction_KWVLevel[];
extern         pwgBOOL  pwgJobErrorAction_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_JobErrorAction;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_1_JOB_ERROR_ACTION_H__                                                             */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.1.job.error.action.h ====================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
