/* ================================ pwg.pjt.pjp.3.job.hold.until.time.h =================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_JOB_HOLD_UNTIL_TIME_H__
#define __PWG_PJT_PJP_3_JOB_HOLD_UNTIL_TIME_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Hold Until Time                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 49] JobHoldUntilTime               */
/* -----------------                                                                                        */
/* Specifies the date and time after which the Job must become a candidate for processing (i.e.,            */
/* document(s) interpreted and output produced). (e.g., Fri, 03 May 2002 08:49:37 GMT)                      */
/* [PWG5100.11] §7.6                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                      */
    /*                           Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
    /*      §7.6 [page 37-40] job-hold-until-time  (dateTime)                                               */
    /* -----------------                                                                                    */
    /* The OPTIONAL "job-hold-until" Job Template attribute permits the client to specify the date and time */
    /* after which the Job MUST become a candidate for processing.                                          */
    /*                                                                                                      */
    /*    Note: The client application has the choice to present the "job-hold-until-time" to the end user  */
    /*          as either a delta time (the amount of time until the job is no longer held), or a fixed     */
    /*          time when the job will no longer be held.  The fixed time is represented using the          */
    /*          appropriate time zone(s) (usually the client's time zone, or the Printer's time zone, or    */
    /*          both if the client is capable).  See the description of "printer-current-time" in [RFC2911].*/
    /*                                                                                                      */
    /* If the Printer supports the "job-hold-until-time" attribute, the "job-hold-until" attribute MUST     */
    /* also be supported.  However, if the "job-hold-until" attribute is supported, the                     */
    /* "job-hold-until-time" attribute NEED  NOT be supported.  If the Printer supports the                 */
    /* "job-hold-until-time" attribute, the "printer-current-time" (dateTime) Printer Description attribute */
    /* MUST also be supported.                                                                              */
    /*                                                                                                      */
    /* The client MUST NOT supply both the "job-hold-until" and "job-hold-until-time" Job Template          */
    /* attributes in a Job Creation request.  If the client supplies such a malformed request by supplying  */
    /* both, the Printer MUST reject the request and return the 'client-error-conflicting-attributes'       */
    /* status code (see [RFC2911]).                                                                         */
    /*                                                                                                      */
    /*    Note: It is not an error for a client to supply and a Printer to support a "job-hold-xxx" and a   */
    /*          "job-delay-output-xxx" in the same Job Creation operation, since they control separate      */
    /*          aspects of job processing.                                                                  */
    /*                                                                                                      */
    /* A Flow Diagram for Job Creation operations with the "job-hold-until-time" attribute is shown in      */
    /* Figure 3 below.  A Time Sequence Diagram for a job with "job-hold-until-time", a job with            */
    /* "job-delay-output-until-time", and 4 ordinary print jobs is shown in Figure 4 below.  A Hold Job     */
    /* request is sent by the Client with a "job-hold-until-time" value specified as a dateTime.  The       */
    /* Printer calculates the number of seconds between the "job-hold-until-time" value and the             */
    /* "printer-current-time" value.  If this number of seconds is NOT in the range specified by the        */
    /* Printer's "job-hold-until-time-supported" attribute value, then the Printer either:                  */
    /*                                                                                                      */
    /*    1. rejects the request with the 'client-error-attributes-or-values-not-supported' status code     */
    /*        (see [RFC2911]) if the "ipp-attribute-fidelity" is 'true' or                                  */
    /*                                                                                                      */
    /*    2. accepts the request with the 'successful-ok-ignored-or-substituted-attributes', if the         */
    /*        client-supplied "ipp-attribute-fidelity" is 'false'.  Also, the Printer MUST return the       */
    /*        "job-hold-until-time" attribute and the client-supplied value in the Unsupported Attributes   */
    /*        group of the operation response. If the "job-hold-until-time" value is earlier than the       */
    /*        "printer-current-time" value plus the minimum value of "job-hold-until-time-supported", the   */
    /*        Printer MUST set the value of the Job's "job-hold-until-time" to the current dateTime plus    */
    /*        the minimum time.  Also, if the "job-hold-until-time" value is later than the                 */
    /*        "printer-current-time" value plus the maximum value of "job-hold-until-time-supported", the   */
    /*        Printer MUST set the value of the Job's "job-hold-until-time" to the current dateTime plus    */
    /*        the maximum time.                                                                             */
    /*                                                                                                      */
    /* If the job is accepted, the Printer then determines the state in which to place this job.  If the    */
    /* dateTime value is equal to or sooner than the Printer's "printer-current-time" dateTime value, then  */
    /* no hold is placed on the job and the job moves into the pending state (assuming there are no other   */
    /* reasons to hold the job).                                                                            */
    /*                                                                                                      */
    /* If the value of this attribute specifies a time period that is in the future, the Printer            */
    /*                                                                                                      */
    /*    1) MUST add the 'job-hold-until-specified' value to the job's "job-state-reasons" attribute,      */
    /*                                                                                                      */
    /*    2) MUST move the job to the 'pending-held' state, and                                             */
    /*                                                                                                      */
    /*    3) MUST NOT schedule the job for printing until the specified time arrives.                       */
    /*                                                                                                      */
    /* When the specified time arrives, the Printer MUST remove the 'job-hold-until-specified' value from   */
    /* the job's "job-state-reason" attribute and, and then if there are no other job state reasons that    */
    /* keep the job in the 'pending-held' state, the Printer MUST consider the job as a candidate for       */
    /* processing by moving the job to the 'pending' state.                                                 */
    /*                                                                                                      */
    /*    7.6.1 Why there is no job-hold-until-time-default                                                 */
    /*        There is no attribute "job-hold-until-time-default" because it would either be a fixed time   */
    /*        in the future or would have to be updated periodically.  Neither seem useful enough to be     */
    /*        worth the complexity.                                                                         */
    /*                                                                                                      */
    /*    7.6.2 job-hold-until-time-supported (rangeOfInteger(0:MAX))                                       */
    /*        A range of integer values of the "job-hold-until-supported" attribute specifies the span of   */
    /*        relative amount of time in seconds into the future that the printer supports keeping the      */
    /*        submitted job in the 'pending-held' state.  The Printer MUST use the time range to validate   */
    /*        a job that is submitted with a "job-hold-until-time" attribute.                               */
    /*                                                                                                      */
    /*           Figure 3 - Job Creation Operation Flow Diagram with "job-hold-until-time" specified        */
    /*                                                                                                      */
    /*           #                                                                                          */
    /*           |                                                                                          */
    /*           V                                                                                          */
    /* +----------------------------+        +--------------------------------------------+                 */
    /* |     Create Job             |        | Calaculate seconds to hold                 |                 */
    /* | "job-hold-until-time"      |------->| 'job-hold-until-time' minus                |                 */
    /* |                            |        | 'printer-current-time'                     |                 */
    /* +----------------------------+        +--------------------------------------------+                 */
    /*                                                        |                                             */
    /*                           +----------------+           |                                             */
    /*  #<-----------------------| Reject Request |           |                                             */
    /*    'status-code' =        +----------------+           |                                             */
    /*       'client-error-              ^ ["ipp-fidelity"    |                                             */
    /*        attributes-or-             |   is TRUE]         |                                             */
    /*        values-not-valid'          |                    V                                             */
    /*                                   /\                   /\                                            */
    /*                                  /  \  [else]         /  \                                           */
    /*                                 /    \<--------------/    \                                          */
    /*                                 \    /               \    /                                          */
    /*                                  \  /                 \  /                                           */
    /*                                   \/                   \/                                            */
    /*                                   |                    |[number of seconds <=                        */
    /*                                   | ["ipp-fidelity     |    "job-hold-until-time-supported"]         */
    /*                                   |  is FALSE]         |                                             */
    /*                                   |                    | ["job-hold-until-time" <=                   */
    /*                                   V                    V   'printer-current-time' (DateTime is       */
    /*              +-------------------------------+         /\   now or in    /\ [no hold reasons         */
    /*              | Change                        |        /  \  the past]   /  \ apply] +--------------+ */
    /* #<-----------| "job-hold-until-time"         |------>/    \----------->/    \------>|"job-state" = | */
    /*   'status-   | to a valid value              |       \    /           7\    /       |    'pending' | */
    /*      code' = +-------------------------------+        \  /           /  \  /        +--------------+ */
    /*      'successful-ok-ignored-                           \/           /    \/                |         */
    /*      or-subsituted-attributes'                         |           /     |                 |         */
    /*                                                        |          /      |                 |         */
    /*                          ["job-hold-until-time" >      |         /       |[other hold      |         */
    /*                             "printer-current-time"     |        /        | reasons apply]  |         */
    /*                          (DateTime is in the future)]  V       /         |                 |         */
    /*                       +------------------------------------+  /          V                 |         */
    /*                       | "job-state-reasons" =              | /    +------------------+     |         */
    /*                       | 'job-hold-until-specified'         |/     | "job-state" =    |     |         */
    /*                       | Note: This is NOT a hold reason    |      |   'pending-held' |     |         */
    /*                       +------------------------------------+      +------------------+     |         */
    /*                                                                          |                 |         */
    /* #<-----------------------------------------------------------------------+-----------------+         */
    /*    'status-code' = 'successful-ok'                                                                   */
    /*                                                                                                      */
    /* Figure 4 below shows a Time Sequence Diagram for an implementation of 6 jobs, where Job 1 is a Job   */
    /* Delay Output Job that processes the job partly before the delay date-time arrives, Job 2 is a Hold   */
    /* Job, and Jobs 3 through 6 are ordinary print jobs that complete successfully.  Jobs 3-5 are          */
    /* submitted before either of the Job Hold Time (B) and the Job Delay Time (A) occurs.  Job 6 is        */
    /* submitted after the Job Hold Time (B) but before the Job Delay Time (A) occurs.  OPTIONAL            */
    /* "job-state-reasons" values are shown in parenthesis.                                                 */
    /*                                                                                                      */
    /* +------+          +----------+ +---------+ +------------+ +------------+ +-----------+ +-----------+ */
    /* | Jobs |          | pending- | | pending | | processing | | processing | |  Produce  | | completed | */
    /* +------+          |   held   | |         | |(max 2 jobs)| |   stopped  | |   Output  | +-----------+ */
    /*                   +----------+ +---------+ +------------+ +------------+ |(max 1 job)|        !      */
    /*                         !           !             1              !       +-----------+        !      */
    /* |                       !           !             !              !             !              !      */
    /* | Time                  !           !             !              !             !              !      */
    /* V                       !           !             !              !             !              !      */
    /*                         !           !             !              !             !              !      */
    /* Job 1                   !           !             !              !             !              !      */
    /* "job-delay-output       !           !             !              !             !              !      */
    /*     -until-time" = A :--------------------------->1              !             !              !      */
    /*                         !           !             1------------->1             !              !      */
    /* Job 2                   !           !             !              1             !              !      */
    /* "job-hold               !           !             !              1             !              !      */
    /*     -until-time" = B :->2           !             !              1             !              !      */
    /*                         2           !             !              1             !              !      */
    /*                         2           !             !              1             !              !      */
    /* Job 3 :-----------------2------------------------>3              1             !              !      */
    /*                         2           !             3              1             !              !      */
    /* Job 4 :-----------------2---------------------->4 3              1             !              !      */
    /*                         2           !           4 3              1             !              !      */
    /*                         2           !           4 3..............1............>3              !      */
    /*                         2           !           4w3              1             3              !      */
    /* Job 5 :-----------------2---------->5           4w3              1             3              !      */
    /*                         2           5           4w3--------------1-------------3------------->3      */
    /* Hold Time B occurs -    2           5-------->5 4w               1             !              !      */
    /* remove "job=hold        2           !         5w4................1............>4              !      */
    /*     -until-specified :->2---------->2         5W4                1             4              !      */
    /*                         !           2         5w4----------------1-------------4------------->4      */
    /* Job 6 :--------------------------->62         5w                 1             !              !      */
    /*                         !          62------>2w5..................1............>5              !      */
    /* Delay Time A occurs -   !          6        2w5                  1             5              !      */
    /* remove 'job-delay       !          6        2w5                  1             5              !      */
    /*     output-until        !          6        2w5                  1             5              !      */
    /*           -specified :-------------6--------2w5----------------->1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5                  1             5              !      */
    /*                                    6        2w5------------------1-------------5------------->5      */
    /*                                    6        2w    1w<------------1             !              !      */
    /*                                    6        2.....1w..........................>2              !      */
    /*                                    6        2     1w             !             2              !      */
    /*                                    6        2     1w             !             2              !      */
    /*                                    6        2     1w             !             2              !      */
    /*                                    6        2-----1w---------------------------2------------->2      */
    /*                                    6----->6w      1              !             !              !      */
    /*                                    !      6w      1              !             !              !      */
    /*                                    !      6w      1...........................>1              !      */
    /*                                    !      6w      1              !             1              !      */
    /*                                    !      6w      1              !             1              !      */
    /*                                    !      6w      1----------------------------1------------->1      */
    /*                                    !      6w      !              !             !              !      */
    /*                                    !      6       !              !             !              !      */
    /*                                    !      6       !              !             !              !      */
    /*                                    !      6...................................>6              !      */
    /*                                    !      6       !              !             6              !      */
    /*                                    !      6------------------------------------6------------->6      */
    /*                                                                                                      */
    /*            Figure 4 - Time Sequence Diagram for 1 Hold, 2 Delay Output, and 4 normal Jobs            */
    /*                                                                                                      */
    /* ==================================================================================================== */
/* pwgCHAR  jobHoldUntilTime[pwgMAX_DATE_TIME_SIZE];  /  Date/Time after which Job MUST be produced.        */

extern  pwgINFO_DEF pwgDef_JobHoldUntilTime;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_JOB_HOLD_UNTIL_TIME_H__                                                          */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.3.job.hold.until.time.h =================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
