/* ============================== pwg.pjt.pjp.3.multiple.documents.handling.h ============================= */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_MULTIPLE_DOCUMENTS_HANDLING_H__
#define __PWG_PJT_PJP_3_MULTIPLE_DOCUMENTS_HANDLING_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Multiple Documents Handling                                                                              */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 55] MultipleDocumentsHandling      */
/* -----------------                                                                                        */
/* Controls whether Input Document in multi-Document jobs are combined into a single Output Document or are */
/* kept as separate Output Documents Useful for application of Finishings.                                  */
/*    Values: MultipleDocumentsHandlingWKV, KeywordNsExtensionPattern                                       */
/*        (e.g. SingleDocument, SeparateDocumentCollatedCopies, SingleDocumentNewSheet)                     */
/* [rfc2911] §4.2.4                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [rfc2911] September 2000: Standards Track                                                            */
    /*                              Internet Printing Protocol/1.1: Model and Semantics                     */
    /*      §4.2.4 [page 96-98] multiple-document-handling (type2 keyword)                                  */
    /* -----------------                                                                                    */
    /* #################################################################################################### */
    /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
    /* This attribute is relevant only if a job consists of two or more documents. This attribute MUST      */
    /* be supported with at least one value if the Printer supports multiple documents per job (see         */
    /* #################################################################################################### */
    /* VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV */
    /* Errata ID: 3072  | Reported By: Michael Sweet  | Date Reported: 2012-01-04                           */
    /*                                                                                                      */
    /* Section 4.2.4 says:                                                                                  */
    /*                                                                                                      */
    /* This attribute is relevant only if a job consists of two or more documents. This attribute MUST      */
    /* be supported with at least one value                                                                 */
    /*                                                                                                      */
    /* It should say:                                                                                       */
    /*                                                                                                      */
    /* This attribute is relevant to jobs consisting of one or more documents. This attribute MUST be       */
    /* supported with at least one value                                                                    */
    /*                                                                                                      */
    /* Notes: Per consensus of the IPP working group in the Printer Working Group, the                      */
    /*        "multiple-document-handling" attribute *is* applicable to single-document jobs since it       */
    /*        is the only common attribute that can be used to request copy collation.                      */
    /*                                                                                                      */
    /*        The other collation attribute ("sheet-collate" from RFC3381])interacts with                   */
    /*        "multiple-document-handling" in some non-obvious ways and requires clients and printers       */
    /*        to support two different attributes for simple collation. The "sheet-collate" attribute       */
    /*        also does not address how finishing options are applied to copies while                       */
    /*        "multiple-document-handling" does.                                                            */
    /* ###################################################################################################  */
    /* This attribute is relevant to jobs consisting of one or more documents. This attribute MUST be       */
    /* supported with at least one value if the Printer supports multiple documents per job (see            */
    /* sections 3.2.4 and 3.3.1).  The attribute controls finishing operations and the placement of one     */
    /* or more print-stream pages into impressions and onto media sheets.  When the value of the            */
    /* "copies" attribute exceeds 1, it also controls the order in which the copies that result from        */
    /* processing the documents are produced. For the purposes of this explanations, if "a" represents      */
    /* an instance of document data, then the result of processing the data in document "a" is a            */
    /* sequence of media sheets represented by "a(*)".                                                      */
    /*                                                                                                      */
    /* Standard keyword values are:                                                                         */
    /*                                                                                                      */
    /*    'single-document': If a Job object has multiple documents, say, the document data is called a     */
    /*        and b, then the result of processing all the document data (a and then b) MUST be treated     */
    /*        as a single sequence of media sheets for finishing operations; that is, finishing would       */
    /*        be performed on the concatenation of the sequences a(*),b(*).  The Printer object MUST        */
    /*        NOT force the data in each document instance to be formatted onto a new print-stream page,    */
    /*        nor to start a new impression on a new media sheet. If more than one copy is made, the        */
    /*        ordering of the sets of media sheets resulting from processing the document data MUST be      */
    /*        a(*), b(*), a(*), b(*), start on a new media sheet.                                           */
    /*                                                                                                      */
    /*    'separate-documents-uncollated-copies': If a Job object has multiple documents, say, the          */
    /*        document data is called a and b, then the result of processing the data in each document      */
    /*        instance MUST be treated as a single sequence of media sheets for finishing operations;       */
    /*        that is, the sets a(*) and b(*) would each be finished separately. The Printer object         */
    /*        MUST force each copy of the result of processing the data in a single document to start       */
    /*        on a new media sheet. If more than one copy is made, the ordering of the sets of media        */
    /*        sheets resulting from processing the document data MUST be a(*), a(*), ..., b(*),             */
    /*        b(*) ... .                                                                                    */
    /*                                                                                                      */
    /*    'separate-documents-collated-copies': If a Job object has multiple documents, say, the            */
    /*        document data is called a and b, then the result of processing the data in each document      */
    /*        instance MUST be treated as a single sequence of media sheets for finishing operations;       */
    /*        that is, the sets a(*) and b(*) would each be finished separately. The Printer object         */
    /*        MUST force each copy of the result of processing the data in a single document to start       */
    /*        on a new media sheet.  If more than one copy is made, the ordering of the sets of media       */
    /*        sheets resulting from processing the document data MUST be a(*), b(*), a(*), b(*), ... .      */
    /*                                                                                                      */
    /*    'single-document-new-sheet':  Same as 'single-document', except that the Printer object MUST      */
    /*        ensure that the first impression of each document instance in the job is placed on a new      */
    /*        media sheet.  This value allows multiple documents to be stapled together with a single       */
    /*        staple where each document starts on a new sheet.                                             */
    /*                                                                                                      */
    /* The 'single-document' value is the same as 'separate-documents-collated-copies' with respect to      */
    /* ordering of print-stream pages, but not media sheet generation, since 'single-document' will put     */
    /* the first page of the next document on the back side of a sheet if an odd number of pages have       */
    /* been produced so far for the job, while 'separate-documents-collated- copies' always forces the      */
    /* next document or document copy on to a new sheet.  In addition, if the "finishings" attribute        */
    /* specifies 'staple', then with 'single-document', documents a and b are stapled together as a         */
    /* single document with no regard to new sheets, with 'single-document-new-sheet', documents a and      */
    /* b are stapled together as a single document, but document b starts on a new sheet, but with          */
    /* 'separate-documents-uncollated-copies' and 'separate-documents-collated-copies', documents a and     */
    /* b are stapled separately.                                                                            */
    /*                                                                                                      */
    /* Note: None of these values provide means to produce uncollated sheets within a document, i.e.,       */
    /*       where multiple copies of sheet n are produced before sheet n+1 of the same document.           */
    /*                                                                                                      */
    /* The relationship of this attribute and the other attributes that control document processing is      */
    /* described in section 15.3.                                                                           */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §3.2.4 [page 49-50] Create-Job Operation                                                    */
        /* -----------------                                                                                */
        /* This OPTIONAL operation is similar to the Print-Job operation (section 3.2.1) except that in the */
        /* Create-Job request, a client does not supply document data or any reference to document data.    */
        /* Also, the client does not supply any of the "document-name", "document-format", "compression",   */
        /* or "document-natural-language" operation attributes.  This operation is followed by one or more  */
        /* Send-Document or Send-URI operations.  In each of those operation requests, the client           */
        /* OPTIONALLY supplies the "document-name", "document-format", and "document-natural-language"      */
        /* attributes for each document in the multi-document Job object.                                   */
        /*                                                                                                  */
        /* If a Printer object supports the Create-Job operation, it MUST also support the Send-Document    */
        /* operation and also MAY support the Send-URI operation.                                           */
        /*                                                                                                  */
        /* If the Printer object supports this operation, it MUST support the "multiple-operation-time-out" */
        /* Printer attribute (see section 4.4.31).                                                          */
        /*                                                                                                  */
        /* If the Printer object supports this operation, then it MUST support the                          */
        /* "multiple-document-jobs-supported" Printer Description attribute (see section 4.4.16) and        */
        /* indicate whether or not it supports multiple-document jobs.                                      */
        /*                                                                                                  */
        /* If the Printer object supports this operation and supports multiple documents in a job, then it  */
        /* MUST support the "multiple-document-handling" Job Template job attribute with at least one value */
        /* (see section 4.2.4) and the associated "multiple-document-handling-default" and                  */
        /* "multiple-document-handling-supported" Job Template Printer attributes (see section 4.2).        */
        /*                                                                                                  */
        /* After the Create-Job operation has completed, the value of the "job-state" attribute is similar  */
        /* to the "job-state" after a Print-Job, even though no document-data has arrived.  A Printer MAY   */
        /* set the 'job-data-insufficient' value of the job's "job-state-reason" attribute to indicate that */
        /* processing cannot begin until sufficient data has arrived and set the "job-state" to either      */
        /* 'pending' or 'pending-held'.  A non-spooling printer that doesn't implement the 'pending' job    */
        /* state may even set the "job-state" to 'processing', even though there is not yet any data to     */
        /* process.  See sections 4.3.7 and 4.3.8.                                                          */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §3.3.1 [page 62-65] Send-Document Operation                                                 */
        /* -----------------                                                                                */
        /* This OPTIONAL operation allows a client to create a multi-document Job object that is initially  */
        /* "empty" (contains no documents).  In the Create-Job response, the Printer object returns the Job */
        /* object's URI (the "job-uri" attribute) and the Job object's 32-bit identifier (the "job-id"      */
        /* attribute).  For each new document that the client desires to add, the client uses a             */
        /* Send-Document operation.  Each Send-Document Request contains the entire stream of document data */
        /* for one document.                                                                                */
        /*                                                                                                  */
        /* If the Printer supports this operation but does not support multiple documents per job, the      */
        /* Printer MUST reject subsequent Send-Document operations supplied with data and return the        */
        /* 'server-error-multiple-document-jobs-not-supported'.  However, the Printer MUST accept the first */
        /* document with a 'true' or 'false' value for the "last-document" operation attribute (see below), */
        /* so that clients MAY always submit one document jobs with a 'false' value for "last-document" in  */
        /* the first Send-Document and a 'true' for "last-document" in the second Send-Document (with no    */
        /* data).                                                                                           */
        /*                                                                                                  */
        /* Since the Create-Job and the send operations (Send-Document or Send-URI operations) that follow  */
        /* could occur over an arbitrarily long period of time for a particular job, a client MUST send     */
        /* another send operation within an IPP Printer defined minimum time interval after the receipt of  */
        /* the previous request for the job.  If a Printer object supports the Create-Job and Send-Document */
        /* operations, the Printer object MUST support the "multiple-operation-time-out" attribute (see     */
        /* section 4.4.31).  This attribute indicates the minimum number of seconds the Printer object will */
        /* wait for the next send operation before taking some recovery action.                             */
        /*                                                                                                  */
        /* An IPP object MUST recover from an errant client that does not supply a send operation, sometime */
        /* after the minimum time interval specified by the Printer object's "multiple-operation-time-out"  */
        /* attribute.  Such recovery MAY include any of the following or other recovery actions:            */
        /*                                                                                                  */
        /*    1. Assume that the Job is an invalid job, start the process of changing the job state to      */
        /*       'aborted', add the 'aborted-by-system' value to the job's "job-state-reasons" attribute    */
        /*       (see section 4.3.8), and clean up all resources associated with the Job.  In this case, if */
        /*       another send operation is finally received, the Printer responds with an                   */
        /*       "client-error-not-possible" or "client-error-not-found" depending on whether or not the    */
        /*       Job object is still around when the send operation finally arrives.                        */
        /*                                                                                                  */
        /*    2. Assume that the last send operation received was in fact the last document (as if the      */
        /*       "last-document" flag had been set to 'true'), close the Job object, and proceed to process */
        /*       it (i.e., move the Job's state to 'pending').                                              */
        /*                                                                                                  */
        /*    3. Assume that the last send operation received was in fact the last document, close the Job, */
        /*       but move it to the 'pending-held' and add the 'submission-interrupted' value to the job's  */
        /*       "job-state-reasons" attribute (see section 4.3.8).  This action allows the user or an      */
        /*       operator to determine whether to continue processing the Job by moving it back to the      */
        /*       'pending' state using the Release-Job operation (see section 3.3.6) or to cancel the job   */
        /*       using the Cancel-Job operation (see section 3.3.3).                                        */
        /*                                                                                                  */
        /* Each implementation is free to decide the "best" action to take depending on local policy,       */
        /* whether any documents have been added, whether the implementation spools jobs or not,  and/or    */
        /* any other piece of information available to it.  If the choice is to abort the Job object, it is */
        /* possible that the Job object may already have been processed to the point that some media sheet  */
        /* pages have been printed.                                                                         */
        /*                                                                                                  */
        /*    Access Rights: The authenticated user (see section 8.3) performing this operation must either */
        /*                   be the job owner (as determined in the Create-Job operation) or an operator or */
        /*                   administrator of the Printer object (see Sections 1 and 8.5).  Otherwise, the  */
        /*                   IPP object MUST reject the operation and return: 'client-error-forbidden',     */
        /*                   'client-error-not-authenticated', or 'client-error-not-authorized' as          */
        /*                   appropriate.                                                                   */
        /*                                                                                                  */
        /*    3.3.1.1 Send-Document Request                                                                 */
        /*        The following attribute sets are part of the Send-Document Request:                       */
        /*                                                                                                  */
        /*        + --------------------------------------------------------------------------------------- */
        /*        | Group 1: Operation Attributes                                                           */
        /*        | -----------------------------                                                           */
        /*        |                                                                                         */
        /*        + ---- Natural Language and Character Set:                                                */
        /*        |         The "attributes-charset" and "attributes-natural-language" attributes as        */
        /*        |         described in section 3.1.4.1.                                                   */
        /*        |                                                                                         */
        /*        + ---- Target:                                                                            */
        /*        |         Either                                                                          */
        /*        |             (1) the "printer-uri" (uri) plus "job-id" (integer(1:MAX))or                */
        /*        |             (2) the "job-uri" (uri) operation attribute(s) which define the target for  */
        /*        |                 this operation as described in section 3.1.5.                           */
        /*        |                                                                                         */
        /*        + ---- Requesting User Name:                                                              */
        /*        |         The "requesting-user-name" (name(MAX)) attribute SHOULD be supplied by the      */
        /*        |         client as described in section 8.3.                                             */
        /*        |                                                                                         */
        /*        + ---- "document-name" (name(MAX)):                                                       */
        /*        |         The client OPTIONALLY supplies this attribute.  The Printer object MUST support */
        /*        |         this attribute.  It contains the client supplied document name.  The document   */
        /*        |         name MAY be different than the Job name.  It might be helpful, but NEED NOT be  */
        /*        |         unique across multiple documents in the same Job.  Typically, the client        */
        /*        |         software automatically supplies the document name on behalf of the end user by  */
        /*        |         using a file name or an application generated name.  See the description of the */
        /*        |         "document-name" operation attribute in the Print-Job Request (section 3.2.1.1)  */
        /*        |         for more information about this attribute.                                      */
        /*        |                                                                                         */
        /*        + ---- "compression" (type3 keyword):                                                     */
        /*        |         See the description of "compression" for the Print-Job operation in             */
        /*        |         Section 3.2.1.1.                                                                */
        /*        |                                                                                         */
        /*        + ---- "document-format" (mimeMediaType):                                                 */
        /*        |         See the description of "document-format" for the Print-Job operation in         */
        /*        |         Section 3.2.1.1.                                                                */
        /*        |                                                                                         */
        /*        + ---- "document-natural-language" (naturalLanguage):                                     */
        /*        |         The client OPTIONALLY supplies this attribute.  The Printer object OPTIONALLY   */
        /*        |         supports this attribute.  This attribute specifies the natural language of the  */
        /*        |         document for those document-formats that require a specification of the natural */
        /*        |         language in order to image the document unambiguously.  There are no particular */
        /*        |         values required for the Printer object to support.                              */
        /*        |                                                                                         */
        /*        + ----- "last-document" (boolean):                                                        */
        /*        |         The client MUST supply this attribute.  The Printer object MUST support this    */
        /*        |         attribute. It is a boolean flag that is set to 'true' if this is the last       */
        /*        |         document for the Job, 'false' otherwise.                                        */
        /*        |                                                                                         */
        /*        +---------------------------------------------------------------------------------------- */
        /*                                                                                                  */
        /*        +---------------------------------------------------------------------------------------- */
        /*        | Group 2: Document Content                                                               */
        /*        | -------------------------                                                               */
        /*        |                                                                                         */
        /*        + ---- The client MUST supply the document data if the "last-document" flag is set to     */
        /*        |      'false'.  However, since a client might not know that the previous document sent   */
        /*        |      with a Send-Document (or Send-URI) operation was the last document (i.e., the      */
        /*        |      "last-document" attribute was set to 'false'), it is legal to send a Send-Document */
        /*        |      request with no document data where the "last-document" flag is set to 'true'.     */
        /*        |      Such a request MUST NOT increment the value of the Job object's                    */
        /*        |      "number-of-documents" attribute, since no real document was added to the job.  It  */
        /*        |      is not an error for a client to submit a job with no actual document data, i.e.,   */
        /*        |      only a single Create-Job and Send-Document request with a "last-document"          */
        /*        |      operation attribute set to 'true' with no document data.                           */
        /*        |                                                                                         */
        /*        +---------------------------------------------------------------------------------------- */
        /*                                                                                                  */
        /*    3.3.1.2 Send-Document Response                                                                */
        /*        The following sets of attributes are part of the Send-Document Response:                  */
        /*                                                                                                  */
        /*        + --------------------------------------------------------------------------------------- */
        /*        | Group 1: Operation Attributes                                                           */
        /*        | -----------------------------                                                           */
        /*        |                                                                                         */
        /*        + ---- Status Message:                                                                    */
        /*        |         In addition to the REQUIRED status code returned in every response, the         */
        /*        |         response OPTIONALLY includes a "status-message" (text(255)) and/or a            */
        /*        |         "detailed-status-message" (text(MAX)) operation attribute as described in       */
        /*        |         sections 13 and 3.1.6.                                                          */
        /*        |                                                                                         */
        /*        + ---- Natural Language and Character Set:                                                */
        /*        |         The "attributes-charset" and "attributes-natural-language" attributes as        */
        /*        |         described in section 3.1.4.2.                                                   */
        /*        |                                                                                         */
        /*        +---------------------------------------------------------------------------------------- */
        /*                                                                                                  */
        /*        +---------------------------------------------------------------------------------------- */
        /*        | Group 2: Unsupported Attributes                                                         */
        /*        | -------------------------------                                                         */
        /*        |                                                                                         */
        /*        + ---- See section 3.1.7 for details on returning Unsupported Attributes.                 */
        /*        |                                                                                         */
        /*        +---------------------------------------------------------------------------------------- */
        /*                                                                                                  */
        /*        +---------------------------------------------------------------------------------------- */
        /*        | Group 2: Job Object Attributes                                                          */
        /*        | -------------------------------                                                         */
        /*        |                                                                                         */
        /*        + ---- This is the same set of attributes as described in the Print-Job response (see     */
        /*        |      section 3.2.1.2).                                                                  */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §15.3 [page 212-213] Using Job Template Attributes During Document Processing.              */
        /* -----------------                                                                                */
        /* The Printer object uses some of the Job object's Job Template attributes during the processing   */
        /* of the document data associated with that job.  These include, but are not limited to,           */
        /* "orientation-requested", "number-up", "sides", "media", and "copies".  The processing of each    */
        /* document in a Job Object MUST follow the steps below. These steps are intended only to identify  */
        /* when and how attributes are to be used in processing document data and any alternative steps     */
        /* that accomplishes the same effect can be used to implement this specification document.          */
        /*                                                                                                  */
        /*    1. Using the client supplied "document-format" attribute or some form of document format      */
        /*       detection algorithm (if the value of "document-format" is not specific enough), determine  */
        /*       whether or not the document data has already been formatted for printing.  If the document */
        /*       data has been formatted, then go to step 2.  Otherwise, the document data MUST be          */
        /*       formatted. The formatting detection algorithm is implementation defined and is not         */
        /*       specified by this document.  The formatting of the document data uses the                  */
        /*       "orientation-requested" attribute to determine how the formatted print data should be      */
        /*       placed on a print-stream page, see section 4.2.10 for the details.                         */
        /*                                                                                                  */
        /*    2. The document data is in the form of a print-stream in a known media type. The              */
        /*       "page-ranges" attribute is used to select, as specified in section 4.2.7, a sub-sequence   */
        /*       of the pages in the print-stream that are to be processed and images.                      */
        /*                                                                                                  */
        /*    3. The input to this step is a sequence of print-stream pages.  This step is controlled by    */
        /*       the "number-up" attribute. If the value of "number-up" is N, then during the processing of */
        /*       the print-stream pages, each N print-stream pages are positioned, as specified in          */
        /*       section 4.2.9, to create a single impression.  If a given document does not have N more    */
        /*       print-stream pages, then the completion of the impression is controlled by the             */
        /*       "multiple-document-handling" attribute as described in section 4.2.4; when the value of    */
        /*       this attribute is 'single-document' or 'single-document-new-sheet', the print-stream pages */
        /*       of document data from subsequent documents is used to complete the impression.             */
        /*                                                                                                  */
        /*       The size(scaling), position(translation) and rotation of the print-stream pages on the     */
        /*       impression is implementation defined.  Note that during this process the print-stream      */
        /*       pages may be rendered to a form suitable for placing on the impression; this rendering is  */
        /*       controlled by the values of the "printer-resolution" and "print-quality" attributes as     */
        /*       described in sections 4.2.12 and 4.2.13. In the case N=1, the impression is nearly the     */
        /*       same as the print-stream page; the differences would only be in the size, position and     */
        /*       rotation of the print-stream page and/or any decoration, such as a frame to the page, that */
        /*       is added by the implementation.                                                            */
        /*                                                                                                  */
        /*    4. The collection of impressions is placed, in sequence, onto sides of the media sheets. This */
        /*       placement is controlled by the "sides" attribute and the orientation of the print-stream   */
        /*       page, as described in section 4.2.8. The orientation of the print-stream pages affects the */
        /*       orientation of the impression; for example, if "number-up" equals 2, then, typically, two  */
        /*       portrait print-stream pages become one landscape impression. Note that the placement of    */
        /*       impressions onto media sheets is also controlled by the "multiple-document-handling"       */
        /*       attribute as described in section 4.2.4.                                                   */
        /*                                                                                                  */
        /*    5. The "copies" and "multiple-document-handling" attributes are used to determine how many    */
        /*       copies of each media instance are created and in what order. See sections 4.2.5 and 4.2.4  */
        /*       for the details.                                                                           */
        /*                                                                                                  */
        /*    6. When the correct number of copies are created, the media instances are finished according  */
        /*       to the values of the "finishings" attribute as described in 4.2.6. Note that sometimes     */
        /*       finishing operations may require manual intervention to perform the finishing operations   */
        /*       on the copies, especially uncollated copies. This document allows any or all of the        */
        /*       processing steps to be performed automatically or manually at the discretion of the        */
        /*       Printer object.                                                                            */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef enum {
    PWG_MULTIPLE_DOCUMENTS_HANDLING_RESERVED_0 = 0,
    PWG_MULTIPLE_DOCUMENTS_HANDLING_RESERVED_1 = 1,
    PWG_MULTIPLE_DOCUMENTS_HANDLING_UNKNOWN    = 2,

    PWG_MULTIPLE_DOCUMENTS_HANDLING_SEPARATE_DOCUMENTS_COLLATED_COPIES,
    PWG_MULTIPLE_DOCUMENTS_HANDLING_SEPARATE_DOCUMENTS_UNCOLLATED_COPIES,
    PWG_MULTIPLE_DOCUMENTS_HANDLING_SINGLE_DOCUMENT,
    PWG_MULTIPLE_DOCUMENTS_HANDLING_SINGLE_DOCUMENT_NEW_SHEET,

    VND_MULT_DOC_HND_ENUM

    PWG_MULTIPLE_DOCUMENTS_HANDLING_END
} pwgMultipleDocumentsHandlingEnum, pwgMultDocHndEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgMultipleDocumentsHandling_Keywords[];
extern         pwgCHAR* pwgMultipleDocumentsHandling_KWValues[];
extern         pwgBIT8  pwgMultipleDocumentsHandling_KWVLevel[];
extern         pwgBOOL  pwgMultipleDocumentsHandling_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_MultipleDocumentsHandling;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_MULTIPLE_DOCUMENTS_HANDLING_H__                                                  */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================== pwg.pjt.pjp.3.multiple.documents.handling.h ============================= */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
