/* ================================ pwg.pjt.pjp.3.overriding.elements.h =================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_OVERRIDING_ELEMENTS_H__
#define __PWG_PJT_PJP_3_OVERRIDING_ELEMENTS_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Overriding Elements                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] OverridingElements             */
/* -----------------                                                                                        */
/* Document Ticket processing elements to apply to the Document pages specified in the Override             */
/* [PWG5100.6] §4.1.4                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.6] October 31, 2003: Candidate Standard 5100.6-2003                                        */
    /*                              Standard for The Internet Printing Protocol (IPP): Page Overrides       */
    /*      §4.1.4 [page 10] Overriding Job Template attributes                                             */
    /* -----------------                                                                                    */
    /* These attributes have the same meaning as in IPP/1.1. The Printer MUST support only Job Template     */
    /* attributes with a scope of Page, Cell, Impressions, or Sheet (see section 4.1.5).  The Printer MUST  */
    /* list Job Template attributes that the Printer supports for Override in the Printer's                 */
    /* "overrides-supported" attribute.                                                                     */
    /*                                                                                                      */
    /* All overriding Job Template attributes follow the same rules as ordinary Job Template attributes not */
    /* specified in an Override and interact with "ipp-attribute-fidelity" as specified in [rfc2911].       */
    /* Therefore if "ipp-attribute-fidelity" is 'false', the Printer MUST accept the request (assuming no   */
    /* other problems are found with the request) and any overriding Job Template attributes not supported  */
    /* by the Printer MUST be returned in "unsupported-attributes". If "ipp-attribute-fidelity" is 'true',  */
    /* then the Printer MUST reject the request and the unsupported Job Template attributes MUST be         */
    /* returned in "unsupported-attributes".                                                                */
    /*                                                                                                      */
    /* The client MUST include at least one attribute to be overridden. A request with "overrides" that     */
    /* does not have any overriding Job Template attributes MUST be rejected with a                         */
    /* 'client-error-bad-request' status code.                                                              */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.6] October 31, 2003: Candidate Standard 5100.6-2003                                    */
        /*                              Standard for The Internet Printing Protocol (IPP): Page Overrides   */
        /*      §4.1.5 [page 10-13] Scope of Job Template Attribute in an Override                          */
        /* -----------------                                                                                */
        /* Table 2 defines scopes for Job Template attributes as they apply to Overrides. The Scope is      */
        /* applicable only when the Job Template attribute is applied as part of an Override. A Scope is    */
        /* the smallest entity to which a Job Template attribute applies. The order of Scopes from largest  */
        /* to smallest is: a Job contains one or more Documents that are printed on one or more Sheets that */
        /* have up to two Impressions containing one or more Cells [^4] containing one or                   */
        /*                                                                                                  */
        /* [^4: If impositions are not applied to the page, then a Cell is equivalent to an Impression.     */
        /*      (i.e. an Impression contains one Cell)]                                                     */
        /*                                                                                                  */
        /* more Pages. For a Printer to support a Job Template attribute in an Override, it MUST support    */
        /* the Job Template at the specified Scope. Implementations MAY apply the Job Template attribute at */
        /* a smaller scope (e.g. Page instead of Impression).                                               */
        /*                                                                                                  */
        /* Job Template attributes with a scope of Job or Document SHOULD NOT be part of an Override.  They */
        /* are meaningless in a Override that is specified with a range of Pages in a Document.             */
        /*                                                                                                  */
        /* Included in the definitions are the rules for handling a change in the Job Template attribute    */
        /* value on Override boundaries. An Override boundary occurs when two contiguous Pages are in       */
        /* separate Overrides or two contiguous Pages have one Page in an Override and the other is not.    */
        /* When an Override boundary is reached and the value of the Job Template attribute does not        */
        /* change, the Printer MUST place the next Page on the Impression or Sheet without the transition   */
        /* move dictated in Table 2. For example: A Document is being printed with "number-up" set to '4'   */
        /* and "sides" set to 'two-sided-long-edge' and an Override is set for page 4 with "number-up" of   */
        /* '1'. Pages 1 to 3 will be printed on the first impression (i.e. first side of sheet 1).  The Job */
        /* Template attribute value change at the transition only affects Impressions (i.e. "number-up"     */
        /* from '4' to '1') so the next Page is printed on a new Impression (i.e. second side of the first  */
        /* sheet). Since the Job Template attribute affecting Sheets did not change, the fourth Page is not */
        /* printed on a new Sheet (i.e. first side of the second Sheet).                                    */
        /*                                                                                                  */
        /*                                      Table 2 Scope definitions                                   */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Override Scope | Definition                                                       |     */
        /*        +================+==================================================================+     */
        /*        | Job            | Job Template Attributes that operate on whole Jobs, such as      |     */
        /*        |                | "job-priority", "job-hold-until", and                            |     */
        /*        |                | "multiple-document-handling", are meaningless as page overrides. |     */
        /*        |                | The Client SHOULD NOT supply these attributes in "overrides".    |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Document       | Job Template Attributes that operate on whole Documents, such as |     */
        /*        |                | "copies", are meaningless as page overrides. These attributes    |     */
        /*        |                | SHOULD NOT be included in "overrides".                           |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Sheet          | Job Template Attributes that operate on whole Sheets, such as    |     */
        /*        |                | "media" and "finishings", are appropriate as Overrides. These    |     */
        /*        |                | attributes MAY be included in "overrides". When a Sheet          |     */
        /*        |                | attribute changes value at an Override boundary, this forces the |     */
        /*        |                | Printer to move on to the first side of a new sheet.             |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Impression     | Job Template Attributes that operate on whole Impressions, such  |     */
        /*        |                | as "imposition-template" or "print-quality", are appropriate as  |     */
        /*        |                | Overrides. These attributes MAY be included in "overrides". When |     */
        /*        |                | an Impression attribute changes value at an Override boundary,   |     */
        /*        |                | this forces the Printer to move on to the next Impression -- that|     */
        /*        |                | is, the next side.                                               |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Cell           | Job Template Attributes that operate on whole Cell, such as      |     */
        /*        |                | "number-up" or "x-side1-image-shift", are appropriate as         |     */
        /*        |                | Overrides. These attributes MAY be included in "overrides". When |     */
        /*        |                | an Cell attribute changes value at an Override boundary, this    |     */
        /*        |                | forces the Printer to move on to the next Cell on the            |     */
        /*        |                | impression. If impositions are not in effect there is only one   |     */
        /*        |                | Cell per impression. Therefore a change at an Override boundary  |     */
        /*        |                | would require moving to the next side.                           |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*        | Page           | Job Template Attributes that operate on whole Pages, such as     |     */
        /*        |                | "orientation-requested", are appropriate as Overrides. These     |     */
        /*        |                | attributes MAY be included in "overrides". Job Template          |     */
        /*        |                | Attributes that operate on Pages do not affect the location of   |     */
        /*        |                | the page image in the Cell (or Impression if impositions are not |     */
        /*        |                | being applied).                                                  |     */
        /*        +----------------+------------------------------------------------------------------+     */
        /*                                                                                                  */
        /* Table 3 below shows the Scope for the Job Template attributes. As indicated above, Job Template  */
        /* attributes with a Scope of Job or Document are not applicable to Overrides. The "Override Scope" */
        /* column contains 'N/A' for these Job Template attributes. Table 2 above indicates the appropriate */
        /* behavior for when the attribute values change on Override boundaries.                            */
        /*                                                                                                  */
        /* The Job Template attributes "print-quality" and "printer-resolution" have an Override Scope of   */
        /* Impression. To support these attributes in an "override"the Printers MUST implement them at      */
        /* least to the Override Scope of Impression. As with any "override" attribute the Printer MAY      */
        /* implement them with the reduced Override Scope of Page.                                          */
        /*                                                                                                  */
        /*                          Table 3 Job Template Attribute Override Scope                           */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | Job Template Attribute |  Override  |      Attribute Syntax        |       Reference       | */
        /*   |                        |    Scope   |                              |                       | */
        /*   +========================+============+==============================+=======================+ */
        /*   | copies                 | N/A        | integer(1:MAX)               | [rfc2911]   | §4.2.5  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | cover-back             | N/A        | collection                   | [pwg5100.3] | §3.1    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | cover-front            | N/A        | collection                   | [pwg5100.3] | §3.1    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | finishings             | Sheet      | 1setOf type2 enum            | [rfc2911]   | §4.2.6  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | finishings-col         | Sheet      | collection                   | [pwg5100.3] | §3.2    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | force-front-side       | Sheet      | 1setOf integer(1:MAX)        | [pwg5100.3] | §3.3    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | imposition-template    | Impression | type2 keyword or name(MAX)   | [pwg5100.3] | §3.4    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | insert-sheet           | N/A        | 1setOf collection            | [pwg5100.3] | §3.5    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-account-id         | N/A        | name(MAX)                    | [pwg5100.3] | §3.6    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-accounting-sheets  | N/A        | collection                   | [pwg5100.3] | §3.8    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-accounting-        |            |                              |             |         | */
        /*   |           user-id**    | N/A        | name(MAX)                    | [pwg5100.3] | §3.7    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-copies             | N/A        | integer(1:MAX)               | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-cover-back         | N/A        | collection                   | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-cover-front        | N/A        | collection                   | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-error-sheet        | N/A        | collection                   | [pwg5100.3] | §3.9    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-finishings         | N/A        | 1setOf type2 enum            | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-finishings-col     | N/A        | collection                   | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-hold-until         | N/A        | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.2  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-message-to-        | N/A        | text(MAX)                    | [pwg5100.3] | §3.10   | */
        /*   |          operator      |            |                              |             |         | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-priority           | N/A        | integer(1:100)               | [rfc2911]   | §4.2.1  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-sheet-message      | N/A        | text(MAX)                    | [pwg5100.3] | §3.12   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-sheets             | N/A        | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.3  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | job-sheets-col         | N/A        | collection                   | [pwg5100.3] | §3.11   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | media                  | Sheet      | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.11 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | media-col              | Sheet      | collection                   | [pwg5100.3] | §3.13   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | media-input-tray-check | N/A        | type3 keyword or name(MAX)   | [pwg5100.3] | §3.14   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | media-type             | Sheet      | type3 keyword or name(MAX)   | [upnp],     |         | */
        /*   |                        |            |                              | [pwg5100.3] | §3.13.2 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | multiple-document-     | N/A        | type2 keyword                | [rfc2911]   | §4.2.4  | */
        /*   |              handling  |            |                              |             |         | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | number-up              | Cell       | integer(1:MAX)               | [rfc2911]   | §4.2.9  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | orientation-requested  | Page       | type2 enum                   | [rfc2911]   | §4.2.10 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | output-bin             | N/A        | type2 keyword or name(MAX)   | [pwg5100.2] | §2.1    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | output-device          | Sheet      | name(MAX)                    | [jobx]      | §5.1.   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | page-delivery          | N/A        | type2 keyword                | [pwg5100.3] | §3.15   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | page-order-received    | N/A        | type2 keyword                | [pwg5100.3] | §3.16   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | page-ranges            | N/A        | 1setOf rangeOfInteger(1:MAX) | [rfc2911]   | §4.2.7  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | presentation-          | Cell       | type2 keyword                | [pwg5100.3] | §3.17   | */
        /*   |   direction-number-up  |            |                              |             |         | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | print-quality          | Impression | type2 enum                   | [rfc2911]   | §4.2.13 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | printer-resolution     | Impression | resolution                   | [rfc2911]   | §4.2.12 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | separator-sheets       | N/A        | collection                   | [pwg5100.3] | §3.18   | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | sheet-collate          | N/A        | type2 keyword                | [rfc3381]   | §3.1    | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | sides                  | Sheet      | type2 keyword                | [rfc2911]   | §4.2.8  | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | x-image-position       | Cell       | type2 keyword                | [pwg5100.3] | §3.19.2 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | x-image-shift          | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.3 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | x-side1-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.4 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | x-side2-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.5 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | y-image-position       | Cell       | type2 keyword                | [pwg5100.3] | §3.19.6 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | y-image-shift          | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.7 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | y-side1-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.8 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*   | y-side2-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.9 | */
        /*   +------------------------+------------+------------------------------+-----------------------+ */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef enum {
    PWG_OVERRIDING_ELEMENTS_RESERVED_0 = 0,
    PWG_OVERRIDING_ELEMENTS_RESERVED_1 = 1,
    PWG_OVERRIDING_ELEMENTS_UNKNOWN    = 2,

    PWG_OVERRIDING_ELEMENTS_IMPOSITION_TEMPLATE,              /* Keyword      pwgImpositionTemplateEnum     */
    PWG_OVERRIDING_ELEMENTS_INSERT_SHEET,                     /* Collection   pwgInsertSheetCollection      */
    PWG_OVERRIDING_ELEMENTS_JOB_ACCOUNT_ID,                   /* String       pwgCHAR[]                     */
    PWG_OVERRIDING_ELEMENTS_JOB_ACCOUNTING_SHEETS,            /* Collection   pwgJobAccountingSheets        */
    PWG_OVERRIDING_ELEMENTS_JOB_ACCOUNTING_USER_ID,           /* String       pwgCHAR[]                     */
    PWG_OVERRIDING_ELEMENTS_JOB_COPIES,                       /* Integer      pwgBIT32                      */
    PWG_OVERRIDING_ELEMENTS_JOB_COVER_BACK,                   /* Collection   pwgCoverCollection            */
    PWG_OVERRIDING_ELEMENTS_JOB_COVER_FRONT,                  /* Collection   pwgCoverCollection            */
    PWG_OVERRIDING_ELEMENTS_JOB_ERROR_SHEET,                  /* Collection   pwgJobErrorSheetCollection    */
    PWG_OVERRIDING_ELEMENTS_JOB_FINISHINGS,                   /* Keyword      pwgJobFinishingsEnum          */
    PWG_OVERRIDING_ELEMENTS_JOB_FINISHINGS_COL,               /* Collection   pwgJobFinsihingCollecton      */
    PWG_OVERRIDING_ELEMENTS_JOB_HOLD_UNTIL,                   /* Keyword      pwgJobHoldUntilEnum           */
    PWG_OVERRIDING_ELEMENTS_JOB_MESSAGE_TO_OPERATOR,          /* String       pwgCHAR[]                     */
    PWG_OVERRIDING_ELEMENTS_JOB_PRIORITY,                     /* Integer      pwgBIT8                       */
    PWG_OVERRIDING_ELEMENTS_JOB_SHEET_MESSAGE,                /* String       pwgCHAR[]                     */
    PWG_OVERRIDING_ELEMENTS_JOB_SHEETS,                       /* Keyword      pwgJobSheetsEnum              */
    PWG_OVERRIDING_ELEMENTS_JOB_SHEETS_COL,                   /* Collection   pwgJobSheetsCol               */
    PWG_OVERRIDING_ELEMENTS_MEDIA,                            /* Keyword      pwgMediaSizeNameEnum          */
    PWG_OVERRIDING_ELEMENTS_MEDIA_COL,                        /* Collection   pwgMediaCollecton             */
    PWG_OVERRIDING_ELEMENTS_MEDIA_INPUT_TRAY_CHECK,           /* Keyword      pwgMediaInputTrayCheckEnum    */
    PWG_OVERRIDING_ELEMENTS_MEDIA_TYPE,                       /* Keyword      pwgMediaTypeEnum              */
    PWG_OVERRIDING_ELEMENTS_MULTIPLE_DOCUMENT_HANDLING,       /* Keyword      pwgMultDocHndEnum             */
    PWG_OVERRIDING_ELEMENTS_NUMBER_UP,                        /* Integer      pwgBIT32                      */
    PWG_OVERRIDING_ELEMENTS_ORIENTATION_REQUESTED,            /* Keyword      pwgOrientationEnum            */
    PWG_OVERRIDING_ELEMENTS_OUTPUT_BIN,                       /* Keyword      pwgOutputBinEnum              */
    PWG_OVERRIDING_ELEMENTS_OUTPUT_DEVICE,                    /* String       pwgCHAR[]                     */
    PWG_OVERRIDING_ELEMENTS_PAGE_DELIVERY,                    /* Keyword      pwgPageDeliveryEnum           */
    PWG_OVERRIDING_ELEMENTS_PAGE_ORDER_RECEIVED,              /* Keyword      pwgPageOrderReceivedEnum      */
    PWG_OVERRIDING_ELEMENTS_PAGE_RANGES,                      /* RangeofInt   pageRanges[]                  */
    PWG_OVERRIDING_ELEMENTS_PRESENTATION_DIRECTION_NUMBER_UP, /* Keyword      pwgPresDirNumUpEnum           */
    PWG_OVERRIDING_ELEMENTS_PRINT_QUALITY,                    /* Keyword      pwgQualityEnum                */
    PWG_OVERRIDING_ELEMENTS_PRINTER_RESOLUTION,               /* Collection   pwgResolution                 */
    PWG_OVERRIDING_ELEMENTS_SEPARATOR_SHEETS,                 /* Collection   pwgSeparatorSheets            */
    PWG_OVERRIDING_ELEMENTS_SHEET_COLLATE,                    /* Keyword      pwgSheetCollateEnum           */
    PWG_OVERRIDING_ELEMENTS_SIDES,                            /* Keyword      pwgSidesEnum                  */
    PWG_OVERRIDING_ELEMENTS_X_IMAGE_POSITION,                 /* Keyword      pwgXImagePositionEnum         */
    PWG_OVERRIDING_ELEMENTS_X_IMAGE_SHIFT,                    /* Integer      pwgINT32                      */
    PWG_OVERRIDING_ELEMENTS_X_SIDE1_IMAGE_SHIFT,              /* Integer      pwgINT32                      */
    PWG_OVERRIDING_ELEMENTS_X_SIDE2_IMAGE_SHIFT,              /* Integer      pwgINT32                      */
    PWG_OVERRIDING_ELEMENTS_Y_IMAGE_POSITION,                 /* Keyword      pwgYImagePositionEnum         */
    PWG_OVERRIDING_ELEMENTS_Y_IMAGE_SHIFT,                    /* Integer      pwgINT32                      */
    PWG_OVERRIDING_ELEMENTS_Y_SIDE1_IMAGE_SHIFT,              /* Integer      pwgINT32                      */
    PWG_OVERRIDING_ELEMENTS_Y_SIDE2_IMAGE_SHIFT,              /* Integer      pwgINT32                      */

    VND_OVR_ELEM_ENUM

    PWG_OVERRIDING_ELEMENTS_END                               /* Pointer      NULL                          */
} pwgOverridingElementsEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgOverridingElements_Keywords[];
extern         pwgCHAR* pwgOverridingElements_KWValues[];
extern         pwgBIT8  pwgOverridingElements_KWVLevel[];
extern         pwgBOOL  pwgOverridingElements_KWVSupported[];
extern  pwgNUM_RNG_DEF  pwgDef_OverridingElements;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_OVERRIDING_ELEMENTS_H__                                                          */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.3.overriding.elements.h =================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
