/* =================================== pwg.pjt.xxx.N.level.config.h ======================================= */
/* ..................................................|..................................................... */

/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_XXX_N_LEVEL_CONFIG_H__
#define __PWG_PJT_XXX_N_LEVEL_CONFIG_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */
/* ======================================================================================================== */
/* The Printer Working Group (PWG) Print Job Ticket (PJT) is rich set of printing objects, attributes,      */
/* elements and values that support the simplest level of printing to most complex.  It supports printing   */
/* from and in an embedded, mobile, home-office, business office and production environments.  However,     */
/* having all Applications and/or Print Clients and even Print Services in the various environments support */
/* the complete PWG: PJT would be a burden.   While a Print Services only needs to provide capability       */
/* information that is supports, it would imply that a Print Client support everything to any Print Service.*/
/* Just not practical.  Therefore, this document provides a set conformance levels that can be used by      */
/* various Print Client (and other print entities).  This support a level of processing that is suited to   */
/* the environment.                                                                                         */
/*                                                                                                          */
/* A Print Client (or other print entity) may advertise the level of support to other print entities to     */
/* align PJT content.  However, advertisement of support level is not required; thus, the Print Client or   */
/* print entity accepting a PJT must accept any level PJT, operate on the level of the PJT it supports and  */
/* gracefully (no errors or failures) not process unsupported PJT elements.  Note, that MUST-HONOR elements */
/* must produce an error (as is normally required) if the level does not support a MUST_HONOR element.      */
/*                                                                                                          */
/* Note that level build on each other; that is, level 2 support all of level 1 plus new items, etc.        */
/*                                                                                                          */
/* Note that any Application, Print Client or other print entity can support any of the possible levels.    */
/* The level really indicate the level of PJT support the Application, Print Client or other print entity   */
/* actually supports.                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
#define PJT_SUPPORT_LEVEL_NONE     99                 /* Undefined                                          */
#define PJT_SUPPORT_LEVEL_1         1                 /* Simple        Print Job Ticket                     */
#define PJT_SUPPORT_LEVEL_2         2                 /* Typical       Print Job Ticket                     */
#define PJT_SUPPORT_LEVEL_3         3                 /* Full Featured Print Job Ticket                     */

#define PJT_EMBEDDED          PJT_SUPPORT_LEVEL_1
#define PJT_MOBILE            PJT_SUPPORT_LEVEL_1

#define PJT_SMALL_OFFICE      PJT_SUPPORT_LEVEL_2
#define PJT_HOME_OFFICE       PJT_SUPPORT_LEVEL_2
#define PJT_OFFICE_WORKER     PJT_SUPPORT_LEVEL_2
#define PJT_DESKTOP_OFFICE    PJT_SUPPORT_LEVEL_2

#define PJT_BUSINESS_OFFICE   PJT_SUPPORT_LEVEL_3
#define PJT_PRODUCITON        PJT_SUPPORT_LEVEL_3

/*                                                                                                          */
/* PrintJobTicket                                                                                           */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/*    printDocumentProcessing ........................................................... X   X   X         */
/*        VENDOR_EXTENSION .............................................................. X   X   X         */
/*    printJobDescription ............................................................... X   X   X         */
/*        VENDOR_EXTENSION .............................................................. X   X   X         */
/*    printJobProcessing ................................................................ X   X   X         */
/*        VENDOR_EXTENSION .............................................................. X   X   X         */
/*                                                                                                          */
/* #########################################################################################################*/
/*                                                                                                          */
/* PrintDocumentProcessingType                                                                              */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/*   NumberUp ........................................................................... X   X   X         */
/*   PresentationDirctionNumberUp                                                                           */
/*                  TO_RIGHT_TO_BOTTOM .................................................. X   X   X         */
/*                  TO_BOTTOM_TO_RIGHT .................................................. _   _   X         */
/*                  TO_LEFT_TO_BOTTOM ................................................... _   _   X         */
/*                  TO_BOTTOM_TO_LEFT ................................................... _   _   X         */
/*                  TO_RIGHT_TO_TOP ..................................................... _   _   X         */
/*                  TO_TOP_TO_RIGHT ..................................................... _   _   X         */
/*                  TO_LEFT_TO_TOP ...................................................... _   _   X         */
/*                  TO_TOP_TO_LEFT ...................................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   Copies ............................................................................. X   X   X         */
/*   CoverBack .......................................................................... _   _   X         */
/*             |> CoverType                                                                                 */
/*                  PWG_COVER_TYPE_NO_COVER ............................................. _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_NONE ........................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_FRONT .......................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_BACK ........................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_BOTH ........................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   CoverFront ......................................................................... _   X   X         */
/*             |> CoverType                                                                                 */
/*                  PWG_COVER_TYPE_NO_COVER ............................................. _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_NONE ........................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_FRONT .......................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_BACK ........................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_BOTH ........................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   FeedOrientation                                                                                        */
/*                  FEED_ORIENTATION_LONG_EDGE_FIRST .................................... _   _   X         */
/*                  FEED_ORIENTATION_SHORT_EDGE_FIRST ................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*   Finishing                                                                                              */
/*                  NONE ................................................................ X   X   X         */
/*                  STAPLE .............................................................. _   _   X         */
/*                  PUNCH ............................................................... _   _   X         */
/*                  COVER ............................................................... _   _   X         */
/*                  BIND ................................................................ _   _   X         */
/*                  SADDLE_STITCH ....................................................... _   _   X         */
/*                  EDGE_STITCH ......................................................... _   _   X         */
/*                  FOLD ................................................................ _   _   X         */
/*                  TRIM ................................................................ _   _   X         */
/*                  BALE ................................................................ _   _   X         */
/*                  BOOKLET_MAKER ....................................................... _   _   X         */
/*                  JOG_OFFSET .......................................................... X   X   X         */
/*                  STAPLE_TOP_LEFT ..................................................... X   X   X         */
/*                  STAPLE_BOTTOM_LEFT .................................................. _   _   X         */
/*                  STAPLE_TOP_RIGHT .................................................... _   _   X         */
/*                  STAPLE_BOTTOM_RIGHT ................................................. _   _   X         */
/*                  EDGE_STITCH_LEFT .................................................... _   _   X         */
/*                  EDGE_STITCH_TOP ..................................................... _   _   X         */
/*                  EDGE_STITCH_RIGHT ................................................... _   _   X         */
/*                  EDGE_STITCH_BOTTOM .................................................. _   _   X         */
/*                  STAPLE_DUAL_LEFT .................................................... _   _   X         */
/*                  STAPLE_DUAL_TOP ..................................................... _   _   X         */
/*                  STAPLE_DUAL_RIGH	................................................... _   _   X         */
/*                  STAPLE_DUAL_BOTTOM .................................................. _   _   X         */
/*                  BIND_LEFT ........................................................... _   _   X         */
/*                  BIND_TOP ............................................................ _   _   X         */
/*                  BIND_RIGHT .......................................................... _   _   X         */
/*                  BIND_BOTTOM ......................................................... _   _   X         */
/*   FinishingCol ....................................................................... _   _   X         */
/*             |> FinishingTemplate ..................................................... _   _   X         */
/*             |> Stitching                                                                                 */
/*                  STITCHING_REF_EDGE_BOTTOM ........................................... _   _   X         */
/*                  STITCHING_REF_EDGE_TOP .............................................. _   _   X         */
/*                  STITCHING_REF_EDGE_LEFT ............................................. _   _   X         */
/*                  STITCHING_REF_EDGE_RIGHT ............................................ _   _   X         */
/*   FontName                                                                                               */
/*                               ???????? ............................................ _   _   X         */
/*   FontSizeRequested .................................................................. X   X   X         */
/*   ForceFrontSide ..................................................................... _   _   X         */
/*   ImpositionTemplate                                                                                     */
/*                  IMPOSITION_TEMPLATE_NONE ............................................ _   _   X         */
/*                  IMPOSITION_TEMPLATE_SIGNATURE ....................................... _   _   X         */
/*                  IMPOSITION_TEMPLATE_Z_FOLD .......................................... _   _   X         */
/*                  IMPOSITION_TEMPLATE_SAME_UP ......................................... _   _   X         */
/*   InsertSheet ........................................................................ _   _   X         */
/*             |> InsertAfterPageNumber ................................................. _   _   X         */
/*             |> InsertCount ........................................................... _   _   X         */
/*             |> MediaType ............................................................. _   _   X         */
/*             |> Media ................................................................. _   _   X         */
/*             |> MediaCol .............................................................. _   X   X         */
/*             |> VENDOR_EXTENSION ...................................................... _   X   X         */
/*   MediaType                                                                                              */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   Media                                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   MediaCol                                                                                               */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   MediaInputTrayCheck                                                                                    */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   OrientationRequested                                                                                   */
/*                  ORIENTATION_REQUESTED_LANDSCAPE ..................................... X   X   X         */
/*                  ORIENTATION_REQUESTED_PORTRAIT ...................................... X   X   X         */
/*                  ORIENTATION_REQUESTED_REVERSE_LANDSCAPE ............................. X   X   X         */
/*                  ORIENTATION_REQUESTED_REVERSE_PORTRAIT .............................. X   X   X         */
/*                  ORIENTATION_REQUESTED_NONE........................................... X   X   X         */
/*   OutputBin                                                                                              */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   OutputDevice ....................................................................... _   _   X         */
/*   PageDelivery                                                                                           */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   PageRanges ......................................................................... X   X   X         */
/*             |> LowerBound ............................................................ X   X   X         */
/*             |> UpperBound ............................................................ X   X   X         */
/*             |> VENDOR_EXTENSION ...................................................... X   X   X         */
/*   PdlInitFile ........................................................................ _   _   X         */
/*   PrintContentOptimize                                                                                   */
/*                  PRINT_CONTENT_OPTIMIZE_TEXT ......................................... X   X   X         */
/*                  PRINT_CONTENT_OPTIMIZE_GRAPHICS ..................................... X   X   X         */
/*                  PRINT_CONTENT_OPTIMIZE_TEXT_AND_GRAPHICS ............................ X   X   X         */
/*                  PRINT_CONTENT_OPTIMIZE_PHOTO ........................................ X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   PrintColorMode                                                                                         */
/*                  AUTO ................................................................ X   X   X         */
/*                  BI_LEVEL ............................................................ X   X   X         */
/*                  COLOR ............................................................... X   X   X         */
/*                  HIGHLIGHT ........................................................... _   _   X         */
/*                  MONOCHROME .......................................................... X   X   X         */
/*                  PROCESS_BI_LEVEL .................................................... X   X   X         */
/*                  PROCESS_MONOCHROME .................................................. X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   PrintRenderingIntent                                                                                   */
/*                  PRINT_RENDERING_INTENT_AUTO ......................................... X   X   X         */
/*                  PRINT_RENDERING_INTENT_ABSOLUTE ..................................... _   X   X         */
/*                  PRINT_RENDERING_INTENT_PERCEPTUAL ................................... X   X   X         */
/*                  PRINT_RENDERING_INTENT_RELATIVE ..................................... _   X   X         */
/*                  PRINT_RENDERING_INTENT_RELATIVE_BPC ................................. _   X   X         */
/*                  PRINT_RENDERING_INTENT_SATURATION ................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   Quality                                                                                                */
/*                  QUALITY_DRAFT ....................................................... X   X   X         */
/*                  QUALITY_NORMAL ...................................................... X   X   X         */
/*                  QUALITY_HIGH ........................................................ X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   Resolution ......................................................................... X   X   X         */
/*             |> CrossFeedDir .......................................................... X   X   X         */
/*             |> FeedDir ............................................................... X   X   X         */
/*             |> ResolutionUnit                                                                            */
/*                  PWG_RESOLUTION_UNITS_DPI ............................................ X   X   X         */
/*                  PWG_RESOLUTION_UNITS_DPCM ........................................... X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   SeparatorSheets                                                                                        */
/*                  SEPARATOR_SHEETS_TYPE_NONE .......................................... _   X   X         */
/*                  SEPARATOR_SHEETS_TYPE_SLIP_SHEET .................................... _   X   X         */
/*                  SEPARATOR_SHEETS_TYPE_START_SHEET ................................... _   X   X         */
/*                  SEPARATOR_SHEETS_TYPE_END_SHEET ..................................... _   X   X         */
/*                  SEPARATOR_SHEETS_TYPE_BOTH_SHEETS ................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*   SheetCollate                                                                                           */
/*                  SHEET_COLLATE_UNCOLLATED ............................................ X   X   X         */
/*                  SHEET_COLLATE_COLLATED .............................................. X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   Sides                                                                                                  */
/*                  SIDES_ONE_SIDED ..................................................... X   X   X         */
/*                  SIDES_TWO_SIDED_LONG_EDGE ........................................... X   X   X         */
/*                  SIDES_TWO_SIDED_SHORT_EDGE .......................................... X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   XImagePosition                                                                                         */
/*                  X_IMAGE_POSITION_NONE ............................................... X   X   X         */
/*                  X_IMAGE_POSITION_CENTER ............................................. X   X   X         */
/*                  X_IMAGE_POSITION_LEFT ............................................... X   X   X         */
/*                  X_IMAGE_POSITION_RIGHT .............................................. X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   XImageShift ........................................................................ X   X   X         */
/*   XSide1ImageShift ................................................................... X   X   X         */
/*   XSide2ImageShift ................................................................... X   X   X         */
/*   YImagePosition                                                                                         */
/*                  Y_IMAGE_POSITION_NONE ............................................... X   X   X         */
/*                  Y_IMAGE_POSITION_CENTER ............................................. X   X   X         */
/*                  Y_IMAGE_POSITION_TOP ................................................ X   X   X         */
/*                  Y_IMAGE_POSITION_BOTTOM ............................................. X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   YImageShift ........................................................................ X   X   X         */
/*   YSide1ImageShift ................................................................... X   X   X         */
/*   YSide2ImageShift ................................................................... X   X   X         */
/*   VENDOR_EXTENSION ................................................................... X   X   X         */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/* End-of --- PrintDocumentProcessingType                                                                   */

/* #########################################################################################################*/
/*                                                                                                          */
/* PrintJobDescriptionType                                                                                  */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/*   ElementsNaturalLanguage                                                                                */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   JobAccountingID .................................................................... X   X   X         */
/*   JobAccountingUserID ................................................................ X   X   X         */
/*   JobMessageFromOperator ............................................................. _   _   X         */
/*   JobMessageToOperator ............................................................... _   _   X         */
/*   JobMoreInfo ........................................................................ X   X   X         */
/*   JobName ............................................................................ _   X   X         */
/*   JobOriginatingUserName ............................................................. X   X   X         */
/*   JobOriginatingUserUri .............................................................. _   X   X         */
/*   JobPages ........................................................................... _   X   X         */
/*   KOctets  ........................................................................... _   X   X         */
/*   TemplateCreatorUserName ............................................................ _   _   X         */
/*   TemplateId ......................................................................... _   _   X         */
/*   TemplateInfo ....................................................................... _   _   X         */
/*   TemplateName ....................................................................... _   _   X         */
/*   TemplateType                                                                                           */
/*                  TEMPLATE_TYPE_NONE .................................................. _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   CompresssionSupplied                                                                                   */
/*                  COMPRESSION_SUPPLIED_DEFLATE ........................................ _   _   X         */
/*                  COMPRESSION_SUPPLIED_GZIP ........................................... _   _   X         */
/*                  COMPRESSION_SUPPLIED_COMPRESS ....................................... _   _   X         */
/*                  COMPRESSION_SUPPLIED_NONE ........................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   DocumentCharsetSupplied                                                                                */
/*      <This is set of over 8000 enum and no specific set can be specified.  Regionally dependent.>        */
/*   DocumentDigitalSignatureSupplied                                                                       */
/*                  DOCUMENT_DIGITAL_SIGNATURE_SUPPLIED_DSS ............................. _   _   X         */
/*                  DOCUMENT_DIGITAL_SIGNATURE_SUPPLIED_NONE ............................ _   _   X         */
/*                  DOCUMENT_DIGITAL_SIGNATURE_SUPPLIED_PGP ............................. _   _   X         */
/*                  DOCUMENT_DIGITAL_SIGNATURE_SUPPLIED_SMIME............................ _   _   X         */
/*                  DOCUMENT_DIGITAL_SIGNATURE_SUPPLIED_XDSIG ........................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   DocumentFormatDetailsSupplied ...................................................... _   _   X         */
/*             |> DocumentFormat                                                                            */
/*                  DOCUMENT_FORMAT_APPLICATION_OCTET_STREAM ............................ _   _   X         */
/*                  DOCUMENT_FORMAT_APPLICATION_PDF ..................................... _   X   X         */
/*                  DOCUMENT_FORMAT_APPLICATION_POSTSCRIPT .............................. _   _   X         */
/*                  DOCUMENT_FORMAT_APPLICATION_VND_PWG_XHTML_PRINT_XML ................. _   X   X         */
/*                  DOCUMENT_FORMAT_APPLICATION_VND_HP_PCL .............................. _   X   X         */
/*                  DOCUMENT_FORMAT_IMAGE_G3FAX ......................................... _   _   X         */
/*                  DOCUMENT_FORMAT_IMAGE_JPEG .......................................... _   X   X         */
/*                  DOCUMENT_FORMAT_IMAGE_TIFF .......................................... _   X   X         */
/*                  DOCUMENT_FORMAT_IMAGE_TIFF_FX ....................................... _   X   X         */
/*                  DOCUMENT_FORMAT_TEXT_HTML ........................................... _   X   X         */
/*                  DOCUMENT_FORMAT_TEXT_PLAIN .......................................... _   X   X         */
/*                  DOCUMENT_FORMAT_TEXT_PLAIN_CHARSET_ISO_8859_1 ....................... _   _   X         */
/*                  DOCUMENT_FORMAT_TEXT_PLAIN_CHARSET_US_ASCII ......................... _   X   X         */
/*                  DOCUMENT_FORMAT_TEXT_PLAIN_CHARSET_UTF_8 ............................ _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> DocumentFormatVersion ................................................. _   X   X         */
/*             |> DocumentFormatDeviceId ................................................ _   X   X         */
/*             |> DocumentNaturalLanguage ............................................... _   X   X         */
/*             |> DocumentSourceApplicationName ......................................... _   X   X         */
/*             |> DocumentSourceApplicationVersion ...................................... _   X   X         */
/*             |> DocumentSourceOsName .................................................. _   X   X         */
/*             |> DocumentSourceOsVersion ............................................... _   X   X         */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   DocumentFormatSupplied                                                                                 */
/*                  DOCUMENT_FORMAT_SUPPLIED_APPLICATION_OCTET_STREAM ................... _   _   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_APPLICATION_PDF ............................ X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_APPLICATION_POSTSCRIPT ..................... _   _   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_APPLICATION_VND_PWG_XHTML_PRINT_XML ........ X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_APPLICATION_VND_HP_PCL ..................... _   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_IMAGE_G3FAX ................................ _   _   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_IMAGE_JPEG ................................. X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_IMAGE_TIFF ................................. _   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_IMAGE_TIFF_FX .............................. _   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_TEXT_HTML .................................. X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_TEXT_PLAIN ................................. X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_TEXT_PLAIN_CHARSET_ISO_8859_1 .............. _   _   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_TEXT_PLAIN_CHARSET_US_ASCII ................ X   X   X         */
/*                  DOCUMENT_FORMAT_SUPPLIED_TEXT_PLAIN_CHARSET_UTF_8 ................... X   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*   DocumentFormatVersionSupplied ...................................................... X   X   X         */
/*   DocumentMessageSupplied ............................................................ _   _   X         */
/*   DocumentMetaData ................................................................... _   _   X         */
/*   DocumentNameSupplied ............................................................... X   X   X         */
/*   DocumentUri ........................................................................ X   X   X         */
/*   Impressions ........................................................................ _   X   X         */
/*   JobCollationType ................................................................... X   X   X         */
/*   MediaSheets ........................................................................ _   X   X         */
/*   PageOrderReceived                                                                                      */
/*                  PWG_PAGE_ORDER_RECEIVED_1_TO_N_ORDER ................................ X   X   X         */
/*                  PWG_PAGE_ORDER_RECEIVED_N_TO_1_ORDER ................................ X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   VENDOR_EXTENSION ................................................................... X   X   X         */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/* End-of --- PrintJobDescriptionType                                                                       */

/* #########################################################################################################*/
/*                                                                                                          */
/* PrintJobProcessingType                                                                                   */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/*   JobDelayOutputUntil                                                                                    */
/*                  JOB_DELAY_OUTPUT_UNTIL_NO_HOLD ...................................... _   X   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_INDEFINITE ................................... _   X   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_DAY_TIME ..................................... _   _   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_EVENING ...................................... _   _   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_NIGHT ........................................ _   _   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_WEEKEND ...................................... _   _   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_SECOND_SHIFT ................................. _   _   X         */
/*                  JOB_DELAY_OUTPUT_UNTIL_THIRD_SHIFT .................................. _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*   JobDelayOutputUntilTime ............................................................ _   _   X         */
/*   JobErrorAction                                                                                         */
/*                  JOB_ERROR_ACTION_ABORT_JOB .......................................... X   X   X         */
/*                  JOB_ERROR_ACTION_CANCEL_JOB ......................................... X   X   X         */
/*                  JOB_ERROR_ACTION_CONTINUE_JOB ....................................... _   _   X         */
/*                  JOB_ERROR_ACTION_SUSPEND_JOB ........................................ _   _   X         */
/*   JobHoldUntil                                                                                           */
/*                  JOB_HOLD_OUTPUT_UNTIL_NO_HOLD ....................................... _   X   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_INDEFINITE .................................... _   X   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_DAY_TIME ...................................... _   _   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_EVENING ....................................... _   _   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_NIGHT ......................................... _   _   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_WEEKEND ....................................... _   _   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_SECOND_SHIFT .................................. _   _   X         */
/*                  JOB_HOLD_OUTPUT_UNTIL_THIRD_SHIFT ................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*   JobHoldUntilTime  .................................................................. _   _   X         */
/*   JobMandatoryElements ..............DEPRECATED....................................... _   _   _         */
/*   JobPhoneNumber ..................................................................... _   _   X         */
/*   JobPriority ........................................................................ _   X   X         */
/*   JobRecipientName ................................................................... _   X   X         */
/*   JobAccountingSheets ................................................................ _   X   X         */
/*             |> JobAccountingSheetsType ............................................... _   X   X         */
/*                  JOB_ACCOUNTING_SHEETS_TYPE_NONE ..................................... _   X   X         */
/*                  JOB_ACCOUNTING_SHEETS_TYPE_STANDARD ................................. _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> JobAccountingOutputBin ................................................ _   X   X         */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media ................................................................. _   X   X         */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaType ............................................................. _   X   X         */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol .............................................................. _   X   X         */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   X   X         */
/*   JobCollationType                                                                                       */
/*                  JOB_COLLATION_TYPE_UNCOLLATED_SHEETS ................................ X   X   X         */
/*                  JOB_COLLATION_TYPE_COLLATED_DOCUMENTS ............................... X   X   X         */
/*                  JOB_COLLATION_TYPE_UNCOLLATED_DOCUMENTS ............................. X   X   X         */
/*                  VENDOR_EXTENSION .................................................... X   X   X         */
/*   JobCopies .......................................................................... X   X   X         */
/*   JobCoverBack ....................................................................... _   _   X         */
/*             |> CoverType                                                                                 */
/*                  PWG_COVER_TYPE_NO_COVER ............................................. _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_NONE ........................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_FRONT .......................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_BACK ........................................... _   _   X         */
/*                  PWG_COVER_TYPE_PRINT_BOTH ........................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   JobCoverFront ...................................................................... _   X   X         */
/*             |> CoverType                                                                                 */
/*                  COVER_TYPE_NO_COVER ................................................. _   X   X         */
/*                  COVER_TYPE_PRINT_NONE ............................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_FRONT .......................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_BACK ........................................... _   X   X         */
/*                  PWG_COVER_TYPE_PRINT_BOTH ........................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   JobErrorSheet ...................................................................... _   X   X         */
/*             |> JobErrorSheetType                                                                         */
/*                  JOB_ERROR_SHEET_TYPE_NONE ........................................... _   X   X         */
/*                  JOB_ERROR_SHEET_TYPE_STANDARD ....................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> JobErrorSheetWhen                                                                         */
/*                  JOB_ERROR_SHEET_WHEN_ON_ERROR ....................................... _   X   X         */
/*                  JOB_ERROR_SHEET_WHEN_ALWAYS ......................................... _   X   X         */
/*                  VENDOR_EXTENSION .................................................... _   X   X         */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   JobFinishings                                                                                          */
/*                  NONE ................................................................ X   X   X         */
/*                  STAPLE .............................................................. _   _   X         */
/*                  PUNCH ............................................................... _   _   X         */
/*                  COVER ............................................................... _   _   X         */
/*                  BIND ................................................................ _   _   X         */
/*                  SADDLE_STITCH ....................................................... _   _   X         */
/*                  EDGE_STITCH ......................................................... _   _   X         */
/*                  FOLD ................................................................ _   _   X         */
/*                  TRIM ................................................................ _   _   X         */
/*                  BALE ................................................................ _   _   X         */
/*                  BOOKLET_MAKER ....................................................... _   _   X         */
/*                  JOG_OFFSET .......................................................... X   X   X         */
/*                  STAPLE_TOP_LEFT ..................................................... X   X   X         */
/*                  STAPLE_BOTTOM_LEFT .................................................. _   _   X         */
/*                  STAPLE_TOP_RIGHT .................................................... _   _   X         */
/*                  STAPLE_BOTTOM_RIGHT ................................................. _   _   X         */
/*                  EDGE_STITCH_LEFT .................................................... _   _   X         */
/*                  EDGE_STITCH_TOP ..................................................... _   _   X         */
/*                  EDGE_STITCH_RIGHT ................................................... _   _   X         */
/*                  EDGE_STITCH_BOTTOM .................................................. _   _   X         */
/*                  STAPLE_DUAL_LEFT .................................................... _   _   X         */
/*                  STAPLE_DUAL_TOP ..................................................... _   _   X         */
/*                  STAPLE_DUAL_RIGH	................................................... _   _   X         */
/*                  STAPLE_DUAL_BOTTOM .................................................. _   _   X         */
/*                  BIND_LEFT ........................................................... _   _   X         */
/*                  BIND_TOP ............................................................ _   _   X         */
/*                  BIND_RIGHT .......................................................... _   _   X         */
/*                  BIND_BOTTOM ......................................................... _   _   X         */
/*   JobFinishingsCol ................................................................... _   _   X         */
/*             |> FinishingTemplate ..................................................... _   _   X         */
/*             |> Stitching                                                                                 */
/*                  STITCHING_REF_EDGE_BOTTOM ........................................... _   _   X         */
/*                  STITCHING_REF_EDGE_TOP .............................................. _   _   X         */
/*                  STITCHING_REF_EDGE_LEFT ............................................. _   _   X         */
/*                  STITCHING_REF_EDGE_RIGHT ............................................ _   _   X         */
/*   JobSaveDisposition ................................................................. _   _   X         */
/*             |> SaveDisposition                                                                           */
/*                  SAVE_DISPOSITION_NONE ............................................... _   _   X         */
/*                  SAVE_DISPOSITION_SAVE_ONLY .......................................... _   _   X         */
/*                  SAVE_DISPOSITION_PRINT_SAVE ......................................... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*             |> SaveInfo .............................................................. _   _   X         */
/*                |> SaveDocumentFormat  ................................................ _   _   X         */
/*                |> SaveLocation  ...................................................... _   _   X         */
/*                |> SaveName  .......................................................... _   _   X         */
/*                |> VENDOR_EXTENSION ................................................... _   _   X         */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   JobSheetMessage .................................................................... _   _   X         */
/*   JobSheets                                                                                              */
/*                  JOB_SHEETS_NONE ..................................................... _   _   X         */
/*                  JOB_SHEETS_STANDARD ................................................. _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   JobSheetsCol  ...................................................................... _   _   X         */
/*             |> JobSheets                                                                                 */
/*                  JOB_SHEETS_NONE ..................................................... _   _   X         */
/*                  JOB_SHEETS_STANDARD ................................................. _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   MultipleDocumentsHandling                                                                              */
/*                  MULTIPLE_DOCUMENTS_HANDLING_SEPARATE_DOCUMENTS_COLLATED_COPIES ...... _   _   X         */
/*                  MULTIPLE_DOCUMENTS_HANDLING_SEPARATE_DOCUMENTS_UNCOLLATED_COPIES .... _   _   X         */
/*                  MULTIPLE_DOCUMENTS_HANDLING_SINGLE_DOCUMENT ......................... _   _   X         */
/*                  MULTIPLE_DOCUMENTS_HANDLING_SINGLE_DOCUMENT_NEW_SHEET ............... _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*   OutputBin  ......................................................................... X   X   X         */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*   OutputDevice ....................................................................... X   X   X         */
/*   Overrides                                                                                              */
/*             |> DocumentCopies ........................................................ _   _   X         */
/*             |> DocumentNumbers  ...................................................... _   _   X         */
/*             |> OverridingElements                                                                        */
/*                  OVERRIDING_ELEMENTS_IMPOSITION_TEMPLATE ............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_INSERT_SHEET .................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_ACCOUNT_ID .................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_ACCOUNTING_SHEETS ........................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_ACCOUNTING_USER_ID .......................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_COPIES ...................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_COVER_BACK .................................. _   _   X         */                   /* Collection   pwgCoverCollection            */
/*                  OVERRIDING_ELEMENTS_JOB_COVER_FRONT ................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_ERROR_SHEET ................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_FINISHINGS .................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_FINISHINGS_COL .............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_HOLD_UNTIL .................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_MESSAGE_TO_OPERATOR ......................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_PRIORITY .................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_SHEET_MESSAGE ............................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_SHEETS ...................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_JOB_SHEETS_COL .................................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_MEDIA ........................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_MEDIA_COL ....................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_MEDIA_INPUT_TRAY_CHECK .......................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_MEDIA_TYPE ...................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_MULTIPLE_DOCUMENT_HANDLING ...................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_NUMBER_UP ....................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_ORIENTATION_REQUESTED ........................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_OUTPUT_BIN ...................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_OUTPUT_DEVICE ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_PAGE_DELIVERY ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_PAGE_ORDER_RECEIVED ............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_PAGE_RANGES ..................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_PRESENTATION_DIRECTION_NUMBER_UP ................ _   _   X         */
/*                  OVERRIDING_ELEMENTS_PRINT_QUALITY ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_PRINTER_RESOLUTION .............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_SEPARATOR_SHEETS ................................ _   _   X         */
/*                  OVERRIDING_ELEMENTS_SHEET_COLLATE ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_SIDES ........................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_X_IMAGE_POSITION ................................ _   _   X         */
/*                  OVERRIDING_ELEMENTS_X_IMAGE_SHIFT ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_X_SIDE1_IMAGE_SHIFT ............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_X_SIDE2_IMAGE_SHIFT ............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_Y_IMAGE_POSITION ................................ _   _   X         */
/*                  OVERRIDING_ELEMENTS_Y_IMAGE_SHIFT ................................... _   _   X         */
/*                  OVERRIDING_ELEMENTS_Y_SIDE1_IMAGE_SHIFT ............................. _   _   X         */
/*                  OVERRIDING_ELEMENTS_Y_SIDE2_IMAGE_SHIFT ............................. _   _   X         */
/*                  VENDOR_EXTENSION .................................................... _   _   X         */
/*             |> Pages ................................................................. _   _   X         */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   PagesPerSubset ..................................................................... _   _   X         */
/*   ProofPrint ......................................................................... _   _   X         */
/*             |> ProofPrintCopies ...................................................... _   _   X         */
/*             |> MediaType                                                                                 */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> Media                                                                                     */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> MediaCol                                                                                  */
/*                  <See Common Table Below> ............ <See Common Table Below>                          */
/*             |> VENDOR_EXTENSION ...................................................... _   _   X         */
/*   VENDOR_EXTENSION ................................................................... X   X   X         */
/* -------------------------------------------------------------------------------------------------------- */
/*   Element Sub-Element  ENUM                                                            1   2   3         */
/* -------------------------------------------------------------------------------------------------------- */
/* End-of --- PrintJobProcessingType                                                                        */

/* #########################################################################################################*/


/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_XXX_N_LEVEL_CONFIG_H__                                                                 */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*																											*/
/* =================================== pwg.pjt.xxx.N.level.config.h ======================================= */
/*																											*/
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
