/* ============================= pwg.pjt.pjd.1.document.charset.supplied.c ================================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.pjt.pjd.1.document.charset.supplied.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/* Document Character Set Supplied                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 42] DocumentCharsetSupplied        */
/* -----------------                                                                                        */
/* Default charset of the Documents content.                                                                */
/*        Values: CharsetWKV, StringExtensionPattern  (e.g., utf-8, iso-10646-unicode-latin1)               */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgDocumentCharsetSupplied_Keywords[] = {
    "-",
    "-",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UNKNOWN",

    "PWG_DOCUMENT_CHARSET_SUPPLIED_ADOBE_STANDARD_ENCODING",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ADOBE_SYMBOL_ENCODING",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ANSI_X3_110_1983",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ASMO_449",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_BIG5",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_BIG5_HKSCS",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_BOCU_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_BS_4730",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_BS_VIEWDATA",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_CESU_8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_CSA_Z243_4_1985_GR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_CSN_369103",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_DEC_MCS",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_DIN_66003",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_DK_US",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_DS_2089",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_AT_DE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_AT_DE_A",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_CA_FR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_DK_NO",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_DK_NO_A",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES_A",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_ES_S",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FI_SE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FI_SE_A",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_FR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_IT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_PT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_UK",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EBCDIC_US",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ECMA_CYRILLIC",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ES",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ES2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EUC_JP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EUC_KR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_EXTENDED_UNIX_CODE_FIXED_WIDTH_FOR_JAPANESE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GB18030",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GB_1988_80",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GB2312",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GB_2312_80",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GBK",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GOST_19768_74",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK7",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK7_OLD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_GREEK_CCITT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HP_DESKTOP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HP_LEGAL",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HP_MATH8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HP_PI_FONT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HP_ROMAN8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_HZ_GB_2312",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM00858",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM00924",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01140",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01141",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01142",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01143",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01144",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01145",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01146",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01147",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01148",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM01149",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM037",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM038",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM1026",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM1047",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM273",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM274",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM275",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM277",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM278",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM280",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM281",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM284",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM285",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM290",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM297",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM420",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM423",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM424",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM437",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM500",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM775",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM850",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM851",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM852",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM855",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM857",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM860",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM861",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM862",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM863",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM864",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM865",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM866",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM868",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM869",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM870",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM871",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM880",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM891",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM903",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM904",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM905",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM918",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM_SYMBOLS",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IBM_THAI",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IEC_P27_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_INIS",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_INIS_8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_INIS_CYRILLIC",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_INVARIANT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10367_BOX",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_4",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UCS_BASIC",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UNICODE_LATIN1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_10646_UTF_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_CN",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_CN_EXT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_JP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_JP_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2022_KR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_2033_1983",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5427",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5427_1981",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_5428_1980",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_646_BASIC_1983",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_646_IRV_1983",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_6937_2_25",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_6937_2_ADD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_10",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_13",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_14",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_15",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_16",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1_WINDOWS_3_0_LATIN_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_1_WINDOWS_3_1_LATIN_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_2_WINDOWS_LATIN_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_3",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_4",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_5",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6_E",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_6_I",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_7",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8_E",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_8_I",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_9",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_9_WINDOWS_LATIN_5",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_8859_SUPP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_IR_90",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1261",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1264",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1265",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1268",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_ISO_UNICODE_IBM_1276",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_IT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6220_1969_JP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6220_1969_RO",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6226_1978",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6226_1983",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_A",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_B",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_B_ADD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_HAND",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_HAND_ADD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_C6229_1984_KANA",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_ENCODING",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_X0201",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JIS_X0212_1990",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_002",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_003_MAC",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_JUS_I_B1_003_SERB",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_KOI8_R",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_KOI8_U",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_KS_C_5601_1987",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_KSC5636",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_GREEK",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_GREEK_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_LATIN_LAP",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_MACINTOSH",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_MICROSOFT_PUBLISHING",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_MNEM",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_MNEMONIC",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_MSZ_7795_3",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_DANO",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_DANO_ADD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_SEFI",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NATS_SEFI_ADD",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NC_NC00_10_81",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NF_Z_62_010",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NF_Z_62_010__1973_",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NS_4551_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_NS_4551_2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_PC8_DANISH_NORWEGIAN",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_PC8_TURKISH",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_PT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_PT2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_PTCP154",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_SCSU",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_SEN_850200_B",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_SEN_850200_C",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_SHIFT_JIS",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_T_101_G2",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_T_61_7BIT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_T_61_8BIT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_TIS_620",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UNICODE_1_1",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UNICODE_1_1_UTF_7",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UNKNOWN_8BIT",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_US_ASCII",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_US_DK",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16BE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_16LE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32BE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_32LE",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_7",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_8",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_INTERNATIONAL",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_MATH",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VENTURA_US",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VIDEOTEX_SUPPL",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VIQR",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_VISCII",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1250",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1251",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1252",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1253",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1254",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1255",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1256",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1257",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_1258",
    "PWG_DOCUMENT_CHARSET_SUPPLIED_WINDOWS_31J",

    VND_DOC_CHR_SET_KW

    pwgNULL
};
#else
pwgCHAR* pwgDocumentCharsetSupplied_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgDocumentCharsetSupplied_KWValues[] = {
    "-",
    "_",
    "Unknown",

    "adobe-standard-encoding",
    "adobe-symbol-encoding",
    "ansi-x3-110-1983",
    "asmo-449",
    "big5",
    "big5-hkscs",
    "bocu-1",
    "bs-4730",
    "bs-viewdata",
    "cesu-8",
    "csa-z243-4-1985-1",
    "csa-z243-4-1985-2",
    "csa-z243-4-1985-gr",
    "csn-369103",
    "dec-mcs",
    "din-66003",
    "dk-us",
    "ds-2089",
    "ebcdic-at-de",
    "ebcdic-at-de-a",
    "ebcdic-ca-fr",
    "ebcdic-dk-no",
    "ebcdic-dk-no-a",
    "ebcdic-es",
    "ebcdic-es-a",
    "ebcdic-es-s",
    "ebcdic-fi-se",
    "ebcdic-fi-se-a",
    "ebcdic-fr",
    "ebcdic-it",
    "ebcdic-pt",
    "ebcdic-uk",
    "ebcdic-us",
    "ecma-cyrillic",
    "es",
    "es2",
    "euc-jp",
    "euc-kr",
    "extended-unix-code-fixed-width-for-japanese",
    "gb18030",
    "gb-1988-80",
    "gb2312",
    "gb-2312-80",
    "gbk",
    "gost-19768-74",
    "greek7",
    "greek7-old",
    "greek-ccitt",
    "hp-desktop",
    "hp-legal",
    "hp-math8",
    "hp-pi-font",
    "hp-roman8",
    "hz-gb-2312",
    "ibm00858",
    "ibm00924",
    "ibm01140",
    "ibm01141",
    "ibm01142",
    "ibm01143",
    "ibm01144",
    "ibm01145",
    "ibm01146",
    "ibm01147",
    "ibm01148",
    "ibm01149",
    "ibm037",
    "ibm038",
    "ibm1026",
    "ibm1047",
    "ibm273",
    "ibm274",
    "ibm275",
    "ibm277",
    "ibm278",
    "ibm280",
    "ibm281",
    "ibm284",
    "ibm285",
    "ibm290",
    "ibm297",
    "ibm420",
    "ibm423",
    "ibm424",
    "ibm437",
    "ibm500",
    "ibm775",
    "ibm850",
    "ibm851",
    "ibm852",
    "ibm855",
    "ibm857",
    "ibm860",
    "ibm861",
    "ibm862",
    "ibm863",
    "ibm864",
    "ibm865",
    "ibm866",
    "ibm868",
    "ibm869",
    "ibm870",
    "ibm871",
    "ibm880",
    "ibm891",
    "ibm903",
    "ibm904",
    "ibm905",
    "ibm918",
    "ibm-symbols",
    "ibm-thai",
    "iec-p27-1",
    "inis",
    "inis-8",
    "inis-cyrillic",
    "invariant",
    "iso-10367-box",
    "iso-10646-ucs-2",
    "iso-10646-ucs-4",
    "iso-10646-ucs-basic",
    "iso-10646-unicode-latin1",
    "iso-10646-utf-1",
    "iso-2022-cn",
    "iso-2022-cn-ext",
    "iso-2022-jp",
    "iso-2022-jp-2",
    "iso-2022-kr",
    "iso-2033-1983",
    "iso-5427",
    "iso-5427-1981",
    "iso-5428-1980",
    "iso-646-basic-1983",
    "iso-646-irv-1983",
    "iso-6937-2-25",
    "iso-6937-2-add",
    "iso-8859-1",
    "iso-8859-10",
    "iso-8859-13",
    "iso-8859-14",
    "iso-8859-15",
    "iso-8859-16",
    "iso-8859-1-windows-3-0-latin-1",
    "iso-8859-1-windows-3-1-latin-1",
    "iso-8859-2",
    "iso-8859-2-windows-latin-2",
    "iso-8859-3",
    "iso-8859-4",
    "iso-8859-5",
    "iso-8859-6",
    "iso-8859-6-e",
    "iso-8859-6-i",
    "iso-8859-7",
    "iso-8859-8",
    "iso-8859-8-e",
    "iso-8859-8-i",
    "iso-8859-9",
    "iso-8859-9-windows-latin-5",
    "iso-8859-supp",
    "iso-ir-90",
    "iso-unicode-ibm-1261",
    "iso-unicode-ibm-1264",
    "iso-unicode-ibm-1265",
    "iso-unicode-ibm-1268",
    "iso-unicode-ibm-1276",
    "it",
    "jis-c6220-1969-jp",
    "jis-c6220-1969-ro",
    "jis-c6226-1978",
    "jis-c6226-1983",
    "jis-c6229-1984-a",
    "jis-c6229-1984-b",
    "jis-c6229-1984-b-add",
    "jis-c6229-1984-hand",
    "jis-c6229-1984-hand-add",
    "jis-c6229-1984-kana",
    "jis-encoding",
    "jis-x0201",
    "jis-x0212-1990",
    "jus-i-b1-002",
    "jus-i-b1-003-mac",
    "jus-i-b1-003-serb",
    "koi8-r",
    "koi8-u",
    "ks-c-5601-1987",
    "ksc5636",
    "latin-greek",
    "latin-greek-1",
    "latin-lap",
    "macintosh",
    "microsoft-publishing",
    "mnem",
    "mnemonic",
    "msz-7795-3",
    "nats-dano",
    "nats-dano-add",
    "nats-sefi",
    "nats-sefi-add",
    "nc-nc00-10-81",
    "nf-z-62-010",
    "nf-z-62-010--1973-",
    "ns-4551-1",
    "ns-4551-2",
    "pc8-danish-norwegian",
    "pc8-turkish",
    "pt",
    "pt2",
    "ptcp154",
    "scsu",
    "sen-850200-b",
    "sen-850200-c",
    "shift-jis",
    "t-101-g2",
    "t-61-7bit",
    "t-61-8bit",
    "tis-620",
    "unicode-1-1",
    "unicode-1-1-utf-7",
    "unknown-8bit",
    "us-ascii",
    "us-dk",
    "utf-16",
    "utf-16be",
    "utf-16le",
    "utf-32",
    "utf-32be",
    "utf-32le",
    "utf-7",
    "utf-8",
    "ventura-international",
    "ventura-math",
    "ventura-us",
    "videotex-suppl",
    "viqr",
    "viscii",
    "windows-1250",
    "windows-1251",
    "windows-1252",
    "windows-1253",
    "windows-1254",
    "windows-1255",
    "windows-1256",
    "windows-1257",
    "windows-1258",
    "windows-31j",

    VND_DOC_CHR_SET_KWV

    pwgNULL
};

pwgBIT8 pwgDocumentCharsetSupplied_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_3,      /*     "adobe-standard-encoding"                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "adobe-symbol-encoding"                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "ansi-x3-110-1983"                                                     */
    PJT_SUPPORT_LEVEL_3,      /*     "asmo-449"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "big5"                                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "big5-hkscs"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "bocu-1"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "bs-4730"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "bs-viewdata"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "cesu-8"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "csa-z243-4-1985-1"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "csa-z243-4-1985-2"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "csa-z243-4-1985-gr"                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "csn-369103"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "dec-mcs"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "din-66003"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "dk-us"                                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "ds-2089"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-at-de"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-at-de-a"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-ca-fr"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-dk-no"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-dk-no-a"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-es"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-es-a"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-es-s"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-fi-se"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-fi-se-a"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-fr"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-it"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-pt"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ebcdic-uk"                                                            */
    PJT_SUPPORT_LEVEL_1,      /*     "ebcdic-us"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ecma-cyrillic"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "es"                                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "es2"                                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "euc-j"                                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "euc-kr"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "extended-unix-code-fixed-width-for-japanese"                          */
    PJT_SUPPORT_LEVEL_3,      /*     "gb18030"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "gb-1988-80"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "gb2312"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "gb-2312-80"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "gbk"                                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "gost-19768-74"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "greek7"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "greek7-old"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "greek-ccitt"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "hp-desktop"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "hp-legal"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "hp-math8"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "hp-pi-font"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "hp-roman8"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "hz-gb-2312"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm00858"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm00924"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01140"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01141"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01142"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01143"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01144"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01145"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01146"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01147"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01148"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm01149"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm037"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm038"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm1026"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm1047"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm273"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm274"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm275"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm277"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm278"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm280"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm281"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm284"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm285"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm290"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm297"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm420"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm423"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm424"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm437"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm500"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm775"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm850"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm851"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm852"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm855"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm857"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm860"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm861"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm862"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm863"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm864"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm865"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm866"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm868"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm869"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm870"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm871"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm880"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm891"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm903"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm904"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm905"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm918"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm-symbols"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "ibm-thai"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "iec-p27-1"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "inis"                                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "inis-8"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "inis-cyrillic"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "invariant"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10367-box"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10646-ucs-2"                                                      */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10646-ucs-4"                                                      */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10646-ucs-basic"                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10646-unicode-latin1"                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-10646-utf-1"                                                      */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2022-cn"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2022-cn-ext"                                                      */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2022-jp"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2022-jp-2"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2022-kr"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-2033-1983"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-5427"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-5427-1981"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-5428-1980"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-646-basic-1983"                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-646-irv-1983"                                                     */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-6937-2-25"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-6937-2-add"                                                       */
    PJT_SUPPORT_LEVEL_1,      /*     "iso-8859-1"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-10"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-13"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-14"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-15"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-16"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-1-windows-3-0-latin-1"                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-1-windows-3-1-latin-1"                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-2"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-2-windows-latin-2"                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-3"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-4"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-5"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-6"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-6-e"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-6-i"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-7"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-8"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-8-e"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-8-i"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-9"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-9-windows-latin-5"                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-8859-supp"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-ir-90"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-unicode-ibm-1261"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-unicode-ibm-1264"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-unicode-ibm-1265"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-unicode-ibm-1268"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "iso-unicode-ibm-1276"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "it"                                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6220-1969-jp"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6220-1969-ro"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6226-1978"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6226-1983"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-a"                                                     */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-b"                                                     */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-b-add"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-hand"                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-hand-add"                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-c6229-1984-kana"                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-encoding"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-x0201"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "jis-x0212-1990"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "jus-i-b1-002"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "jus-i-b1-003-mac"                                                     */
    PJT_SUPPORT_LEVEL_3,      /*     "jus-i-b1-003-serb"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "koi8-r"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "koi8-u"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "ks-c-5601-1987"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "ksc5636"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "latin-greek"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "latin-greek-1"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "latin-lap"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "macintosh"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "microsoft-publishing"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "mnem"                                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "mnemonic"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "msz-7795-3"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "nats-dano"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "nats-dano-add"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "nats-sefi"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "nats-sefi-add"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "nc-nc00-10-81"                                                        */
    PJT_SUPPORT_LEVEL_3,      /*     "nf-z-62-010"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "nf-z-62-010--1973-"                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "ns-4551-1"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "ns-4551-2"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "pc8-danish-norwegian"                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "pc8-turkish"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "pt"                                                                   */
    PJT_SUPPORT_LEVEL_3,      /*     "pt2"                                                                  */
    PJT_SUPPORT_LEVEL_3,      /*     "ptcp154"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "scsu"                                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "sen-850200-b"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "sen-850200-c"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "shift-jis"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "t-101-g2"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "t-61-7bit"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "t-61-8bit"                                                            */
    PJT_SUPPORT_LEVEL_3,      /*     "tis-620"                                                              */
    PJT_SUPPORT_LEVEL_3,      /*     "unicode-1-1"                                                          */
    PJT_SUPPORT_LEVEL_3,      /*     "unicode-1-1-utf-7"                                                    */
    PJT_SUPPORT_LEVEL_3,      /*     "unknown-8bit"                                                         */
    PJT_SUPPORT_LEVEL_1,      /*     "us-ascii"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "us-dk"                                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-16"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-16be"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-16le"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-32"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-32be"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-32le"                                                             */
    PJT_SUPPORT_LEVEL_3,      /*     "utf-7"                                                                */
    PJT_SUPPORT_LEVEL_1,      /*     "utf-8"                                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "ventura-international"                                                */
    PJT_SUPPORT_LEVEL_3,      /*     "ventura-math"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "ventura-us"                                                           */
    PJT_SUPPORT_LEVEL_3,      /*     "videotex-suppl"                                                       */
    PJT_SUPPORT_LEVEL_3,      /*     "viqr"                                                                 */
    PJT_SUPPORT_LEVEL_3,      /*     "viscii"                                                               */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1250"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1251"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1252"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1253"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1254"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1255"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1256"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1257"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-1258"                                                         */
    PJT_SUPPORT_LEVEL_3,      /*     "windows-31j"                                                          */

    VND_DOC_CHR_SET_KWVL

    0
};

pwgBOOL pwgDocumentCharsetSupplied_KWVSupported[] = {
    pwgNOT_SUPPORTED,   /* "-"                */
    pwgNOT_SUPPORTED,   /* "_"                */
    pwgSUPPORTED,       /* "Unknown"          */

 /* 244               1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,

    VND_DOC_CHR_SET_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_DocumentCharsetSupplied = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_BIT32,                           /* The data type                        */
                          "Document Character Set Supplied",        /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1,                      /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_8,      /* Default or nominal setting           */
                          PWG_DOCUMENT_CHARSET_SUPPLIED_UTF_8,      /* Setting data value                   */

                          pwgDocumentCharsetSupplied_Keywords,      /* ENUM Keyword names (strings)         */
                          pwgDocumentCharsetSupplied_KWValues,      /* ENUM Keyword (string) values         */
                          pwgDocumentCharsetSupplied_KWVLevel,      /* ENUM Keyword pjt support level       */
                          pwgDocumentCharsetSupplied_KWVSupported,  /* ENUM Keywords supported              */

                          PWG_DOCUMENT_CHARSET_SUPPLIED_UNKNOWN,    /* The minimum   data value             */
                          PWG_DOCUMENT_CHARSET_SUPPLIED_END - 1,    /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================= pwg.pjt.pjd.1.document.charset.supplied.c ================================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
