/* ============================ pwg.pjt.pjd.2.document.source.os.name.h" ================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.pjt.pjd.2.document.source.os.name.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgDocumentSourceOsName_Keywords[] = {
                "PWG_DOCUMENT_SOURCE_OS_NAME_NOT_SET",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NONE",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNKNOWN",

                "PWG_DOCUMENT_SOURCE_OS_NAME_AEGIS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_1_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_1_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_2_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_2_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_5",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AMIGA_OS_3_9",
                "PWG_DOCUMENT_SOURCE_OS_NAME_APOLLO",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AIX_370",
                "PWG_DOCUMENT_SOURCE_OS_NAME_AIX_PS_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_BEOS_4_5_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_BEOS_5_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_BS_2000",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CEDAR",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CGW",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CHORUS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CHRYSALIS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CMOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CMS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_COS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CPIX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CTOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CTSS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_CYGWIN",
                "PWG_DOCUMENT_SOURCE_OS_NAME_DCN",
                "PWG_DOCUMENT_SOURCE_OS_NAME_DDNOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_DOMAIN",
                "PWG_DOCUMENT_SOURCE_OS_NAME_DOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_EDX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_ELF",
                "PWG_DOCUMENT_SOURCE_OS_NAME_EMBOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_EMMOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_EPOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_FOONEX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_FREEBSD",
                "PWG_DOCUMENT_SOURCE_OS_NAME_FORTH",
                "PWG_DOCUMENT_SOURCE_OS_NAME_FUZZ",
                "PWG_DOCUMENT_SOURCE_OS_NAME_GCOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_GPOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_HDOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_IMAGEN",
                "PWG_DOCUMENT_SOURCE_OS_NAME_INSTANT_INTERNET",
                "PWG_DOCUMENT_SOURCE_OS_NAME_INTERCOM",
                "PWG_DOCUMENT_SOURCE_OS_NAME_IMPRESS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_INTERLISP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_IOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_IRIX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_ISI_68020",
                "PWG_DOCUMENT_SOURCE_OS_NAME_ITS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_KOSOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_1_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_1_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_4",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LINUX_2_6",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LISP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LISPM",
                "PWG_DOCUMENT_SOURCE_OS_NAME_LOCUS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MACOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MINOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MPE5",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MPE_V",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MPE_IX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MSDOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MULTICS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MUSIC",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MUSIC_SP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MVS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_MVS_SP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETBSD_1_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_3_11",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_4_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_4_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NETWARE_5_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NEXUS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NMS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NONSTOP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NOS_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_NTOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OPENBSD",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OPENVME",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OPENVMS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OS_DDP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OS_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OS4",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OS86",
                "PWG_DOCUMENT_SOURCE_OS_NAME_OSX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PCDOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PERQ_OS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PLI",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PSDOS_MIT",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PSOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_PRIMOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_10",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_50",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_60",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_3_70",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RISC_OS_4_00",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RMX_RDOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_ROS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RSX11M",
                "PWG_DOCUMENT_SOURCE_OS_NAME_RTE_A",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SATOPS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SINIX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_1_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_1_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_2_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_3_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_DESKTOP_LITE_3_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_OPEN_SERVER_3_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V2_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V2_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_UNIX_3_2V4_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCO_XENIX_386_2_3_4",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SCS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SIMP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SUN",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SUN_OS_3_5",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SUN_OS_4_0",
                "PWG_DOCUMENT_SOURCE_OS_NAME_SWIFT",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TAC",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TANDEM",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TENEX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_THE_MAJOR_BBS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TOPS10",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TOPS20",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TP3010",
                "PWG_DOCUMENT_SOURCE_OS_NAME_TRSDOS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_ULTRIX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_BSD",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V1AT",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_V_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_UNIX_PC",
/*                "PWG_DOCUMENT_SOURCE_OS_NAME_UNKNOWN", */
                "PWG_DOCUMENT_SOURCE_OS_NAME_UT2D",
                "PWG_DOCUMENT_SOURCE_OS_NAME_V",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VM",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VM_370",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VM_CMS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VM_SP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VMS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VMS_EUNICE",
                "PWG_DOCUMENT_SOURCE_OS_NAME_VRTX",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WAITS",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WANG",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WIN32",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95_OSR1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_95_OSR2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_98",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_CE",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_2",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3_5",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_3_51",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_4",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_5",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_5_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_6",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WINDOWS_NT_6_1",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WORLDGROUP",
                "PWG_DOCUMENT_SOURCE_OS_NAME_WYSE_WYXWARE",
                "PWG_DOCUMENT_SOURCE_OS_NAME_X11R3",
                "PWG_DOCUMENT_SOURCE_OS_NAME_XDE",
                "PWG_DOCUMENT_SOURCE_OS_NAME_XENIX",

                VND_DOC_SRC_OS_NAM_KW

                pwgNULL
};
#else
pwgCHAR* pwgDocumentSourceOsName_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgDocumentSourceOsName_KWValues[] = {
                "NotSet",
                "None",
                "unknown",

                "AEGIS",
                "AMIGA_OS_1_2",
                "AMIGA_OS_1_3",
                "AMIGA_OS_2_0",
                "AMIGA_OS_2_1",
                "AMIGA_OS_3_0",
                "AMIGA_OS_3_1",
                "AMIGA_OS_3_5",
                "AMIGA_OS_3_9",
                "APOLLO",
                "AIX_370",
                "AIX_PS_2",
                "BEOS_4_5_2",
                "BEOS_5_0",
                "BS_2000",
                "CEDAR",
                "CGW",
                "CHORUS",
                "CHRYSALIS",
                "CMOS",
                "CMS",
                "COS",
                "CPIX",
                "CTOS",
                "CTSS",
                "CYGWIN",
                "DCN",
                "DDNOS",
                "DOMAIN",
                "DOS",
                "EDX",
                "ELF",
                "EMBOS",
                "EMMOS",
                "EPOS",
                "FOONEX",
                "FREEBSD",
                "FORTH",
                "FUZZ",
                "GCOS",
                "GPOS",
                "HDOS",
                "IMAGEN",
                "INSTANT_INTERNET",
                "INTERCOM",
                "IMPRESS",
                "INTERLISP",
                "IOS",
                "IRIX",
                "ISI_68020",
                "ITS",
                "KOSOS",
                "LINUX",
                "LINUX_1_0",
                "LINUX_1_2",
                "LINUX_2_0",
                "LINUX_2_2",
                "LINUX_2_4",
                "LINUX_2_6",
                "LISP",
                "LISPM",
                "LOCUS",
                "MACOS",
                "MINOS",
                "MOS",
                "MPE5",
                "MPE_V",
                "MPE_IX",
                "MSDOS",
                "MULTICS",
                "MUSIC",
                "MUSIC_SP",
                "MVS",
                "MVS_SP",
                "NETBSD_1_0",
                "NETBSD_1_1",
                "NETBSD_1_2",
                "NETBSD_1_3",
                "NETWARE_3",
                "NETWARE_3_11",
                "NETWARE_4_0",
                "NETWARE_4_1",
                "NETWARE_5_0",
                "NEXUS",
                "NMS",
                "NONSTOP",
                "NOS_2",
                "NTOS",
                "OPENBSD",
                "OPENVME",
                "OPENVMS",
                "OS_DDP",
                "OS_2",
                "OS4",
                "OS86",
                "OSX",
                "PCDOS",
                "PERQ_OS",
                "PLI",
                "PSDOS_MIT",
                "PSOS",
                "PRIMOS",
                "RISC_OS",
                "RISC_OS_3_10",
                "RISC_OS_3_50",
                "RISC_OS_3_60",
                "RISC_OS_3_70",
                "RISC_OS_4_00",
                "RMX_RDOS",
                "ROS",
                "RSX11M",
                "RTE_A",
                "SATOPS",
                "SINIX",
                "SCO_OPEN_DESKTOP_1_0",
                "SCO_OPEN_DESKTOP_1_1",
                "SCO_OPEN_DESKTOP_2_0",
                "SCO_OPEN_DESKTOP_3_0",
                "SCO_OPEN_DESKTOP_LITE_3_0",
                "SCO_OPEN_SERVER_3_0",
                "SCO_UNIX_3_2_0",
                "SCO_UNIX_3_2V2_0",
                "SCO_UNIX_3_2V2_1",
                "SCO_UNIX_3_2V4_0",
                "SCO_UNIX_3_2V4_1",
                "SCO_UNIX_3_2V4_2",
                "SCO_XENIX_386_2_3_2",
                "SCO_XENIX_386_2_3_3",
                "SCO_XENIX_386_2_3_4",
                "SCS",
                "SIMP",
                "SUN",
                "SUN_OS_3_5",
                "SUN_OS_4_0",
                "SWIFT",
                "TAC",
                "TANDEM",
                "TENEX",
                "THE_MAJOR_BBS",
                "TOPS10",
                "TOPS20",
                "TOS",
                "TP3010",
                "TRSDOS",
                "ULTRIX",
                "UNIX",
                "UNIX_BSD",
                "UNIX_V1AT",
                "UNIX_V",
                "UNIX_V_1",
                "UNIX_V_2",
                "UNIX_V_3",
                "UNIX_PC",
/*                "UNKNOWN", */
                "UT2D",
                "V",
                "VM",
                "VM_370",
                "VM_CMS",
                "VM_SP",
                "VMS",
                "VMS_EUNICE",
                "VRTX",
                "WAITS",
                "WANG",
                "WIN32",
                "WINDOWS_95",
                "WINDOWS_95_OSR1",
                "WINDOWS_95_OSR2",
                "WINDOWS_98",
                "WINDOWS_CE",
                "WINDOWS_NT",
                "WINDOWS_NT_2",
                "WINDOWS_NT_3",
                "WINDOWS_NT_3_5",
                "WINDOWS_NT_3_51",
                "WINDOWS_NT_4",
                "WINDOWS_NT_5",
                "WINDOWS_NT_5_1",
                "WINDOWS_NT_6",
                "WINDOWS_NT_6_1",
                "WORLDGROUP",
                "WYSE_WYXWARE",
                "X11R3",
                "XDE",
                "XENIX",

                VND_DOC_SRC_OS_NAM_KWV

                pwgNULL
};

pwgBIT8 pwgDocumentSourceOsName_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "none"             */
    PJT_SUPPORT_LEVEL_1,      /* "standard"         */

    PJT_SUPPORT_LEVEL_1,      /* "AEGIS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_1_2"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_1_3"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_2_0"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_2_1"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_3_0"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_3_1"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_3_5"               */
    PJT_SUPPORT_LEVEL_1,      /* "AMIGA_OS_3_9"               */
    PJT_SUPPORT_LEVEL_1,      /* "APOLLO"                     */
    PJT_SUPPORT_LEVEL_1,      /* "AIX_370"                    */
    PJT_SUPPORT_LEVEL_1,      /* "AIX_PS_2"                   */
    PJT_SUPPORT_LEVEL_1,      /* "BEOS_4_5_2"                 */
    PJT_SUPPORT_LEVEL_1,      /* "BEOS_5_0"                   */
    PJT_SUPPORT_LEVEL_1,      /* "BS_2000"                    */
    PJT_SUPPORT_LEVEL_1,      /* "CEDAR"                      */
    PJT_SUPPORT_LEVEL_1,      /* "CGW"                        */
    PJT_SUPPORT_LEVEL_1,      /* "CHORUS"                     */
    PJT_SUPPORT_LEVEL_1,      /* "CHRYSALIS"                  */
    PJT_SUPPORT_LEVEL_1,      /* "CMOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "CMS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "COS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "CPIX"                       */
    PJT_SUPPORT_LEVEL_1,      /* "CTOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "CTSS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "CYGWIN"                     */
    PJT_SUPPORT_LEVEL_1,      /* "DCN"                        */
    PJT_SUPPORT_LEVEL_1,      /* "DDNOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "DOMAIN"                     */
    PJT_SUPPORT_LEVEL_1,      /* "DOS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "EDX"                        */
    PJT_SUPPORT_LEVEL_1,      /* "ELF"                        */
    PJT_SUPPORT_LEVEL_1,      /* "EMBOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "EMMOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "EPOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "FOONEX"                     */
    PJT_SUPPORT_LEVEL_1,      /* "FREEBSD"                    */
    PJT_SUPPORT_LEVEL_1,      /* "FORTH"                      */
    PJT_SUPPORT_LEVEL_1,      /* "FUZZ"                       */
    PJT_SUPPORT_LEVEL_1,      /* "GCOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "GPOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "HDOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "IMAGEN"                     */
    PJT_SUPPORT_LEVEL_1,      /* "INSTANT_INTERNET"           */
    PJT_SUPPORT_LEVEL_1,      /* "INTERCOM"                   */
    PJT_SUPPORT_LEVEL_1,      /* "IMPRESS"                    */
    PJT_SUPPORT_LEVEL_1,      /* "INTERLISP"                  */
    PJT_SUPPORT_LEVEL_1,      /* "IOS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "IRIX"                       */
    PJT_SUPPORT_LEVEL_1,      /* "ISI_68020"                  */
    PJT_SUPPORT_LEVEL_1,      /* "ITS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "KOSOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX"                      */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_1_0"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_1_2"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_2_0"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_2_2"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_2_4"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LINUX_2_6"                  */
    PJT_SUPPORT_LEVEL_1,      /* "LISP"                       */
    PJT_SUPPORT_LEVEL_1,      /* "LISPM"                      */
    PJT_SUPPORT_LEVEL_1,      /* "LOCUS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MACOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MINOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MOS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "MPE5"                       */
    PJT_SUPPORT_LEVEL_1,      /* "MPE_V"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MPE_IX"                     */
    PJT_SUPPORT_LEVEL_1,      /* "MSDOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MULTICS"                    */
    PJT_SUPPORT_LEVEL_1,      /* "MUSIC"                      */
    PJT_SUPPORT_LEVEL_1,      /* "MUSIC_SP"                   */
    PJT_SUPPORT_LEVEL_1,      /* "MVS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "MVS_SP"                     */
    PJT_SUPPORT_LEVEL_1,      /* "NETBSD_1_0"                 */
    PJT_SUPPORT_LEVEL_1,      /* "NETBSD_1_1"                 */
    PJT_SUPPORT_LEVEL_1,      /* "NETBSD_1_2"                 */
    PJT_SUPPORT_LEVEL_1,      /* "NETBSD_1_3"                 */
    PJT_SUPPORT_LEVEL_1,      /* "NETWARE_3"                  */
    PJT_SUPPORT_LEVEL_1,      /* "NETWARE_3_11"               */
    PJT_SUPPORT_LEVEL_1,      /* "NETWARE_4_0"                */
    PJT_SUPPORT_LEVEL_1,      /* "NETWARE_4_1"                */
    PJT_SUPPORT_LEVEL_1,      /* "NETWARE_5_0"                */
    PJT_SUPPORT_LEVEL_1,      /* "NEXUS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "NMS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "NONSTOP"                    */
    PJT_SUPPORT_LEVEL_1,      /* "NOS_2"                      */
    PJT_SUPPORT_LEVEL_1,      /* "NTOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "OPENBSD"                    */
    PJT_SUPPORT_LEVEL_1,      /* "OPENVME"                    */
    PJT_SUPPORT_LEVEL_1,      /* "OPENVMS"                    */
    PJT_SUPPORT_LEVEL_1,      /* "OS_DDP"                     */
    PJT_SUPPORT_LEVEL_1,      /* "OS_2"                       */
    PJT_SUPPORT_LEVEL_1,      /* "OS4"                        */
    PJT_SUPPORT_LEVEL_1,      /* "OS86"                       */
    PJT_SUPPORT_LEVEL_1,      /* "OSX"                        */
    PJT_SUPPORT_LEVEL_1,      /* "PCDOS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "PERQ_OS"                    */
    PJT_SUPPORT_LEVEL_1,      /* "PLI"                        */
    PJT_SUPPORT_LEVEL_1,      /* "PSDOS_MIT"                  */
    PJT_SUPPORT_LEVEL_1,      /* "PSOS"                       */
    PJT_SUPPORT_LEVEL_1,      /* "PRIMOS"                     */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS"                    */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS_3_10"               */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS_3_50"               */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS_3_60"               */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS_3_70"               */
    PJT_SUPPORT_LEVEL_1,      /* "RISC_OS_4_00"               */
    PJT_SUPPORT_LEVEL_1,      /* "RMX_RDOS"                   */
    PJT_SUPPORT_LEVEL_1,      /* "ROS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "RSX11M"                     */
    PJT_SUPPORT_LEVEL_1,      /* "RTE_A"                      */
    PJT_SUPPORT_LEVEL_1,      /* "SATOPS"                     */
    PJT_SUPPORT_LEVEL_1,      /* "SINIX"                      */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_DESKTOP_1_0"       */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_DESKTOP_1_1"       */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_DESKTOP_2_0"       */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_DESKTOP_3_0"       */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_DESKTOP_LITE_3_0"  */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_OPEN_SERVER_3_0"        */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2_0"             */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2V2_0"           */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2V2_1"           */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2V4_0"           */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2V4_1"           */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_UNIX_3_2V4_2"           */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_XENIX_386_2_3_2"        */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_XENIX_386_2_3_3"        */
    PJT_SUPPORT_LEVEL_1,      /* "SCO_XENIX_386_2_3_4"        */
    PJT_SUPPORT_LEVEL_1,      /* "SCS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "SIMP"                       */
    PJT_SUPPORT_LEVEL_1,      /* "SUN"                        */
    PJT_SUPPORT_LEVEL_1,      /* "SUN_OS_3_5"                 */
    PJT_SUPPORT_LEVEL_1,      /* "SUN_OS_4_0"                 */
    PJT_SUPPORT_LEVEL_1,      /* "SWIFT"                      */
    PJT_SUPPORT_LEVEL_1,      /* "TAC"                        */
    PJT_SUPPORT_LEVEL_1,      /* "TANDEM"                     */
    PJT_SUPPORT_LEVEL_1,      /* "TENEX"                      */
    PJT_SUPPORT_LEVEL_1,      /* "THE_MAJOR_BBS"              */
    PJT_SUPPORT_LEVEL_1,      /* "TOPS10"                     */
    PJT_SUPPORT_LEVEL_1,      /* "TOPS20"                     */
    PJT_SUPPORT_LEVEL_1,      /* "TOS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "TP3010"                     */
    PJT_SUPPORT_LEVEL_1,      /* "TRSDOS"                     */
    PJT_SUPPORT_LEVEL_1,      /* "ULTRIX"                     */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX"                       */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_BSD"                   */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_V1AT"                  */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_V"                     */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_V_1"                   */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_V_2"                   */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_V_3"                   */
    PJT_SUPPORT_LEVEL_1,      /* "UNIX_PC"                    */
    PJT_SUPPORT_LEVEL_1,      /* "UNKNOWN"                    */
    PJT_SUPPORT_LEVEL_1,      /* "UT2D"                       */
    PJT_SUPPORT_LEVEL_1,      /* "V"                          */
    PJT_SUPPORT_LEVEL_1,      /* "VM"                         */
    PJT_SUPPORT_LEVEL_1,      /* "VM_370"                     */
    PJT_SUPPORT_LEVEL_1,      /* "VM_CMS"                     */
    PJT_SUPPORT_LEVEL_1,      /* "VM_SP"                      */
    PJT_SUPPORT_LEVEL_1,      /* "VMS"                        */
    PJT_SUPPORT_LEVEL_1,      /* "VMS_EUNICE"                 */
    PJT_SUPPORT_LEVEL_1,      /* "VRTX"                       */
    PJT_SUPPORT_LEVEL_1,      /* "WAITS"                      */
    PJT_SUPPORT_LEVEL_1,      /* "WANG"                       */
    PJT_SUPPORT_LEVEL_1,      /* "WIN32"                      */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_95"                 */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_95_OSR1"            */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_95_OSR2"            */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_98"                 */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_CE"                 */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT"                 */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_2"               */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_3"               */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_3_5"             */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_3_51"            */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_4"               */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_5"               */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_5_1"             */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_6"               */
    PJT_SUPPORT_LEVEL_1,      /* "WINDOWS_NT_6_1"             */
    PJT_SUPPORT_LEVEL_1,      /* "WORLDGROUP"                 */
    PJT_SUPPORT_LEVEL_1,      /* "WYSE_WYXWARE"               */
    PJT_SUPPORT_LEVEL_1,      /* "X11R3"                      */
    PJT_SUPPORT_LEVEL_1,      /* "XDE"                        */
    PJT_SUPPORT_LEVEL_1,      /* "XENIX"                      */

    VND_DOC_SRC_OS_NAM_KWVL

    0
};

pwgBOOL pwgDocumentSourceOsName_KWVSupported[] = {
    pwgNOT_SUPPORTED,   /* "-"                */
    pwgNOT_SUPPORTED,   /* "_"                */
    pwgSUPPORTED,       /* "Unknown"          */

    pwgSUPPORTED,      /* "none"             */
    pwgSUPPORTED,      /* "standard"         */

    pwgSUPPORTED,      /* "AEGIS"                      */
    pwgSUPPORTED,      /* "AMIGA_OS_1_2"               */
    pwgSUPPORTED,      /* "AMIGA_OS_1_3"               */
    pwgSUPPORTED,      /* "AMIGA_OS_2_0"               */
    pwgSUPPORTED,      /* "AMIGA_OS_2_1"               */
    pwgSUPPORTED,      /* "AMIGA_OS_3_0"               */
    pwgSUPPORTED,      /* "AMIGA_OS_3_1"               */
    pwgSUPPORTED,      /* "AMIGA_OS_3_5"               */
    pwgSUPPORTED,      /* "AMIGA_OS_3_9"               */
    pwgSUPPORTED,      /* "APOLLO"                     */
    pwgSUPPORTED,      /* "AIX_370"                    */
    pwgSUPPORTED,      /* "AIX_PS_2"                   */
    pwgSUPPORTED,      /* "BEOS_4_5_2"                 */
    pwgSUPPORTED,      /* "BEOS_5_0"                   */
    pwgSUPPORTED,      /* "BS_2000"                    */
    pwgSUPPORTED,      /* "CEDAR"                      */
    pwgSUPPORTED,      /* "CGW"                        */
    pwgSUPPORTED,      /* "CHORUS"                     */
    pwgSUPPORTED,      /* "CHRYSALIS"                  */
    pwgSUPPORTED,      /* "CMOS"                       */
    pwgSUPPORTED,      /* "CMS"                        */
    pwgSUPPORTED,      /* "COS"                        */
    pwgSUPPORTED,      /* "CPIX"                       */
    pwgSUPPORTED,      /* "CTOS"                       */
    pwgSUPPORTED,      /* "CTSS"                       */
    pwgSUPPORTED,      /* "CYGWIN"                     */
    pwgSUPPORTED,      /* "DCN"                        */
    pwgSUPPORTED,      /* "DDNOS"                      */
    pwgSUPPORTED,      /* "DOMAIN"                     */
    pwgSUPPORTED,      /* "DOS"                        */
    pwgSUPPORTED,      /* "EDX"                        */
    pwgSUPPORTED,      /* "ELF"                        */
    pwgSUPPORTED,      /* "EMBOS"                      */
    pwgSUPPORTED,      /* "EMMOS"                      */
    pwgSUPPORTED,      /* "EPOS"                       */
    pwgSUPPORTED,      /* "FOONEX"                     */
    pwgSUPPORTED,      /* "FREEBSD"                    */
    pwgSUPPORTED,      /* "FORTH"                      */
    pwgSUPPORTED,      /* "FUZZ"                       */
    pwgSUPPORTED,      /* "GCOS"                       */
    pwgSUPPORTED,      /* "GPOS"                       */
    pwgSUPPORTED,      /* "HDOS"                       */
    pwgSUPPORTED,      /* "IMAGEN"                     */
    pwgSUPPORTED,      /* "INSTANT_INTERNET"           */
    pwgSUPPORTED,      /* "INTERCOM"                   */
    pwgSUPPORTED,      /* "IMPRESS"                    */
    pwgSUPPORTED,      /* "INTERLISP"                  */
    pwgSUPPORTED,      /* "IOS"                        */
    pwgSUPPORTED,      /* "IRIX"                       */
    pwgSUPPORTED,      /* "ISI_68020"                  */
    pwgSUPPORTED,      /* "ITS"                        */
    pwgSUPPORTED,      /* "KOSOS"                      */
    pwgSUPPORTED,      /* "LINUX"                      */
    pwgSUPPORTED,      /* "LINUX_1_0"                  */
    pwgSUPPORTED,      /* "LINUX_1_2"                  */
    pwgSUPPORTED,      /* "LINUX_2_0"                  */
    pwgSUPPORTED,      /* "LINUX_2_2"                  */
    pwgSUPPORTED,      /* "LINUX_2_4"                  */
    pwgSUPPORTED,      /* "LINUX_2_6"                  */
    pwgSUPPORTED,      /* "LISP"                       */
    pwgSUPPORTED,      /* "LISPM"                      */
    pwgSUPPORTED,      /* "LOCUS"                      */
    pwgSUPPORTED,      /* "MACOS"                      */
    pwgSUPPORTED,      /* "MINOS"                      */
    pwgSUPPORTED,      /* "MOS"                        */
    pwgSUPPORTED,      /* "MPE5"                       */
    pwgSUPPORTED,      /* "MPE_V"                      */
    pwgSUPPORTED,      /* "MPE_IX"                     */
    pwgSUPPORTED,      /* "MSDOS"                      */
    pwgSUPPORTED,      /* "MULTICS"                    */
    pwgSUPPORTED,      /* "MUSIC"                      */
    pwgSUPPORTED,      /* "MUSIC_SP"                   */
    pwgSUPPORTED,      /* "MVS"                        */
    pwgSUPPORTED,      /* "MVS_SP"                     */
    pwgSUPPORTED,      /* "NETBSD_1_0"                 */
    pwgSUPPORTED,      /* "NETBSD_1_1"                 */
    pwgSUPPORTED,      /* "NETBSD_1_2"                 */
    pwgSUPPORTED,      /* "NETBSD_1_3"                 */
    pwgSUPPORTED,      /* "NETWARE_3"                  */
    pwgSUPPORTED,      /* "NETWARE_3_11"               */
    pwgSUPPORTED,      /* "NETWARE_4_0"                */
    pwgSUPPORTED,      /* "NETWARE_4_1"                */
    pwgSUPPORTED,      /* "NETWARE_5_0"                */
    pwgSUPPORTED,      /* "NEXUS"                      */
    pwgSUPPORTED,      /* "NMS"                        */
    pwgSUPPORTED,      /* "NONSTOP"                    */
    pwgSUPPORTED,      /* "NOS_2"                      */
    pwgSUPPORTED,      /* "NTOS"                       */
    pwgSUPPORTED,      /* "OPENBSD"                    */
    pwgSUPPORTED,      /* "OPENVME"                    */
    pwgSUPPORTED,      /* "OPENVMS"                    */
    pwgSUPPORTED,      /* "OS_DDP"                     */
    pwgSUPPORTED,      /* "OS_2"                       */
    pwgSUPPORTED,      /* "OS4"                        */
    pwgSUPPORTED,      /* "OS86"                       */
    pwgSUPPORTED,      /* "OSX"                        */
    pwgSUPPORTED,      /* "PCDOS"                      */
    pwgSUPPORTED,      /* "PERQ_OS"                    */
    pwgSUPPORTED,      /* "PLI"                        */
    pwgSUPPORTED,      /* "PSDOS_MIT"                  */
    pwgSUPPORTED,      /* "PSOS"                       */
    pwgSUPPORTED,      /* "PRIMOS"                     */
    pwgSUPPORTED,      /* "RISC_OS"                    */
    pwgSUPPORTED,      /* "RISC_OS_3_10"               */
    pwgSUPPORTED,      /* "RISC_OS_3_50"               */
    pwgSUPPORTED,      /* "RISC_OS_3_60"               */
    pwgSUPPORTED,      /* "RISC_OS_3_70"               */
    pwgSUPPORTED,      /* "RISC_OS_4_00"               */
    pwgSUPPORTED,      /* "RMX_RDOS"                   */
    pwgSUPPORTED,      /* "ROS"                        */
    pwgSUPPORTED,      /* "RSX11M"                     */
    pwgSUPPORTED,      /* "RTE_A"                      */
    pwgSUPPORTED,      /* "SATOPS"                     */
    pwgSUPPORTED,      /* "SINIX"                      */
    pwgSUPPORTED,      /* "SCO_OPEN_DESKTOP_1_0"       */
    pwgSUPPORTED,      /* "SCO_OPEN_DESKTOP_1_1"       */
    pwgSUPPORTED,      /* "SCO_OPEN_DESKTOP_2_0"       */
    pwgSUPPORTED,      /* "SCO_OPEN_DESKTOP_3_0"       */
    pwgSUPPORTED,      /* "SCO_OPEN_DESKTOP_LITE_3_0"  */
    pwgSUPPORTED,      /* "SCO_OPEN_SERVER_3_0"        */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2_0"             */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2V2_0"           */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2V2_1"           */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2V4_0"           */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2V4_1"           */
    pwgSUPPORTED,      /* "SCO_UNIX_3_2V4_2"           */
    pwgSUPPORTED,      /* "SCO_XENIX_386_2_3_2"        */
    pwgSUPPORTED,      /* "SCO_XENIX_386_2_3_3"        */
    pwgSUPPORTED,      /* "SCO_XENIX_386_2_3_4"        */
    pwgSUPPORTED,      /* "SCS"                        */
    pwgSUPPORTED,      /* "SIMP"                       */
    pwgSUPPORTED,      /* "SUN"                        */
    pwgSUPPORTED,      /* "SUN_OS_3_5"                 */
    pwgSUPPORTED,      /* "SUN_OS_4_0"                 */
    pwgSUPPORTED,      /* "SWIFT"                      */
    pwgSUPPORTED,      /* "TAC"                        */
    pwgSUPPORTED,      /* "TANDEM"                     */
    pwgSUPPORTED,      /* "TENEX"                      */
    pwgSUPPORTED,      /* "THE_MAJOR_BBS"              */
    pwgSUPPORTED,      /* "TOPS10"                     */
    pwgSUPPORTED,      /* "TOPS20"                     */
    pwgSUPPORTED,      /* "TOS"                        */
    pwgSUPPORTED,      /* "TP3010"                     */
    pwgSUPPORTED,      /* "TRSDOS"                     */
    pwgSUPPORTED,      /* "ULTRIX"                     */
    pwgSUPPORTED,      /* "UNIX"                       */
    pwgSUPPORTED,      /* "UNIX_BSD"                   */
    pwgSUPPORTED,      /* "UNIX_V1AT"                  */
    pwgSUPPORTED,      /* "UNIX_V"                     */
    pwgSUPPORTED,      /* "UNIX_V_1"                   */
    pwgSUPPORTED,      /* "UNIX_V_2"                   */
    pwgSUPPORTED,      /* "UNIX_V_3"                   */
    pwgSUPPORTED,      /* "UNIX_PC"                    */
    pwgSUPPORTED,      /* "UNKNOWN"                    */
    pwgSUPPORTED,      /* "UT2D"                       */
    pwgSUPPORTED,      /* "V"                          */
    pwgSUPPORTED,      /* "VM"                         */
    pwgSUPPORTED,      /* "VM_370"                     */
    pwgSUPPORTED,      /* "VM_CMS"                     */
    pwgSUPPORTED,      /* "VM_SP"                      */
    pwgSUPPORTED,      /* "VMS"                        */
    pwgSUPPORTED,      /* "VMS_EUNICE"                 */
    pwgSUPPORTED,      /* "VRTX"                       */
    pwgSUPPORTED,      /* "WAITS"                      */
    pwgSUPPORTED,      /* "WANG"                       */
    pwgSUPPORTED,      /* "WIN32"                      */
    pwgSUPPORTED,      /* "WINDOWS_95"                 */
    pwgSUPPORTED,      /* "WINDOWS_95_OSR1"            */
    pwgSUPPORTED,      /* "WINDOWS_95_OSR2"            */
    pwgSUPPORTED,      /* "WINDOWS_98"                 */
    pwgSUPPORTED,      /* "WINDOWS_CE"                 */
    pwgSUPPORTED,      /* "WINDOWS_NT"                 */
    pwgSUPPORTED,      /* "WINDOWS_NT_2"               */
    pwgSUPPORTED,      /* "WINDOWS_NT_3"               */
    pwgSUPPORTED,      /* "WINDOWS_NT_3_5"             */
    pwgSUPPORTED,      /* "WINDOWS_NT_3_51"            */
    pwgSUPPORTED,      /* "WINDOWS_NT_4"               */
    pwgSUPPORTED,      /* "WINDOWS_NT_5"               */
    pwgSUPPORTED,      /* "WINDOWS_NT_5_1"             */
    pwgSUPPORTED,      /* "WINDOWS_NT_6"               */
    pwgSUPPORTED,      /* "WINDOWS_NT_6_1"             */
    pwgSUPPORTED,      /* "WORLDGROUP"                 */
    pwgSUPPORTED,      /* "WYSE_WYXWARE"               */
    pwgSUPPORTED,      /* "X11R3"                      */
    pwgSUPPORTED,      /* "XDE"                        */
    pwgSUPPORTED,      /* "XENIX"                      */

    VND_DOC_SRC_OS_NAM_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_DocumentSourceOsName = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Document Source Operating System Name", /* Textual name of parametric      */
                                PJT_SUPPORT_LEVEL_1, /*Office*/     /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_DOCUMENT_SOURCE_OS_NAME_NOT_SET,/* Default or nominal setting           */
                                PWG_DOCUMENT_SOURCE_OS_NAME_NOT_SET,/* Setting data value                   */

                                pwgDocumentSourceOsName_Keywords,   /* ENUM Keyword names (strings)         */
                                pwgDocumentSourceOsName_KWValues,   /* ENUM Keyword (string) values         */
                                pwgDocumentSourceOsName_KWVLevel,   /* ENUM Keyword pjt support level       */
                                pwgDocumentSourceOsName_KWVSupported,/*ENUM Keywords supported              */

                                PWG_DOCUMENT_SOURCE_OS_NAME_NOT_SET,/* The minimum   data value             */
                                PWG_DOCUMENT_SOURCE_OS_NAME_END - 1,/* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================ pwg.pjt.pjd.2.document.source.os.name.h" ================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
