/* ======================================= pwg.pjt.xxx.N.media.c ========================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.pjt.xxx.N.media.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/* Media Back  Coating                                                                                      */
/* Media Front Coating                                                                                      */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaBackCoating               */
/* -----------------                                                                                        */
/* Indicates the pre-process coating applied to the back of the media.                                      */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaFrontCoating              */
/* -----------------                                                                                        */
/* Indicates the pre-process coating applied to the front of the media.                                     */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaCoating_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_COATING_UNKNOWN",

                "PWG_MEDIA_COATING_NONE",
                "PWG_MEDIA_COATING_GLOSSY",
                "PWG_MEDIA_COATING_HIGH_GLOSS",
                "PWG_MEDIA_COATING_SEMI_GLOSS",
                "PWG_MEDIA_COATING_SATIN",
                "PWG_MEDIA_COATING_MATTE",

                VND_MEDIA_COT_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaCoating_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaCoating_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "None",
                "Glossy",
                "HighGloss",
                "SemiGloss",
                "Satin",
                "Matte",

                VND_MEDIA_COT_KWV

                pwgNULL
};

pwgBIT8 pwgMediaCoating_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_NONE"         */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_GLOSSY"       */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_HIGH_GLOSS"   */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_SEMI_GLOSS"   */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_SATIN"        */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_COATING_MATTE"        */

    VND_MEDIA_COT_KWVL

    0
};

pwgBOOL pwgMediaCoating_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                              */
    pwgNOT_SUPPORTED,  /* "_"                              */
    pwgSUPPORTED,      /* "Unknown"                        */

    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_NONE"         */
    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_GLOSSY"       */
    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_HIGH_GLOSS"   */
    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_SEMI_GLOSS"   */
    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_SATIN"        */
    pwgSUPPORTED,      /* "PWG_MEDIA_COATING_MATTE"        */

    VND_MEDIA_COT_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaCoating = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Coating",                    /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1, /*Embedded*/   /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_COATING_NONE,             /* Default or nominal setting           */
                                PWG_MEDIA_COATING_NONE,             /* Setting data value                   */

                                pwgMediaCoating_Keywords,           /* ENUM Keyword names (strings)         */
                                pwgMediaCoating_KWVAlues,           /* ENUM Keyword (string) values         */
                                pwgMediaCoating_KWVLevel,           /* ENUM Keyword pjt support level       */
                                pwgMediaCoating_KWVSupported,       /* ENUM Keyword supported               */

                                PWG_MEDIA_COATING_UNKNOWN,          /* The minimum   data value             */
                                PWG_MEDIA_COATING_END - 1,          /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Color                                                                                              */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaColor                     */
/* -----------------                                                                                        */
/* Indicates the desired color of the media being specified.                                                */
/* ..................................................|..................................................... */

/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: 2012.07.18 -- PWG MSN  2.0 was used to update the PWG:PJT values                          */
/*                                                                                                          */
/*  pwgCHAR* pwgMediaColor_Keywords[] = {                                                                   */
/*                  "-",                                                                                    */
/*                  "PWG_MEDIA_COLOR_OTHER",                                                                */
/*                  "PWG_MEDIA_COLOR_UNKNOWN",                                                              */
/*  //                "PWG_MEDIA_COLOR_TRANSPARENT",                                                        */
/*                  "PWG_MEDIA_COLOR_NO_COLOR",                                                             */
/*                  "PWG_MEDIA_COLOR_WHITE",                                                                */
/*                  "PWG_MEDIA_COLOR_PINK",                                                                 */
/*                  "PWG_MEDIA_COLOR_YELLOW",                                                               */
/*                  "PWG_MEDIA_COLOR_BLUE",                                                                 */
/*                  "PWG_MEDIA_COLOR_GREEN",                                                                */
/*                  "PWG_MEDIA_COLOR_BUFF",                                                                 */
/*                  "PWG_MEDIA_COLOR_GOLDENROD",                                                            */
/*                  "PWG_MEDIA_COLOR_RED",                                                                  */
/*                  "PWG_MEDIA_COLOR_GRAY",                                                                 */
/*                  "PWG_MEDIA_COLOR_IVORY",                                                                */
/*                  "PWG_MEDIA_COLOR_ORANGE",                                                               */
/*                                                                                                          */
/*                  pwgNULL                                                                                 */
/*  };                                                                                                      */
/*                                                                                                          */
/*  pwgCHAR* pwgMediaColor_KWVAlues[] = {                                                                   */
/*                  "-",                                                                                    */
/*                  "Other",                                                                                */
/*                  "Unknown",                                                                              */
/*  //                "Transparent",                                                                        */
/*                  "NoColor",                                                                              */
/*                  "White",                                                                                */
/*                  "Pink",                                                                                 */
/*                  "Yellow",                                                                               */
/*                  "Blue",                                                                                 */
/*                  "Green",                                                                                */
/*                  "Buff",                                                                                 */
/*                  "Goldenrod",                                                                            */
/*                  "Red",                                                                                  */
/*                  "Gray",                                                                                 */
/*                  "Ivory",                                                                                */
/*                  "Orange",                                                                               */
/*                  pwgNULL                                                                                 */
/*  };                                                                                                      */
/*                                                                                                          */
/*  pwgBIT8 pwgMediaColor_KWVLevel[] = {                                                                    */
/*      PJT_SUPPORT_LEVEL_NONE,   * "-"                                                                     */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_OTHER"                                                 */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_UNKNOWN"                                               */
/*                                                                                                          */
/*  //                               "PWG_MEDIA_COLOR_TRANSPARENT"                                          */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_NO_COLOR"                                              */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_WHITE"                                                 */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_PINK"                                                  */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_YELLOW"                                                */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_BLUE"                                                  */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_GREEN"                                                 */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_BUFF"                                                  */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_GOLDENROD"                                             */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_RED"                                                   */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_GRAY"                                                  */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_IVORY"                                                 */
/*      PJT_SUPPORT_LEVEL_1,      * "PWG_MEDIA_COLOR_ORANGE"                                                */
/*                                                                                                          */
/*      0                                                                                                   */
/*  };                                                                                                      */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* Replaced by:                                                                                             */
/*                                                                                                          */
/*. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaColor_Keywords[] = {
                "-",
                "PWG_MEDIA_COLOR_OTHER",
                "PWG_MEDIA_COLOR_UNKNOWN",

        /*       Name (and named-index)                Localized Name       R G B A                         */
        /*       "PWG_MEDIA_COLOR_NO_COLOR",                                                                */
                "PWG_MEDIA_COLOR_TRANSPARENT",      /* Transparent        0xFFFFFF00                        */
                "PWG_MEDIA_COLOR_BLACK",            /*       Black        0x000000FF                        */
                "PWG_MEDIA_COLOR_CLEAR_BLACK",      /* Clear Black        0x0000007F                        */
                "PWG_MEDIA_COLOR_LIGHT_BLACK",      /* Light Black        0x808080FF                        */
                "PWG_MEDIA_COLOR_BLUE",             /*       Blue         0x0000FFFF                        */
                "PWG_MEDIA_COLOR_CLEAR_BLUE",       /* Clear Blue         0x0000FF7F                        */
                "PWG_MEDIA_COLOR_DARK_BLUE",        /* Dark  Blue         0x00008BFF                        */
                "PWG_MEDIA_COLOR_LIGHT_BLUE",       /* Light Blue         0xADD8E6FF                        */
                "PWG_MEDIA_COLOR_BROWN",            /*       Brown        0xA52A2AFF                        */
                "PWG_MEDIA_COLOR_CLEAR_BROWN",      /* Clear Brown        0xA52A2A7F                        */
                "PWG_MEDIA_COLOR_DARK_BROWN",       /* Dark  Brown        0x5C4033FF                        */
                "PWG_MEDIA_COLOR_LIGHT_BROWN",      /* Light Brown        0x9966FFFF                        */
                "PWG_MEDIA_COLOR_BUFF",             /*       Buff         0xF0DC82FF                        */
                "PWG_MEDIA_COLOR_CLEAR_BUFF",       /* Clear Buff         0xF0DC827F                        */
                "PWG_MEDIA_COLOR_DARK_BUFF",        /* Dark  Buff         0x976638FF                        */
                "PWG_MEDIA_COLOR_LIGHT_BUFF",       /* Light Buff         0xECD9B0FF                        */
                "PWG_MEDIA_COLOR_CYAN",             /*       Cyan         0x00FFFFFF                        */
                "PWG_MEDIA_COLOR_CLEAR_CYAN",       /* Clear Cyan         0x00FFFF7F                        */
                "PWG_MEDIA_COLOR_DARK_CYAN",        /* Dark  Cyan         0x008B8BFF                        */
                "PWG_MEDIA_COLOR_LIGHT_CYAN",       /* Light Cyan         0xE0FFFFFF                        */
                "PWG_MEDIA_COLOR_GOLD",             /*       Gold         0xFFD700FF                        */
                "PWG_MEDIA_COLOR_CLEAR_GOLD",       /* Clear Gold         0xFFD7007F                        */
                "PWG_MEDIA_COLOR_DARK_GOLD",        /* Dark  Gold         0xEEBC1DFF                        */
                "PWG_MEDIA_COLOR_LIGHT_GOLD",       /* Light Gold         0xF1E5ACFF                        */
                "PWG_MEDIA_COLOR_GOLDENDROD",       /*       Goldenrod    0xDAA520FF                        */
                "PWG_MEDIA_COLOR_CLEAR_GOLDENROD",  /* Clear Goldenrod    0xDAA5207F                        */
                "PWG_MEDIA_COLOR_DARK_GOLDENROD",   /* Dark  Goldenrod    0xB8860BFF                        */
                "PWG_MEDIA_COLOR_LIGHT_GOLDENROD",  /* Light Goldenrod    0xFFEC8BFF                        */
                "PWG_MEDIA_COLOR_GRAY",             /*       Gray         0x808080FF                        */
                "PWG_MEDIA_COLOR_CLEAR_GRAY",       /* Clear Gray         0x8080807F                        */
                "PWG_MEDIA_COLOR_DARK_GRAY",        /* Dark  Gray         0x404040FF                        */
                "PWG_MEDIA_COLOR_LIGHT_GRAY",       /* Light Gray         0xD3D3D3FF                        */
                "PWG_MEDIA_COLOR_GREEN",            /*       Green        0x008000FF                        */
                "PWG_MEDIA_COLOR_CLEAR_GREEN",      /* Clear Green        0x0080007F                        */
                "PWG_MEDIA_COLOR_DARK_GREEN",       /* Dark  Green        0x006400FF                        */
                "PWG_MEDIA_COLOR_LIGHT_GREEN",      /* Light Green        0x90EE90FF                        */
                "PWG_MEDIA_COLOR_IVORY",            /*       Ivory        0xFFFFF0FF                        */
                "PWG_MEDIA_COLOR_CLEAR_IVORY",      /* Clear Ivory        0xFFFFF07F                        */
                "PWG_MEDIA_COLOR_DARK_IVORY",       /* Dark  Ivory        0xF2E58FFF                        */
                "PWG_MEDIA_COLOR_LIGHT_IVORY",      /* Light Ivory        0xFFF8C9FF                        */
                "PWG_MEDIA_COLOR_MAGENTA",          /*       Magenta      0xFF00FFFF                        */
                "PWG_MEDIA_COLOR_CLEAR_MAGENTA",    /* Clear Magenta      0xFF00FF7F                        */
                "PWG_MEDIA_COLOR_DARK_MAGENTA",     /* Dark  Magenta      0x8B008BFF                        */
                "PWG_MEDIA_COLOR_LIGHT_MAGENTA",    /* Light Magenta      0xFF77FFFF                        */
                "PWG_MEDIA_COLOR_MULTI_COLOR",      /*       Multi-Color  Undefined                         */
                "PWG_MEDIA_COLOR_CLEAR_MULTI_COLOR",/* Clear Multi-Color  Undefined                         */
                "PWG_MEDIA_COLOR_MUSTARD",          /*       Mustard      0xFFDB58FF                        */
                "PWG_MEDIA_COLOR_CLEAR_MUSTARD",    /* Clear Mustard      0xFFDB587F                        */
                "PWG_MEDIA_COLOR_DARK_MUSTARD",     /* Dark  Mustard      0x7C7C40FF                        */
                "PWG_MEDIA_COLOR_LIGHT_MUSTRAD",    /* Light Mustard      0xEEDD62FF                        */
                "PWG_MEDIA_COLOR_ORANGE",           /*       Orange       0xFFA500FF                        */
                "PWG_MEDIA_COLOR_CLEAR_ORANGE",     /* Clear Orange       0xFFA5007F                        */
                "PWG_MEDIA_COLOR_DARK_ORANGE",      /* Dark  Orange       0xFF8C00FF                        */
                "PWG_MEDIA_COLOR_LIGHT_ORANGE",     /* Light Orange       0xD9A465FF                        */
                "PWG_MEDIA_COLOR_PINK",             /*       Pink         0xFFC0CBFF                        */
                "PWG_MEDIA_COLOR_CLEAR_PINK",       /* Clear Pink         0xFFC0CB7F                        */
                "PWG_MEDIA_COLOR_DARK_PINK",        /* Dark  Pink         0xE75480FF                        */
                "PWG_MEDIA_COLOR_LIGHT_PINK",       /* Light Pink         0xFFB6C1FF                        */
                "PWG_MEDIA_COLOR_RED",              /*       Red          0xFF0000FF                        */
                "PWG_MEDIA_COLOR_CLEAR_RED",        /* Clear Red          0xFF00007F                        */
                "PWG_MEDIA_COLOR_DARK_RED",         /* Dark  Red          0x8B0000FF                        */
                "PWG_MEDIA_COLOR_LIGHT_RED",        /* Light Red          0xFF3333FF                        */
                "PWG_MEDIA_COLOR_SILVER",           /*       Silver       0xC0C0C0FF                        */
                "PWG_MEDIA_COLOR_CLEAR_SILVER",     /* Clear Silver       0xC0C0C07F                        */
                "PWG_MEDIA_COLOR_DARK_SILVER",      /* Dark  Silver       0xAFAFAFFF                        */
                "PWG_MEDIA_COLOR_LIGHT_SILVER",     /* Light Silver       0xE1E1E1FF                        */
                "PWG_MEDIA_COLOR_TURQUOISE",        /*       Turquoise    0x30D5C8FF                        */
                "PWG_MEDIA_COLOR_CLEAR_TURQUOISE",  /* Clear Turquoise    0x30D5C87F                        */
                "PWG_MEDIA_COLOR_DARK_TURQUOISE",   /* Dark  Turquoise    0x00CED1FF                        */
                "PWG_MEDIA_COLOR_LIGHT_TURQUOISE",  /* Light Turquoise    0xAFE4DEFF                        */
                "PWG_MEDIA_COLOR_VIOLET",           /*       Violet       0xEE82EEFF                        */
                "PWG_MEDIA_COLOR_CLEAR_VIOLET",     /* Clear Violet       0xEE82EE7F                        */
                "PWG_MEDIA_COLOR_DARK_VIOLET",      /* Dark  Violet       0x9400D3FF                        */
                "PWG_MEDIA_COLOR_LIGHT_VIOLET",     /* Light Violet       0x7A5299FF                        */
                "PWG_MEDIA_COLOR_WHITE",            /*       White        0xFFFFFFFF                        */
                "PWG_MEDIA_COLOR_CLEAR_WHITE",      /* Clear White        0xFFFFFF7F                        */
                "PWG_MEDIA_COLOR_YELLOW",           /*       Yellow       0xFFFF00FF                        */
                "PWG_MEDIA_COLOR_CLEAR_YELLOW",     /* Clear Yellow       0xFFFF007F                        */
                "PWG_MEDIA_COLOR_DARK_YELLOW",      /* Dark  Yellow       0xFFCC00FF                        */
                "PWG_MEDIA_COLOR_LIGHT_YELLOW",     /* Light Yellow       0xFFFFE0FF                        */

                 VND_MEDIA_CLR_KW

                 pwgNULL
};
#else
pwgCHAR* pwgMediaColor_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaColor_KWVAlues[] = {
                "-",
                "Other",
                "Unknown",
             /* Name (and named-index)                Localized Name       R G B A                          */
             /* "NoColor",                                                                                  */
                "Transparent",                      /* Transparent        0xFFFFFF00                        */
                "Black",                            /*       Black        0x000000FF                        */
                "ClearBlack",                       /* Clear Black        0x0000007F                        */
                "LightBlack",                       /* Light Black        0x808080FF                        */
                "Blue",                             /*       Blue         0x0000FFFF                        */
                "ClearBlue",                        /* Clear Blue         0x0000FF7F                        */
                "DarkBlue",                         /* Dark  Blue         0x00008BFF                        */
                "LightBlue",                        /* Light Blue         0xADD8E6FF                        */
                "Brown",                            /*       Brown        0xA52A2AFF                        */
                "ClearBrown",                       /* Clear Brown        0xA52A2A7F                        */
                "DarkBrown",                        /* Dark  Brown        0x5C4033FF                        */
                "LightBrown",                       /* Light Brown        0x9966FFFF                        */
                "Buff",                             /*       Buff         0xF0DC82FF                        */
                "ClearBuff",                        /* Clear Buff         0xF0DC827F                        */
                "DarkBuff",                         /* Dark  Buff         0x976638FF                        */
                "LightBuff",                        /* Light Buff         0xECD9B0FF                        */
                "Cyan",                             /*       Cyan         0x00FFFFFF                        */
                "ClearCyan",                        /* Clear Cyan         0x00FFFF7F                        */
                "DarkCyan",                         /* Dark  Cyan         0x008B8BFF                        */
                "LightCyan",                        /* Light Cyan         0xE0FFFFFF                        */
                "Gold",                             /*       Gold         0xFFD700FF                        */
                "ClearGold",                        /* Clear Gold         0xFFD7007F                        */
                "DarkGold",                         /* Dark  Gold         0xEEBC1DFF                        */
                "LightGold",                        /* Light Gold         0xF1E5ACFF                        */
                "Goldenrod",                        /*       Goldenrod    0xDAA520FF                        */
                "ClearGoldenrod",                   /* Clear Goldenrod    0xDAA5207F                        */
                "DarkGoldenrod",                    /* Dark  Goldenrod    0xB8860BFF                        */
                "LightGoldenrod",                   /* Light Goldenrod    0xFFEC8BFF                        */
                "Gray",                             /*       Gray         0x808080FF                        */
                "ClearGray",                        /* Clear Gray         0x8080807F                        */
                "DarkGray",                         /* Dark  Gray         0x404040FF                        */
                "LightGray",                        /* Light Gray         0xD3D3D3FF                        */
                "Green",                            /*       Green        0x008000FF                        */
                "ClearGreen",                       /* Clear Green        0x0080007F                        */
                "DarkGreen",                        /* Dark  Green        0x006400FF                        */
                "LightGreen",                       /* Light Green        0x90EE90FF                        */
                "Ivory",                            /*       Ivory        0xFFFFF0FF                        */
                "ClearIvory",                       /* Clear Ivory        0xFFFFF07F                        */
                "DarkIvory",                        /* Dark  Ivory        0xF2E58FFF                        */
                "LightIvory",                       /* Light Ivory        0xFFF8C9FF                        */
                "Magenta",                          /*       Magenta      0xFF00FFFF                        */
                "ClearMagenta",                     /* Clear Magenta      0xFF00FF7F                        */
                "DarkMagenta",                      /* Dark  Magenta      0x8B008BFF                        */
                "LightMagenta",                     /* Light Magenta      0xFF77FFFF                        */
                "MultiColor",                       /*       Multi-Color  Undefined                         */
                "ClearMultiColor",                  /* Clear Multi-Color  Undefined                         */
                "Mustard",                          /*       Mustard      0xFFDB58FF                        */
                "ClearMustard",                     /* Clear Mustard      0xFFDB587F                        */
                "DarkMustard",                      /* Dark  Mustard      0x7C7C40FF                        */
                "LightMustard",                     /* Light Mustard      0xEEDD62FF                        */
                "Orange",                           /*       Orange       0xFFA500FF                        */
                "ClearOrange",                      /* Clear Orange       0xFFA5007F                        */
                "DarkOrange",                       /* Dark  Orange       0xFF8C00FF                        */
                "LightOrange",                      /* Light Orange       0xD9A465FF                        */
                "Pink",                             /*       Pink         0xFFC0CBFF                        */
                "ClearPink",                        /* Clear Pink         0xFFC0CB7F                        */
                "DarkPink",                         /* Dark  Pink         0xE75480FF                        */
                "LightPink",                        /* Light Pink         0xFFB6C1FF                        */
                "Red",                              /*       Red          0xFF0000FF                        */
                "ClearRed",                         /* Clear Red          0xFF00007F                        */
                "DarkRed",                          /* Dark  Red          0x8B0000FF                        */
                "LightRed",                         /* Light Red          0xFF3333FF                        */
                "Silver",                           /*       Silver       0xC0C0C0FF                        */
                "ClearSilver",                      /* Clear Silver       0xC0C0C07F                        */
                "DarkSilver",                       /* Dark  Silver       0xAFAFAFFF                        */
                "LightSilver",                      /* Light Silver       0xE1E1E1FF                        */
                "Turquoise",                        /*       Turquoise    0x30D5C8FF                        */
                "ClearTurquoise",                   /* Clear Turquoise    0x30D5C87F                        */
                "DarkTurquoise",                    /* Dark  Turquoise    0x00CED1FF                        */
                "LightTurquoise",                   /* Light Turquoise    0xAFE4DEFF                        */
                "Violet",                           /*       Violet       0xEE82EEFF                        */
                "ClearViolet",                      /* Clear Violet       0xEE82EE7F                        */
                "DarkViolet",                       /* Dark  Violet       0x9400D3FF                        */
                "LightViolet",                      /* Light Violet       0x7A5299FF                        */
                "White",                            /*       White        0xFFFFFFFF                        */
                "ClearWhite",                       /* Clear White        0xFFFFFF7F                        */
                "Yellow",                           /*       Yellow       0xFFFF00FF                        */
                "ClearYellow",                      /* Clear Yellow       0xFFFF007F                        */
                "DarkYellow",                       /* Dark  Yellow       0xFFCC00FF                        */
                "LightYellow",                      /* Light Yellow       0xFFFFE0FF                        */

                VND_MEDIA_CLR_KWV

                pwgNULL
 };

 pwgBIT8 pwgMediaColor_KWVLevel[] = {
      PJT_SUPPORT_LEVEL_NONE,   /* "-",                                                                     */
      PJT_SUPPORT_LEVEL_1,      /* "Other",                                                                 */
      PJT_SUPPORT_LEVEL_1,      /* "Unknown",                                                               */
                                /* Name(& named-index) Localized Name       R G B A                         */
                                /* "NoColor",                                                               */
      PJT_SUPPORT_LEVEL_1,      /* "Transparent",      Transparent        0xFFFFFF00                        */
      PJT_SUPPORT_LEVEL_1,      /* "Black",                  Black        0x000000FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearBlack",       Clear Black        0x0000007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightBlack",       Light Black        0x808080FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Blue",                   Blue         0x0000FFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearBlue",        Clear Blue         0x0000FF7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkBlue",         Dark  Blue         0x00008BFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightBlue",        Light Blue         0xADD8E6FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Brown",                  Brown        0xA52A2AFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearBrown",       Clear Brown        0xA52A2A7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkBrown",        Dark  Brown        0x5C4033FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightBrown",       Light Brown        0x9966FFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Buff",                   Buff         0xF0DC82FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearBuff",        Clear Buff         0xF0DC827F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkBuff",         Dark  Buff         0x976638FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightBuff",        Light Buff         0xECD9B0FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Cyan",                   Cyan         0x00FFFFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearCyan",        Clear Cyan         0x00FFFF7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkCyan",         Dark  Cyan         0x008B8BFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightCyan",        Light Cyan         0xE0FFFFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Gold",                   Gold         0xFFD700FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearGold",        Clear Gold         0xFFD7007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkGold",         Dark  Gold         0xEEBC1DFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightGold",        Light Gold         0xF1E5ACFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Goldenrod",              Goldenrod    0xDAA520FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearGoldenrod",   Clear Goldenrod    0xDAA5207F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkGoldenrod",    Dark  Goldenrod    0xB8860BFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightGoldenrod",   Light Goldenrod    0xFFEC8BFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Gray",                   Gray         0x808080FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearGray",        Clear Gray         0x8080807F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkGray",         Dark  Gray         0x404040FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightGray",        Light Gray         0xD3D3D3FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Green",                  Green        0x008000FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearGreen",       Clear Green        0x0080007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkGreen",        Dark  Green        0x006400FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightGreen",       Light Green        0x90EE90FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Ivory",                  Ivory        0xFFFFF0FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearIvory",       Clear Ivory        0xFFFFF07F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkIvory",        Dark  Ivory        0xF2E58FFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightIvory",       Light Ivory        0xFFF8C9FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Magenta",                Magenta      0xFF00FFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearMagenta",     Clear Magenta      0xFF00FF7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkMagenta",      Dark  Magenta      0x8B008BFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightMagenta",     Light Magenta      0xFF77FFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "MultiColor",             Multi-Color  Undefined                         */
      PJT_SUPPORT_LEVEL_1,      /* "ClearMultiColor",  Clear Multi-Color  Undefined                         */
      PJT_SUPPORT_LEVEL_1,      /* "Mustard",                Mustard      0xFFDB58FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearMustard",     Clear Mustard      0xFFDB587F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkMustard",      Dark  Mustard      0x7C7C40FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightMustard",     Light Mustard      0xEEDD62FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Orange",                 Orange       0xFFA500FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearOrange",      Clear Orange       0xFFA5007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkOrange",       Dark  Orange       0xFF8C00FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightOrange",      Light Orange       0xD9A465FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Pink",                   Pink         0xFFC0CBFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearPink",        Clear Pink         0xFFC0CB7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkPink",         Dark  Pink         0xE75480FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightPink",        Light Pink         0xFFB6C1FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Red",                    Red          0xFF0000FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearRed",         Clear Red          0xFF00007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkRed",          Dark  Red          0x8B0000FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightRed",         Light Red          0xFF3333FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Silver",                 Silver       0xC0C0C0FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearSilver",      Clear Silver       0xC0C0C07F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkSilver",       Dark  Silver       0xAFAFAFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightSilver",      Light Silver       0xE1E1E1FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Turquoise",              Turquoise    0x30D5C8FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearTurquoise",   Clear Turquoise    0x30D5C87F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkTurquoise",    Dark  Turquoise    0x00CED1FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightTurquoise",   Light Turquoise    0xAFE4DEFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "Violet",                 Violet       0xEE82EEFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearViolet",      Clear Violet       0xEE82EE7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkViolet",       Dark  Violet       0x9400D3FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightViolet",      Light Violet       0x7A5299FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "White",                  White        0xFFFFFFFF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearWhite",       Clear White        0xFFFFFF7F                        */
      PJT_SUPPORT_LEVEL_1,      /* "Yellow",                 Yellow       0xFFFF00FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "ClearYellow",      Clear Yellow       0xFFFF007F                        */
      PJT_SUPPORT_LEVEL_1,      /* "DarkYellow",       Dark  Yellow       0xFFCC00FF                        */
      PJT_SUPPORT_LEVEL_1,      /* "LightYellow",      Light Yellow       0xFFFFE0FF                        */

      VND_MEDIA_CLR_KWVL

      0
  };

 pwgBOOL pwgMediaColor_KWVSupported[] = {
      pwgNOT_SUPPORTED,                 /* "-",                                                                     */
      pwgSUPPORTED,             /* "Other",                                                                 */
      pwgSUPPORTED,             /* "Unknown",                                                               */
                                /* Name(& named-index) Localized Name       R G B A                         */
                                /* "NoColor",                                                               */
      pwgSUPPORTED,             /* "Transparent",      Transparent        0xFFFFFF00                        */
      pwgSUPPORTED,             /* "Black",                  Black        0x000000FF                        */
      pwgSUPPORTED,             /* "ClearBlack",       Clear Black        0x0000007F                        */
      pwgSUPPORTED,             /* "LightBlack",       Light Black        0x808080FF                        */
      pwgSUPPORTED,             /* "Blue",                   Blue         0x0000FFFF                        */
      pwgSUPPORTED,             /* "ClearBlue",        Clear Blue         0x0000FF7F                        */
      pwgSUPPORTED,             /* "DarkBlue",         Dark  Blue         0x00008BFF                        */
      pwgSUPPORTED,             /* "LightBlue",        Light Blue         0xADD8E6FF                        */
      pwgSUPPORTED,             /* "Brown",                  Brown        0xA52A2AFF                        */
      pwgSUPPORTED,             /* "ClearBrown",       Clear Brown        0xA52A2A7F                        */
      pwgSUPPORTED,             /* "DarkBrown",        Dark  Brown        0x5C4033FF                        */
      pwgSUPPORTED,             /* "LightBrown",       Light Brown        0x9966FFFF                        */
      pwgSUPPORTED,             /* "Buff",                   Buff         0xF0DC82FF                        */
      pwgSUPPORTED,             /* "ClearBuff",        Clear Buff         0xF0DC827F                        */
      pwgSUPPORTED,             /* "DarkBuff",         Dark  Buff         0x976638FF                        */
      pwgSUPPORTED,             /* "LightBuff",        Light Buff         0xECD9B0FF                        */
      pwgSUPPORTED,             /* "Cyan",                   Cyan         0x00FFFFFF                        */
      pwgSUPPORTED,             /* "ClearCyan",        Clear Cyan         0x00FFFF7F                        */
      pwgSUPPORTED,             /* "DarkCyan",         Dark  Cyan         0x008B8BFF                        */
      pwgSUPPORTED,             /* "LightCyan",        Light Cyan         0xE0FFFFFF                        */
      pwgSUPPORTED,             /* "Gold",                   Gold         0xFFD700FF                        */
      pwgSUPPORTED,             /* "ClearGold",        Clear Gold         0xFFD7007F                        */
      pwgSUPPORTED,             /* "DarkGold",         Dark  Gold         0xEEBC1DFF                        */
      pwgSUPPORTED,             /* "LightGold",        Light Gold         0xF1E5ACFF                        */
      pwgSUPPORTED,             /* "Goldenrod",              Goldenrod    0xDAA520FF                        */
      pwgSUPPORTED,             /* "ClearGoldenrod",   Clear Goldenrod    0xDAA5207F                        */
      pwgSUPPORTED,             /* "DarkGoldenrod",    Dark  Goldenrod    0xB8860BFF                        */
      pwgSUPPORTED,             /* "LightGoldenrod",   Light Goldenrod    0xFFEC8BFF                        */
      pwgSUPPORTED,             /* "Gray",                   Gray         0x808080FF                        */
      pwgSUPPORTED,             /* "ClearGray",        Clear Gray         0x8080807F                        */
      pwgSUPPORTED,             /* "DarkGray",         Dark  Gray         0x404040FF                        */
      pwgSUPPORTED,             /* "LightGray",        Light Gray         0xD3D3D3FF                        */
      pwgSUPPORTED,             /* "Green",                  Green        0x008000FF                        */
      pwgSUPPORTED,             /* "ClearGreen",       Clear Green        0x0080007F                        */
      pwgSUPPORTED,             /* "DarkGreen",        Dark  Green        0x006400FF                        */
      pwgSUPPORTED,             /* "LightGreen",       Light Green        0x90EE90FF                        */
      pwgSUPPORTED,             /* "Ivory",                  Ivory        0xFFFFF0FF                        */
      pwgSUPPORTED,             /* "ClearIvory",       Clear Ivory        0xFFFFF07F                        */
      pwgSUPPORTED,             /* "DarkIvory",        Dark  Ivory        0xF2E58FFF                        */
      pwgSUPPORTED,             /* "LightIvory",       Light Ivory        0xFFF8C9FF                        */
      pwgSUPPORTED,             /* "Magenta",                Magenta      0xFF00FFFF                        */
      pwgSUPPORTED,             /* "ClearMagenta",     Clear Magenta      0xFF00FF7F                        */
      pwgSUPPORTED,             /* "DarkMagenta",      Dark  Magenta      0x8B008BFF                        */
      pwgSUPPORTED,             /* "LightMagenta",     Light Magenta      0xFF77FFFF                        */
      pwgSUPPORTED,             /* "MultiColor",             Multi-Color  Undefined                         */
      pwgSUPPORTED,             /* "ClearMultiColor",  Clear Multi-Color  Undefined                         */
      pwgSUPPORTED,             /* "Mustard",                Mustard      0xFFDB58FF                        */
      pwgSUPPORTED,             /* "ClearMustard",     Clear Mustard      0xFFDB587F                        */
      pwgSUPPORTED,             /* "DarkMustard",      Dark  Mustard      0x7C7C40FF                        */
      pwgSUPPORTED,             /* "LightMustard",     Light Mustard      0xEEDD62FF                        */
      pwgSUPPORTED,             /* "Orange",                 Orange       0xFFA500FF                        */
      pwgSUPPORTED,             /* "ClearOrange",      Clear Orange       0xFFA5007F                        */
      pwgSUPPORTED,             /* "DarkOrange",       Dark  Orange       0xFF8C00FF                        */
      pwgSUPPORTED,             /* "LightOrange",      Light Orange       0xD9A465FF                        */
      pwgSUPPORTED,             /* "Pink",                   Pink         0xFFC0CBFF                        */
      pwgSUPPORTED,             /* "ClearPink",        Clear Pink         0xFFC0CB7F                        */
      pwgSUPPORTED,             /* "DarkPink",         Dark  Pink         0xE75480FF                        */
      pwgSUPPORTED,             /* "LightPink",        Light Pink         0xFFB6C1FF                        */
      pwgSUPPORTED,             /* "Red",                    Red          0xFF0000FF                        */
      pwgSUPPORTED,             /* "ClearRed",         Clear Red          0xFF00007F                        */
      pwgSUPPORTED,             /* "DarkRed",          Dark  Red          0x8B0000FF                        */
      pwgSUPPORTED,             /* "LightRed",         Light Red          0xFF3333FF                        */
      pwgSUPPORTED,             /* "Silver",                 Silver       0xC0C0C0FF                        */
      pwgSUPPORTED,             /* "ClearSilver",      Clear Silver       0xC0C0C07F                        */
      pwgSUPPORTED,             /* "DarkSilver",       Dark  Silver       0xAFAFAFFF                        */
      pwgSUPPORTED,             /* "LightSilver",      Light Silver       0xE1E1E1FF                        */
      pwgSUPPORTED,             /* "Turquoise",              Turquoise    0x30D5C8FF                        */
      pwgSUPPORTED,             /* "ClearTurquoise",   Clear Turquoise    0x30D5C87F                        */
      pwgSUPPORTED,             /* "DarkTurquoise",    Dark  Turquoise    0x00CED1FF                        */
      pwgSUPPORTED,             /* "LightTurquoise",   Light Turquoise    0xAFE4DEFF                        */
      pwgSUPPORTED,             /* "Violet",                 Violet       0xEE82EEFF                        */
      pwgSUPPORTED,             /* "ClearViolet",      Clear Violet       0xEE82EE7F                        */
      pwgSUPPORTED,             /* "DarkViolet",       Dark  Violet       0x9400D3FF                        */
      pwgSUPPORTED,             /* "LightViolet",      Light Violet       0x7A5299FF                        */
      pwgSUPPORTED,             /* "White",                  White        0xFFFFFFFF                        */
      pwgSUPPORTED,             /* "ClearWhite",       Clear White        0xFFFFFF7F                        */
      pwgSUPPORTED,             /* "Yellow",                 Yellow       0xFFFF00FF                        */
      pwgSUPPORTED,             /* "ClearYellow",      Clear Yellow       0xFFFF007F                        */
      pwgSUPPORTED,             /* "DarkYellow",       Dark  Yellow       0xFFCC00FF                        */
      pwgSUPPORTED,             /* "LightYellow",      Light Yellow       0xFFFFE0FF                        */

      VND_MEDIA_CLR_KWVS

      0

  };

pwgNUM_RNG_DEF pwgDef_MediaColor = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Color",                      /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1, /*Embedded*/   /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_COLOR_WHITE,              /* Default or nominal setting           */
                                PWG_MEDIA_COLOR_WHITE,              /* Setting data value                   */

                                pwgMediaColor_Keywords,             /* ENUM Keyword names (strings)         */
                                pwgMediaColor_KWVAlues,             /* ENUM Keyword (string) values         */
                                pwgMediaColor_KWVLevel,             /* ENUM Keyword pjt support level       */
                                pwgMediaColor_KWVSupported,         /* ENUM Keywords supported              */

                                PWG_MEDIA_COLOR_OTHER,              /* The minimum   data value             */
                                PWG_MEDIA_COLOR_END - 1,            /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Grain                                                                                              */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaGrain                     */
/* -----------------                                                                                        */
/* Indicates the grain of the media.                                                                        */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaGrain_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_GRAIN_UNKNOWN",
                "PWG_MEDIA_GRAIN_X_DIRECTION",
                "PWG_MEDIA_GRAIN_Y_DIRECTION",

                VND_MEDIA_GRN_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaGrain_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaGrain_KWVAlues[] = {
                "-",
                "-",
                "Unknown",
                "XDirection",
                "YDirection",

                VND_MEDIA_GRN_KWV

                pwgNULL
};

pwgBIT8 pwgMediaGrain_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_GRAIN_X_DIRECTION"  */
    PJT_SUPPORT_LEVEL_1,      /* "PWG_MEDIA_GRAIN_Y_DIRECTION"  */

    VND_MEDIA_GRN_KWVL

    0
};

pwgBOOL pwgMediaGrain_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

    pwgSUPPORTED,      /* "PWG_MEDIA_GRAIN_X_DIRECTION"  */
    pwgSUPPORTED,      /* "PWG_MEDIA_GRAIN_Y_DIRECTION"  */

    VND_MEDIA_GRN_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaGrain = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Grain",                      /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_GRAIN_UNKNOWN,            /* Default or nominal setting           */
                                PWG_MEDIA_GRAIN_UNKNOWN,            /* Setting data value                   */

                                pwgMediaGrain_Keywords,             /* ENUM Keyword names (strings)         */
                                pwgMediaGrain_KWVAlues,             /* ENUM Keyword (string) values         */
                                pwgMediaGrain_KWVLevel,             /* ENUM Keyword pjt support level       */
                                pwgMediaGrain_KWVSupported,         /* ENUM Keywords supporeted             */

                                PWG_MEDIA_GRAIN_UNKNOWN,            /* The minimum   data value             */
                                PWG_MEDIA_GRAIN_END - 1,            /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Key                                                                                                */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaKey                       */
/* -----------------                                                                                        */
/* The unique media name associated with an instance of MediaCol elements and their values.  Identical      */
/* values  of MediaKey and the Media element represent the same media.                                      */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaKey_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_KEY_UNKNOWN",

                VND_MEDIA_KEY_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaKey_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaKey_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                VND_MEDIA_KEY_KWV

                pwgNULL
};

pwgBIT8 pwgMediaKey_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    VND_MEDIA_KEY_KWVL

    0
};

pwgBOOL pwgMediaKey_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

    VND_MEDIA_KEY_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaKey = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Key",                        /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1, /*Embedded*/   /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_KEY_UNKNOWN,              /* Default or nominal setting           */
                                PWG_MEDIA_KEY_UNKNOWN,              /* Setting data value                   */

                                pwgMediaKey_Keywords,               /* ENUM Keyword names (strings)         */
                                pwgMediaKey_KWVAlues,               /* ENUM Keyword (string) values         */
                                pwgMediaKey_KWVLevel,               /* ENUM Keyword pjt support level       */
                                pwgMediaKey_KWVSupported,           /* ENUM Keywords supported              */

                                PWG_MEDIA_KEY_UNKNOWN,              /* The minimum   data value             */
                                PWG_MEDIA_KEY_END - 1,              /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Pre-Printed                                                                                        */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaKey                       */
/* -----------------                                                                                        */
/* Indicates the pre-printed characteristics of the desired media.                                          */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaPrePrinted_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_PRE_PRINTED_UNKNOWN",

                "PWG_MEDIA_PRE_PRINTED_BLANK",
                "PWG_MEDIA_PRE_PRINTED_PRE_PRINTED",
                "PWG_MEDIA_PRE_PRINTED_LETTER_HEAD",

                VND_MEDIA_PREPRT_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaPrePrinted_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaPrePrinted_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "Blank",
                "Preprinted",
                "Letterhead",

                VND_MEDIA_PREPRT_KWV

                pwgNULL
};

pwgBIT8 pwgMediaPrePrinted_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "Blank"            */
    PJT_SUPPORT_LEVEL_1,      /* "Preprinted"       */
    PJT_SUPPORT_LEVEL_1,      /* "Letterhead"       */

    VND_MEDIA_PREPRT_KWVL

    0
};

pwgBOOL pwgMediaPrePrinted_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

    pwgSUPPORTED,      /* "Blank"            */
    pwgSUPPORTED,      /* "Preprinted"       */
    pwgSUPPORTED,      /* "Letterhead"       */

    VND_MEDIA_PREPRT_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaPrePrinted = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Pre-Printed",                /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1, /*Embedded*/   /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_PRE_PRINTED_BLANK,        /* Default or nominal setting           */
                                PWG_MEDIA_PRE_PRINTED_BLANK,        /* Setting data value                   */

                                pwgMediaPrePrinted_Keywords,        /* ENUM Keyword names (strings)         */
                                pwgMediaPrePrinted_KWVAlues,        /* ENUM Keyword (string) values         */
                                pwgMediaPrePrinted_KWVLevel,        /* ENUM Keyword pjt support level       */
                                pwgMediaPrePrinted_KWVSupported,    /* ENUM Keywords supported              */

                                PWG_MEDIA_PRE_PRINTED_UNKNOWN,      /* The minimum   data value             */
                                PWG_MEDIA_PRE_PRINTED_END - 1,      /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Recycled                                                                                           */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaRecycled                  */
/* -----------------                                                                                        */
/* Indicates the recycled characteristics of the media.                                                     */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaRecycled_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_RECYCLED_UNKNOWN",

                "PWG_MEDIA_RECYCLED_NONE",
                "PWG_MEDIA_RECYCLED_STANDARD",

                VND_MEDIA_RCY_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaRecycled_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaRecycled_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "None",
                "Standard",

                VND_MEDIA_RCY_KWV

                pwgNULL
};


pwgBIT8 pwgMediaRecycled_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "None"             */
    PJT_SUPPORT_LEVEL_1,      /* "Standard"         */

    VND_MEDIA_RCY_KWVL

    0
};

pwgBOOL pwgMediaRecycled_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

    pwgSUPPORTED,      /* "None"             */
    pwgSUPPORTED,      /* "Standard"         */

    VND_MEDIA_RCY_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaRecycled = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Recycled",                   /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_RECYCLED_NONE,            /* Default or nominal setting           */
                                PWG_MEDIA_RECYCLED_NONE,            /* Setting data value                   */

                                pwgMediaRecycled_Keywords,          /* ENUM Keyword names (strings)         */
                                pwgMediaRecycled_KWVAlues,          /* ENUM Keyword (string) values         */
                                pwgMediaRecycled_KWVLevel,          /* ENUM Keyword pjt support level       */
                                pwgMediaRecycled_KWVSupported,      /* ENUM Keywords supported              */

                                PWG_MEDIA_RECYCLED_UNKNOWN,         /* The minimum   data value             */
                                PWG_MEDIA_RECYCLED_END - 1,         /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* media description                                                                                        */
/* ======================================================================================================== */
/* -----------------                                                                                        */
/* Indicates what type of media description is being used.                                                  */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaDescType_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_DESC_TYPE_UNKNOWN",
                "PWG_MEDIA_DESC_TYPE_MEDIA_COLLECTION",
                "PWG_MEDIA_DESC_TYPE_MEDIA_AND_TYPE",

                VND_MEDIA_DES_TYP_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaDescType_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaDescType_KWVAlues[] = {
                "-",
                "-",
                "Unknown",
                "MediaCollection",
                "MediaAndType",

                VND_MEDIA_DES_TYP_KWV

                pwgNULL
};

pwgBIT8 pwgMediaDescType_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "MediaCollection"  */
    PJT_SUPPORT_LEVEL_1,      /* "MediaAndType"     */

    VND_MEDIA_DES_TYP_KWVL

    0
};

pwgBOOL pwgMediaDescType_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

    pwgSUPPORTED,      /* "MediaCollection"  */
    pwgSUPPORTED,      /* "MediaAndType"     */

    VND_MEDIA_DES_TYP_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaDescType = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Media Description Type",           /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_MEDIA_DESC_TYPE_MEDIA_AND_TYPE, /* Default or nominal setting           */
                                PWG_MEDIA_DESC_TYPE_MEDIA_AND_TYPE, /* Setting data value                   */

                                pwgMediaDescType_Keywords,          /* ENUM Keyword names (strings)         */
                                pwgMediaDescType_KWVAlues,          /* ENUM Keyword (string) values         */
                                pwgMediaDescType_KWVLevel,          /* ENUM Keyword pjt support level       */
                                pwgMediaDescType_KWVSupported,      /* ENUM Keywords supported              */

                                PWG_MEDIA_DESC_TYPE_UNKNOWN,        /* The minimum   data value             */
                                PWG_MEDIA_DESC_TYPE_END - 1,        /* The maximum   data value             */
                                1                                   /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Bottom Margin \                                                                                    */
/* Media Left   Margin  \____ Media Margins                                                                 */
/* Media Right  Margin  /                                                                                   */
/* Media Top    Margin /                                                                                    */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 51] MediaBottomMargin              */
/* -----------------                                                                                        */
/* Defines the PrintService's physical bottom margin in hundredths of millimeters from the bottom edge,     */
/* without respect to the value of the "OrientationRequested" element.                                      */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 51] MediaLeftMargin                */
/* -----------------                                                                                        */
/* Defines the PrintService's physical left margin in hundredths of millimeters from the left edge, without */
/* respect to the value of the "OrientationRequested" element.                                              */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaRightMargin               */
/* -----------------                                                                                        */
/* Defines the PrintService's physical right margin in hundredths of millimeters from the right edge,       */
/* without respect to the value of the "OrientationRequested" element.                                      */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaTopMargin                 */
/* -----------------                                                                                        */
/* Defines the PrintService's physical top margin in hundredths of millimeters from the top edge, without   */
/* respect to the value of the "OrientationRequested" element.                                              */
/* ..................................................|..................................................... */
pwgNUM_DEF pwgDef_Dim = {
                                PWG_ELEMENT_TYPE_NUM,               /* Type of parameter definition         */
                                PWG_TYPE_BIT32,                     /* The data type                        */
                                "Dimension",                        /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,  /* Embedded *//* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                1,                                  /* Default or nominal setting           */
                                1                                   /* Setting data value                   */
};

pwgMediaMarginsDefLst pwgMediaMarginsDefElem = {

                &pwgDef_Dim,                /* Media margin, hundredths of a millimeter, along bottom edge  */
                &pwgDef_Dim,                /* Media margin, hundredths of a millimeter, along left   edge  */
                &pwgDef_Dim,                /* Media margin, hundredths of a millimeter, along left   edge  */
                &pwgDef_Dim,                /* Media margin, hundredths of a millimeter, along left   edge  */

                VND_MEDIA_MRGN_ELEM_DATA

                (pwgVOID*)pwgNULL
};

pwgSTRUCT_DEF pwgDef_MediaMargins = {
                                PWG_ELEMENT_TYPE_STRUCT,            /* Type of parameter definition         */
                                PWG_TYPE_STRUCT,                    /* The data type                        */
                                "Media Margins",                    /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                0,
                                0,
                                (pwgVOID**)&pwgMediaMarginsDefElem
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Size                                                                                                */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.4: [page 20] MediaCol and MediaSize Elements                                                   */
/* -----------------                                                                                        */
/* MediaCol allows a finer granularity specification of media than is possible with the Media and MediaType */
/* elements.  Figure  8  shows the MediaCol constituent elements and the constituent elements of MediaSize  */
/* and Margins.                                                                                             */
/* ..................................................|..................................................... */
pwgMediaSizeDefLst pwgMediaSizeDefElem = {

                &pwgDef_Dim,               /* Media size, in hundredths of a millimeter, along bottom edge */
                &pwgDef_Dim,               /* Media size, in hundredths of a millimeter, along left   edge */

                VND_MEDIA_SIZ_ELEM_DATA

                (pwgVOID*)pwgNULL
};

pwgSTRUCT_DEF pwgDef_MediaSize = {
                                PWG_ELEMENT_TYPE_STRUCT,            /* Type of parameter definition         */
                                PWG_TYPE_STRUCT,                    /* The data type                        */
                                "Media Size",                       /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,    /* Office *//* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                0,
                                0,
                                (pwgVOID**)&pwgMediaSizeDefElem
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Size Name                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] Media Size Name                */
/* -----------------                                                                                        */
/* Explicitly specifies the numerical media width and height dimensions in hundredth of a millimeter.       */
/* ..................................................|..................................................... */
typedef struct __pwgMsnPieces{
      pwgCHAR* top[ 10];
      pwgCHAR*  NA[100];
      pwgCHAR* ROC[100];
      pwgCHAR* ISO[100];
      pwgCHAR* JIS[100];
      pwgCHAR*  OM[100];
      pwgCHAR* VND[100];
} pwgMsnP;

#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaSizeName_Keywords[] = {
                /* Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top      */
                  "-",
                  "-",
                  "PWG_MEDIA_SIZE_NAME_UNKNOWN",
                                             "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* North American Standard Sheet Media Sizes      North American Standard Sheet Media Sizes */
                  "PWG_MEDIA_SIZE_NAME_NA_INDEX_3X5_3X5IN",         /*  = 100,                              */
                  "PWG_MEDIA_SIZE_NAME_NA_PERSONAL_3o625X6o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_MONARCH_3o875X7o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_NUMBER_9_3o875X8o875IN",
                  "PWG_MEDIA_SIZE_NAME_NA_INDEX_4X6_4X6IN",
                  "PWG_MEDIA_SIZE_NAME_NA_NUMBER_10_4o125X9o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_A2_4o375X5o75IN",
                  "PWG_MEDIA_SIZE_NAME_NA_NUMBER_11_4o5X10o375IN",
                  "PWG_MEDIA_SIZE_NAME_NA_NUMBER_12_4o75X11IN",
                  "PWG_MEDIA_SIZE_NAME_NA_5X7_5X7IN",

                  "PWG_MEDIA_SIZE_NAME_NA_INDEX_5X8_5X8IN",
                  "PWG_MEDIA_SIZE_NAME_NA_NUMBER_14_5X11o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_INVOICE_5o5X8o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_INDEX_4X6_EXT_6X8IN",
                  "PWG_MEDIA_SIZE_NAME_NA_6X9_6X9IN",
                  "PWG_MEDIA_SIZE_NAME_NA_C5_6o5X9o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_7X9_7X9IN",
                  "PWG_MEDIA_SIZE_NAME_NA_EXECUTIVE_7o25X10o5IN",
                  "PWG_MEDIA_SIZE_NAME_NA_GOVT_LETTER_8X10IN",
                  "PWG_MEDIA_SIZE_NAME_NA_GOVT_LEGAL_8X13IN",

                  "PWG_MEDIA_SIZE_NAME_NA_QUARTO_8o5X10o83IN",
                  "PWG_MEDIA_SIZE_NAME_NA_LETTER_8o5X11IN",
                  "PWG_MEDIA_SIZE_NAME_NA_FANFOLD_EUR_8o5X12IN",
                  "PWG_MEDIA_SIZE_NAME_NA_LETTER_PLUS_8o5X12o69IN",
                  "PWG_MEDIA_SIZE_NAME_NA_FOOLSCAP_8o5X13IN",
                  "PWG_MEDIA_SIZE_NAME_NA_LEGAL_8o5X14IN",
                  "PWG_MEDIA_SIZE_NAME_NA_SUPER_A_8o94X14IN",
                  "PWG_MEDIA_SIZE_NAME_NA_9X11_9X11IN",
                  "PWG_MEDIA_SIZE_NAME_NA_ARCH_A_9X12IN",
                  "PWG_MEDIA_SIZE_NAME_NA_LETTER_EXTRA_9o5X12IN",

                  "PWG_MEDIA_SIZE_NAME_NA_LEGAL_EXTRA_9o5X15IN",
                  "PWG_MEDIA_SIZE_NAME_NA_10X11_10X11IN",
                  "PWG_MEDIA_SIZE_NAME_NA_10X13_10X13IN",
                  "PWG_MEDIA_SIZE_NAME_NA_10X14_10X14IN",
                  "PWG_MEDIA_SIZE_NAME_NA_10X15_10X15IN",
                  "PWG_MEDIA_SIZE_NAME_NA_11X12_11X12IN",
                  "PWG_MEDIA_SIZE_NAME_NA_EDP_11X14IN",
                  "PWG_MEDIA_SIZE_NAME_NA_FANFOLD_US_11X14o875IN",
                  "PWG_MEDIA_SIZE_NAME_NA_11X15_11X15IN",
                  "PWG_MEDIA_SIZE_NAME_NA_LEDGER_11X17IN",

                  "PWG_MEDIA_SIZE_NAME_NA_EUR_EDP_12X14IN",
                  "PWG_MEDIA_SIZE_NAME_NA_ARCH_B_12X18IN",
                  "PWG_MEDIA_SIZE_NAME_NA_12X19_12X19IN",
                  "PWG_MEDIA_SIZE_NAME_NA_B_PLUS_12X19o17IN",
                  "PWG_MEDIA_SIZE_NAME_NA_SUPER_B_13X19IN",
                  "PWG_MEDIA_SIZE_NAME_NA_C_17X22IN",
                  "PWG_MEDIA_SIZE_NAME_NA_ARCH_C_18X24IN",
                  "PWG_MEDIA_SIZE_NAME_NA_D_22X34IN",
                  "PWG_MEDIA_SIZE_NAME_NA_ARCH_D_24X36IN",
                  "PWG_MEDIA_SIZE_NAME_ASME_F_28X40IN",

                  "PWG_MEDIA_SIZE_NAME_NA_WIDE_FORMAT_30X42IN",
                  "PWG_MEDIA_SIZE_NAME_NA_E_34X44IN",
                  "PWG_MEDIA_SIZE_NAME_NA_ARCH_E_36X48IN",
                  "PWG_MEDIA_SIZE_NAME_NA_F_44X68IN",
                                                      "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* Chinese Standard Sheet Media Inch Sizes        Chinese Standard Sheet Media Inch Sizes   */
                  "PWG_MEDIA_SIZE_NAME_ROC_16K_7o75X10o75IN",   /*  = 200,                                  */
                  "PWG_MEDIA_SIZE_NAME_ROC_8K_10o75X15o5IN",
                  "PWG_MEDIA_SIZE_NAME_PRC_32K_97X151MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_1_102X165MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_2_102X176MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_4_110X208MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_5_110X220MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_8_120X309MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_6_120X320MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_3_125X176MM",

                  "PWG_MEDIA_SIZE_NAME_PRC_16K_146X215MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_7_160X230MM",
                  "PWG_MEDIA_SIZE_NAME_OM_JUURO_KU_KAI_198X275MM",
                  "PWG_MEDIA_SIZE_NAME_OM_PA_KAI_267X389MM",
                  "PWG_MEDIA_SIZE_NAME_OM_DAI_PA_KAI_275X395MM",
                  "PWG_MEDIA_SIZE_NAME_PRC_10_324X458MM",
                                                                        "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* ISO Standard Sheet Media Sizes                          ISO Standard Sheet Media Sizes   */
                  "PWG_MEDIA_SIZE_NAME_ISO_A10_26X37MM",        /*  = 300,                                  */
                  "PWG_MEDIA_SIZE_NAME_ISO_A9_37X52MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A8_52X74MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A7_74X105MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A6_105X148MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A5_148X210MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A5_EXTRA_174X235MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4_210X297MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4_TAB_225X297MM",

                  "PWG_MEDIA_SIZE_NAME_ISO_A4_EXTRA_235o5X322o3MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3_297X420MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X3_297X630MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X4_297X841MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X5_297X1051MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X6_297X1261MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X7_297X1471MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X8_297X1682MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A4X9_297X1892MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3_EXTRA_322X445MM",

                  "PWG_MEDIA_SIZE_NAME_ISO_A2_420X594MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3X3_420X891MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3X4_420X1189MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3X5_420X1486MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3X6_420X1783MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A3X7_420X2080MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A1_594X841MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A2X3_594X1261MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A2X4_594X1682MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A2X5_594X2102MM",

                  "PWG_MEDIA_SIZE_NAME_ISO_A0_841X1189MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A1X3_841X1783MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A1X4_841X2378MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_2A0_1189X1682MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_A0X3_1189X2523MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B10_31X44MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B9_44X62MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B8_62X88MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B7_88X125MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B6_125X176MM,"

                  "PWG_MEDIA_SIZE_NAME_ISO_B6C4_125X324MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B5_176X250MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B5_EXTRA_201X276MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B4_250X353MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B3_353X500MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B2_500X707MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B1_707X1000MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_B0_1000X1414MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C10_28X40MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C9_40X57MM",

                  "PWG_MEDIA_SIZE_NAME_ISO_C8_57X81MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C7_81X114MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C7C6_81X162MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C6_114X162MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C6C5_114X229MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C5_162X229MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C4_229X324MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C3_324X458MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C2_458X648MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_C1_648X917MM",

                  "PWG_MEDIA_SIZE_NAME_ISO_C0_917X1297MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_DL_110X220MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_RA2_430X610MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_SRA2_450X640MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_RA1_610X860MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_SRA1_640X900MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_RA0_860X1220MM",
                  "PWG_MEDIA_SIZE_NAME_ISO_SRA0_900X1280MM",
                                                                                          "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* Japanese Standard Sheet Media Sizes              Japanese Standard Sheet Media Sizes     */
                  "PWG_MEDIA_SIZE_NAME_JIS_B10_32X45MM",        /*  = 400,                                  */
                  "PWG_MEDIA_SIZE_NAME_JIS_B9_45X64MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B8_64X91MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B7_91X128MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B6_128X182MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B5_182X257MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B4_257X364MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B3_364X515MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B2_515X728MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_B1_728X1030MM",

                  "PWG_MEDIA_SIZE_NAME_JIS_B0_1030X1456MM",
                  "PWG_MEDIA_SIZE_NAME_JIS_EXEC_216X330MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_CHOU4_90X205MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_HAGAKI_100X148MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_YOU4_105X235MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_CHOU2_111o1X146MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_CHOU3_120X235MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_OUFUKU_148X200MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_KAHU_240X322o1MM",
                  "PWG_MEDIA_SIZE_NAME_JPN_KAKU2_240X332MM",

                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* Other Metric Standard Sheet Media Sizes        Other Metric Standard Sheet Media Sizes   */
                  "PWG_MEDIA_SIZE_NAME_OM_SMALL_PHOTO_100X150MM", /*  = 500,                                */
                  "PWG_MEDIA_SIZE_NAME_OM_ITALIAN_110X230MM",
                  "PWG_MEDIA_SIZE_NAME_OM_POSTFIX_114X229MM",
                  "PWG_MEDIA_SIZE_NAME_OM_LARGE_PHOTO_200X300MM",
                  "PWG_MEDIA_SIZE_NAME_OM_FOLIO_210X330MM",
                  "PWG_MEDIA_SIZE_NAME_OM_FOLIO_SP_215X315MM",
                  "PWG_MEDIA_SIZE_NAME_OM_INVITE_220X220MM",
                                                                                 "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                  "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",

                /* Vendor Extensions for Sheet Media Sizes     Vendor Extensions for Sheet Media Size       */

                /* "PWG_MEDIA_SIZE_NAME_VENDOR_MSN_START              = 600,                                */

                  VND_MEDIA_SIZ_NAM_KW

                };

union { pwgCHAR** pwgMediaSizeName_Keywords; pwgMsnP pwgMsnKeywordParts; } pwgMsnKWAll;

#else
pwgCHAR* pwgMediaSizeName_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaSizeName_KWValues[] = {
                /* Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top  Top      */
                  "-",
                  "-",
                  "Unknown",
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* North American Standard Sheet Media Sizes      North American Standard Sheet Media Sizes */
                  "na_index-3x5_3x5in",
                  "na_personal_3.625x6.5in",
                  "na_monarch_3.875x7.5in",
                  "na_number-9_3.875x8.875in",
                  "na_index-4x6_4x6in",
                  "na_number-10_4.125x9.5in",
                  "na_a2_4.375x5.75in",
                  "na_number-11_4.5x10.375in",
                  "na_number-12_4.75x11in",
                  "na_5x7_5x7in",
                  "na_index-5x8_5x8in",
                  "na_number-14_5x11.5in",
                  "na_invoice_5.5x8.5in",
                  "na_index-4x6-ext_6x8in",
                  "na_6x9_6x9in",
                  "na_c5_6.5x9.5in",
                  "na_7x9_7x9in",
                  "na_executive_7.25x10.5in",
                  "na_govt-letter_8x10in",
                  "na_govt-legal_8x13in",
                  "na_quarto_8.5x10.83in",
                  "na_letter_8.5x11in",
                  "na_fanfold-eur_8.5x12in",
                  "na_letter-plus_8.5x12.69in",
                  "na_foolscap_8.5x13in",
                  "na_legal_8.5x14in",
                  "na_super-a_8.94x14in",
                  "na_9x11_9x11in",
                  "na_arch-a_9x12in",
                  "na_letter-extra_9.5x12in",
                  "na_legal-extra_9.5x15in",
                  "na_10x11_10x11in",
                  "na_10x13_10x13in",
                  "na_10x14_10x14in",
                  "na_10x15_10x15in",
                  "na_11x12_11x12in",
                  "na_edp_11x14in",
                  "na_fanfold-us_11x14.875in",
                  "na_11x15_11x15in",
                  "na_ledger_11x17in",
                  "na_eur-edp_12x14in",
                  "na_arch-b_12x18in",
                  "na_12x19_12x19in",
                  "na_b-plus_12x19.17in",
                  "na_super-b_13x19in",
                  "na_c_17x22in",
                  "na_arch-c_18x24in",
                  "na_d_22x34in",
                  "na_arch-d_24x36in",
                  "asme_f_28x40in",
                  "na_wide-format_30x42in",
                  "na_e_34x44in",
                  "na_arch-e_36x48in",
                  "na_f_44x68in",
                                                      pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* Chinese Standard Sheet Media Inch Sizes        Chinese Standard Sheet Media Inch Sizes   */
                  "roc_16k_7.75x10.75in",
                  "roc_8k_10.75x15.5in",
                  "prc_32k_97x151mm",
                  "prc_1_102x165mm",
                  "prc_2_102x176mm",
                  "prc_4_110x208mm",
                  "prc_5_110x220mm",
                  "prc_8_120x309mm",
                  "prc_6_120x320mm",
                  "prc_3_125x176mm",
                  "prc_16k_146x215mm",
                  "prc_7_160x230mm",
                  "om_juuro-ku-kai_198x275mm",
                  "om_pa-kai_267x389mm",
                  "om_dai-pa-kai_275x395mm",
                  "prc_10_324x458mm",
                                                                        pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* ISO Standard Sheet Media Sizes                          ISO Standard Sheet Media Sizes   */
                  "iso_a10_26x37mm",
                  "iso_a9_37x52mm",
                  "iso_a8_52x74mm",
                  "iso_a7_74x105mm",
                  "iso_a6_105x148mm",
                  "iso_a5_148x210mm",
                  "iso_a5-extra_174x235mm",
                  "iso_a4_210x297mm",
                  "iso_a4-tab_225x297mm",
                  "iso_a4-extra_235.5x322.3mm",
                  "iso_a3_297x420mm",
                  "iso_a4x3_297x630mm",
                  "iso_a4x4_297x841mm",
                  "iso_a4x5_297x1051mm",
                  "iso_a4x6_297x1261mm",
                  "iso_a4x7_297x1471mm",
                  "iso_a4x8_297x1682mm",
                  "iso_a4x9_297x1892mm",
                  "iso_a3-extra_322x445mm",
                  "iso_a2_420x594mm",
                  "iso_a3x3_420x891mm",
                  "iso_a3x4_420x1189mm",
                  "iso_a3x5_420x1486mm",
                  "iso_a3x6_420x1783mm",
                  "iso_a3x7_420x2080mm",
                  "iso_a1_594x841mm",
                  "iso_a2x3_594x1261mm",
                  "iso_a2x4_594x1682mm",
                  "iso_a2x5_594x2102mm",
                  "iso_a0_841x1189mm",
                  "iso_a1x3_841x1783mm",
                  "iso_a1x4_841x2378mm",
                  "iso_2a0_1189x1682mm",
                  "iso_a0x3_1189x2523mm",
                  "iso_b10_31x44mm",
                  "iso_b9_44x62mm",
                  "iso_b8_62x88mm",
                  "iso_b7_88x125mm",
                  "iso_b6_125x176mm",
                  "iso_b6c4_125x324mm",
                  "iso_b5_176x250mm",
                  "iso_b5-extra_201x276mm",
                  "iso_b4_250x353mm",
                  "iso_b3_353x500mm",
                  "iso_b2_500x707mm",
                  "iso_b1_707x1000mm",
                  "iso_b0_1000x1414mm",
                  "iso_c10_28x40mm",
                  "iso_c9_40x57mm",
                  "iso_c8_57x81mm",
                  "iso_c7_81x114mm",
                  "iso_c7c6_81x162mm",
                  "iso_c6_114x162mm",
                  "iso_c6c5_114x229mm",
                  "iso_c5_162x229mm",
                  "iso_c4_229x324mm",
                  "iso_c3_324x458mm",
                  "iso_c2_458x648mm",
                  "iso_c1_648x917mm",
                  "iso_c0_917x1297mm",
                  "iso_dl_110x220mm",
                  "iso_ra2_430x610mm",
                  "iso_sra2_450x640mm",
                  "iso_ra1_610x860mm",
                  "iso_sra1_640x900mm",
                  "iso_ra0_860x1220mm",
                  "iso_sra0_900x1280mm",
                                                                                          pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* Japanese Standard Sheet Media Sizes              Japanese Standard Sheet Media Sizes     */
                  "jis_b10_32x45mm",
                  "jis_b9_45x64mm",
                  "jis_b8_64x91mm",
                  "jis_b7_91x128mm",
                  "jis_b6_128x182mm",
                  "jis_b5_182x257mm",
                  "jis_b4_257x364mm",
                  "jis_b3_364x515mm",
                  "jis_b2_515x728mm",
                  "jis_b1_728x1030mm",
                  "jis_b0_1030x1456mm",
                  "jis_exec_216x330mm",
                  "jpn_chou4_90x205mm",
                  "jpn_hagaki_100x148mm",
                  "jpn_you4_105x235mm",
                  "jpn_chou2_111.1x146mm",
                  "jpn_chou3_120x235mm",
                  "jpn_oufuku_148x200mm",
                  "jpn_kahu_240x322.1mm",
                  "jpn_kaku2_240x332mm",
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* Other Metric Standard Sheet Media Sizes        Other Metric Standard Sheet Media Sizes   */
                  "om_small-photo_100x150mm",
                  "om_italian_110x230mm",
                  "om_postfix_114x229mm",
                  "om_large-photo_200x300",
                  "om_folio_210x330mm",
                  "om_folio-sp_215x315mm",
                  "om_invite_220x220mm",
                                                                                 pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,
                  pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

                /* Vendor Extensions for Sheet Media Sizes     Vendor Extensions for Sheet Media Size       */

                /* "PWG_MEDIA_SIZE_NAME_VENDOR_MSN_START              = 600,                                */

                  VND_MEDIA_SIZ_NAM_KWV

              };
union { pwgCHAR* pwgMediaSizeName_KWValues[710]; pwgMsnP pwgMsnKWValuesParts; } pwgMsnKWVAll;

pwgBIT8 pwgMediaSizeName_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /*  30 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /*  60 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /*  90 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 120 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 150 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 180 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 210 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 240 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 270 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 300 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 330 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 360 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 390 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 420 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 450 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 480 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 510 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 540 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 570 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,  /* 600 */

    VND_MEDIA_SIZ_NAM_KWVL

    0
};

pwgBOOL pwgMediaSizeName_KWVSupported[] = {
    pwgNOT_SUPPORTED,   /* "-"                */
    pwgNOT_SUPPORTED,   /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /*  30 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /*  60 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /*  90 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 120 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 150 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 180 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 210 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 240 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 270 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 300 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 330 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 360 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 390 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 420 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 450 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 480 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 510 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 540 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 570 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,  /* 600 */

    VND_MEDIA_SIZ_NAM_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaSizeName = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_ENUM,                            /* The data type                        */
                          "Media Size Name",                        /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1, /*Embedded*/         /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_MEDIA_SIZE_NAME_NA_LETTER_8o5X11IN,   /* Default or nominal setting           */
                          PWG_MEDIA_SIZE_NAME_NA_LETTER_8o5X11IN,   /* Setting data value                   */

                          pwgMediaSizeName_Keywords,                /* ENUM Keyword names (strings)         */
                          pwgMediaSizeName_KWValues,                /* ENUM Keyword (string) values         */
                          pwgMediaSizeName_KWVLevel,                /* ENUM Keyword pjt support level       */
                          pwgMediaSizeName_KWVSupported,            /* ENUM Keywords supported              */

                          PWG_MEDIA_SIZE_NAME_UNKNOWN,              /* The minimum   data value             */
                          PWG_MEDIA_SIZE_NAME_END - 1,              /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Source                                                                                             */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaSource                    */
/* -----------------                                                                                        */
/* Specifies the input tray, slot, roll, or other source for the media.                                     */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaSource_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_SOURCE_UNKNOWN",

                "PWG_MEDIA_SOURCE_ALTERNATE",
                "PWG_MEDIA_SOURCE_ALTERNATE_ROLL",
                "PWG_MEDIA_SOURCE_AUTO",
                "PWG_MEDIA_SOURCE_BOTTOM",
                "PWG_MEDIA_SOURCE_BY_PASS_TRAY",
                "PWG_MEDIA_SOURCE_CENTER",
                "PWG_MEDIA_SOURCE_DISC",
                "PWG_MEDIA_SOURCE_ENVELOPE",
                "PWG_MEDIA_SOURCE_HAGAKI",
                "PWG_MEDIA_SOURCE_LARGE_CAPACITY",
                "PWG_MEDIA_SOURCE_LEFT",
                "PWG_MEDIA_SOURCE_MAIN",
                "PWG_MEDIA_SOURCE_MAIN_ROLL",
                "PWG_MEDIA_SOURCE_MANUAL",
                "PWG_MEDIA_SOURCE_MIDDLE",
                "PWG_MEDIA_SOURCE_PHOTO",
                "PWG_MEDIA_SOURCE_REAR",
                "PWG_MEDIA_SOURCE_RIGHT",
                "PWG_MEDIA_SOURCE_ROLL_1",
                "PWG_MEDIA_SOURCE_ROLL_2",
                "PWG_MEDIA_SOURCE_ROLL_3",
                "PWG_MEDIA_SOURCE_ROLL_4",
                "PWG_MEDIA_SOURCE_ROLL_5",
                "PWG_MEDIA_SOURCE_ROLL_6",
                "PWG_MEDIA_SOURCE_ROLL_7",
                "PWG_MEDIA_SOURCE_ROLL_8",
                "PWG_MEDIA_SOURCE_ROLL_9",
                "PWG_MEDIA_SOURCE_ROLL_10",
                "PWG_MEDIA_SOURCE_SIDE",
                "PWG_MEDIA_SOURCE_TOP",
                "PWG_MEDIA_SOURCE_TRAY_1",
                "PWG_MEDIA_SOURCE_TRAY_2",
                "PWG_MEDIA_SOURCE_TRAY_3",
                "PWG_MEDIA_SOURCE_TRAY_4",
                "PWG_MEDIA_SOURCE_TRAY_5",
                "PWG_MEDIA_SOURCE_TRAY_6",
                "PWG_MEDIA_SOURCE_TRAY_7",
                "PWG_MEDIA_SOURCE_TRAY_8",
                "PWG_MEDIA_SOURCE_TRAY_9",
                "PWG_MEDIA_SOURCE_TRAY_10",
                "PWG_MEDIA_SOURCE_TRAY_11",
                "PWG_MEDIA_SOURCE_TRAY_12",
                "PWG_MEDIA_SOURCE_TRAY_13",
                "PWG_MEDIA_SOURCE_TRAY_14",
                "PWG_MEDIA_SOURCE_TRAY_15",
                "PWG_MEDIA_SOURCE_TRAY_16",
                "PWG_MEDIA_SOURCE_TRAY_17",
                "PWG_MEDIA_SOURCE_TRAY_18",
                "PWG_MEDIA_SOURCE_TRAY_19",
                "PWG_MEDIA_SOURCE_TRAY_20",

                VND_MEDIA_SRC_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaSource_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaSource_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "Alternate",
                "AlternateRoll",
                "Auto",
                "Bottom",
                "ByPassTray",
                "Center",
                "Disc",
                "Envelope",
                "Hagaki",
                "LargeCapacity",

                "Left",
                "Main",
                "MainRoll",
                "Manual",
                "Middle",
                "Photo",
                "Rear",
                "Right",
                "Roll1",
                "Roll2",

                "Roll3",
                "Roll4",
                "Roll5",
                "Roll6",
                "Roll7",
                "Roll8",
                "Roll9",
                "Roll10",
                "Side",
                "Top",

                "Tray1",
                "Tray2",
                "Tray3",
                "Tray4",
                "Tray5",
                "Tray6",
                "Tray7",
                "Tray8",
                "Tray9",
                "Tray10",

                "Tray11",
                "Tray12",
                "Tray13",
                "Tray14",
                "Tray15",
                "Tray16",
                "Tray17",
                "Tray18",
                "Tray19",
                "Tray20",

                VND_MEDIA_SRC_KWV

                pwgNULL
};

pwgBIT8 pwgMediaSource_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,

    VND_MEDIA_SRC_KWVL

    0
};

pwgBOOL pwgMediaSource_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,

    VND_MEDIA_SRC_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaSource = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_ENUM,                            /* The data type                        */
                          "Media Source",                           /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1, /*Embedded*/         /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_MEDIA_SOURCE_AUTO,                    /* Default or nominal setting           */
                          PWG_MEDIA_SOURCE_AUTO,                    /* Setting data value                   */

                          pwgMediaSource_Keywords,                  /* ENUM Keyword names (strings)         */
                          pwgMediaSource_KWVAlues,                  /* ENUM Keyword (string) values         */
                          pwgMediaSource_KWVLevel,                  /* ENUM Keyword pjt support level       */
                          pwgMediaSource_KWVSupported,              /* ENUM Keywords supported              */

                          PWG_MEDIA_SOURCE_UNKNOWN,                 /* The minimum   data value             */
                          PWG_MEDIA_SOURCE_END - 1,                 /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Input Tray Check                                                                                   */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaInputTrayCheck            */
/* -----------------                                                                                        */
/* Indicates that the characteristics of the media in the identified input tray must match the              */
/* characteristics of the media identified by the "media" or "media-col"  element.                          */
/* ..................................................|..................................................... */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: MediaInputTray for the PJT is called MediaSource; thus, MediaInputTrayCheck (which        */
/*                should really be MediaSourceCheck) has the values as MediaSource.  However, to prevent    */
/*                confusion with "Source" and "SourceCheck" the values will be repeated.                    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaInputTrayCheck_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_INPUT_TRAY_CHECK_UNKNOWN",

                "PWG_MEDIA_INPUT_TRAY_CHECK_ALTERNATE",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ALTERNATE_ROLL",
                "PWG_MEDIA_INPUT_TRAY_CHECK_AUTO",
                "PWG_MEDIA_INPUT_TRAY_CHECK_BOTTOM",
                "PWG_MEDIA_INPUT_TRAY_CHECK_BY_PASS_TRAY",
                "PWG_MEDIA_INPUT_TRAY_CHECK_CENTER",
                "PWG_MEDIA_INPUT_TRAY_CHECK_DISC",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ENVELOPE",
                "PWG_MEDIA_INPUT_TRAY_CHECK_HAGAKI",
                "PWG_MEDIA_INPUT_TRAY_CHECK_LARGE_CAPACITY",
                "PWG_MEDIA_INPUT_TRAY_CHECK_LEFT",
                "PWG_MEDIA_INPUT_TRAY_CHECK_MAIN",
                "PWG_MEDIA_INPUT_TRAY_CHECK_MAIN_ROLL",
                "PWG_MEDIA_INPUT_TRAY_CHECK_MANUAL",
                "PWG_MEDIA_INPUT_TRAY_CHECK_MIDDLE",
                "PWG_MEDIA_INPUT_TRAY_CHECK_PHOTO",
                "PWG_MEDIA_INPUT_TRAY_CHECK_REAR",
                "PWG_MEDIA_INPUT_TRAY_CHECK_RIGHT",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_1",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_2",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_3",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_4",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_5",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_6",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_7",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_8",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_9",
                "PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_10",
                "PWG_MEDIA_INPUT_TRAY_CHECK_SIDE",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TOP",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_1",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_2",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_3",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_4",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_5",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_6",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_7",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_8",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_9",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_10",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_11",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_12",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_13",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_14",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_15",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_16",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_17",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_18",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_19",
                "PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_20",

                VND_MEDIA_INP_TRAY_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaInputTrayCheck_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaInputTrayCheck_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "Alternate",
                "AlternateRoll",
                "Auto",
                "Bottom",
                "ByPassTray",
                "Center",
                "Disc",
                "Envelope",
                "Hagaki",
                "LargeCapacity",

                "Left",
                "Main",
                "MainRoll",
                "Manual",
                "Middle",
                "Photo",
                "Rear",
                "Right",
                "Roll1",
                "Roll2",

                "Roll3",
                "Roll4",
                "Roll5",
                "Roll6",
                "Roll7",
                "Roll8",
                "Roll9",
                "Roll10",
                "Side",
                "Top",

                "Tray1",
                "Tray2",
                "Tray3",
                "Tray4",
                "Tray5",
                "Tray6",
                "Tray7",
                "Tray8",
                "Tray9",
                "Tray10",

                "Tray11",
                "Tray12",
                "Tray13",
                "Tray14",
                "Tray15",
                "Tray16",
                "Tray17",
                "Tray18",
                "Tray19",
                "Tray20",

                VND_MEDIA_INP_TRAY_KWV

                pwgNULL
};

pwgBIT8 pwgMediaInputTrayCheck_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,

    VND_MEDIA_INP_TRAY_KWVL

    0
};

pwgBOOL pwgMediaInputTrayCheck_KWVSupported[] = {
    pwgNOT_SUPPORTED, /* "-"                */
    pwgNOT_SUPPORTED, /* "_"                */
    pwgSUPPORTED,     /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,

    VND_MEDIA_INP_TRAY_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaInputTrayCheck = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_ENUM,                            /* The data type                        */
                          "Media Input Tray Check",                 /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1,                      /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_MEDIA_INPUT_TRAY_CHECK_AUTO,          /* Default or nominal setting           */
                          PWG_MEDIA_INPUT_TRAY_CHECK_AUTO,          /* Setting data value                   */

                          pwgMediaInputTrayCheck_Keywords,          /* ENUM Keyword names (strings)         */
                          pwgMediaInputTrayCheck_KWVAlues,          /* ENUM Keyword (string) values         */
                          pwgMediaInputTrayCheck_KWVLevel,          /* ENUM Keyword pjt support level       */
                          pwgMediaInputTrayCheck_KWVSupported,      /* ENUM Keywords supported              */

                          PWG_MEDIA_INPUT_TRAY_CHECK_UNKNOWN,       /* The minimum   data value             */
                          PWG_MEDIA_INPUT_TRAY_CHECK_END - 1,       /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Tooth                                                                                              */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaTooth                     */
/* -----------------                                                                                        */
/* The tooth (or roughness) of the media.                                                                   */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaTooth_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_TOOTH_UNKNOWN",

                "PWG_MEDIA_TOOTH_ANTIQUE",
                "PWG_MEDIA_TOOTH_CALENDARED",
                "PWG_MEDIA_TOOTH_COARSE",
                "PWG_MEDIA_TOOTH_FINE",
                "PWG_MEDIA_TOOTH_LINEN",
                "PWG_MEDIA_TOOTH_MEDIUM",
                "PWG_MEDIA_TOOTH_SMOOTH",
                "PWG_MEDIA_TOOTH_STIPPLE",
                "PWG_MEDIA_TOOTH_UNCALENDARED",
                "PWG_MEDIA_TOOTH_VELLUM",

                VND_MEDIA_TTH_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaTooth_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaTooth_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "Antique",
                "Calendared",
                "Coarse",
                "Fine",
                "Linen",
                "Medium",
                "Smooth",
                "Stipple",
                "Uncalendared",
                "Vellum",

                VND_MEDIA_TTH_KWV

                pwgNULL
};

pwgBIT8 pwgMediaTooth_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    1,1,1,1,1,1,1,1,1,1,

    VND_MEDIA_TTH_KWVL

    0
};

pwgBOOL pwgMediaTooth_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,

    VND_MEDIA_TTH_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaTooth = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_ENUM,                            /* The data type                        */
                          "Media Tooth",                            /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1,                      /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_MEDIA_TOOTH_UNKNOWN,                  /* Default or nominal setting           */
                          PWG_MEDIA_TOOTH_UNKNOWN,                  /* Setting data value                   */

                          pwgMediaTooth_Keywords,                   /* ENUM Keyword names (strings)         */
                          pwgMediaTooth_KWVAlues,                   /* ENUM Keyword (string) values         */
                          pwgMediaTooth_KWVLevel,                   /* ENUM Keyword pjt support level       */
                          pwgMediaTooth_KWVSupported,               /* ENUM Keywords supported              */

                          PWG_MEDIA_TOOTH_UNKNOWN,                  /* The minimum   data value             */
                          PWG_MEDIA_TOOTH_END - 1,                  /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Type                                                                                               */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 55] MediaType                      */
/* -----------------                                                                                        */
/* The medium type that the PrintService uses for all impressions.                                          */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgMediaType_Keywords[] = {
                "-",
                "-",
                "PWG_MEDIA_TYPE_UNKNOWN",

                "PWG_MEDIA_TYPE_STATIONERY",
                "PWG_MEDIA_TYPE_STATIONERY_COATED",
                "PWG_MEDIA_TYPE_STATIONERY_INKJET",
                "PWG_MEDIA_TYPE_STATIONERY_PREPRINTED",
                "PWG_MEDIA_TYPE_STATIONERY_LETTERHEAD",
                "PWG_MEDIA_TYPE_STATIONERY_PREPUNCHED",
                "PWG_MEDIA_TYPE_STATIONERY_FINE",
                "PWG_MEDIA_TYPE_STATIONERY_HEAVYWEIGHT",
                "PWG_MEDIA_TYPE_STATIONERY_LIGHTWEIGHT",
                "PWG_MEDIA_TYPE_TRANSPARENCY",
                "PWG_MEDIA_TYPE_ENVELOPE",
                "PWG_MEDIA_TYPE_ENVELOPE_PLAIN",
                "PWG_MEDIA_TYPE_ENVELOPE_WINDOW",
                "PWG_MEDIA_TYPE_CONTINUOUS",
                "PWG_MEDIA_TYPE_CONTINUOUS_LONG",
                "PWG_MEDIA_TYPE_CONTINUOUS_SHORT",
                "PWG_MEDIA_TYPE_TAB_STOCK",
                "PWG_MEDIA_TYPE_PRE_CUT_TABS",
                "PWG_MEDIA_TYPE_FULL_CUT_TABS",
                "PWG_MEDIA_TYPE_MULTI_PART_FORM",
                "PWG_MEDIA_TYPE_LABELS",
                "PWG_MEDIA_TYPE_MULTI_LAYER",
                "PWG_MEDIA_TYPE_SCREEN",
                "PWG_MEDIA_TYPE_SCREEN_PAGED",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_GLOSSY",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_HIGH_GLOSS",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_SEMI_GLOSS",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_SATIN",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_MATTE",
                "PWG_MEDIA_TYPE_PHOTOGRAPHIC_FILM",
                "PWG_MEDIA_TYPE_BACK_PRINT_FILM",
                "PWG_MEDIA_TYPE_CARDSTOCK",
                "PWG_MEDIA_TYPE_ROLL",

                VND_MEDIA_TYP_KW

                pwgNULL
};
#else
pwgCHAR* pwgMediaType_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgMediaType_KWVAlues[] = {
                "-",
                "-",
                "Unknown",

                "Stationery",
                "StationeryCoated",
                "StationeryInkjet",
                "StationeryPreprinted",
                "StationeryLetterhead",
                "StationeryPrepunched",
                "StationeryFine",
                "StationeryHeavyweight",
                "StationeryLightweight",
                "Transparency",

                "Envelope",
                "EnvelopePlain",
                "EnvelopeWindow",
                "Continuous",
                "ContinuousLong",
                "ContinuousShort",
                "TabStock",
                "PreCutTabs",
                "FullCutTabs",
                "MultiPartForm",

                "Labels",
                "MultiLayer",
                "Screen",
                "ScreenPaged",
                "Photographic",
                "PhotographicGlossy",
                "PhotographicHighGloss",
                "PhotographicSemiGloss",
                "PhotographicSatin",
                "PhotographicMatte",

                "PhotographicFilm",
                "BackPrintFilm",
                "Cardstock",
                "Roll",

                VND_MEDIA_TYP_KWV

                pwgNULL
};

pwgBIT8 pwgMediaType_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,

    VND_MEDIA_TYP_KWVL

    0
};

pwgBOOL pwgMediaType_KWVSupported[] = {
    pwgNOT_SUPPORTED,  /* "-"                */
    pwgNOT_SUPPORTED,  /* "_"                */
    pwgSUPPORTED,      /* "Unknown"          */

 /*                   1                   2                   3 */
 /* 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 */
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,
    pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,pwgSUPPORTED,

    VND_MEDIA_TYP_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_MediaType = {
                          PWG_ELEMENT_TYPE_NUM_RNG,                 /* Type of parameter definition         */
                          PWG_TYPE_ENUM,                            /* The data type                        */
                          "Media Type",                             /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1, /*Embedded*/         /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          PWG_MEDIA_TYPE_STATIONERY,                /* Default or nominal setting           */
                          PWG_MEDIA_TYPE_STATIONERY,                /* Setting data value                   */

                          pwgMediaType_Keywords,                    /* ENUM Keyword names (strings)         */
                          pwgMediaType_KWVAlues,                    /* ENUM Keyword (string) values         */
                          pwgMediaType_KWVLevel,                    /* ENUM Keyword pjt support level       */
                          pwgMediaType_KWVSupported,                /* ENUM Keywords supported              */

                          PWG_MEDIA_TYPE_UNKNOWN,                   /* The minimum   data value             */
                          PWG_MEDIA_TYPE_END - 1,                   /* The maximum   data value             */
                          1                                         /* The increment data value             */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Information                                                                                        */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaInfo                      */
/* -----------------                                                                                        */
/* Specifies information that helps describe the media instance. Intended for human consumption.            */
/* ======================================================================================================== */
pwgINFO_DEF pwgDef_MediaInfo = {
                          PWG_ELEMENT_TYPE_INFO,                    /* Type of parameter definition         */
                          PWG_TYPE_CHAR,                            /* The data type                        */
                          "Media Information",                      /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1,  /* Embedded */      /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,

                          " \0",                                    /* Default or nominal setting           */
                          " \0"                                     /* Setting data value                   */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Hole Count                                                                                         */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaHoleCount                 */
/* -----------------                                                                                        */
/* Indicates the number of pre-drilled holes in the desired media.                                          */
/* ..................................................|..................................................... */
pwgNUM_DEF pwgDef_MediaHoleCount = {
                                PWG_ELEMENT_TYPE_NUM,               /* Type of parameter definition         */
                                PWG_TYPE_BIT32,                     /* The data type                        */
                                "Media Hole Count",                 /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                0,                                  /* Default or nominal setting           */
                                0                                   /* Setting data value                   */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Order Count                                                                                        */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaOrderCount                */
/* -----------------                                                                                        */
/* Indicates the number of sheets, within an ordered sequence of sheets; after which the sequence begins to */
/* repeat.                                                                                                  */
/* ..................................................|..................................................... */
pwgNUM_DEF pwgDef_MediaOrderCount = {
                                PWG_ELEMENT_TYPE_NUM,               /* Type of parameter definition         */
                                PWG_TYPE_BIT32,                     /* The data type                        */
                                "Media Order Count",                /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                0,                                  /* Default or nominal setting           */
                                0                                   /* Setting data value                   */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Thickness                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaThickness                 */
/* -----------------                                                                                        */
/* The thickness of the media in units of one hundredth of a millimeter. This unit is equivalent to         */
/* 1/2540 th of an inch.                                                                                    */
/* ..................................................|..................................................... */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: From the Web, typical 20 lb paper has a thickness of about 0.097 mm (~246/2540)           */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
pwgNUM_DEF pwgDef_MediaThickness = {
                                PWG_ELEMENT_TYPE_NUM,               /* Type of parameter definition         */
                                PWG_TYPE_BIT32,                     /* The data type                        */
                                "Media Thickness",                  /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                246,                                /* Default or nominal setting           */
                                246                                 /* Setting data value                   */
};

/* -------------------------------------------------------------------------------------------------------- */
/* Media Weight Metric                                                                                      */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 55] MediaWeightMetric              */
/* -----------------                                                                                        */
/* Indicates the weight of the desired media rounded to the nearest whole number of grams per square meter. */
/* ..................................................|..................................................... */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: From the Web, typical 20 lb paper has a weight metric of about 74 GSM                     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
pwgNUM_DEF pwgDef_MediaWeightMetric = {
                                PWG_ELEMENT_TYPE_NUM,               /* Type of parameter definition         */
                                PWG_TYPE_BIT32,                     /* The data type                        */
                                "Media Weight Metric",              /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_1,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,                       /* Is/Is-not Supported                  */

                                74,                                 /* Default or nominal setting           */
                                74                                  /* Setting data value                   */
};


/* -------------------------------------------------------------------------------------------------------- */
/* Media Col Type                                                                                           */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.4: [page 20-21] MediaCol and MediaSize.                                                        */
/* -----------------                                                                                        */
/* MediaCol allows a finer granularity specification of media than is possible with the Media and MediaType */
/* elements.  Figure  8  shows the MediaCol constituent elements and the constituent elements of MediaSize  */
/* and Margins.                                                                                             */
/* ..................................................|..................................................... */
pwgMediaColDefLst pwgMediaColDefElem = {
                          &pwgDef_MediaCoating,           /* Coating of the back of the media.    */
                          &pwgDef_MediaColor,             /* Color of the media being specified.  */
                          &pwgDef_MediaCoating,           /* Coating of the front of the media.   */
                          &pwgDef_MediaGrain,             /* Indicates the grain of the media.    */
                          &pwgDef_MediaHoleCount,         /* Number of pre-drilled holes          */
                          &pwgDef_MediaInfo,              /* Information to helps describe  media */
                          &pwgDef_MediaKey,               /* Unique name of MediaCol              */
                          &pwgDef_MediaOrderCount,        /* Repeat count of sheets               */
                          &pwgDef_MediaPrePrinted,        /* Indicates pre-printed                */
                          &pwgDef_MediaRecycled,          /* Indicates the recycled               */
                          &pwgDef_MediaSize,              /* X-Dim, Y-Dim in 1/100 of a mm.       */
                          &pwgDef_MediaSizeName,          /* Index Media Size Self-Describing Name*/
                          &pwgDef_MediaSource,            /* The input source for the media.      */
                          &pwgDef_MediaThickness,         /* Thickness in units of /100 mm        */
                          &pwgDef_MediaTooth,             /* Tooth (or roughness) of the media    */
                          &pwgDef_MediaType,              /* The medium type                      */
                          &pwgDef_MediaWeightMetric,      /* Media Weight nearest grams/m^2       */
                          &pwgDef_MediaMargins,           /* Physical margin 1/100 mm             */

                          VND_MEDIA_COL_ELEM_DATA

                          (pwgVOID*)pwgNULL
};

pwgSTRUCT_DEF pwgDef_MediaCollection = {
                          PWG_ELEMENT_TYPE_STRUCT,                  /* Type of parameter definition         */
                          PWG_TYPE_STRUCT,                          /* The data type                        */
                          "Media Collection",                       /* Textual name of parametric           */
                          PJT_SUPPORT_LEVEL_1,                      /* Minimum pjt level it is supported    */
                          PWG_MUST_HONOR,                           /* Must Honor Enforcement               */
                          pwgSUPPORTED,                             /* Is/Is-not Supported                  */

                          0,
                          0,
                          (pwgVOID**)&pwgMediaColDefElem
};

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ======================================= pwg.pjt.xxx.N.media.c ========================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
