/* ====================================== pwg.pjt.xxx.N.media.h =========================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_XXX_N_MEDIA_H__
#define __PWG_PJT_XXX_N_MEDIA_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Back  Coating                                                                                      */
/* Media Front Coating                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaBackCoating               */
/* -----------------                                                                                        */
/* Indicates the pre-process coating applied to the back of the media.                                      */
/* [PWG5100.3] §3.13.10                                                                                     */
/*                                                                                                          */
/* ........................................................................................................ */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaFrontCoating              */
/* -----------------                                                                                        */
/* Indicates the pre-process coating applied to the front of the media.                                     */
/* [PWG5100.3] §3.13.10                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                         Internet Printing Protocol(IPP): Production Printing Attributes - Set1   */
        /*      §3.13.10 [page 47] media-front-coating (type3 keyword | name(MAX)) and                      */
        /*                         media-back-coating  (type3 keyword | name(MAX))                          */
        /* -----------------                                                                                */
        /* The "media-front-coating" and "media-back-coating" member attributes indicate what pre-process   */
        /* coating has been applied to the front and back of the desired media, respectively.               */
        /*                                                                                                  */
        /* Standard keyword values for "media-front-coating" and "media-back-coating" are:                  */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'none'        | Indicated that the media MUST not have any coating.                   | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'glossy'      | Indicates that the media MUST have a "glossy" coating.                | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'high-gloss'  | Indicates that the media MUST have a "high-gloss" coating.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'semi-gloss'  | Indicates that the media MUST have a "semi-gloss" coating.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'satin'       | Indicates that the media MUST have a "satin" coating.                 | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'matte'       | Indicates that the media MUST have a "matte" coating.                 | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* The "media-front-coating-supported" (1setOf (type3 keyword | name(MAX))) and                     */
        /* "media-back-coating-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies */
        /* the values of these "media-front-coating" and "media-back-coating" member attributes that the    */
        /* Printer supports.                                                                                */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef enum {
    PWG_MEDIA_COATING_RESERVED_0          =  0,
    PWG_MEDIA_COATING_RESERVED_1          =  1,
    PWG_MEDIA_COATING_UNKNOWN             =  2,

    PWG_MEDIA_COATING_NONE,
    PWG_MEDIA_COATING_GLOSSY,
    PWG_MEDIA_COATING_HIGH_GLOSS,
    PWG_MEDIA_COATING_SEMI_GLOSS,
    PWG_MEDIA_COATING_SATIN,
    PWG_MEDIA_COATING_MATTE,

    VND_MEDIA_COT_ENUM

    PWG_MEDIA_COATING_END
} pwgMediaCoatingEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Color                                                                                              */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaColor                     */
/* -----------------                                                                                        */
/* Indicates the desired color of the media being specified.                                                */
/* [PWG5100.3] §3.13.4                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*      §3.13.4 [page 43-44] media-color (type3 keyword | name(MAX))                                */
        /* -----------------                                                                                */
        /* The "media-color" member attribute indicates the desired color of the media being specified.     */
        /*                                                                                                  */
        /* Standard keyword values for "media-color" are:                                                   */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: PRINTER MIB 1759 includes the 'color's:                                                   */
/*                |-------------|-------------------------------------------|                               */
/*                | other       | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/*                | unknown     | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/*                | transparent | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'no-color'  | The specified media should have no color. |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'white'     | The specified media should be white.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'pink'      | The specified media should be pink.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'yellow'    | The specified media should be yellow.     |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'blue'      | The specified media should be blue.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'green'     | The specified media should be green.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'buff'      | The specified media should be buff.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'goldenrod' | The specified media should be goldenrod.  |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'red'       | The specified media should be red.        |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'gray'      | The specified media should be gray.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'ivory'     | The specified media should be ivory.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'orange'    | The specified media should be orange.     |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*                                                                                                  */
        /* Note: The standard keyword values for the "media-color" attribute are derived primarily from the */
        /*       Printer MIB [RFC1759] prtInputMediaColor standard values with the addition of 'blue',      */
        /*       'red', 'gray', 'ivory', 'orange', and 'no-color' (instead of 'transparent' - see           */
        /*       'transparency' in "media-type", section 3.13.2).                                           */
        /*                                                                                                  */
        /* The "media-color-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies    */
        /* the values of this "media-color" member attribute that the Printer supports, i.e., the colors    */
        /* supported.                                                                                       */
        /*                                                                                                  */
        /* The Administrator can define custom paper colors using the 'name' (MAX) attribute syntax  of the */
        /* "media-color-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute.  Note: as with   */
        /* other Job Template and member attributes, the user can also supply user-defined color names that */
        /* are not among the values of the "media-color-supported" Printer attribute, if the Administrator  */
        /* has configured the Printer's "user-defined-values-supported" attribute to contain the            */
        /* 'media-color' attribute keyword value (see section 5.1).                                         */
        /*                                                                                                  */
        /* ================================================================================================ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: 2012.07.18 -- PWG MSN  2.0 was used to update the PWG:PJT values                          */
/*    Values based o  n PWG:PJT                                                                             */
/*    typedef enum {                                                                                        */
/*        PWG_MEDIA_COLOR_RESERVED_0          =  0,                                                         */
/*        PWG_MEDIA_COLOR_OTHER               =  1,                                                         */
/*        PWG_MEDIA_COLOR_UNKNOWN             =  2,                                                         */
/*        PWG_MEDIA_COLOR_TRANSPARENT         =  3,    Transparent and No-Color are the same                */
/*        PWG_MEDIA_COLOR_NO_COLOR            =  3,    Transparent and No-Color are the same                */
/*        PWG_MEDIA_COLOR_WHITE,                                                                            */
/*        PWG_MEDIA_COLOR_PINK,                                                                             */
/*        PWG_MEDIA_COLOR_YELLOW,                                                                           */
/*        PWG_MEDIA_COLOR_BLUE,                                                                             */
/*        PWG_MEDIA_COLOR_GREEN,                                                                            */
/*        PWG_MEDIA_COLOR_BUFF,                                                                             */
/*        PWG_MEDIA_COLOR_GOLDENROD,                                                                        */
/*        PWG_MEDIA_COLOR_RED,                                                                              */
/*        PWG_MEDIA_COLOR_GRAY,                                                                             */
/*        PWG_MEDIA_COLOR_IVORY,                                                                            */
/*        PWG_MEDIA_COLOR_ORANGE,                                                                           */
/*                                                                                                          */
/*        PWG_MEDIA_COLOR_END                                                                               */
/*    } pwgMediaColorEnum;                                                                                  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* Replaced by:                                                                                             */
/*                                                                                                          */
/*. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

typedef enum {
        PWG_MEDIA_COLOR_RESERVED_0          =  0,
        PWG_MEDIA_COLOR_OTHER               =  1,
        PWG_MEDIA_COLOR_UNKNOWN             =  2,

        /*       Name (and named-index)   /   Localized Name     s R G B A                                */
        PWG_MEDIA_COLOR_NO_COLOR,         /*       Transparent  0xFFFFFF00                                */
        PWG_MEDIA_COLOR_TRANSPARENT         =  PWG_MEDIA_COLOR_NO_COLOR,

        PWG_MEDIA_COLOR_BLACK,            /*       Black        0x000000FF                                */
        PWG_MEDIA_COLOR_CLEAR_BLACK,      /* Clear Black        0x0000007F                                */
        PWG_MEDIA_COLOR_LIGHT_BLACK,      /* Light Black        0x808080FF                                */
        PWG_MEDIA_COLOR_BLUE,             /*       Blue         0x0000FFFF                                */
        PWG_MEDIA_COLOR_CLEAR_BLUE,       /* Clear Blue         0x0000FF7F                                */
        PWG_MEDIA_COLOR_DARK_BLUE,        /* Dark  Blue         0x00008BFF                                */
        PWG_MEDIA_COLOR_LIGHT_BLUE,       /* Light Blue         0xADD8E6FF                                */
        PWG_MEDIA_COLOR_BROWN,            /*       Brown        0xA52A2AFF                                */
        PWG_MEDIA_COLOR_CLEAR_BROWN,      /* Clear Brown        0xA52A2A7F                                */
        PWG_MEDIA_COLOR_DARK_BROWN,       /* Dark  Brown        0x5C4033FF                                */
        PWG_MEDIA_COLOR_LIGHT_BROWN,      /* Light Brown        0x9966FFFF                                */
        PWG_MEDIA_COLOR_BUFF,             /*       Buff         0xF0DC82FF                                */
        PWG_MEDIA_COLOR_CLEAR_BUFF,       /* Clear Buff         0xF0DC827F                                */
        PWG_MEDIA_COLOR_DARK_BUFF,        /* Dark  Buff         0x976638FF                                */
        PWG_MEDIA_COLOR_LIGHT_BUFF,       /* Light Buff         0xECD9B0FF                                */
        PWG_MEDIA_COLOR_CYAN,             /*       Cyan         0x00FFFFFF                                */
        PWG_MEDIA_COLOR_CLEAR_CYAN,       /* Clear Cyan         0x00FFFF7F                                */
        PWG_MEDIA_COLOR_DARK_CYAN,        /* Dark  Cyan         0x008B8BFF                                */
        PWG_MEDIA_COLOR_LIGHT_CYAN,       /* Light Cyan         0xE0FFFFFF                                */
        PWG_MEDIA_COLOR_GOLD,             /*       Gold         0xFFD700FF                                */
        PWG_MEDIA_COLOR_CLEAR_GOLD,       /* Clear Gold         0xFFD7007F                                */
        PWG_MEDIA_COLOR_DARK_GOLD,        /* Dark  Gold         0xEEBC1DFF                                */
        PWG_MEDIA_COLOR_LIGHT_GOLD,       /* Light Gold         0xF1E5ACFF                                */
        PWG_MEDIA_COLOR_GOLDENDROD,       /*       Goldenrod    0xDAA520FF                                */
        PWG_MEDIA_COLOR_CLEAR_GOLDENROD,  /* Clear Goldenrod    0xDAA5207F                                */
        PWG_MEDIA_COLOR_DARK_GOLDENROD,   /* Dark  Goldenrod    0xB8860BFF                                */
        PWG_MEDIA_COLOR_LIGHT_GOLDENROD,  /* Light Goldenrod    0xFFEC8BFF                                */
        PWG_MEDIA_COLOR_GRAY,             /*       Gray         0x808080FF                                */
        PWG_MEDIA_COLOR_CLEAR_GRAY,       /* Clear Gray         0x8080807F                                */
        PWG_MEDIA_COLOR_DARK_GRAY,        /* Dark  Gray         0x404040FF                                */
        PWG_MEDIA_COLOR_LIGHT_GRAY,       /* Light Gray         0xD3D3D3FF                                */
        PWG_MEDIA_COLOR_GREEN,            /*       Green        0x008000FF                                */
        PWG_MEDIA_COLOR_CLEAR_GREEN,      /* Clear Green        0x0080007F                                */
        PWG_MEDIA_COLOR_DARK_GREEN,       /* Dark  Green        0x006400FF                                */
        PWG_MEDIA_COLOR_LIGHT_GREEN,      /* Light Green        0x90EE90FF                                */
        PWG_MEDIA_COLOR_IVORY,            /*       Ivory        0xFFFFF0FF                                */
        PWG_MEDIA_COLOR_CLEAR_IVORY,      /* Clear Ivory        0xFFFFF07F                                */
        PWG_MEDIA_COLOR_DARK_IVORY,       /* Dark  Ivory        0xF2E58FFF                                */
        PWG_MEDIA_COLOR_LIGHT_IVORY,      /* Light Ivory        0xFFF8C9FF                                */
        PWG_MEDIA_COLOR_MAGENTA,          /*       Magenta      0xFF00FFFF                                */
        PWG_MEDIA_COLOR_CLEAR_MAGENTA,    /* Clear Magenta      0xFF00FF7F                                */
        PWG_MEDIA_COLOR_DARK_MAGENTA,     /* Dark  Magenta      0x8B008BFF                                */
        PWG_MEDIA_COLOR_LIGHT_MAGENTA,    /* Light Magenta      0xFF77FFFF                                */
        PWG_MEDIA_COLOR_MULTI_COLOR,      /*       Multi-Color  Undefined                                 */
        PWG_MEDIA_COLOR_CLEAR_MULTI_COLOR,/* Clear Multi-Color  Undefined                                 */
        PWG_MEDIA_COLOR_MUSTARD,          /*       Mustard      0xFFDB58FF                                */
        PWG_MEDIA_COLOR_CLEAR_MUSTARD,    /* Clear Mustard      0xFFDB587F                                */
        PWG_MEDIA_COLOR_DARK_MUSTARD,     /* Dark  Mustard      0x7C7C40FF                                */
        PWG_MEDIA_COLOR_LIGHT_MUSTRAD,    /* Light Mustard      0xEEDD62FF                                */
        PWG_MEDIA_COLOR_ORANGE,           /*       Orange       0xFFA500FF                                */
        PWG_MEDIA_COLOR_CLEAR_ORANGE,     /* Clear Orange       0xFFA5007F                                */
        PWG_MEDIA_COLOR_DARK_ORANGE,      /* Dark  Orange       0xFF8C00FF                                */
        PWG_MEDIA_COLOR_LIGHT_ORANGE,     /* Light Orange       0xD9A465FF                                */
        PWG_MEDIA_COLOR_PINK,             /*       Pink         0xFFC0CBFF                                */
        PWG_MEDIA_COLOR_CLEAR_PINK,       /* Clear Pink         0xFFC0CB7F                                */
        PWG_MEDIA_COLOR_DARK_PINK,        /* Dark  Pink         0xE75480FF                                */
        PWG_MEDIA_COLOR_LIGHT_PINK,       /* Light Pink         0xFFB6C1FF                                */
        PWG_MEDIA_COLOR_RED,              /*       Red          0xFF0000FF                                */
        PWG_MEDIA_COLOR_CLEAR_RED,        /* Clear Red          0xFF00007F                                */
        PWG_MEDIA_COLOR_DARK_RED,         /* Dark  Red          0x8B0000FF                                */
        PWG_MEDIA_COLOR_LIGHT_RED,        /* Light Red          0xFF3333FF                                */
        PWG_MEDIA_COLOR_SILVER,           /*       Silver       0xC0C0C0FF                                */
        PWG_MEDIA_COLOR_CLEAR_SILVER,     /* Clear Silver       0xC0C0C07F                                */
        PWG_MEDIA_COLOR_DARK_SILVER,      /* Dark  Silver       0xAFAFAFFF                                */
        PWG_MEDIA_COLOR_LIGHT_SILVER,     /* Light Silver       0xE1E1E1FF                                */
        PWG_MEDIA_COLOR_TURQUOISE,        /*       Turquoise    0x30D5C8FF                                */
        PWG_MEDIA_COLOR_CLEAR_TURQUOISE,  /* Clear Turquoise    0x30D5C87F                                */
        PWG_MEDIA_COLOR_DARK_TURQUOISE,   /* Dark  Turquoise    0x00CED1FF                                */
        PWG_MEDIA_COLOR_LIGHT_TURQUOISE,  /* Light Turquoise    0xAFE4DEFF                                */
        PWG_MEDIA_COLOR_VIOLET,           /*       Violet       0xEE82EEFF                                */
        PWG_MEDIA_COLOR_CLEAR_VIOLET,     /* Clear Violet       0xEE82EE7F                                */
        PWG_MEDIA_COLOR_DARK_VIOLET,      /* Dark  Violet       0x9400D3FF                                */
        PWG_MEDIA_COLOR_LIGHT_VIOLET,     /* Light Violet       0x7A5299FF                                */
        PWG_MEDIA_COLOR_WHITE,            /*       White        0xFFFFFFFF                                */
        PWG_MEDIA_COLOR_CLEAR_WHITE,      /* Clear White        0xFFFFFF7F                                */
        PWG_MEDIA_COLOR_YELLOW,           /*       Yellow       0xFFFF00FF                                */
        PWG_MEDIA_COLOR_CLEAR_YELLOW,     /* Clear Yellow       0xFFFF007F                                */
        PWG_MEDIA_COLOR_DARK_YELLOW,      /* Dark  Yellow       0xFFCC00FF                                */
        PWG_MEDIA_COLOR_LIGHT_YELLOW,     /* Light Yellow       0xFFFFE0FF                                */

    /* End of Standard Media Color List                             */
    /* ------------------------------------------------------------ */

        VND_MEDIA_CLR_ENUM

        PWG_MEDIA_COLOR_END

} pwgMediaColorEnum;

/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Grain                                                                                              */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaGrain                     */
/* -----------------                                                                                        */
/* Indicates the grain of the media.                                                                        */
/* [PWG5100.11] §11.5.2                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §11.5.2 [page 71-72] media-grain (type3 keyword | name(MAX))                                */
        /* -----------------                                                                                */
        /* The "media-grain" member attribute indicates the desired grain of the media being specified.     */
        /* The source for this attribute is [ISO10175].                                                     */
        /*                                                                                                  */
        /* Grain affects the curl and the folding of the medium.  Some marking engines are sensitive to the */
        /* resulting curl.                                                                                  */
        /*                                                                                                  */
        /* Standard keyword values for "media-grain" are:                                                   */
        /*                                                                                                  */
        /*        |---------------|---------------------------------------------------------------------|   */
        /*        |    Keyword    | Description                                                         |   */
        /*        |---------------|---------------------------------------------------------------------|   */
        /*        | 'x-direction' | The direction of the paper fibers  is in the short dimension        |   */
        /*        |               | (i.e. the x-direction) of the medium.                               |   */
        /*        |---------------|---------------------------------------------------------------------|   */
        /*        | 'y-direction' | The direction of the paper fibers is in the long dimension          |   */
        /*        |               | (i.e. the y-direction) of the medium.                               |   */
        /*        |---------------|---------------------------------------------------------------------|   */
        /*                                                                                                  */
        /* See section 2.4 of [PWG5100.3] regarding the coordinate system.                                  */
        /*                                                                                                  */
        /* The Administrator can define a custom media grain using the 'name' (MAX) attribute syntax of the */
        /* "media-grain-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute.  Note: as with   */
        /* other Job Template and member attributes, the user can also supply user-defined grain names that */
        /* are not among the values of the "media-grain-supported" Printer attribute, if the Administrator  */
        /* has configured the Printer's "user-defined-values-supported" attribute (see [PWG5100.3]) to      */
        /* contain the 'media-grain' attribute keyword value.                                               */
        /*                                                                                                  */
        /* 11.5.2.1 media-grain-supported (1setOf (type3 keyword | name(MAX)))                              */
        /* The "media-grain-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies    */
        /* the values of this "media-grain" member attribute that the Printer supports, i.e., the media     */
        /* grain supported.                                                                                 */
        /*                                                                                                  */
        /* The Administrator can define custom media types using the 'name' (MAX) attribute syntax  of the  */
        /* "media-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute.  Note: as with other   */
        /* Job Template and member attributes, the user can also supply user-defined material names that    */
        /* are not among the values of the "media-supported" Printer attribute, if the Administrator has    */
        /* configured the Printer's "user-defined-values-supported" attribute (see [PWG5100.3]) to contain  */
        /* the 'media' attribute keyword value.                                                             */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                      Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
            /*      §2.4 [page 14-15] Coordinate System                                                     */
            /* -----------------                                                                            */
            /* Some of the attribute extensions defined in this document refer to specific edges of a sheet */
            /* of printed media.  Specifying that a staple be placed in the upper left corner of a printed  */
            /* document is an example.  To resolve ambiguity the following coordinate system is used        */
            /* throughout this document:                                                                    */
            /*                                                                                              */
            /*    The specified edge is always with respect to the document as if the document were a       */
            /*    portrait document.  If the document is actually a landscape or a reverse-landscape        */
            /*    document, the client (which may include a user) supplies the appropriate transformed      */
            /*    value.  For example, to position a staple in the upper left hand corner of a landscape    */
            /*    document when held for reading, the client supplies the 'staple-bottom-left' value (since */
            /*    landscape is defined as a +90 degree rotation from portrait, i.e., anti-clockwise).  On   */
            /*    the other hand, to position a staple in the upper left hand corner of a reverse-landscape */
            /*    document when held for reading, the client supplies the 'staple-top-right' value (since   */
            /*    reverse-landscape is defined as a –90 degree rotation from portrait, i.e., clockwise).    */
            /*                                                                                              */
            /*    The x-axis is defined to be along the bottom edge, with positive values extending in the  */
            /*    direction of the right edge.                                                              */
            /*                                                                                              */
            /*    The y-axis is defined to be along the left edge, with positive values extending toward    */
            /*    the top edge.                                                                             */
            /*                                                                                              */
            /*    The origin (0,0) is the bottom-left corner.                                               */
            /*                                                                                              */
            /* Some other attribute extensions defined in this document refer to edges of the               */
            /* Finished-Page-Image Cell and to axes relative to the Finished-Page-Image Cell. For example,  */
            /* there is an attribute that shifts a Finished-Page Image along the x-axis and another that    */
            /* shifts it to a left edge.                                                                    */
            /*                                                                                              */
            /* When imposition is not applied, the Finished-Page-Image Cell coincides to the surface of a   */
            /* medium. The rules cited in the above paragraphs of this section apply.                       */
            /*                                                                                              */
            /* When imposition is applied, the Finished-Page-Image Cell acts like the surface of a medium   */
            /* with regard to the co-ordinate system. That is, the edges and axes are as if the             */
            /* Finished-Page-Image Cell were in portrait orientation.  The x-axis is along the bottom of    */
            /* the Finished-Page-Image Cell, the y-axis is along the left edge of the Finished-Page-Image   */
            /* Cell, and the origin at the bottom-left corner of the Finished-Page-Image Cell.              */
            /*                                                                                              */
            /* ============================================================================================ */

typedef enum {
    PWG_MEDIA_GRAIN_RESERVED_0          =  0,
    PWG_MEDIA_GRAIN_RESERVED_1          =  1,
    PWG_MEDIA_GRAIN_UNKNOWN             =  2,

    PWG_MEDIA_GRAIN_X_DIRECTION,
    PWG_MEDIA_GRAIN_Y_DIRECTION,

    VND_MEDIA_GRN_ENUM

    PWG_MEDIA_GRAIN_END
} pwgMediaGrainEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Key                                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaKey                       */
/* -----------------                                                                                        */
/* The unique media name associated with an instance of MediaCol elements and their values.  Identical      */
/* values  of MediaKey and the Media element represent the same media.                                      */
/* [PWG5100.3] §3.13.1                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                       Internet Printing Protocol(IPP): Production Printing Attributes - Set1     */
        /*      §3.13.1 [page 41] media-key (type3 keyword |name(MAX))                                      */
        /* -----------------                                                                                */
        /* The "media-key" member attribute contains the name of the media represented as a keyword or name.*/
        /* Values MUST be the same as the keyword and name values for the "media" Job Template attribute    */
        /* and represent the same media, except for media size and input tray keywords (see section 6.3     */
        /* in this document and [RFC2911] Appendix C) which MUST NOT be "media-key" values.                 */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: DUE TO THE SIZE OF THE MEDIA TABLE INFO IN RFC2911, IT HAS NOT BEEN INCLUDED              */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /* The value of this member attribute MUST be unique for each media supported by an IPP Printer     */
        /* instance, i.e., no two media instances can have the same "media-key" value on the same IPP       */
        /* Printer instance.  However, the same "media-key" value can represent the same or different media */
        /* on different IPP Printer instances.  For example, the 'iso-a4-white' keyword might represent     */
        /* recycled 80 gm/mm on two Printer instances and non-recycled, 72 gm/mm on a third Printer         */
        /* instance.  An administrator or a number of administrators within an organization MAY choose to   */
        /* have "media-key" values represent the same media instances across a set of Printers.             */
        /*                                                                                                  */
        /* Note: Since the above requires that each media instance have a unique "media-key" value (if      */
        /*       "media-key" attribute is supported), then the Printer automatically meets the requirement  */
        /*       (see section 3.13) that each media instance have a unique combination of member attribute  */
        /*       values.                                                                                    */
        /*                                                                                                  */
        /* Note: As with any combination of supported "media-col" member attributes, if a client supplies   */
        /*       the "media-key" member attribute and other member attributes, the Printer will attempt to  */
        /*       match all of the supplied member attributes, including the "media-key" value, following    */
        /*       the algorithm defined in section 3.13.  So if the supplied collection value does not match */
        /*       any supported "media-col" value, the Printer treats the "media-col" attribute as having an */
        /*       undefined attribute value.  Thus, a client can ensure that the Printer maps a standard     */
        /*       media name keyword to certain expected member attribute values.                            */
        /*                                                                                                  */
        /* The "media-key-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies the  */
        /* values of this "media-key" member attribute that the Printer supports.                           */
        /*                                                                                                  */
        /* For Printers that support a large number of media (and the "media-key" attribute), the burden of */
        /* an administrator to define unique "media-key" values for each media instance could be quite      */
        /* large.  Therefore, it is RECOMMENDED that such a Printer assign a unique "media-key" value in an */
        /* IMPLEMENTATION-DEFINED manner for each media instance for which the administrator has not        */
        /* defined a "media-key" value, rather than refusing the media definition.  The Printer also adds   */
        /* such generated values to its "media-key-supported" attribute.  A client can supply such a        */
        /* Printer-generated value with either (1) the "media-key" member attribute or (2) the "media" Job  */
        /* Template attribute.                                                                              */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_KEY_RESERVED_0          =  0,
    PWG_MEDIA_KEY_RESERVED_1          =  1,
    PWG_MEDIA_KEY_UNKNOWN             =  2,

    VND_MEDIA_KEY_ENUM

    PWG_MEDIA_KEY_END
} pwgMediaKeyEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Pre-Printed                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaPrePrinted                */
/* -----------------                                                                                        */
/* Indicates the pre-printed characteristics of the desired media.                                          */
/* [PWG5100.3] §3.13.5                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                         Internet Printing Protocol(IPP): Production Printing Attributes - Set1   */
        /*      §3.13.5 [page 44] media-pre-printed (type3 keyword | name(MAX))                             */
        /* -----------------                                                                                */
        /* The "media-pre-printed" member attribute indicates that the pre-printed characteristics of the   */
        /* desired media.  Examples of pre-printed media include forms and company letterhead.  The         */
        /* standard keyword values for "media-pre-printed" are:                                             */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'blank'       | The desired medium is not pre-printed.  The Printer MAY use an        | */
        /*        |               | electronic representation of a form, if the medium has some imaged    | */
        /*        |               | information already associated with it.                               | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'pre-printed' | The desired medium is pre-printed; the other attributes identify      | */
        /*        |               | which medium instance and so what is actually pre-printed.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'letter-head' | The site-defined letter head pre-printed is desired.                  | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* The "media-pre-printed-supported" (1setOf (type3 keyword | name(MAX)) Printer attribute          */
        /* identifies the values of this "media-pre-printed" member attribute that the Printer supports.    */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_PRE_PRINTED_RESERVED_0          =  0,
    PWG_MEDIA_PRE_PRINTED_RESERVED_1          =  1,
    PWG_MEDIA_PRE_PRINTED_UNKNOWN             =  2,

    PWG_MEDIA_PRE_PRINTED_BLANK,
    PWG_MEDIA_PRE_PRINTED_PRE_PRINTED,
    PWG_MEDIA_PRE_PRINTED_LETTER_HEAD,

      VND_MEDIA_PREPRT_ENUM

    PWG_MEDIA_PRE_PRINTED_END
} pwgMediaPrePrintedEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Recycled                                                                                           */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaRecycled                  */
/* -----------------                                                                                        */
/* Indicates the recycled characteristics of the media.                                                     */
/* [PWG5100.3] §3.13.11                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                         Internet Printing Protocol(IPP): Production Printing Attributes - Set1   */
        /*      §3.13.11 [page 47] media-recycled (type3 keyword | name(MAX))                               */
        /* -----------------                                                                                */
        /* 3.13.11 media-recycled (type3 keyword | name(MAX))                                               */
        /* The "media-recycled" member attribute indicates the recycled characteristics of the media.  The  */
        /* standard keyword values are:                                                                     */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'none'        | The media MUST NOT be recycled.                                       | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'standard'    | The media MUST be the site-defined standard recycled stock.           | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* If this member attribute is supported, the Printer MUST support at least the 'none' and          */
        /* 'standard' values.                                                                               */
        /*                                                                                                  */
        /* The "media-recycled-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies */
        /* the values of this "media-recycled" member attribute that the Printer supports, i.e., the        */
        /* recycled characteristics supported, which MUST include the 'none' keyword value so that          */
        /* validation follows the normal rules.                                                             */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_RECYCLED_RESERVED_0       =  0,
    PWG_MEDIA_RECYCLED_RESERVED_1       =  1,
    PWG_MEDIA_RECYCLED_UNKNOWN          =  2,

    PWG_MEDIA_RECYCLED_NONE,
    PWG_MEDIA_RECYCLED_STANDARD,

    VND_MEDIA_RCY_ENUM

    PWG_MEDIA_RECYCLED_END
} pwgMediaRecycledEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Description Type                                                                                   */
/*                                                                                                          */
/* ======================================================================================================== */
/* This file                                                                                                */
/* -----------------                                                                                        */
/* What type of Media Description Data is represented.                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
typedef enum {
    PWG_MEDIA_DESC_TYPE_RESERVED_0        = 0,
    PWG_MEDIA_DESC_TYPE_RESERVED_1        = 1,
    PWG_MEDIA_DESC_TYPE_UNKNOWN           = 2,

    PWG_MEDIA_DESC_TYPE_MEDIA_COLLECTION,
    PWG_MEDIA_DESC_TYPE_MEDIA_AND_TYPE,

    VND_MEDIA_DES_TYP_ENUM

    PWG_MEDIA_DESC_TYPE_END
} pwgMediaDescTypeEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Size Name                                                                                          */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaSizeName                  */
/* -----------------                                                                                        */
/* The medium size that the PrintService uses for all impressions of the Job.                               */
/* [PWG5101.1] §5                                                                                           */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5101.1] February 26, 2002: Candidate Standard 5101.1-2001                                   */
        /*                                           Standard for Media Standardized Names                  */
        /*      §5 [page 9-16]  Media Size Self-Describing Names                                            */
        /* -----------------                                                                                */
        /* The media size specifications defined in this document, labeled as Media Size Self-Describing    */
        /* Names, are cross indexed to Legacy Names and Alias (common) names.  The Legacy Names define the  */
        /* names currently used in the ISO DPA, Printer MIB, or IPP documents.  A reference column is       */
        /* included in the tables to indicate which of these three documents contain the Legacy Name.       */
        /*                                                                                                  */
        /* Ref column entry definitions:                                                                    */
        /*                                                                                                  */
        /*    1 =  Printer MIB [PRT-MIB] and ISO DPA [DPA].  (Both documents contain an identical set.)     */
        /*    2 =  IPP [IPP-MOD].                                                                           */
        /*    4 =  ASME Y14  [ASME-IN]                                                                      */
        /*    5 =  ASME Y14.M  [ASME-M]                                                                     */
        /*                                                                                                  */
        /* 5.1 Media Size Self-Describing Name Format                                                      */
        /* This specification defines a new Media Size Self-Describing Name format that is recommended to   */
        /* be used by all new implementations.  This new format has the Media Size Name and the Media       */
        /* Dimensions embedded within the string and allows a device to operate without a Media Size Name   */
        /* to Media Dimensions table.  The Media Size Self-Describing Name format is structured as follows  */
        /* using ABNF:                                                                                      */
        /*                                                                                                  */
        /*    media-size-self-describing-name =                                                             */
        /*                      ( class-in "_" size-name "_" short-dim "x" long-dim "in" ) |                */
        /*                      ( class-mm "_" size-name "_" short-dim "x" long-dim "mm" )                  */
        /*                                                                                                  */
        /*      class-in       = "custom" | "na" | "asme" | "roc" | "oe"                                    */
        /*      class-mm       = "custom" | "iso" | "jis" | "jpn" | "prc" | "om"                            */
        /*      size-name      = ( lowalpha | digit ) *( lowalpha | digit | "-" )                           */
        /*      short-dim      = dim                                                                        */
        /*      long-dim       = dim                                                                        */
        /*      dim            = integer-part [fraction-part] | "0" fraction-part                           */
        /*      integer-part   = non-zero-digit *digit                                                      */
        /*      fraction-part  = "." *digit non-zero-digit                                                  */
        /*      lowalpha       = "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" |                      */
        /*                       "j" | "k" | "l" | "m" | "n" | "o" | "p" | "q" | "r" |                      */
        /*                       "s" | "t" | "u" | "v" | "w" | "x" | "y" | "z"                              */
        /*      non-zero-digit = "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"                        */
        /*      digit          = "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"                  */
        /*                                                                                                  */
        /* The above ABNF is current as of the date of publication this document.  Implementers should be   */
        /* aware that the currently defined class names may be expanded in the future to cover new groups   */
        /* of media sizes.  Thus client parser implementations that are developed using this ABNF should    */
        /* accept class names that are not currently represented in this list.  The latest ABNF, which      */
        /* shall always be the proper reference for use within this standard, may be obtained at:           */
        /*                                                                                                  */
        /*              ftp://ftp.pwg.org/pub/pwg/informational/pwg5101.1-media-name-abnf.txt               */
        /*                                                                                                  */
        /* 5.1.1 class-xx                                                                                   */
        /* This string part is present to indicate the name space or jurisdiction for the size name in      */
        /* order to prevent name clashes.  Currently defined values are                                     */
        /*                                                                                                  */
        /*        "na"      for North America,                                                              */
        /*        "asme"    for American Society of Mechanical Engineers,                                   */
        /*        "iso"     for the International Standards Organization,                                   */
        /*        "jis"     for Japanese Information Standard,                                              */
        /*        "jpn"     for Japan,                                                                      */
        /*        "prc"     for People's Republic of China,                                                 */
        /*        "roc"     for Republic of China (Taiwan),                                                 */
        /*        "oe"      for other English, and                                                          */
        /*        "om"      for other metric.                                                               */
        /*        "custom"  defines a unique class name that allows site and vendor unique size definitions,*/
        /*                  see paragraph 5.1.7.                                                            */
        /*                                                                                                  */
        /* New class names must conform to the following ABNF:                                              */
        /*                                                                                                  */
        /*    class-name = ( lowalpha | digit ) *( lowalpha | digit | "." )                                 */
        /*                                                                                                  */
        /* 5.1.2   size-name                                                                                */
        /* This string provides a textual description of the media size.  It is normally derived from the   */
        /* Legacy or Alias name associated with the media size.  The size-name can consist of multiple      */
        /* parts, with each part separated by a hyphen (0x2D).                                              */
        /*                                                                                                  */
        /* 5.1.3   short-dim and long-dim                                                                   */
        /* These values define the media size.  The short-dim is always the smaller of the two dimensions.  */
        /* The dimensions are presented in decimal format to as many places as necessary to define the size.*/
        /* Trailing zeros must never be used if a decimal portion is present.                               */
        /*                                                                                                  */
        /* 5.1.4 [Interchange]                                                                              */
        /* For interchange between programs, the dimensions presented in this standard must never be        */
        /* converted to the another system of units, but must remain as defined in this standard.           */
        /* Furthermore, an identical size shall never appear in this standard with different units.         */
        /* Programs may convert the dimensions to other units when displaying these names to human users    */
        /* and for internal use, both of which are outside the scope of this standard.                      */
        /*                                                                                                  */
        /* The common usage of some names may represent several physical sizes (e.g. folio, quarto,         */
        /* foolscap, and executive).  To avoid naming conflicts, a hyphenated identifier must be used to    */
        /* link the names to a specific size.  Only one of the possible sizes may use the name without a    */
        /* hyphenated identifier.                                                                           */
        /*                                                                                                  */
        /* 5.1.5   General                                                                                  */
        /* The Media Size Self-Describing Name shall not contain any space characters (0x20).               */
        /*                                                                                                  */
        /* Wherever possible, the Media Size Self-Describing Name has been derived from the Legacy Name.    */
        /* In many cases the 'class_size-name' portion is identical to the Legacy Name.  In the  remaining  */
        /* cases, the 'class' portion must be ignored to match the Legacy Name.                             */
        /*                                                                                                  */
        /* 5.1.6  Examples:                                                                                 */
        /* The letter size (8.5 inches by 11 inches) used in North America:   na_letter_8.5x11in            */
        /* The iso A4 size (210 mm by 297 mm) used in metric countries:       iso_a4_210x297mm              */
        /*                                                                                                  */
        /* 5.1.7  Custom Media Size Self-Describing Names                                                   */
        /* The "class-custom" allows extensibility of the media size set without an update to this          */
        /* specification.  This feature is primarily intended for special media sizes that are used at a    */
        /* minimum number of locations.  Size names that use the "custom" prefix are never registered or    */
        /* published within this standard.                                                                  */
        /*                                                                                                  */
        /* 5.2 Reserved Size Names                                                                         */
        /* The size-name "max" shall be reserved to indicate an upper size limit of either a device or      */
        /* application.  Also, the size-name "min" shall be reserved to indicate a lower size limit.        */
        /* Example: For a device that can process forms as small as 2 x 3 inches to 18 x 36 inches:         */
        /*                                                                                                  */
        /*                          custom_max_18x36in   and  custom_min_2x3in                              */
        /*                                                                                                  */
        /* 5.3 Conventions for the Tables                                                                  */
        /* The rest of this section contains the tables of Media Size Self-Describing Names.  Within a      */
        /* table entries from different sources are grouped together.  The entries in these groups are      */
        /* arranged in order of increasing size of the smaller dimension.                                   */
        /*                                                                                                  */
        /* The presence of "(envelope)" in the Alias column indicates this size is also commonly used for   */
        /* envelopes.  It does not imply that this size is only available as an envelope media type.        */
        /*                                                                                                  */
        /*                Table 3   - North American Standard Sheet Media Sizes  (part 1)                   */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(inches)| */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | index-3x5                       | na_index-3x5_3x5in          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | personal  (envelope)            | na_personal_3.625x6.5in     | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | monarch-envelope      | 2    |                                 | na_monarch_3.875x7.5in      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-number-9-envelope  | 1, 2 |                                 | na_number-9_3.875x8.875in   | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | index-4x6  (postcard)           | na_index-4x6_4x6in          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-number-10-envelope | 1, 2 | comm-10 (envelope)              | na_number-10_4.125x9.5in    | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | a2 (envelope)                   | na_a2_4.375x5.75in          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | number-11 (envelope)            | na_number-11_4.5x10.375in   | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | number-12 (envelope)            | na_number-12_4.75x11in      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | 5x7                             | na_5x7_5x7in                | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | index-5x8                       | na_index-5x8_5x8in          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | number-14 (envelope)            | na_number-14_5x11.5in       | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | invoice               | 2    | statement, mini, half-letter    | na_invoice_5.5x8.5in        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | index-4x6-ext                   | na_index-4x6-ext_6x8in      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-6x9-envelope       | 1, 2 | 6x9 (envelope)                  | na_6x9_6x9in                | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | c5 (envelope)                   | na_c5_6.5x9.5in             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-7x9-envelope       | 1, 2 | 7x9 (envelope)                  | na_7x9_7x9in                | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | executive             | 2    |                                 | na_executive_7.25x10.5in    | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-8x10               | 2    | government-letter               | na_govt-letter_8x10in       | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       | 2    | government-legal                | na_govt-legal_8x13in        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | quarto                | 2    |                                 | na_quarto_8.5x10.83in       | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-letter             | 1, 2 | letter, a, engineering-a        | na_letter_8.5x11in          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | fanfold-European                | na_fanfold-eur_8.5x12in     | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | letter-plus                     | na_letter-plus_8.5x12.69in  | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | foolscap, german-legal-fanfold  | na_foolscap_8.5x13in        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-legal              | 1, 2 | legal                           | na_legal_8.5x14in           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | super-a                         | na_super-a_8.94x14in        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-9x11-envelope      | 1, 2 | 9x11 (envelope), letter-tab     | na_9x11_9x11in              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | arch-a                | 2    | architecture-a (envelope)       | na_arch-a_9x12in            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | letter-extra                    | na_letter-extra_9.5x12in    | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | legal-extra                     | na_legal-extra_9.5x15in     | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | 10x11                           | na_10x11_10x11in            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-10x13-envelope     | 1, 2 | 10x13                           | (envelope) na_10x13_10x13in | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-10x14-envelope     | 1, 2 | 10x14                           | (envelope) na_10x14_10x14in | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-10x15-envelope     | 1, 2 | 10x15                           | (envelope) na_10x15_10x15in | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | na-10x15-envelope     | 1, 2 | 10x15                           | (envelope) na_10x15_10x15in | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: DUPLICATE ENTRY IN SPECIFICATION FOR na_10x15_10x15in                                     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /* |                       |      | 11x12                           | na_11x12_11x12in            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | edp                             | na_edp_11x14in              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                Table 3   - North American Standard Sheet Media Sizes  (part 1)                   */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(inches)| */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | fanfold-us                      | na_fanfold-us_11x14.875in     */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | 11x15                           | na_11x15_11x15in              */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | tabloid               | 2    | ledger, b, engineering-b        | na_ledger_11x17in             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | european-edp                    | na_eur-edp_12x14in            */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | arch-b                | 2    | architecture-b, tabloid-extra   | na_arch-b_12x18in             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | 12x19                           | na_12x19_12x19in              */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | b-plus                          | na_b-plus_12x19.17in          */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | super-b                         | na_super-b_13x19in            */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | c                     | 2    | engineering-c                   | na_c_17x22in                  */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | arch-c                | 2    | architecture-c                  | na_arch-c_18x24in             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | d                     | 2    | engineering-d                   | na_d_22x34in                  */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | arch-d                | 2    | architecture-d                  | na_arch-d_24x36in             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | f                     | 5    | e1                              | asme_f_28x40in                */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | wide-format                     | na_wide-format_30x42in        */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | e                     | 2    | engineering-e                   | na_e_34x44in                  */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | arch-e                | 2    | architecture-e                  | na_arch-e_36x48in             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | f, engineering-f                | na_f_44x68in                  */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                      Table 4 - Chinese Standard Sheet Media Inch Sizes                           */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(inches)| */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | roc-16k                         | roc_16k_7.75x10.75in        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | roc-8k                          | roc_8k_10.75x15.5in         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 5 - ISO Standard Sheet Media Sizes  (part 1)                            */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* | iso-a10               | 1, 2 | a10                             | iso_a10_26x37mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a9                | 1, 2 | a9                              | iso_a9_37x52mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a8                | 1, 2 | a8                              | iso_a8_52x74mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a7                | 1, 2 | a7                              | iso_a7_74x105mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a6                | 1, 2 | a6                              | iso_a6_105x148mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a5                | 1, 2 | a5                              | iso_a5_148x210mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | a5-extra                        | iso_a5-extra_174x235mm      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4                | 1, 2 | a4                              | iso_a4_210x297mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | a4-tab                          | iso_a4-tab_225x297mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | a4-extra                        | iso_a4-extra_235.5x322.3mm  | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3                | 1, 2 | a3                              | iso_a3_297x420mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x3, a4x3        | 2, 4 |                                 | iso_a4x3_297x630mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 5 - ISO Standard Sheet Media Sizes  (part 2)                            */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* | iso-a4x4, a4x4        | 2, 4 |                                 | iso_a4x4_297x841mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x5, a4x5        | 2, 4 |                                 | iso_a4x5_297x1051mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x6, a4x6        | 2, 4 |                                 | iso_a4x6_297x1261mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x7, a4x7        | 2, 4 |                                 | iso_a4x7_297x1471mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x8, a4x8        | 2, 4 |                                 | iso_a4x8_297x1682mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a4x9, a4x9        | 2, 4 |                                 | iso_a4x9_297x1892mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3-extra          |      |                                 | iso_a3-extra_322x445mm      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a2                | 1, 2 | a2                              | iso_a2_420x594mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3x3, a3x3        | 2, 4 |                                 | iso_a3x3_420x891mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3x4, a3x4        | 2, 4 |                                 | iso_a3x4_420x1189mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3x5, a3x5        | 2, 4 |                                 | iso_a3x5_420x1486mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3x6, a3x6        | 2, 4 |                                 | iso_a3x6_420x1783mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a3x7, a3x7        | 2, 4 |                                 | iso_a3x7_420x2080mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a1                | 1, 2 | a1                              | iso_a1_594x841mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a2x3, a2x3        | 2, 4 |                                 | iso_a2x3_594x1261mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a2x4, a2x4        | 2, 4 |                                 | iso_a2x4_594x1682mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a2x5, a2x5        | 2, 4 |                                 | iso_a2x5_594x2102mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a0                | 1, 2 | a0                              | iso_a0_841x1189mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a1x3, a1x3        | 2, 4 |                                 | iso_a1x3_841x1783mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-a1x4, a1x4        | 2, 4 |                                 | iso_a1x4_841x2378mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | a0x2                  | 4    | 2a0                             | iso_2a0_1189x1682mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | a0x3                  | 4    |                                 | iso_a0x3_1189x2523mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b10               | 1, 2 | b10                             | iso_b10_31x44mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b9                | 1, 2 | b9                              | iso_b9_44x62mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b8                | 1, 2 | b8                              | iso_b8_62x88mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b7                | 1, 2 | b7                              | iso_b7_88x125mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b6                | 1, 2 | b6 (envelope)                   | iso_b6_125x176mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | b6/c4 (envelope)                | iso_b6c4_125x324mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b5                | 1, 2 | b5 (envelope)                   | iso_b5_176x250mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | b5-extra                        | iso_b5-extra_201x276mm      | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b4                | 1, 2 | b4 (envelope)                   | iso_b4_250x353mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b3                | 1, 2 | b3                              | iso_b3_353x500mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b2                | 1, 2 | b2                              | iso_b2_500x707mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b1                | 1, 2 | b1                              | iso_b1_707x1000mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-b0                | 1, 2 | b0                              | iso_b0_1000x1414mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      |                                 |                             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | c10 (envelope)                  | iso_c10_28x40mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | c9 (envelope)                   | iso_c9_40x57mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c8                | 1    | c8 (envelope)                   | iso_c8_57x81mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c7                | 1    | c7 (envelope)                   | iso_c7_81x114mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | c7/c6 (envelope)                | iso_c7c6_81x162mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c6                | 1, 2 | c6 (envelope)                   | iso_c6_114x162mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 5 - ISO Standard Sheet Media Sizes  (part 3)                          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | c6/c5 (envelope)                | iso_c6c5_114x229mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c5                | 1, 2 | c5 (envelope)                   | iso_c5_162x229mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c4                | 1, 2 | c4 (envelope)                   | iso_c4_229x324mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c3                | 1, 2 | c3 (envelope)                   | iso_c3_324x458mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c2                | 1    | c2 | (envelope)                 | iso_c2_458x648mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c1                | 1    | c1 | (envelope)                 | iso_c1_648x917mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-c0                | 1    | c0 | (envelope)                 | iso_c0_917x1297mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      |                                 |                             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-designated        | 1, 2 | designated-long, dl (envelope)  | iso_dl_110x220mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-ra2               |      |                                 | iso_ra2_430x610mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-sra2              |      |                                 | iso_sra2_450x640mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-ra1               |      |                                 | iso_ra1_610x860mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-sra1              |      |                                 | iso_sra1_640x900mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-ra0               |      |                                 | iso_ra0_860x1220mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | iso-sra0              |      |                                 | iso_sra0_900x1280mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 6 - Japanese Standard Sheet Media Sizes                                 */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* | jis-b10               | 1, 2 |                                 | jis_b10_32x45mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b9                | 1, 2 |                                 | jis_b9_45x64mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b8                | 1, 2 |                                 | jis_b8_64x91mm              | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b7                | 1, 2 |                                 | jis_b7_91x128mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b6                | 1, 2 |                                 | jis_b6_128x182mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b5                | 1, 2 |                                 | jis_b5_182x257mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b4                | 1, 2 |                                 | jis_b4_257x364mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b3                | 1, 2 |                                 | jis_b3_364x515mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b2                | 1, 2 |                                 | jis_b2_515x728mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b1                | 1, 2 |                                 | jis_b1_728x1030mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | jis-b0                | 1, 2 |                                 | jis_b0_1030x1456mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      |                                 |                             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | exec                            | jis_exec_216x330mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      |                                 |                             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | chou4 (envelope)                | jpn_chou4_90x205mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | hagaki  (postcard)              | jpn_hagaki_100x148mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | you4 (envelope)                 | jpn_you4_105x235mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | chou2 (envelope)                | jpn_chou2_111.1x146mm       | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | chou3 (envelope)                | jpn_chou3_120x235mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | oufuku  (reply postcard)        | jpn_oufuku_148x200mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | kahu (envelope)                 | jpn_kahu_240x322.1mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | kaku2 (envelope)                | jpn_kaku2_240x332mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 7 - Chinese Standard Sheet Media Sizes                                  */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | prc-32k                         | prc_32k_97x151mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc1 (envelope)                 | prc_1_102x165mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc2 (envelope)                 | prc_2_102x176mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc4 (envelope)                 | prc_4_110x208mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc5 (envelope)                 | prc_5_110x220mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc8 (envelope)                 | prc_8_120x309mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc6 (envelope)                 | prc_6_120x320mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc3 (envelope)                 | prc_3_125x176mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc-16k                         | prc_16k_146x215mm           | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc7 (envelope)                 | prc_7_160x230mm             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      |                                 |                             | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | juuro-ku-kai                    | om_juuro-ku-kai_198x275mm   | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | pa-kai                          | om_pa-kai_267x389mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | dai-pa-kai                      | om_dai-pa-kai_275x395mm     | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | prc10 (envelope)                | prc_10_324x458mm            | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /*                    Table 8 - Other Metric Standard Sheet Media Sizes                             */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* | Legacy Name           | Ref. | Alias(common name)              | Self-Describing Name(mm)    | */
        /* |=======================|======|=================================|=============================| */
        /* |                       |      | small-photo                     | om_small-photo_100x150mm    | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | Italian (envelope)              | om_italian_110x230mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | Postfix (envelope)              | om_postfix_114x229mm        | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | large-photo                     | om_large-photo_200x300mm    | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | folio 2                         | om_folio_210x330mm          | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | folio-sp                        | om_folio-sp_215x315mm       | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /* |                       |      | Invite (envelope)               | om_invite_220x220mm         | */
        /* |-----------------------|------|---------------------------------|-----------------------------| */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {

    PWG_MEDIA_SIZE_NAME_RESERVED_0       =  0,
    PWG_MEDIA_SIZE_NAME_RESERVED_1       =  1,
    PWG_MEDIA_SIZE_NAME_UNKNOWN          =  2,

  /* North American Standard Sheet Media Sizes                                                      */
    PWG_MEDIA_SIZE_NAME_NA_START                  = 100,

    PWG_MEDIA_SIZE_NAME_NA_INDEX_3X5_3X5IN        = 100,
    PWG_MEDIA_SIZE_NAME_NA_PERSONAL_3o625X6o5IN,
    PWG_MEDIA_SIZE_NAME_NA_MONARCH_3o875X7o5IN,
    PWG_MEDIA_SIZE_NAME_NA_NUMBER_9_3o875X8o875IN,
    PWG_MEDIA_SIZE_NAME_NA_INDEX_4X6_4X6IN,
    PWG_MEDIA_SIZE_NAME_NA_NUMBER_10_4o125X9o5IN,
    PWG_MEDIA_SIZE_NAME_NA_A2_4o375X5o75IN,
    PWG_MEDIA_SIZE_NAME_NA_NUMBER_11_4o5X10o375IN,
    PWG_MEDIA_SIZE_NAME_NA_NUMBER_12_4o75X11IN,
    PWG_MEDIA_SIZE_NAME_NA_5X7_5X7IN,
    PWG_MEDIA_SIZE_NAME_NA_INDEX_5X8_5X8IN,
    PWG_MEDIA_SIZE_NAME_NA_NUMBER_14_5X11o5IN,
    PWG_MEDIA_SIZE_NAME_NA_INVOICE_5o5X8o5IN,
    PWG_MEDIA_SIZE_NAME_NA_INDEX_4X6_EXT_6X8IN,
    PWG_MEDIA_SIZE_NAME_NA_6X9_6X9IN,
    PWG_MEDIA_SIZE_NAME_NA_C5_6o5X9o5IN,
    PWG_MEDIA_SIZE_NAME_NA_7X9_7X9IN,
    PWG_MEDIA_SIZE_NAME_NA_EXECUTIVE_7o25X10o5IN,
    PWG_MEDIA_SIZE_NAME_NA_GOVT_LETTER_8X10IN,
    PWG_MEDIA_SIZE_NAME_NA_GOVT_LEGAL_8X13IN,
    PWG_MEDIA_SIZE_NAME_NA_QUARTO_8o5X10o83IN,
    PWG_MEDIA_SIZE_NAME_NA_LETTER_8o5X11IN,
    PWG_MEDIA_SIZE_NAME_NA_FANFOLD_EUR_8o5X12IN,
    PWG_MEDIA_SIZE_NAME_NA_LETTER_PLUS_8o5X12o69IN,
    PWG_MEDIA_SIZE_NAME_NA_FOOLSCAP_8o5X13IN,
    PWG_MEDIA_SIZE_NAME_NA_LEGAL_8o5X14IN,
    PWG_MEDIA_SIZE_NAME_NA_SUPER_A_8o94X14IN,
    PWG_MEDIA_SIZE_NAME_NA_9X11_9X11IN,
    PWG_MEDIA_SIZE_NAME_NA_ARCH_A_9X12IN,
    PWG_MEDIA_SIZE_NAME_NA_LETTER_EXTRA_9o5X12IN,
    PWG_MEDIA_SIZE_NAME_NA_LEGAL_EXTRA_9o5X15IN,
    PWG_MEDIA_SIZE_NAME_NA_10X11_10X11IN,
    PWG_MEDIA_SIZE_NAME_NA_10X13_10X13IN,
    PWG_MEDIA_SIZE_NAME_NA_10X14_10X14IN,
    PWG_MEDIA_SIZE_NAME_NA_10X15_10X15IN,
    PWG_MEDIA_SIZE_NAME_NA_11X12_11X12IN,
    PWG_MEDIA_SIZE_NAME_NA_EDP_11X14IN,
    PWG_MEDIA_SIZE_NAME_NA_FANFOLD_US_11X14o875IN,
    PWG_MEDIA_SIZE_NAME_NA_11X15_11X15IN,
    PWG_MEDIA_SIZE_NAME_NA_LEDGER_11X17IN,
    PWG_MEDIA_SIZE_NAME_NA_EUR_EDP_12X14IN,
    PWG_MEDIA_SIZE_NAME_NA_ARCH_B_12X18IN,
    PWG_MEDIA_SIZE_NAME_NA_12X19_12X19IN,
    PWG_MEDIA_SIZE_NAME_NA_B_PLUS_12X19o17IN,
    PWG_MEDIA_SIZE_NAME_NA_SUPER_B_13X19IN,
    PWG_MEDIA_SIZE_NAME_NA_C_17X22IN,
    PWG_MEDIA_SIZE_NAME_NA_ARCH_C_18X24IN,
    PWG_MEDIA_SIZE_NAME_NA_D_22X34IN,
    PWG_MEDIA_SIZE_NAME_NA_ARCH_D_24X36IN,
    PWG_MEDIA_SIZE_NAME_ASME_F_28X40IN,
    PWG_MEDIA_SIZE_NAME_NA_WIDE_FORMAT_30X42IN,
    PWG_MEDIA_SIZE_NAME_NA_E_34X44IN,
    PWG_MEDIA_SIZE_NAME_NA_ARCH_E_36X48IN,
    PWG_MEDIA_SIZE_NAME_NA_F_44X68IN,

    PWG_MEDIA_SIZE_NAME_NA_END,
  /*  PWG_NA_END to 199 are reserved                                                                */

  /* Chinese Standard Sheet Media Inch Sizes                                                        */
    PWG_MEDIA_SIZE_NAME_ROC_START             = 200,

    PWG_MEDIA_SIZE_NAME_ROC_16K_7o75X10o75IN  = 200,
    PWG_MEDIA_SIZE_NAME_ROC_8K_10o75X15o5IN,
    PWG_MEDIA_SIZE_NAME_PRC_32K_97X151MM,
    PWG_MEDIA_SIZE_NAME_PRC_1_102X165MM,
    PWG_MEDIA_SIZE_NAME_PRC_2_102X176MM,
    PWG_MEDIA_SIZE_NAME_PRC_4_110X208MM,
    PWG_MEDIA_SIZE_NAME_PRC_5_110X220MM,
    PWG_MEDIA_SIZE_NAME_PRC_8_120X309MM,
    PWG_MEDIA_SIZE_NAME_PRC_6_120X320MM,
    PWG_MEDIA_SIZE_NAME_PRC_3_125X176MM,
    PWG_MEDIA_SIZE_NAME_PRC_16K_146X215MM,
    PWG_MEDIA_SIZE_NAME_PRC_7_160X230MM,
    PWG_MEDIA_SIZE_NAME_OM_JUURO_KU_KAI_198X275MM,
    PWG_MEDIA_SIZE_NAME_OM_PA_KAI_267X389MM,
    PWG_MEDIA_SIZE_NAME_OM_DAI_PA_KAI_275X395MM,
    PWG_MEDIA_SIZE_NAME_PRC_10_324X458MM,

    PWG_MEDIA_SIZE_NAME_ROC_END,
  /*  PWG_ROC_END to 299 are reserved                                                               */

  /* ISO Standard Sheet Media Sizes                                                                 */
    PWG_MEDIA_SIZE_NAME_ISO_START                  = 300,

    PWG_MEDIA_SIZE_NAME_ISO_A10_26X37MM            = 300,
    PWG_MEDIA_SIZE_NAME_ISO_A9_37X52MM,
    PWG_MEDIA_SIZE_NAME_ISO_A8_52X74MM,
    PWG_MEDIA_SIZE_NAME_ISO_A7_74X105MM,
    PWG_MEDIA_SIZE_NAME_ISO_A6_105X148MM,
    PWG_MEDIA_SIZE_NAME_ISO_A5_148X210MM,
    PWG_MEDIA_SIZE_NAME_ISO_A5_EXTRA_174X235MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4_210X297MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4_TAB_225X297MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4_EXTRA_235o5X322o3MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3_297X420MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X3_297X630MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X4_297X841MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X5_297X1051MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X6_297X1261MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X7_297X1471MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X8_297X1682MM,
    PWG_MEDIA_SIZE_NAME_ISO_A4X9_297X1892MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3_EXTRA_322X445MM,
    PWG_MEDIA_SIZE_NAME_ISO_A2_420X594MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3X3_420X891MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3X4_420X1189MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3X5_420X1486MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3X6_420X1783MM,
    PWG_MEDIA_SIZE_NAME_ISO_A3X7_420X2080MM,
    PWG_MEDIA_SIZE_NAME_ISO_A1_594X841MM,
    PWG_MEDIA_SIZE_NAME_ISO_A2X3_594X1261MM,
    PWG_MEDIA_SIZE_NAME_ISO_A2X4_594X1682MM,
    PWG_MEDIA_SIZE_NAME_ISO_A2X5_594X2102MM,
    PWG_MEDIA_SIZE_NAME_ISO_A0_841X1189MM,
    PWG_MEDIA_SIZE_NAME_ISO_A1X3_841X1783MM,
    PWG_MEDIA_SIZE_NAME_ISO_A1X4_841X2378MM,
    PWG_MEDIA_SIZE_NAME_ISO_2A0_1189X1682MM,
    PWG_MEDIA_SIZE_NAME_ISO_A0X3_1189X2523MM,
    PWG_MEDIA_SIZE_NAME_ISO_B10_31X44MM,
    PWG_MEDIA_SIZE_NAME_ISO_B9_44X62MM,
    PWG_MEDIA_SIZE_NAME_ISO_B8_62X88MM,
    PWG_MEDIA_SIZE_NAME_ISO_B7_88X125MM,
    PWG_MEDIA_SIZE_NAME_ISO_B6_125X176MM,
    PWG_MEDIA_SIZE_NAME_ISO_B6C4_125X324MM,
    PWG_MEDIA_SIZE_NAME_ISO_B5_176X250MM,
    PWG_MEDIA_SIZE_NAME_ISO_B5_EXTRA_201X276MM,
    PWG_MEDIA_SIZE_NAME_ISO_B4_250X353MM,
    PWG_MEDIA_SIZE_NAME_ISO_B3_353X500MM,
    PWG_MEDIA_SIZE_NAME_ISO_B2_500X707MM,
    PWG_MEDIA_SIZE_NAME_ISO_B1_707X1000MM,
    PWG_MEDIA_SIZE_NAME_ISO_B0_1000X1414MM,
    PWG_MEDIA_SIZE_NAME_ISO_C10_28X40MM,
    PWG_MEDIA_SIZE_NAME_ISO_C9_40X57MM,
    PWG_MEDIA_SIZE_NAME_ISO_C8_57X81MM,
    PWG_MEDIA_SIZE_NAME_ISO_C7_81X114MM,
    PWG_MEDIA_SIZE_NAME_ISO_C7C6_81X162MM,
    PWG_MEDIA_SIZE_NAME_ISO_C6_114X162MM,
    PWG_MEDIA_SIZE_NAME_ISO_C6C5_114X229MM,
    PWG_MEDIA_SIZE_NAME_ISO_C5_162X229MM,
    PWG_MEDIA_SIZE_NAME_ISO_C4_229X324MM,
    PWG_MEDIA_SIZE_NAME_ISO_C3_324X458MM,
    PWG_MEDIA_SIZE_NAME_ISO_C2_458X648MM,
    PWG_MEDIA_SIZE_NAME_ISO_C1_648X917MM,
    PWG_MEDIA_SIZE_NAME_ISO_C0_917X1297MM,
    PWG_MEDIA_SIZE_NAME_ISO_DL_110X220MM,
    PWG_MEDIA_SIZE_NAME_ISO_RA2_430X610MM,
    PWG_MEDIA_SIZE_NAME_ISO_SRA2_450X640MM,
    PWG_MEDIA_SIZE_NAME_ISO_RA1_610X860MM,
    PWG_MEDIA_SIZE_NAME_ISO_SRA1_640X900MM,
    PWG_MEDIA_SIZE_NAME_ISO_RA0_860X1220MM,
    PWG_MEDIA_SIZE_NAME_ISO_SRA0_900X1280MM,

    PWG_MEDIA_SIZE_NAME_ISO_END,
  /*  PWG_ISO_END to 399 are reserved                                                               */

  /* Japanese Standard Sheet Media Sizes                                                            */
    PWG_MEDIA_SIZE_NAME_JIS_START                  = 400,

    PWG_MEDIA_SIZE_NAME_JIS_B10_32X45MM            = 400,
    PWG_MEDIA_SIZE_NAME_JIS_B9_45X64MM,
    PWG_MEDIA_SIZE_NAME_JIS_B8_64X91MM,
    PWG_MEDIA_SIZE_NAME_JIS_B7_91X128MM,
    PWG_MEDIA_SIZE_NAME_JIS_B6_128X182MM,
    PWG_MEDIA_SIZE_NAME_JIS_B5_182X257MM,
    PWG_MEDIA_SIZE_NAME_JIS_B4_257X364MM,
    PWG_MEDIA_SIZE_NAME_JIS_B3_364X515MM,
    PWG_MEDIA_SIZE_NAME_JIS_B2_515X728MM,
    PWG_MEDIA_SIZE_NAME_JIS_B1_728X1030MM,
    PWG_MEDIA_SIZE_NAME_JIS_B0_1030X1456MM,
    PWG_MEDIA_SIZE_NAME_JIS_EXEC_216X330MM,
    PWG_MEDIA_SIZE_NAME_JPN_CHOU4_90X205MM,
    PWG_MEDIA_SIZE_NAME_JPN_HAGAKI_100X148MM,
    PWG_MEDIA_SIZE_NAME_JPN_YOU4_105X235MM,
    PWG_MEDIA_SIZE_NAME_JPN_CHOU2_111o1X146MM,
    PWG_MEDIA_SIZE_NAME_JPN_CHOU3_120X235MM,
    PWG_MEDIA_SIZE_NAME_JPN_OUFUKU_148X200MM,
    PWG_MEDIA_SIZE_NAME_JPN_KAHU_240X322o1MM,
    PWG_MEDIA_SIZE_NAME_JPN_KAKU2_240X332MM,

    PWG_MEDIA_SIZE_NAME_JIS_END,
  /*  PWG_JIS_END to 499 are reserved                                                               */

  /* Other Metric Standard Sheet Media Sizes                                                        */
    PWG_MEDIA_SIZE_NAME_OM_START                  = 500,

    PWG_MEDIA_SIZE_NAME_OM_SMALL_PHOTO_100X150MM  = 500,
    PWG_MEDIA_SIZE_NAME_OM_ITALIAN_110X230MM,
    PWG_MEDIA_SIZE_NAME_OM_POSTFIX_114X229MM,
    PWG_MEDIA_SIZE_NAME_OM_LARGE_PHOTO_200X300MM,
    PWG_MEDIA_SIZE_NAME_OM_FOLIO_210X330MM,
    PWG_MEDIA_SIZE_NAME_OM_FOLIO_SP_215X315MM,
    PWG_MEDIA_SIZE_NAME_OM_INVITE_220X220MM,

    PWG_MEDIA_SIZE_NAME_OM_END,
  /*  PWG_OOM_END to 599 are reserved                                                               */

  /* Vendor Extensions for Sheet "Media Size Name" (MSN)                                            */
    PWG_MEDIA_SIZE_NAME_VENDOR_MSN_START              = 600,

    VND_MEDIA_SIZ_NAM_ENUM

    PWG_MEDIA_SIZE_NAME_VENDOR_MSN_END,
  /*  PWG_OOM_END to 699 are reserved                                                               */


    PWG_MEDIA_SIZE_NAME_END
} pwgMediaSizeNameEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Source                                                                                             */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaSource                    */
/* -----------------                                                                                        */
/* Specifies the input tray, slot, roll, or other source for the media.                                     */
/* [PWG 5100.13] §7.4.5                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §7.6.5 [page 61-63] media-source (type3 keyword | name(MAX))                                    */
    /* -----------------                                                                                    */
    /* The RECOMMENDED "media-source" member attribute specifies the input tray, slot, roll, or other       */
    /* source for the media. Printers MUST support this member attribute when the "media-source-properties" */
    /* member attribute (section 7.6.6) or "printer-input-tray" Printer attribute (section 5.6.32) are      */
    /* supported.                                                                                           */
    /*                                                                                                      */
    /* The standard keyword values are shown in Table 14.                                                   */
    /*                                                                                                      */
    /*      Note: The name "media-source" was chosen over "media-input-tray" since the values               */
    /*            represent more than trays. However, the "printer-input-tray" Printer attribute            */
    /*            (section 5.6.32) retains the input tray name because it provides access to                */
    /*            Printer MIB [RFC3805] properties of the same name.                                        */
    /*                                                                                                      */
    /*                              Table 14 - "media-source" Keyword Values                                 */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | Keyword         | Description                               |                       */
    /*                |=================|===========================================|                       */
    /*                | alternate       | The alternate or secondary input tray     |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | alternate-roll  | The alternate or secondary roll           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | auto            | The Printer's automatic choice            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | bottom          | The bottom input tray                     |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | by-pass-tray    | The by-pass tray                          |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | center          | The center feed slot/tray                 |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | disc            | The CD/DVD/Bluray disc feed slot/tray     |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | envelope        | The envelope feed slot/tray               |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | hagaki          | The Hagaki feed slot/tray                 |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | large-capacity  | The large capacity input tray             |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | left            | The left feed slot/tray                   |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | main            | The main or primary input tray            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | main-roll       | The main or primary roll                  |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | manual          | The manual feed slot                      |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | middle          | The middle input tray                     |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | photo           | The photo feed slot/tray                  |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | rear            | The rear feed slot/tray                   |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | right           | The right feed slot/tray                  |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-1          | The first roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-2          | The second roll                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-3          | The third roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-4          | The fourth roll                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-5          | The fifth roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-6          | The sixth roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-7          | The seventh roll                          |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-8          | The eighth roll                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-9          | The ninth roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | roll-10         | The tenth roll                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | side            | The side feed slot/tray                   |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | top             | The topmost input tray                    |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-1          | The first tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-2          | The second tray                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-3          | The third tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-4          | The fourth tray                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-5          | The fifth tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-6          | The sixth tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-7          | The seventh tray                          |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-8          | The eighth tray                           |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-9          | The ninth tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-10         | The tenth tray                            |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-11         | The eleventh tray                         |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-12         | The twelfth tray                          |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-13         | The thirteenth tray                       |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-14         | The fourteenth tray                       |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-15         | The fifteenth tray                        |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-16         | The sixteenth tray                        |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-17         | The seventeenth tray                      |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-18         | The eighteenth tray                       |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-19         | The nineteenth tray                       |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                | tray-20         | The twentieth tray                        |                       */
    /*                |-----------------|-------------------------------------------|                       */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                     */
        /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)  */
        /*      §7.6.6 [page 63] media-source-properties (collection)                                       */
        /* -----------------                                                                                */
        /* The RECOMMENDED "media-source-properties" member attribute is provided in the                    */
        /* "media-col-database" and "media-col-ready" collections to describe the media path and natural    */
        /* orientation for the specified collection. For example, when printing an envelope or form it is   */
        /* important to know which orientation to use for the document data.                                */
        /*                                                                                                  */
        /* Printers MUST support this member attribute when the "media-source" member attribute             */
        /* (section 7.6.5) or "printer-input-tray" Printer attribute (section 5.6.32) are supported.        */
        /*                                                                                                  */
        /* When supported, Clients SHOULD use "media-col-ready" instead of "media-col-database" since the   */
        /* latter includes all possible media combinations, including potentially multiple instances of the */
        /* same media with different "media-source-properties" values.                                      */
        /*                                                                                                  */
        /* This member attribute MUST NOT be included in the "media-col" Job Template attribute since it is */
        /* informational rather than specifying intent.                                                     */
        /*                                                                                                  */
        /* 7.6.6.1 media-source-feed-direction (type2 keyword)                                              */
        /* The "media-source-feed-direction" member attribute of "media-source-properties" defines whether  */
        /* the long edge ('long-edge-first') or short edge ('short-edge-first') of the media is pulled from */
        /* the source.                                                                                      */
        /*                                                                                                  */
        /* 7.6.6.2 media-source-feed-orientation (type2 enum)                                               */
        /* The "media-source-feed-orientation" member attribute of "media-source-properties" defines the    */
        /* orientation of the media as pulled from the source. The value is an "orientation-requested"      */
        /* enumeration.                                                                                     */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_SOURCE_RESERVED_0       =  0,
    PWG_MEDIA_SOURCE_RESERVED_1       =  1,
    PWG_MEDIA_SOURCE_UNKNOWN          =  2,

    PWG_MEDIA_SOURCE_ALTERNATE,
    PWG_MEDIA_SOURCE_ALTERNATE_ROLL,
    PWG_MEDIA_SOURCE_AUTO,
    PWG_MEDIA_SOURCE_BOTTOM,
    PWG_MEDIA_SOURCE_BY_PASS_TRAY,
    PWG_MEDIA_SOURCE_CENTER,
    PWG_MEDIA_SOURCE_DISC,
    PWG_MEDIA_SOURCE_ENVELOPE,
    PWG_MEDIA_SOURCE_HAGAKI,
    PWG_MEDIA_SOURCE_LARGE_CAPACITY,
    PWG_MEDIA_SOURCE_LEFT,
    PWG_MEDIA_SOURCE_MAIN,
    PWG_MEDIA_SOURCE_MAIN_ROLL,
    PWG_MEDIA_SOURCE_MANUAL,
    PWG_MEDIA_SOURCE_MIDDLE,
    PWG_MEDIA_SOURCE_PHOTO,
    PWG_MEDIA_SOURCE_REAR,
    PWG_MEDIA_SOURCE_RIGHT,
    PWG_MEDIA_SOURCE_ROLL_1,
    PWG_MEDIA_SOURCE_ROLL_2,
    PWG_MEDIA_SOURCE_ROLL_3,
    PWG_MEDIA_SOURCE_ROLL_4,
    PWG_MEDIA_SOURCE_ROLL_5,
    PWG_MEDIA_SOURCE_ROLL_6,
    PWG_MEDIA_SOURCE_ROLL_7,
    PWG_MEDIA_SOURCE_ROLL_8,
    PWG_MEDIA_SOURCE_ROLL_9,
    PWG_MEDIA_SOURCE_ROLL_10,
    PWG_MEDIA_SOURCE_SIDE,
    PWG_MEDIA_SOURCE_TOP,
    PWG_MEDIA_SOURCE_TRAY_1,
    PWG_MEDIA_SOURCE_TRAY_2,
    PWG_MEDIA_SOURCE_TRAY_3,
    PWG_MEDIA_SOURCE_TRAY_4,
    PWG_MEDIA_SOURCE_TRAY_5,
    PWG_MEDIA_SOURCE_TRAY_6,
    PWG_MEDIA_SOURCE_TRAY_7,
    PWG_MEDIA_SOURCE_TRAY_8,
    PWG_MEDIA_SOURCE_TRAY_9,
    PWG_MEDIA_SOURCE_TRAY_10,
    PWG_MEDIA_SOURCE_TRAY_11,
    PWG_MEDIA_SOURCE_TRAY_12,
    PWG_MEDIA_SOURCE_TRAY_13,
    PWG_MEDIA_SOURCE_TRAY_14,
    PWG_MEDIA_SOURCE_TRAY_15,
    PWG_MEDIA_SOURCE_TRAY_16,
    PWG_MEDIA_SOURCE_TRAY_17,
    PWG_MEDIA_SOURCE_TRAY_18,
    PWG_MEDIA_SOURCE_TRAY_19,
    PWG_MEDIA_SOURCE_TRAY_20,

    VND_MEDIA_SRC_ENUM

    PWG_MEDIA_SOURCE_END
} pwgMediaSourceEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Tooth                                                                                              */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaTooth                     */
/* -----------------                                                                                        */
/* The tooth (or roughness) of the media.                                                                   */
/* [PWG5100.11] §11.5.1                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §11.5.1 [page 70-71] media-tooth (type3 keyword | name(MAX))                                */
        /* -----------------                                                                                */
        /* The "media-tooth" member attribute indicates the desired tooth (or roughness) of the media being */
        /* specified.  The source for this attribute is [ISO10175].                                         */
        /*                                                                                                  */
        /* The tooth of a medium is particularly important for those marking engines that use pens (e.g.    */
        /* plotters) to mark the medium.  The type of pen used shall match the tooth of the medium for best */
        /* resolution.                                                                                      */
        /*                                                                                                  */
        /* Standard keyword values for "media-tooth" are:                                                   */
        /*                                                                                                  */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | Keyword         | Description                                                           | */
        /*      |=================|=======================================================================| */
        /*      | 'antique'       | Rougher than vellum surface                                           | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'calendared'    | Extra smooth or polished, uncoated paper                              | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'coarse'        | The specified media should have a coarse tooth or rough finish.       | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'fine'          | The specified media should have a fine tooth or smooth finish.        | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'linen'         | Texture of coarse woven cloth                                         | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'medium'        | The specified media should have a medium tooth or regular finish.     | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'smooth'        | Smooth                                                                | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'stipple'       | Fine pebble finish                                                    | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*      | 'uncalendared'  | Rough, unpolished and uncoated papers                                 | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      | 'vellum'        | Slightly rough surface                                                | */
        /*      |                 |     - from [JDF1.4] Media/@Texture attribute.                         | */
        /*      |-----------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* The Administrator can define a custom media tooth using the 'name' (MAX) attribute syntax of the */
        /* "media-tooth-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute.  Note: as with   */
        /* other Job Template and member attributes, the user can also supply user-defined tooth names that */
        /* are not among the values of the "media-tooth-supported" Printer attribute, if the Administrator  */
        /* has configured the Printer's "user-defined-values-supported" attribute (see [PWG5100.3]) to      */
        /* contain the 'media-tooth' attribute keyword value.                                               */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_TOOTH_RESERVED_0       =  0,
    PWG_MEDIA_TOOTH_RESERVED_1       =  1,
    PWG_MEDIA_TOOTH_UNKNOWN          =  2,

    PWG_MEDIA_TOOTH_ANTIQUE,
    PWG_MEDIA_TOOTH_CALENDARED,
    PWG_MEDIA_TOOTH_COARSE,
    PWG_MEDIA_TOOTH_FINE,
    PWG_MEDIA_TOOTH_LINEN,
    PWG_MEDIA_TOOTH_MEDIUM,
    PWG_MEDIA_TOOTH_SMOOTH,
    PWG_MEDIA_TOOTH_STIPPLE,
    PWG_MEDIA_TOOTH_UNCALENDARED,
    PWG_MEDIA_TOOTH_VELLUM,

    VND_MEDIA_TTH_ENUM

    PWG_MEDIA_TOOTH_END
} pwgMediaToothEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Type                                                                                               */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 55] MediaType                      */
/* -----------------                                                                                        */
/* The medium type that the PrintService uses for all impressions.                                          */
/* [PWG5101.1] §3                                                                                           */
/* [WS-Print]  §3.5.2.3.2                                                                                   */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5101.1] February 26, 2002: Candidate Standard 5101.1-2001                                   */
        /*                                           Standard for Media Standardized Names                  */
        /*      §3 [page 7-8] Media Type Names                                                              */
        /* -----------------                                                                                */
        /* The standardized Media Type Names are defined in Table 1.  The base set of these names is        */
        /* derived from the Printer MIB [PRT-MIB] and "Media Features for Display, Print, and Fax"          */
        /* [FEATURES] documents. Additional values MAY be registered according to both [TAG-REG] and        */
        /* [IPP-MOD].                                                                                       */
        /*                                                                                                  */
        /* For Media Types that produced using a coating or special process, the coating or process may     */
        /* only be applied to one side.  The Media Type Names defined in this standard do not define either */
        /* one sided or two sided conditions.  For situations where this information needs to be presented, */
        /* an implementation specific method  must be used.                                                 */
        /*                                                                                                  */
        /* The Ref column indicates the source document(s) for the name.                                    */
        /*                                                                                                  */
        /*      1  =  The Printer MIB [PRT-MIB].                                                            */
        /*      3  =  Media Features for Display, Print, and Fax [FEATURES].                                */
        /*      5  =  IPP Production Printing Attributes [IPP-PROD]                                         */
        /*                The name in this document is derived from the "media-front-coating" and           */
        /*                "media-back-coating" member attributes by adding the 'photographic-' prefix to    */
        /*                the IPP keyword values.                                                           */
        /*      6  =  IPP Production Printing Attributes [IPP-PROD]                                         */
        /*                The name in this document is derived from the "media-pre-printed" member          */
        /*                attributes by adding the 'stationery-' prefix to the IPP keyword values.          */
        /*                                                                                                  */
        /*                      Table 1  - Standardized Media Type Names  (part 1)                          */
        /*                                                                                                  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | Keyword                  | Description                                               | Ref. |  */
        /* |==========================|===========================================================|======|  */
        /* | stationery               | Separately cut sheets of an opaque material               | 1, 3 |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-coated        | Separately cut sheets of an opaque material with a        |      |  */
        /* |                          |     coating of unspecified type                           |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-inkjet        | Separately cut sheets of an opaque material designed to   |      |  */
        /* |                          |     minimize the spread of liquid inks.  May be           |      |  */
        /* |                          |     accomplished using a coating                          |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-preprinted    | Separately cut sheets of an opaque material with a        | 6    |  */
        /* |                          |     preprinted image.                                     |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-letterhead    | Separately cut sheets of an opaque material with a        | 6    |  */
        /* |                          |     preprinted letterhead.                                |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-prepunched    | Separately cut sheets of an opaque material that are      |      |  */
        /* |                          |     punched with an unspecified hole pattern.             |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-fine          | Separately cut sheets of vellum or other high quality     |      |  */
        /* |                          |     opaque material.                                      |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-heavyweight   | Separately cut sheets of a heavy stock opaque material.   |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | stationery-lightweight   | Separately cut sheets of a light stock opaque material.   |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | transparency             | Separately cut sheets of a transparent material           | 1, 3 |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | envelope                 | Envelopes that can be used for conventional mailing       | 1, 3 |  */
        /* |                          |     purposes                                              |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | envelope-plain           | Envelopes that are not preprinted and have no windows     | 1, 3 |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | envelope-window          | Envelopes that have windows for addressing purposes       | 1    |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | continuous               | Continuously connected sheets of an opaque material       | 3    |  */
        /* |                          |     - which edge is connected is not specified            |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | continuous-long          | Continuously connected sheets of an opaque material       | 1    |  */
        /* |                          |     connected along the long edge                         |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | continuous-short         | Continuously connected sheets of an opaque material       | 1    |  */
        /* |                          |     connected along the short edge                        |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | tab-stock                | Media with tabs (either pre-cut or full-cut)              | 1    |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | pre-cut-tabs             | Media with tabs that are cut so that more than one tab is |      |  */
        /* |                          |     visible extending out beyond the edge of non-tabbed   |      |  */
        /* |                          |     media in an Output-Document.                          |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | full-cut-tabs            | Media with a tab that runs the full length of the sheet   |      |  */
        /* |                          |     so  that only one tab is visible extending out beyond |      |  */
        /* |                          |     the edge of non-tabbed media in an Output-Document.   |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | multi-part-form          | Form medium composed of multiple layers not pre-attached  | 1    |  */
        /* |                          |     to one another; each sheet may be drawn separately    |      |  */
        /* |                          |     from an input source                                  |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | labels                   | Label stock (For example, a sheet of peel-off labels).    | 1    |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | multi-layer              | Form medium composed of multiple layers which are         | 1    |  */
        /* |                          |     pre-attached to one another; e.g., for use with       |      |  */
        /* |                          |     impact printers.                                      |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | screen                   | A refreshable display                                     | 3    |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | screen-paged             | A refreshable display which cannot scroll                 | 3    |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic             | Separately cut sheets of an opaque material to produce    |      |  */
        /* |                          |     photographic quality images.  The coating is          |      |  */
        /* |                          |     unspecified.                                          |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-glossy      | Separately cut sheets of an opaque material that has a    | 5    |  */
        /* |                          |     "glossy" coating to produce photographic quality      |      |  */
        /* |                          |     images.                                               |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-high-gloss  | Separately cut sheets of an opaque material that has a    | 5    |  */
        /* |                          |     "high-gloss" coating to produce photographic quality  |      |  */
        /* |                          |     images.                                               |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-semi-gloss  | Separately cut sheets of an opaque material that has a    | 5    |  */
        /* |                          |     "semi-gloss" coating to produce photographic quality  |      |  */
        /* |                          |     images.                                               |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-satin       | Separately cut sheets of an opaque material that has a    | 5    |  */
        /* |                          |     "satin" coating to produce photographic quality       |      |  */
        /* |                          |     images.                                               |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-matte       | Separately cut sheets of an opaque material that has a    | 5    |  */
        /* |                          |     "matte" coating to produce photographic quality       |      |  */
        /* |                          |     images.                                               |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | photographic-film        | Separately cut sheets of film used to produce             |      |  */
        /* |                          |     photographic quality images.                          |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | back-print-film          | Separately cut sheet of a translucent film that the user  |      |  */
        /* |                          |     can view with or without backlighting.                |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | cardstock                | Separately cut sheets of a heavier or stiffer opaque      |      |  */
        /* |                          |     material than stationery                              |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /* | roll                     | A continuous roll of media with no predefined page        |      |  */
        /* |                          |     separation points.                                    |      |  */
        /* |--------------------------|-----------------------------------------------------------|------|  */
        /*                                                                                                  */
        /* 3.1 Custom Media Type Names                                                                      */
        /* Media Type Names may be locally extended using a Custom Media Type Name, without an update to    */
        /* this specification.  The format is defined by the following ABNF:                                */
        /*                                                                                                  */
        /*    custom-media-type-name = "custom-media-type-" type-name                                       */
        /*                                                                                                  */
        /*        type-name = lowalpha *( lowalpha | digit | "-" )                                          */
        /*        lowalpha  = "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" |                         */
        /*                    "j" | "k" | "l" | "m" | "n" | "o" | "p" | "q" | "r" |                         */
        /*                    "s" | "t" | "u" | "v" | "w" | "x" | "y" | "z"                                 */
        /*        digit     = "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"                     */
        /*                                                                                                  */
        /* Example, preprinted stationery for company XYZ:   custom-media-type-xyz-letterhead               */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [WSDPrintService] November 9, 2009: Version 1.0                                                  */
        /*                       Print Service Definition Version 1.0                                       */
        /*      §3.5.2.3 [page 38] MediaType                                                                */
        /* -----------------                                                                                */
        /* Microsoft Copyright will not allow content to be copied here.                                    */
        /* ................................................................................................ */
        /*      §3.3.4.1.5 [page 24] MediaType                                                              */
        /* -----------------                                                                                */
        /* Microsoft Copyright will not allow content to be copied here.                                    */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef enum {
    PWG_MEDIA_TYPE_RESERVED_0       =  0,
    PWG_MEDIA_TYPE_RESERVED_1       =  1,
    PWG_MEDIA_TYPE_UNKNOWN          =  2,

    PWG_MEDIA_TYPE_STATIONERY,
    PWG_MEDIA_TYPE_STATIONERY_COATED,
    PWG_MEDIA_TYPE_STATIONERY_INKJET,
    PWG_MEDIA_TYPE_STATIONERY_PREPRINTED,
    PWG_MEDIA_TYPE_STATIONERY_LETTERHEAD,
    PWG_MEDIA_TYPE_STATIONERY_PREPUNCHED,
    PWG_MEDIA_TYPE_STATIONERY_FINE,
    PWG_MEDIA_TYPE_STATIONERY_HEAVYWEIGHT,
    PWG_MEDIA_TYPE_STATIONERY_LIGHTWEIGHT,
    PWG_MEDIA_TYPE_TRANSPARENCY,
    PWG_MEDIA_TYPE_ENVELOPE,
    PWG_MEDIA_TYPE_ENVELOPE_PLAIN,
    PWG_MEDIA_TYPE_ENVELOPE_WINDOW,
    PWG_MEDIA_TYPE_CONTINUOUS,
    PWG_MEDIA_TYPE_CONTINUOUS_LONG,
    PWG_MEDIA_TYPE_CONTINUOUS_SHORT,
    PWG_MEDIA_TYPE_TAB_STOCK,
    PWG_MEDIA_TYPE_PRE_CUT_TABS,
    PWG_MEDIA_TYPE_FULL_CUT_TABS,
    PWG_MEDIA_TYPE_MULTI_PART_FORM,
    PWG_MEDIA_TYPE_LABELS,
    PWG_MEDIA_TYPE_MULTI_LAYER,
    PWG_MEDIA_TYPE_SCREEN,
    PWG_MEDIA_TYPE_SCREEN_PAGED,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_GLOSSY,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_HIGH_GLOSS,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_SEMI_GLOSS,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_SATIN,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_MATTE,
    PWG_MEDIA_TYPE_PHOTOGRAPHIC_FILM,
    PWG_MEDIA_TYPE_BACK_PRINT_FILM,
    PWG_MEDIA_TYPE_CARDSTOCK,
    PWG_MEDIA_TYPE_ROLL,

    VND_MEDIA_TYP_ENUM

    PWG_MEDIA_TYPE_END
} pwgMediaTypeEnum;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Input Tray Check                                                                                   */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaInputTrayCheck            */
/* -----------------                                                                                        */
/* Indicates that the characteristics of the media in the identified input tray must match the              */
/* characteristics of the media identified by the "media" or "media-col"  element.                          */
/* [PWG5100.3] §3.14                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                         Internet Printing Protocol(IPP): Production Printing Attributes - Set1   */
        /*      §3.14 [page 48-49] media-input-tray-check (type3 keyword | name(MAX))                       */
        /* -----------------                                                                                */
        /* The "media-input-tray-check" Job Template attribute indicates that the Printer MUST check that   */
        /* the characteristics of the media in the identified input tray are the same as characteristics of */
        /* the media identified by the Job's "media" Job Template attribute or matched (see section 3.13)   */
        /* by the Job's "media-col" Job Template attribute.  The keyword values are the same input tray     */
        /* keyword values as are defined for the "media" Job Template attribute (see section 6.3 in this    */
        /* document and [RFC2911] Appendix C), i.e., 'top', 'middle', 'bottom', etc.                        */
        /*                                                                                                  */
        /* Independent of the "ipp-attributes-fidelity" operation attribute supplied by the client, if the  */
        /* characteristics differ, the Printer adds the 'resources-are-not-ready' value (see section 6.1)   */
        /* to the job's "job-state-reasons" attribute and MAY either (1) put the job into the               */
        /* 'pending-held' state or (2) start to process the job normally, but immediately stop the job      */
        /* ("job-state" = 'processing-stopped') and the Printer ("printer-state" = 'stopped').  In either   */
        /* implementation, the operator can change the media in the input tray to agree with the job or can */
        /* modify the job's "media" or "media-col" attributes to agree with the input tray, depending on    */
        /* policy.                                                                                          */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                  Internet Printing Protocol(IPP): Production Printing Attributes - Set1      */
            /*      §6.3 [page 68-70] Additional values for the IPP "media" Job Template and "media-key"    */
            /*                        member attributeS                                                     */
            /* -----------------                                                                            */
            /* This section defines additional values for the "media" (type3 keyword | name(MAX)) Job       */
            /* Template attribute (see [RFC2911] section 4.2.11), the "media" member attribute defined in   */
            /* this document in a number of the collection attributes, and the "media-key" member attribute */
            /* defined in section 3.13.1.                                                                   */
            /*                                                                                              */
            /* If the Printer implementation supports the use of tray name keywords to identify media,      */
            /* there SHOULD be one and only one keyword assigned for each input tray on the printer.  If    */
            /* multiple keywords for the same tray exist in "media-supported", the client UI could          */
            /* potentially become very confusing to the user because the Printer would appear to have more  */
            /* input trays than it actually has.  However, see the discussion in the Printer MIB [RFC1759]  */
            /* about a manual input tray that uses the same input slot as a regular input tray.  Also, if   */
            /* using tray names, it is RECOMMENDED that the printer implementation use the most descriptive */
            /* keyword for a logical tray in order to assist the user or operator to recognize the matching */
            /* physical tray at the printer.  There are three methods to choose the keyword: 1) If the      */
            /* printer trays aren't physically labeled, the keyword SHOULD best match the physical location */
            /* of the tray (e.g. 'top', 'bottom').  2) If the printer trays are physically labeled, the     */
            /* keyword SHOULD best match the label of the tray (e.g. 'tray-1', tray-2'),   3) If more than  */
            /* one keyword matches the label of the tray, the keyword SHOULD be used that best              */
            /* distinguishes the tray from the Printer's other trays.                                       */
            /*                                                                                              */
            /* If a Printer allows the media to be specified by tray name keyword, the Printer              */
            /* implementation MUST NOT use the 'name(MAX)' attribute syntax to create custom tray names,    */
            /* but rather MUST use the most appropriate tray name keyword value.  This ensures              */
            /* interoperability among clients that submit jobs to multiple types of printers.               */
            /*                                                                                              */
            /* These are additional standard keyword values defined for input-trays.                        */
            /*                                                                                              */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'bypass-tray'  | The specified tray is used for handling odd or special paper.  This  | */
            /*    |                | paper tray usually has a small capacity and is physically located    | */
            /*    |                | such that the paper travels through a shorter paper path.  In some   | */
            /*    |                | printer implementations, the 'bypass-tray' may also be used to       | */
            /*    |                | bypass any marking device and be used for insert sheets.  See the    | */
            /*    |                | "insert-sheet" definition in section 3.5.                            | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'tray-N'       | The input tray that is best specified as a tray with values          | */
            /*    |                | 'tray-1', 'tray-2'....  The correspondence between the 'tray-N'      | */
            /*    |                | keyword and the actual input-tray is implementation dependent, as is | */
            /*    |                | the number of input trays.  If this group of 'tray-N' values is      | */
            /*    |                | supported, at least the 'tray-1' value MUST be supported.            | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*                                                                                              */
            /* These additional keyword values are provided for use in implementations that don't support   */
            /* the "media-col" attribute, since they represent some of the more important "media-col"       */
            /* member attributes:                                                                           */
            /*                                                                                              */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'plain'        | The plain media as specified by the output device.                   | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'pre-punched'  | The pre-punched media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'transparency' | The transparent media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'letterhead'   | The pre-printed letterhead media as specified by the output device.  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'heavyweight'  | The heavyweight media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'recycled'     | The recycled media as specified by the output device.                | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'bond'         | The bonded media as specified by the output device.                  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'labels'       | The labels media as specified by the output device.                  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'pre-printed'  | The pre-printed media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'customN'      | A custom type of media understood by the user and the operator.  It  | */
            /*    |                | is simply specified to the Printer as the keyword values 'custom1',  | */
            /*    |                | 'custom2',...,'custom7'.                                             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*                                                                                              */
            /* These additional keyword values are the same as the "media-type" keywords (see               */
            /* section 3.13.2), except 'other', for use in implementations that don't support the           */
            /* "media-col" attribute:                                                                       */
            /*                                                                                              */
            /*    stationery                                                                                */
            /*    envelope                                                                                  */
            /*    envelope-plain                                                                            */
            /*    envelope-window                                                                           */
            /*    continuous                                                                                */
            /*    continuous-long                                                                           */
            /*    continuous-short                                                                          */
            /*    tab-stock                                                                                 */
            /*    pre-cut-tab                                                                               */
            /*    full-cut-tab                                                                              */
            /*    multi-part-form                                                                           */
            /*    multi-layer                                                                               */
            /*    screen                                                                                    */
            /*    screen-paged                                                                              */
            /*    photographic                                                                              */
            /*    cardstock                                                                                 */
            /*                                                                                              */
            /* These are additional standard keyword values which are used by the implementation for        */
            /* specifying a pre-defined media size:                                                         */
            /*                                                                                              */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'iso-a4-wide'       | Specifies the iso A4 cover size: 223 mm x 297 mm                | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'na-letter-cover'   | Specifies the letter cover size:  9 in x 11 in                  | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'jp-reply-postcard' | Specifies the Ofuku-Hagaki postcard size: 148 mm x 200 mm       | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'na-postcard'       | Specifies the North American postcard size: 4.5 in x 6 in       | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'taiwan-815'        | Specifies the 815 Taiwan size: 267 mm x 388 mm                  | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'iso-220x330'       | Specifies the 220 mm x 330 mm size                              | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §Appendix C [page 201] ONLY DATA FOR 'input-trays'                                      */
            /* -----------------                                                                            */
            /*  The following standard values are defined for input-trays (from ISO DPA and the Printer     */
            /* MIB):                                                                                        */
            /*                                                                                              */
            /*      'top'           : The top input tray in the printer.                                    */
            /*      'middle'        : The middle input tray in the printer.                                 */
            /*      'bottom'        : The bottom input tray in the printer.                                 */
            /*      'envelope'      : The envelope input tray in the printer.                               */
            /*      'manual'        : The manual feed input tray in the printer.                            */
            /*      'large-capacity': The large capacity input tray in the printer.                         */
            /*      'main'          : The main input tray                                                   */
            /*      'side'          : The side input tray                                                   */
            /*                                                                                              */
            /* ============================================================================================ */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: MediaInputTray for the PJT is called MediaSource; thus, MediaInputTrayCheck (which        */
/*                should really be MediaSourceCheck) has the values as MediaSource.  However, to prevent    */
/*                confusion with "Source" and "SourceCheck" the values will be repeated.                    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
typedef enum {
    PWG_MEDIA_INPUT_TRAY_CHECK_RESERVED_0       =  0,
    PWG_MEDIA_INPUT_TRAY_CHECK_RESERVED_1       =  1,
    PWG_MEDIA_INPUT_TRAY_CHECK_UNKNOWN          =  2,

    PWG_MEDIA_INPUT_TRAY_CHECK_ALTERNATE,
    PWG_MEDIA_INPUT_TRAY_CHECK_ALTERNATE_ROLL,
    PWG_MEDIA_INPUT_TRAY_CHECK_AUTO,
    PWG_MEDIA_INPUT_TRAY_CHECK_BOTTOM,
    PWG_MEDIA_INPUT_TRAY_CHECK_BY_PASS_TRAY,
    PWG_MEDIA_INPUT_TRAY_CHECK_CENTER,
    PWG_MEDIA_INPUT_TRAY_CHECK_DISC,
    PWG_MEDIA_INPUT_TRAY_CHECK_ENVELOPE,
    PWG_MEDIA_INPUT_TRAY_CHECK_HAGAKI,
    PWG_MEDIA_INPUT_TRAY_CHECK_LARGE_CAPACITY,
    PWG_MEDIA_INPUT_TRAY_CHECK_LEFT,
    PWG_MEDIA_INPUT_TRAY_CHECK_MAIN,
    PWG_MEDIA_INPUT_TRAY_CHECK_MAIN_ROLL,
    PWG_MEDIA_INPUT_TRAY_CHECK_MANUAL,
    PWG_MEDIA_INPUT_TRAY_CHECK_MIDDLE,
    PWG_MEDIA_INPUT_TRAY_CHECK_PHOTO,
    PWG_MEDIA_INPUT_TRAY_CHECK_REAR,
    PWG_MEDIA_INPUT_TRAY_CHECK_RIGHT,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_1,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_2,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_3,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_4,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_5,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_6,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_7,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_8,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_9,
    PWG_MEDIA_INPUT_TRAY_CHECK_ROLL_10,
    PWG_MEDIA_INPUT_TRAY_CHECK_SIDE,
    PWG_MEDIA_INPUT_TRAY_CHECK_TOP,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_1,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_2,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_3,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_4,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_5,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_6,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_7,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_8,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_9,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_10,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_11,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_12,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_13,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_14,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_15,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_16,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_17,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_18,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_19,
    PWG_MEDIA_INPUT_TRAY_CHECK_TRAY_20,

    VND_MEDIA_INP_TRAY_ENUM

    PWG_MEDIA_INPUT_TRAY_CHECK_END
} pwgMediaInputTrayCheckEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Bottom Margin                                                                                      */
/* Media Left   Margin                                                                                      */
/* Media Right  Margin                                                                                      */
/* Media Top    Margin                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 51] MediaBottomMargin              */
/* -----------------                                                                                        */
/* Defines the PrintService's physical bottom margin in hundredths of millimeters from the bottom edge,     */
/* without respect to the value of the "OrientationRequested" element.                                      */
/* [PWG5100.13] §7.4.1                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:  (section 7.6.1)                                                                          */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 51] MediaLeftMargin                */
/* -----------------                                                                                        */
/* Defines the PrintService's physical left margin in hundredths of millimeters from the left edge, without */
/* respect to the value of the "OrientationRequested" element.                                              */
/* [PWG5100.13] §7.4.2                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:  (section 7.6.2)                                                                          */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaRightMargin               */
/* -----------------                                                                                        */
/* Defines the PrintService's physical right margin in hundredths of millimeters from the right edge,       */
/* without respect to the value of the "OrientationRequested" element.                                      */
/* [PWG5100.13] §7.4.3                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:  (section 7.6.3)                                                                          */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 52] MediaTopMargin                 */
/* -----------------                                                                                        */
/* Defines the PrintService's physical top margin in hundredths of millimeters from the top edge, without   */
/* respect to the value of the "OrientationRequested" element.                                              */
/* [PWG5100.13] §7.4.7                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:  (section 7.6.7)                                                                          */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §7.6.1 [page 46] media-bottom-margin (integer(0:MAX))                                           */
    /* -----------------                                                                                    */
    /* The RECOMMENDED "media-bottom-margin"  member attribute defines the Printer's physical bottom margin */
    /* in hundredths of millimeters from the bottom edge, without respect to the value of the               */
    /* "orientation-requested" Job Template attribute.                                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §7.6.2 [page 46] media-left-margin (integer(0:MAX))                                             */
    /* -----------------                                                                                    */
    /* The RECOMMENDED "media-left-margin" member attribute defines the Printer's physical left margin in   */
    /* hundredths of millimeters from the left edge, without respect to the value of the                    */
    /* "orientation-requested" Job Template attribute.                                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §7.6.3 [page 46] media-right-margin (integer(0:MAX))                                            */
    /* -----------------                                                                                    */
    /* The RECOMMENDED "media-right-margin" member attribute defines the Printer's physical right margin in */
    /* hundredths of millimeters from the right edge, without respect to the value of the                   */
    /* "orientation-requested" Job Template attribute.                                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §7.6.7 [page 47] media-top-margin (integer(0:MAX))                                              */
    /* -----------------                                                                                    */
    /* The RECOMMENDED "media-top-margin" member attribute defines the Printer's physical top margin in     */
    /* hundredths of millimeters from the top edge, without respect to the value of the                     */
    /* "orientation-requested” Job Template attribute.                                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */

typedef struct {
    pwgBIT32       mediaTopMargin;          /* Media margin, hundredths of a millimeter, along bottom edge  */
    pwgBIT32       mediaLeftMargin;         /* Media margin, hundredths of a millimeter, along left   edge  */
    pwgBIT32       mediaBottomMargin;       /* Media margin, hundredths of a millimeter, along left   edge  */
    pwgBIT32       mediaRightMargin;        /* Media margin, hundredths of a millimeter, along left   edge  */

    VND_MEDIA_MRGN_STRUCT

} pwgMediaMargins;


typedef struct {
      pwgNUM_DEF*  mediaTopMargin;          /* Media margin, hundredths of a millimeter, along bottom edge  */
      pwgNUM_DEF*  mediaLeftMargin;         /* Media margin, hundredths of a millimeter, along left   edge  */
      pwgNUM_DEF*  mediaBottomMargin;       /* Media margin, hundredths of a millimeter, along left   edge  */
      pwgNUM_DEF*  mediaRightMargin;        /* Media margin, hundredths of a millimeter, along left   edge  */

            VND_MEDIA_MRGN_DEF_STRUCT

      pwgVOID*          last;
} pwgMediaMarginsDefLst;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Size                                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.4: [page 20] MediaCol and MediaSize Elements                                                   */
/* -----------------                                                                                        */
/* MediaCol allows a finer granularity specification of media than is possible with the Media and MediaType */
/* elements.  Figure  8  shows the MediaCol constituent elements and the constituent elements of MediaSize  */
/* and Margins.                                                                                             */
/*                                                                                                          */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: THE DIAGRAM BELOW WILL ONLY SHOW MediaSize (which is defined and contained MedeaCol!)     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*                                                                                                          */
/*                           + - - - - - - - - - - - - - - - - - - +                                        */
/*                           ! mediaSize                           !                                        */
/*                           !                    +------------+   !                                        */
/*                           !                +---| XDimension |   !                                        */
/*            +-----------+  !   /---------\  |   I------------M   !                                        */
/*        ----| MediaSize |--!---| -o-o-o- |--+                    !                                        */
/*            +-----------+  !   \---------/  |   +------------+   !                                        */
/*                           !                +---| YDimension |   !                                        */
/*                           !                    I------------M   !                                        */
/*                           !                                     !                                        */
/*                           + - - - - - - - - - - - - - - - - - - +                                        */
/*                                                                                                          */
/*                              Sub-Set of Figure 8 MediaCol and MediaSize                                  */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaSize                      */
/* -----------------                                                                                        */
/* Explicitly specifies the numerical media width and height dimensions in hundredth of a millimeter.       */
/* [PWG5100.3] §3.13.8                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                         Internet Printing Protocol(IPP): Production Printing Attributes - Set1   */
        /*      §3.13.8 [page 45-46] media-size (collection)                                                */
        /* -----------------                                                                                */
        /* The "media-size" member attribute is a collection that explicitly specifies the numerical media  */
        /* width and height dimensions.                                                                     */
        /*                                                                                                  */
        /* It is RECOMMENDED that a client localize the collection values to the size names that users are  */
        /* familiar with, such as 'letter' and 'A4', possibly also including the exact dimensions as well   */
        /* (and in the units appropriate for the user's locale).  If a client does not recognize a pair of  */
        /* numbers as a named size, it can simply display the two numbers instead.  Thus the pair of size   */
        /* dimensions serve the same function as keyword values, except that the client has an obvious      */
        /* fallback display for an unrecognized pair, namely, the actual dimension numbers.                 */
        /*                                                                                                  */
        /* The "media-size" collection member attributes are:                                               */
        /*                                                                                                  */
        /*                            Table 11 - "media-size" member attributes                             */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | Attribute name         |  attribute syntax          |     request      |   Printer Support   | */
        /* |========================|============================|==================|=====================| */
        /* | x-dimension            | integer (0:MAX)            |       MUST       |        MUST         | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | y-dimension            | integer (0:MAX)            |       MUST       |        MUST         | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /*                                                                                                  */
        /* 3.13.8.1 x-dimension (integer(0:MAX))                                                            */
        /* Indicates the size of the media in hundredths of a millimeter along the bottom edge of the media.*/
        /* See section 2.4 regarding the coordinate system.  This unit is equivalent to 1/2540 th of an     */
        /* inch resolution.                                                                                 */
        /*                                                                                                  */
        /* 3.13.8.2 y-dimension (integer(0:MAX))                                                            */
        /* Indicates the size of the media in hundredths of a millimeter along the left edge of the media.  */
        /* See section 2.4 regarding the coordinate system.  This is equivalent to 1/2540 th of an inch     */
        /* resolution.                                                                                      */
        /*                                                                                                  */
        /* 3.13.8.3 media-size-supported (1setOf collection)                                                */
        /* Indicates the sizes supported by the Printer.  A requested media size dimension matches a        */
        /* supported media dimension if it is within an implementation-defined tolerance.  For example,     */
        /* PostScript [redbook] specifies a tolerance of 5 points (5/72 of an inch = 1.7 mm) of a supported */
        /* dimension, i.e., within 176 units of the value of the dimension.                                 */
        /*                                                                                                  */
        /* The "media-size-supported" collection member attributes are:                                     */
        /*                                                                                                  */
        /*                          Table 12 - "media-size-supported" member attributes                     */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | Attribute name         |  attribute syntax          |     request      |   Printer Support   | */
        /* |========================|============================|==================|=====================| */
        /* | x-dimension            | integer (1:MAX) |          |      MUST        |        MUST         | */
        /* |                        | rangeOfInteger (1:MAX)     |                  |                     | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | y-dimension            | integer (1:MAX) |          |      MUST        |        MUST         | */
        /* |                        | rangeOfInteger (1:MAX)     |                  |                     | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /*                                                                                                  */
        /* 3.13.8.3.1 x-dimension (integer(1:MAX) | rangeOfInteger(1:MAX))                                  */
        /* Indicates the size of the media in hundredths of a millimeter along the bottom edge of the media.*/
        /* This is equivalent to 1/2540 th of an inch resolution.  The rangeOfInteger attribute syntax      */
        /* accommodated variable size implementations, such as printers supporting adjustable input trays   */
        /* and web printers.  See section 2.4 regarding the coordinate system and section 5.1 regarding     */
        /* user-define media sizes.                                                                         */
        /*                                                                                                  */
        /* 3.13.8.3.2 y-dimension (integer(1:MAX) | rangeOfInteger(1:MAX))                                  */
        /* Indicates the size of the media in hundredths of a millimeter along the left edge of the media.  */
        /* This is equivalent to 1/2540 th of an inch resolution.  The rangeOfInteger attribute syntax      */
        /* accommodated variable size implementations, such as printers supporting adjustable input trays   */
        /* and web printers.  See section 2.4 regarding the coordinate system and section 5.1 regarding     */
        /* user-defined media sizes.                                                                        */
        /*                                                                                                  */
        /* ================================================================================================ */

typedef struct {
    pwgBIT32       xDim;                    /* Media size, in hundredths of a millimeter, along bottom edge */
    pwgBIT32       yDim;                    /* Media size, in hundredths of a millimeter, along left   edge */

    VND_MEDIA_SIZ_STRUCT

} pwgMediaSize;

typedef struct {
            pwgNUM_DEF*       xDim;         /* Media size, in hundredths of a millimeter, along bottom edge */
            pwgNUM_DEF*       yDim;         /* Media size, in hundredths of a millimeter, along left   edge */

            VND_MEDIA_SIZ_DEF_STRUCT

            pwgVOID*          last;
} pwgMediaSizeDefLst;

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Information                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaInfo                      */
/* -----------------                                                                                        */
/* Specifies information that helps describe the media instance. Intended for human consumption.            */
/* [PWG5100.3] §3.13.3                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                              Internet Printing Protocol(IPP): Production Printing Attributes     */
        /*                                  - Set1                                                          */
        /*      §3.13 [page 43] media-info (text(255))                                                      */
        /* -----------------                                                                                */
        /* The "media-info" member attribute specifies information that helps describe the media instance   */
        /* for human consumption. This attribute can also be used to distinguish two media instances for    */
        /* which all other member attributes (except "media-key", if implemented) are the same. For example,*/
        /* this member attribute could be used to distinguish between self-sticking and moisture-required   */
        /* envelopes, both of which have a "media-type" value of 'envelope'.                                */
        /*                                                                                                  */
        /* The "media-info-supported" (boolean) Printer attribute indicates whether or not the Printer      */
        /* supports the "media-info" member attribute.                                                      */
        /*                                                                                                  */
        /* ================================================================================================ */

/*     pwgCHAR                   info[255];    * Information that helps describe the media instance.        */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Thickness                                                                                          */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaThickness                 */
/* -----------------                                                                                        */
/* The thickness of the media in units of one hundredth of a millimeter. This unit is equivalent to         */
/* 1/2540 th of an inch.                                                                                    */
/* [PWG5100.11] §11.5.3                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §11.5.2 [page 70] media-thickness (integer(1:MAX))                                          */
        /* -----------------                                                                                */
        /* The "media-thickness" member attribute indicates the thickness of the media being specified. The */
        /* source for this attribute is JDF v1.0.                                                           */
        /*                                                                                                  */
        /* The unit of measure for the "media-thickness" member attribute is one hundredth of a millimeter. */
        /* This unit is equivalent to 1/2540 th of an inch resolution.                                      */
        /*                                                                                                  */
        /* 11.5.3.1  media-thickness-supported (rangeOfInteger(1:MAX))                                      */
        /* The "media-thickness-supported" (rangeOfInteger(1:MAX)) Printer attribute identifies the values  */
        /* of this "media-thickness" member attribute that the Printer supports.                            */
        /*                                                                                                  */
        /* ================================================================================================ */

/*     pwgBIT32                thickness;    * Thickness of media in units of one hundredth of a millimeter.*/


/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Collection Type                                                                                    */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1.4: [page 20-21] MediaCol and MediaSize.                                                        */
/* -----------------                                                                                        */
/* MediaCol allows a finer granularity specification of media than is possible with the Media and MediaType */
/* elements.  Figure  8  shows the MediaCol constituent elements and the constituent elements of MediaSize  */
/* and Margins.                                                                                             */
/*                                                                                                          */
/*                  + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .+  */
/*                  .  MediaColType                                                                      .  */
/*                  .                                                                                    .  */
/*                  .     +------------+                                                                 .  */
/*                  . +---| attributes |                                                                 .  */
/*                  . |   +------------+                                                                 .  */
/*                  . |                                                                                  .  */
/*                  . |                                                                                  .  */
/*                  . |                  + - - - - - - - - - +                                           .  */
/*                  . |              + - ! MediaBackCoating  !                                           .  */
/*                  . |              !   K - - - - - - - - - M                                           .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - - +                                           .  */
/*                  . |              + - ! MediaBottomMargin !                                           .  */
/*                  . |              !   I - - - - - - - - - M                                           .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - +                                                 .  */
/*                  . |              + - ! MediaColor  !                                                 .  */
/*                  . |              !   K - - - - - - M                                                 .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - - +                                           .  */
/*                  . |              + - ! MediaFrontCoating !                                           .  */
/*                  . |              !   K - - - - - - - - - M                                           .  */
/*                  . |              !                                                                   .  */
/*    +----------+  . |              !   + - - - - - - +                                                 .  */
/*    | MediaCol |--.-+              + - ! MediaGrain  !                                                 .  */
/*    +----------+  . |              !   K - - - - - - M                                                 .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - +                                             .  */
/*                  . |              + - ! MediaHoleCount  !                                             .  */
/*                  . |              !   I - - - - - - - - M                                             .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - +                                                   .  */
/*                  . |              + - ! MediaInfo !                                                   .  */
/*                  . |              !   S - - - - - M                                                   .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - +                                                   .  */
/*                  . |              + - ! MediaKey  !                                                   .  */
/*                  . |              !   K - - - - - M                                                   .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - +                                             .  */
/*                  . |              + - ! MediaLeftMargin !                                             .  */
/*                  . |              !   I - - - - - - - - M                                             .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - +                                             .  */
/*                  . |              + - ! MediaOrderCount !                                             .  */
/*                  . |              !   I - - - - - - - - M                                             .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - +                                             .  */
/*                  . |              + - ! MediaPreprinted !                                             .  */
/*                  . |              !   K - - - - - - - - M                                             .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - +                                               .  */
/*                  . |              + - ! MediaRecycled !                                               .  */
/*                  . |              !   K - - - - - - - M                                               .  */
/*                  . |              !                                                                   .  */
/*                  . |              !   + - - - - - - - - - +                                           .  */
/*                  . |              + - ! MediaRightMargin  !                                           .  */
/*                  . |              !   I - - - - - - - - - M                                           .  */
/*                  . |              !                                                                   .  */
/*                  . |              !                              + . . . . . . . . . . . . . . . . +  .  */
/*                  . | /---------\  !                              . mediaSize                       .  .  */
/*                  . +-| -o-o-o- |--+                              .                  +------------+ .  .  */
/*                  .   \---------/  |                              .              +---| XDimension | .  .  */
/*                  .                |               +-----------+  . /---------\  |   I------------M .  .  */
/*                  .                |  / - - \  +---| MediaSize |--.-| -o-o-o- |--+                  .  .  */
/*                  .                |  |   o |  |   C-----------M  . \---------/  |   +------------+ .  .  */
/*                  .                +--|__/o |--+                  .              +---| YDimension | .  .  */
/*                  .                !  |   o |  |                  .                  I------------M .  .  */
/*                  .                !  \ - - /  |                  + . . . . . . . . . . . . . . . . +  .  */
/*                  .                !           |                                                       .  */
/*                  .                !           |   +---------------+                                   .  */
/*                  .                !           +---| MediaSizeName |                                   .  */
/*                  .                !               K---------------M                                   .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - - +                                                 .  */
/*                  .                + - ! MediaSource !                                                 .  */
/*                  .                !   K - - - - - - M                                                 .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - - - - +                                             .  */
/*                  .                + - ! MediaThickness  !                                             .  */
/*                  .                !   I - - - - - - - - M                                             .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - - +                                                 .  */
/*                  .                + - ! MediaTooth  !                                                 .  */
/*                  .                !   I - - - - - - M                                                 .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - - - - +                                             .  */
/*                  .                + - ! MediaTopMargin  !                                             .  */
/*                  .                !   I - - - - - - - - M                                             .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - +                                                   .  */
/*                  .                + - ! MediaType !+                                                  .  */
/*                  .                !   K - - - - - M                                                   .  */
/*                  .                !                                                                   .  */
/*                  .                !   + - - - - - - - - - +                                           .  */
/*                  .                + - ! MediaWeightMetric !                                           .  */
/*                  .                !   I - - - - - - - - - M                                           .  */
/*                  .                !                                                                   .  */
/*                  .                !   / - - - - - - -\                                                .  */
/*                  .                + - ! any ##other  !                                                .  */
/*                  .                    \ - - - - - - -/                                                .  */
/*                  .                        0..infinite                                                 .  */
/*                  + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .+  */
/*                                                                                                          */
/*                            Figure 8 MediaCol and MediaSize                                               */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaCol                       */
/* -----------------                                                                                        */
/* Enables a client end user to submit a list of media characteristics to the PrintService as a way to more */
/* completely specify the media to be used than the Media element.                                          */
/* [PWG5100.3] §3.13                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                              Internet Printing Protocol(IPP): Production Printing Attributes     */
        /*                                  - Set1                                                          */
        /*      §3.13 [page 38-48] media-col (collection) - augments IPP "media                             */
        /* -----------------                                                                                */
        /* This attribute augments the "media" Job Template attribute (defined in [RFC2911] section 4.2.11).*/
        /* This "media-col" Job Template collection attribute enables a client end user to submit a list of */
        /* media characteristics to the Printer as a way to more completely specify the media to be used.   */
        /* Each member attribute of the collection identifies a media characteristic.  A Printer MAY        */
        /* support the "media" attribute without supporting the "media-col" attribute.  However, if a       */
        /* Printer supports the "media-col" attribute, it MUST also support the "media" attribute.          */
        /* Otherwise, clients that support only the IPP/1.0 or IPP/1.1 "media" Job Template attribute would */
        /* not be able to interoperate with a Printer that supports only the "media-col" Job Template       */
        /* attribute.                                                                                       */
        /*                                                                                                  */
        /* Each value of the "media" (type3 keyword | name) Job Template attribute uniquely identifies an   */
        /* instance of media.  Each combination of values of the "media-col" collection attribute also      */
        /* uniquely identify an instance of media.  In other words, each media instance supported by a      */
        /* Printer MUST have a combination of member attribute values that differs from the combination of  */
        /* values for all other supported media instances.                                                  */
        /*                                                                                                  */
        /* When associating standard media keywords with media instances to be used with the "media"        */
        /* attribute, the implementation and/or the administrator SHOULD associate them with media          */
        /* instances whose characteristics are what users would normally expect.  For example, the          */
        /* 'iso-a4-white' keyword SHOULD be associated with a media instance that is A4 in size, 20 pound   */
        /* or 24 pound in weight, white in color, with 'stationery' media type, no holes, etc.              */
        /*                                                                                                  */
        /* The standard media keywords that identify media sizes, such as 'iso-a4' and 'na-letter', are     */
        /* associated with any media in an input tray that is configured for that media size.  Thus         */
        /* specifying media size keywords with the "media" attribute does not guarantee reproducible        */
        /* results from one job submission to another, since different media of the same size may be        */
        /* present from one time to the next.  If none of the input trays are configured for that size, the */
        /* association with a media instance is IMPLEMENTATION DEPENDENT.                                   */
        /*                                                                                                  */
        /* The client MUST NOT supply both the "media" and the "media-col" Job Template attributes in a Job */
        /* Creation request.  If the client supplies such a mal-formed request by supplying both, the       */
        /* Printer MUST (depending on implementation) either (1) reject the request and return the          */
        /* 'client-error-bad-request' status code (see [RFC2911] section 13.1.4.1) or (2) use either the    */
        /* "media" or the "media-col" attribute, independent of the value of the "ipp-attribute-fidelity"   */
        /* attribute supplied by the client.                                                                */
        /*                                                                                                  */
        /* A number of collection Job Template attributes defined in this document have both the "media"    */
        /* and "media-col" member attributes.  The same rule against supplying both in a request holds for  */
        /* those collection attributes.  Those Job Template attributes whose sole purpose is to specify the */
        /* media are defined so that the Printer MUST use the requested media, while those that have        */
        /* additional purposes as well are defined so that the Printer SHOULD use the requested media.      */
        /*                                                                                                  */
        /* Each "media-col" value in a Printer MUST contain a value for each "media-col" member attribute   */
        /* supported by the Printer. That is, all "media-col" values in a Printer contain the same member   */
        /* attributes. The "media-col" values supported by a Printer MUST be either all combinations of     */
        /* supported member attribute values or a subset thereof. When a client supplies a "media-col"      */
        /* attribute in a Job Creation or Validate-Job request, the client NEED NOT include all "media-col" */
        /* member attributes supported by the Printer.                                                      */
        /*                                                                                                  */
        /* When a Printer receives a "media-col" attribute in a Job Creation or Validate-Job request, it    */
        /* finds the specified "media-col" value in the Printer using the following "matching algorithm":   */
        /* (this algorithm effectively fills in the member attributes not supplied by the client)           */
        /*                                                                                                  */
        /*    1) Find all "media-col" values where each member attribute value is identical to the          */
        /*       corresponding member attribute in the client supplied "media-col" attribute.  Any member   */
        /*       attribute not supplied by the client matches any value of the corresponding member         */
        /*       attribute in the Printer. The Printer ignores those member attributes supplied by the      */
        /*       client and not supported by the Printer.                                                   */
        /*                                                                                                  */
        /*    2) If the number of matched "media-col" values is:                                            */
        /*        0: the Printer MUST either                                                                */
        /*            a) treat the client-supplied "media-col" value as an unsupported value (see [RFC2911] */
        /*               Print-Job operation) if "media-col" is not a value of the                          */
        /*               "user-defined-values-supported" attribute (see section 5.1), or                    */
        /*            b) accept the "media-col" value and put the Job in the 'pending-held' state if        */
        /*               "media-col" is a value of the "user-defined-values-supported" attribute, and if    */
        /*               the Job is otherwise accepted.                                                     */
        /*        1: a Printer implementation MUST either                                                   */
        /*            a) use this single value of "media-col" as the value specified by the client, or      */
        /*            b) use step "2 or more" below to confirm the single matched value or to eliminate it. */
        /*        2 or more: a Printer MUST reduce the number "media-col" values in an                      */
        /*            implementation-defined manner to 1 or 0.  If the number of values from this step is 1,*/
        /*            the Printer implementation MUST go to step '1a)' above.  If the number of values from */
        /*            this step is 0, the Printer implementation MUST go to step '0' above.                 */
        /*                                                                                                  */
        /*            To reduce the number of "media-col" values, an implementation SHOULD pick an          */
        /*            algorithm that gives reproducible results.  For example, an algorithm that picks one  */
        /*            value at random does not give reproducible results. The following are some possible   */
        /*            algorithms. Others are possible too.                                                  */
        /*                a) A Printer MAY apply implementation-defined defaults for member attributes not  */
        /*                   specified by the client and perform the matching algorithm again on the        */
        /*                   matched values. This algorithm may result in 0 matches.                        */
        /*                b) A Printer MAY find the "closest" or "best" match of the matched "media-col"    */
        /*                   values. This document doesn't attempt to define "closest" or "best", but the   */
        /*                   result MUST be a single match.                                                 */
        /*                c) A Printer MAY find the "closest" or "best" match of the matched "media-col"    */
        /*                   values that are also ready (i.e. loaded in trays). This algorithm has a chance */
        /*                   of being less reproducible, but may still be sufficiently reproducible to be   */
        /*                   useful. This algorithm may yield 0 matches unless there is a fallback, such as */
        /*                   to the preceding algorithm (b).                                                */
        /*                                                                                                  */
        /* A Printer MUST implement either the above algorithm or one that produces equivalent results.     */
        /*                                                                                                  */
        /* Table 10 lists the member attributes of the "media-col" collection attribute:                    */
        /*                                                                                                  */
        /*                            Table 10 - "media-col" member attributes                              */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | Attribute name         |  attribute syntax          |     request      |   Printer Support   | */
        /* |========================|============================|==================|=====================| */
        /* | media-key              |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-type             |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-info             |  text(255                  |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-color            |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-pre-printed      |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-hole-count       |  integer(0:MAX)            |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-order-count      |  integer(1:MAX)            |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-size             |  collection                |  MAY             |   MUST              | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-weight-metric    |  integer(0:MAX)            |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-back-coating     |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-front-coating    |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | media-recycled         |  type3 keyword | name(MAX) |  MAY             |   MAY               | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /*                                                                                                  */
        /* The "media-col" collection member attributes definitions are:                                    */
        /*                                                                                                  */
        /* 3.13.1 media-key (type3 keyword | name(MAX))                                                     */
        /* The "media-key" member attribute contains the name of the media represented as a keyword or name.*/
        /* Values MUST be the same as the keyword and name values for the "media" Job Template attribute    */
        /* and represent the same media, except for media size and input tray keywords (see section 6.3     */
        /* in this document and [RFC2911] Appendix C) which MUST NOT be "media-key" values.                 */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: DUE TO THE SIZE OF THE MEDIA TABLE INFO IN RFC2911, IT HAS NOT BEEN INCLUDED              */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /* The value of this member attribute MUST be unique for each media supported by an IPP Printer     */
        /* instance, i.e., no two media instances can have the same "media-key" value on the same IPP       */
        /* Printer instance.  However, the same "media-key" value can represent the same or different media */
        /* on different IPP Printer instances.  For example, the 'iso-a4-white' keyword might represent     */
        /* recycled 80 gm/mm on two Printer instances and non-recycled, 72 gm/mm on a third Printer         */
        /* instance.  An administrator or a number of administrators within an organization MAY choose to   */
        /* have "media-key" values represent the same media instances across a set of Printers.             */
        /*                                                                                                  */
        /* Note: Since the above requires that each media instance have a unique "media-key" value (if      */
        /*       "media-key" attribute is supported), then the Printer automatically meets the requirement  */
        /*       (see section 3.13) that each media instance have a unique combination of member attribute  */
        /*       values.                                                                                    */
        /*                                                                                                  */
        /* Note: As with any combination of supported "media-col" member attributes, if a client supplies   */
        /*       the "media-key" member attribute and other member attributes, the Printer will attempt to  */
        /*       match all of the supplied member attributes, including the "media-key" value, following    */
        /*       the algorithm defined in section 3.13.  So if the supplied collection value does not match */
        /*       any supported "media-col" value, the Printer treats the "media-col" attribute as having an */
        /*       undefined attribute value.  Thus, a client can ensure that the Printer maps a standard     */
        /*       media name keyword to certain expected member attribute values.                            */
        /*                                                                                                  */
        /* The "media-key-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies the  */
        /* values of this "media-key" member attribute that the Printer supports.                           */
        /*                                                                                                  */
        /* For Printers that support a large number of media (and the "media-key" attribute), the burden of */
        /* an administrator to define unique "media-key" values for each media instance could be quite      */
        /* large.  Therefore, it is RECOMMENDED that such a Printer assign a unique "media-key" value in an */
        /* IMPLEMENTATION-DEFINED manner for each media instance for which the administrator has not        */
        /* defined a "media-key" value, rather than refusing the media definition.  The Printer also adds   */
        /* such generated values to its "media-key-supported" attribute.  A client can supply such a        */
        /* Printer-generated value with either (1) the "media-key" member attribute or (2) the "media" Job  */
        /* Template attribute.                                                                              */
        /*                                                                                                  */
        /* 3.13.2 media-type (type3 keyword | name(MAX))                                                    */
        /* The "media-type" member attribute identifies the type of media, i.e., the media instance's       */
        /* predominate characteristic.  Depending on implementation, the Printer MAY need to behave         */
        /* differently or perform different validation, depending on the type of the media.  For example,   */
        /* prohibiting stapling transparencies or selecting a different paper path for an envelope.         */
        /*                                                                                                  */
        /* The values and descriptions indicated with 'yes' are taken verbatim from the Printer             */
        /* MIB [RFC1759] and "Media Features for Display, Print, and Fax" [RFC2534] documents.  Bracketed   */
        /* text indicates additions to these Descriptions taken from other standards.  Additional values    */
        /* MAY be registered according to both [REG] and [RFC2911].                                         */
        /*                                                                                                  */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | Keyword          |  Description                                        | Print MIB | RFC2524 | */
        /* |==================|=====================================================|===========|=========| */
        /* | stationery       | Separately cut sheets of an opaque material         | yes       | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | transparency     | Separately cut sheets of a transparent material     | yes       | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | envelope         | Envelopes that can be used for conventional mailing |           |         | */
        /* |                  | purposes                                            | yes       | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | envelope-plain   | Envelopes that are not preprinted and have no       |           |         | */
        /* |                  | windows                                             | yes       | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | envelope-window  | Envelopes that have windows for addressing purposes | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | continuous       | Continuously connected sheets of an opaque material |           |         | */
        /* |                  | - which edge is connected is not specified          | no        | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | continuous-long  | Continuously connected sheets of an opaque material |           |         | */
        /* |                  | connected along the long edge                       | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | continuous-short | Continuously connected sheets of an opaque material |           |         | */
        /* |                  | connected along the short edge                      | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | tab-stock        | Media with tabs [either pre-cut or full-cut]        | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | pre-cut-tabs     | Media with tabs that are cut so that more than one  |           |         | */
        /* |                  | tab is visible extending out beyond the edge of     |           |         | */
        /* |                  | non-tabbed media in an Output-Document.             | no        |no       | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | full-cut-tabs    | Media with a tab that runs the full length of the   |           |         | */
        /* |                  | sheet so  that only one tab is visible extending    |           |         | */
        /* |                  | out beyond the edge of non-tabbed media in an       |           |         | */
        /* |                  | Output-Document.                                    | no        | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | multi-part-form  | Form medium composed of multiple layers not         |           |         | */
        /* |                  | pre-attached to one another; each sheet may be      |           |         | */
        /* |                  | drawn separately from an input source               | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | labels Label     | stock [For example, a sheet of peel-off labels].    | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | multi-layer      | Form medium composed of multiple layers which are   |           |         | */
        /* |                  | pre-attached to one another; e.g., for use with     |           |         | */
        /* |                  | impact printers.                                    | yes       | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | screen           | A refreshable display                               | no        | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | screen-paged     | A refreshable display which cannot scroll           | no        | yes     | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | photographic     | Separately cut sheets of an opaque material to      |           |         | */
        /* |                  | produce photographic quality images                 | no        | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | cardstock        | Separately cut sheets of a heavier or stiffer       |           |         | */
        /* |                  | opaque material than stationery                     | no        | no      | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /* | other            | The 'other' keyword value is used when the media    | no        | no      | */
        /* |                  | instance does not correspond to any of the          |           |         | */
        /* |                  | Printer's supported media types (keyword or name).  |           |         | */
        /* |                  |                                                     |           |         | */
        /* |                  | The 'other' keyword value SHOULD NOT be used to     |           |         | */
        /* |                  | refine the defined values.  For example, the        |           |         | */
        /* |                  | "media-type" member attribute SHOULD use the        |           |         | */
        /* |                  | 'envelope' value for both self-sealing and          |           |         | */
        /* |                  | moisture-required envelopes in combination with the |           |         | */
        /* |                  | "media-info" attributes indicating the difference,  |           |         | */
        /* |                  | rather than using the value 'other'. Alternatively, |           |         | */
        /* |                  | if the Printer supports the name attribute syntax   |           |         | */
        /* |                  | for the "media-type" member attribute and allows    |           |         | */
        /* |                  | the 'name' attribute syntax for envelopes, the      |           |         | */
        /* |                  | administrator could define two new "media-type"     |           |         | */
        /* |                  | name values: 'envelope-self-sealing' and            |           |         | */
        /* |                  | 'envelope-moisture-required'.                       |           |         | */
        /* |------------------|-----------------------------------------------------|-----------|---------| */
        /*                                                                                                  */
        /* The "media-type-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies the */
        /* values of this "media-type" member attribute that the Printer supports, i.e., the media types    */
        /* supported.                                                                                       */
        /*                                                                                                  */
        /* Note: The Administrator can define custom media types using the 'name' (MAX) attribute syntax of */
        /*       the "media-type-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute, if the  */
        /*       Printer supports the 'name' attribute syntax for this attribute.  As with other Job        */
        /*       Template and member attributes, the user can also supply user-defined media type names     */
        /*       that are not among the values of the "media-type-supported" Printer attribute, if the      */
        /*       Administrator has configured the Printer's "user-defined-values-supported" attribute to    */
        /*       contain the 'media-type' attribute keyword value (see section 5.1).                        */
        /*                                                                                                  */
        /* 3.13.3 media-info (text(255))                                                                    */
        /* The "media-info" member attribute specifies information that helps describe the media instance   */
        /* for human consumption.  This attribute can also be used to distinguish two media instances for   */
        /* which all other member attributes (except "media-key", if implemented) are the same.  For        */
        /* example, this member attribute could be used to distinguish between self-sticking and            */
        /* moisture-required envelopes, both of which have a "media-type" value of 'envelope'.              */
        /*                                                                                                  */
        /* The "media-info-supported" (boolean) Printer attribute indicates whether or not the Printer      */
        /* supports the "media-info" member attribute.                                                      */
        /*                                                                                                  */
        /* 3.13.4 media-color (type3 keyword | name(MAX))                                                   */
        /* The "media-color" member attribute indicates the desired color of the media being specified.     */
        /*                                                                                                  */
        /* Standard keyword values for "media-color" are:                                                   */
        /*                                                                                                  */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: PRINTER MIB 1759 includes the 'color's:                                                   */
/*                |-------------|-------------------------------------------|                               */
/*                | other       | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/*                | unknown     | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/*                | transparent | ---------                                 |                               */
/*                |-------------|-------------------------------------------|                               */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'no-color'  | The specified media should have no color. |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'white'     | The specified media should be white.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'pink'      | The specified media should be pink.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'yellow'    | The specified media should be yellow.     |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'blue'      | The specified media should be blue.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'green'     | The specified media should be green.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'buff'      | The specified media should be buff.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'goldenrod' | The specified media should be goldenrod.  |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'red'       | The specified media should be red.        |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'gray'      | The specified media should be gray.       |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'ivory'     | The specified media should be ivory.      |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*        | 'orange'    | The specified media should be orange.     |                               */
        /*        |-------------|-------------------------------------------|                               */
        /*                                                                                                  */
        /* Note: The standard keyword values for the "media-color" attribute are derived primarily from the */
        /*       Printer MIB [RFC1759] prtInputMediaColor standard values with the addition of 'blue',      */
        /*       'red', 'gray', 'ivory', 'orange', and 'no-color' (instead of 'transparent' - see           */
        /*       'transparency' in "media-type", section 3.13.2).                                           */
        /*                                                                                                  */
        /* The "media-color-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies    */
        /* the values of this "media-color" member attribute that the Printer supports, i.e., the colors    */
        /* supported.                                                                                       */
        /*                                                                                                  */
        /* The Administrator can define custom paper colors using the 'name' (MAX) attribute syntax  of the */
        /* "media-color-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute.  Note: as with   */
        /* other Job Template and member attributes, the user can also supply user-defined color names that */
        /* are not among the values of the "media-color-supported" Printer attribute, if the Administrator  */
        /* has configured the Printer's "user-defined-values-supported" attribute to contain the            */
        /* 'media-color' attribute keyword value (see section 5.1).                                         */
        /*                                                                                                  */
        /* 3.13.5 media-pre-printed (type3 keyword | name(MAX))                                             */
        /* The "media-pre-printed" member attribute indicates that the pre-printed characteristics of the   */
        /* desired media.  Examples of pre-printed media include forms and company letterhead.  The         */
        /* standard keyword values for "media-pre-printed" are:                                             */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'blank'       | The desired medium is not pre-printed.  The Printer MAY use an        | */
        /*        |               | electronic representation of a form, if the medium has some imaged    | */
        /*        |               | information already associated with it.                               | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'pre-printed' | The desired medium is pre-printed; the other attributes identify      | */
        /*        |               | which medium instance and so what is actually pre-printed.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'letter-head' | The site-defined letter head pre-printed is desired.                  | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* The "media-pre-printed-supported" (1setOf (type3 keyword | name(MAX)) Printer attribute          */
        /* identifies the values of this "media-pre-printed" member attribute that the Printer supports.    */
        /*                                                                                                  */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Hole Count                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 53] MediaHoleCount                 */
/* -----------------                                                                                        */
/* Indicates the number of pre-drilled holes in the desired media.                                          */
/* [PWG5100.3] §3.13.6                                                                                      */
/* ..................................................|..................................................... */
        /*                                                                                                  */
        /* 3.13.6 media-hole-count (integer(0:MAX))                                                         */
        /* The "media-hole-count" member attribute indicates the number of pre-drilled holes in the desired */
        /* media. A value of 0 (zero) indicates that no holes should be present in the media.               */
        /*                                                                                                  */
        /* The "media-hole-count-supported" (1setOf rangeOfInteger(0:MAX)) Printer attribute identifies the */
        /* ranges of values of this "media-hole-count" member attribute that the Printer supports.          */
        /*                                                                                                  */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Order Count                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 54] MediaOrderCount                */
/* -----------------                                                                                        */
/* Indicates the number of sheets, within an ordered sequence of sheets; after which the sequence begins to */
/* repeat.                                                                                                  */
/* [PWG5100.3] §3.13.7                                                                                      */
/* ..................................................|..................................................... */
        /*                                                                                                  */
        /* 3.13.7 media-order-count (integer(1:MAX))                                                        */
        /* The "media-order-count" member attribute indicates the number of sheets, within an ordered       */
        /* sequence of sheets; after which the sequence begins to repeat.  For example, third cut tab stock */
        /* in which all three forms are present has an order count of 3 (this is also sometimes called the  */
        /* modulus of the ordered media).  Full-cut tab stock MAY have an order count greater than 1 if it  */
        /* has an ordered sequence, such as a cycle of colors or cycle of pre-printing.                     */
        /*                                                                                                  */
        /* If the "media-order-count" is 1, then all media is the same.                                     */
        /*                                                                                                  */
        /* The "media-order-count-supported" (1setOf rangeOfInteger(1:MAX)) Printer attribute identifies    */
        /* the range of values of this "media-order-count" member attribute that the Printer supports.      */
        /*                                                                                                  */
        /* 3.13.8 media-size (collection)                                                                   */
        /* The "media-size" member attribute is a collection that explicitly specifies the numerical media  */
        /* width and height dimensions.                                                                     */
        /*                                                                                                  */
        /* It is RECOMMENDED that a client localize the collection values to the size names that users are  */
        /* familiar with, such as 'letter' and 'A4', possibly also including the exact dimensions as well   */
        /* (and in the units appropriate for the user's locale).  If a client does not recognize a pair of  */
        /* numbers as a named size, it can simply display the two numbers instead.  Thus the pair of size   */
        /* dimensions serve the same function as keyword values, except that the client has an obvious      */
        /* fallback display for an unrecognized pair, namely, the actual dimension numbers.                 */
        /*                                                                                                  */
        /* The "media-size" collection member attributes are:                                               */
        /*                                                                                                  */
        /*                            Table 11 - "media-size" member attributes                             */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | Attribute name         |  attribute syntax          |     request      |   Printer Support   | */
        /* |========================|============================|==================|=====================| */
        /* | x-dimension            | integer (0:MAX)            |       MUST       |        MUST         | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | y-dimension            | integer (0:MAX)            |       MUST       |        MUST         | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /*                                                                                                  */
        /* 3.13.8.1 x-dimension (integer(0:MAX))                                                            */
        /* Indicates the size of the media in hundredths of a millimeter along the bottom edge of the media.*/
        /* See section 2.4 regarding the coordinate system.  This unit is equivalent to 1/2540 th of an     */
        /* inch resolution.                                                                                 */
        /*                                                                                                  */
        /* 3.13.8.2 y-dimension (integer(0:MAX))                                                            */
        /* Indicates the size of the media in hundredths of a millimeter along the left edge of the media.  */
        /* See section 2.4 regarding the coordinate system.  This is equivalent to 1/2540 th of an inch     */
        /* resolution.                                                                                      */
        /*                                                                                                  */
        /* 3.13.8.3 media-size-supported (1setOf collection)                                                */
        /* Indicates the sizes supported by the Printer.  A requested media size dimension matches a        */
        /* supported media dimension if it is within an implementation-defined tolerance.  For example,     */
        /* PostScript [redbook] specifies a tolerance of 5 points (5/72 of an inch = 1.7 mm) of a supported */
        /* dimension, i.e., within 176 units of the value of the dimension.                                 */
        /*                                                                                                  */
        /* The "media-size-supported" collection member attributes are:                                     */
        /*                                                                                                  */
        /*                          Table 12 - "media-size-supported" member attributes                     */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | Attribute name         |  attribute syntax          |     request      |   Printer Support   | */
        /* |========================|============================|==================|=====================| */
        /* | x-dimension            | integer (1:MAX) |          |      MUST        |        MUST         | */
        /* |                        | rangeOfInteger (1:MAX)     |                  |                     | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /* | y-dimension            | integer (1:MAX) |          |      MUST        |        MUST         | */
        /* |                        | rangeOfInteger (1:MAX)     |                  |                     | */
        /* |------------------------|----------------------------|------------------|---------------------| */
        /*                                                                                                  */
        /* 3.13.8.3.1 x-dimension (integer(1:MAX) | rangeOfInteger(1:MAX))                                  */
        /* Indicates the size of the media in hundredths of a millimeter along the bottom edge of the media.*/
        /* This is equivalent to 1/2540 th of an inch resolution.  The rangeOfInteger attribute syntax      */
        /* accommodated variable size implementations, such as printers supporting adjustable input trays   */
        /* and web printers.  See section 2.4 regarding the coordinate system and section 5.1 regarding     */
        /* user-define media sizes.                                                                         */
        /*                                                                                                  */
        /* 3.13.8.3.2 y-dimension (integer(1:MAX) | rangeOfInteger(1:MAX))                                  */
        /* Indicates the size of the media in hundredths of a millimeter along the left edge of the media.  */
        /* This is equivalent to 1/2540 th of an inch resolution.  The rangeOfInteger attribute syntax      */
        /* accommodated variable size implementations, such as printers supporting adjustable input trays   */
        /* and web printers.  See section 2.4 regarding the coordinate system and section 5.1 regarding     */
        /* user-defined media sizes.                                                                        */
        /*                                                                                                  */
/* ........................................................................................................ */
/*                                                                                                          */
/* Media Weight Metric                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 55] MediaWeightMetric              */
/* -----------------                                                                                        */
/* Indicates the weight of the desired media rounded to the nearest whole number of grams per square meter. */
/* [PWG5100.3] §3.13.9                                                                                      */
/* ..................................................|..................................................... */
        /*                                                                                                  */
        /* 3.13.9 media-weight-metric (integer(0:MAX))                                                      */
        /* The "media-weight-metric" member attribute indicates the weight of the desired media rounded to  */
        /* the nearest whole number of grams per square meter.                                              */
        /*                                                                                                  */
        /* The "media-weight-metric-supported" (1setOf rangeOfInteger(1:MAX)) Printer attribute identifies  */
        /* the values of this "media-weight-metric" member attribute that the Printer supports, i.e., the   */
        /* weights supported in metric units.                                                               */
        /*                                                                                                  */
        /* 3.13.10 media-front-coating (type3 keyword | name(MAX)) and                                      */
        /*         media-back-coating  (type3 keyword | name(MAX))                                          */
        /* The "media-front-coating" and "media-back-coating" member attributes indicate what pre-process   */
        /* coating has been applied to the front and back of the desired media, respectively.               */
        /*                                                                                                  */
        /* Standard keyword values for "media-front-coating" and "media-back-coating" are:                  */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'none'        | Indicated that the media MUST not have any coating.                   | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'glossy'      | Indicates that the media MUST have a "glossy" coating.                | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'high-gloss'  | Indicates that the media MUST have a "high-gloss" coating.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'semi-gloss'  | Indicates that the media MUST have a "semi-gloss" coating.            | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'satin'       | Indicates that the media MUST have a "satin" coating.                 | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'matte'       | Indicates that the media MUST have a "matte" coating.                 | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* The "media-front-coating-supported" (1setOf (type3 keyword | name(MAX))) and                     */
        /* "media-back-coating-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies */
        /* the values of these "media-front-coating" and "media-back-coating" member attributes that the    */
        /* Printer supports.                                                                                */
        /*                                                                                                  */
        /* 3.13.11 media-recycled (type3 keyword | name(MAX))                                               */
        /* The "media-recycled" member attribute indicates the recycled characteristics of the media.  The  */
        /* standard keyword values are:                                                                     */
        /*                                                                                                  */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'none'        | The media MUST NOT be recycled.                                       | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*        | 'standard'    | The media MUST be the site-defined standard recycled stock.           | */
        /*        |---------------|-----------------------------------------------------------------------| */
        /*                                                                                                  */
        /* If this member attribute is supported, the Printer MUST support at least the 'none' and          */
        /* 'standard' values.                                                                               */
        /*                                                                                                  */
        /* The "media-recycled-supported" (1setOf (type3 keyword | name(MAX))) Printer attribute identifies */
        /* the values of this "media-recycled" member attribute that the Printer supports, i.e., the        */
        /* recycled characteristics supported, which MUST include the 'none' keyword value so that          */
        /* validation follows the normal rules.                                                             */
        /*                                                                                                  */
        /* 3.13.12 media-default (type3 keyword | name(MAX)) and media-col-default (collection)             */
        /* The "media-default" (see [RFC2911] section 4.2.11) and the "media-col-default" Printer           */
        /* attributes specify the media that the Printer uses, if the client omits both the "media" and the */
        /* "media-col" Job Template attributes in the Job Creation operation (and the PDL doesn't include a */
        /* media specification).  The member attributes are defined in Table 10.  A Printer MUST support    */
        /* the same member attributes for this default collection attribute as it supports for the          */
        /* corresponding "media-col" Job Template attribute.                                                */
        /*                                                                                                  */
        /* The "media-default" and "media-col-default" Printer attributes MUST both be configured to        */
        /* specify the same media instance.  If the administrator sets one of them to a value (either       */
        /* locally or with the Set-Printer-Attributes operation - see [ipp-set]), the Printer MUST set the  */
        /* other attribute's value to specify the same media instance or to the 'unknown' out-of-band value,*/
        /* if there isn't a corresponding value to be set for the other attribute. If a client attempts to  */
        /* set both attributes, but their values specify different media instances, the Printer MUST reject */
        /* the Set-Printer-Attributes operation and return the 'client-error-conflicting-attributes' status */
        /* code.  The reason to have both default attributes configured, is so that clients that only know  */
        /* about the "media" attribute will see the "media-default" attribute, while clients that know      */
        /* about the "media-col" attribute will be able to determine the characteristics of the media       */
        /* default.                                                                                         */
        /*                                                                                                  */
        /* 3.13.13 media-ready (1setOf (type3 keyword | name(MAX))) and media-col-ready (1setOf collection) */
        /* The "media-ready" (see [RFC2911] section 4.2.11) and "media-col-ready" Printer attribute         */
        /* identifies the media that are available for use without human intervention, i.e., the media that */
        /* are ready to be used without human intervention.  The collection value MUST have all of the      */
        /* member attributes that are supported in Table 10.  If this attribute is supported, the Printer   */
        /* MUST support the IPP/1.1 "media-ready" (1setOf (type3 keyword | name(MAX))) Printer attribute    */
        /* also.  The i th value of the "media-ready" corresponds to the i th value of the                  */
        /* "media-col-ready" attribute, so that the client can correlate the media name or keywords with    */
        /* the collection values, i.e., determine the characteristics of each ready media instance.         */
        /*                                                                                                  */
        /* 3.13.14 media-col-supported (1setOf type2 keyword)                                               */
        /* The "media-col-supported" Printer attribute identifies the keyword names of the member           */
        /* attributes supported in the "media-col" collection Job Template attribute, i.e., the keyword     */
        /* names of the member attributes in Table 10 that the Printer supports.                            */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                              Internet Printing Protocol(IPP): Production Printing            */
            /*                                  Attributes - Set1                                           */
            /*      §5.1 [page 65-66] user-defined-values-supported (1setOf type2 keyword)                  */
            /* -----------------                                                                            */
            /* This Printer attribute identifies the Job Template and Job Template member attributes for    */
            /* which the client can supply any value in a Job Creation request, i.e., any custom or         */
            /* user-defined value.  The values of this attribute are any "xxx" attribute names that are Job */
            /* Template attributes or member attributes of a Job Template collection attributes for which   */
            /* the Printer will accept any value in a Job Creation request.  In effect, the presence of the */
            /* 'xxx' keyword value in this attribute suspends validation of the "xxx" attribute supplied by */
            /* the client with the values of the corresponding "xxx-supported" Printer attribute.  This     */
            /* feature MAY be used to specify any 'name', 'integer', or 'collection' (whose member          */
            /* attributes are 'name' or 'integer') attributes supplied by the client.  Thus a user can      */
            /* supply a custom name for this "xxx" attribute.  If there are no Job Template attributes that */
            /* will accept any value, the value of this attribute MUST be the keyword 'none'.               */
            /*                                                                                              */
            /* For any "xxx" Job Template or Job Template member attributes identified by this attribute,   */
            /* the Printer suspends validation for values of type 'name', 'integer', and 'collection' and   */
            /* the job is created containing the user-defined value, even when the client supplied the      */
            /* "ipp-attribute-fidelity" with a 'true' value (which would otherwise, have caused the         */
            /* Printer to reject the request, if the "xxx" value had not been among those of the Printer's  */
            /* "xxx-supported" attribute).                                                                  */
            /*                                                                                              */
            /* For example, the system administrator could add the 'media' keyword attribute name value to  */
            /* the "user-defined-values-supported" Printer attribute in order to allow the user to supply   */
            /* any media name value for the "media" attribute even if that name wasn't one of the media     */
            /* names in the Printer's "media-supported" (1setOf (type3 keyword | name(MAX))) attribute.  As */
            /* another example, the system administrator could add the 'media-size' keyword attribute name  */
            /* value to the "user-defined-values-supported" Printer attribute in order to allow the user to */
            /* supply any media size x and y dimensions in the "media-size" member attribute of the         */
            /* "media-col" Job Template attribute, even if that pair wasn't one of the pairs in the         */
            /* Printer's "media-size-supported" (1setOf collection) attribute.                              */
            /*                                                                                              */
            /* Keyword values include the IPP/1.1 Job Template attribute name keywords:                     */
            /*    'job-priority',                                                                           */
            /*    'job-sheets',                                                                             */
            /*    'job-hold-until',                                                                         */
            /*    'number-up',       and                                                                    */
            /*    'media',                                                                                  */
            /* along with the Job Template and member attributes defined in this document:                  */
            /* 'finishings-col',                                                                            */
            /* 'stitching-offset',                                                                          */
            /* 'stitching-locations',                                                                       */
            /* 'job-error-sheet-type',                                                                      */
            /* 'media-type',                                                                                */
            /* 'media-color',                                                                               */
            /* 'media-pre-punched',                                                                         */
            /* 'media-hole-count',                                                                          */
            /* 'media-order-count',                                                                         */
            /* 'media-size',                                                                                */
            /* 'media-weight-metric',                                                                       */
            /* 'media-front-coating',                                                                       */
            /* 'media-back-coating',                                                                        */
            /* 'media-recycled',      and                                                                   */
            /* 'separator-sheets-type'.                                                                     */
            /*                                                                                              */
            /* Note: The requirement that the "media-key" member attribute values of the "media-col"        */
            /* attribute be unique and that each supported media have a distinct value precludes the        */
            /* 'media-key' from being a value of the "user-defined-values-supported" Printer attribute.     */
            /*                                                                                              */
            /* When the client supplies a 'yyy' value for the "xxx" attribute that is not in the            */
            /* "xxx-supported" Printer attribute, the Printer does not return the "xxx" value in the        */
            /* Unsupported Attributes group in the response.  Instead, the Printer stores the requested     */
            /* attribute and value unmodified on the Job object for subsequent queries as with any          */
            /* supported value.  Subsequently, a user or operator can query the Job using the               */
            /* Get-Job-Attributes or Get-Jobs operations to see what user-defined value was requested.      */
            /* Depending on implementation and/or site policy, the Printer schedules the job following one  */
            /* of the following options:                                                                    */
            /*                                                                                              */
            /*    1. Add the 'resources-are-not-supported' value (see section 6.1) to the Job's             */
            /*       "job-state-reasons" attribute and move the job to the 'pending-held' state until       */
            /*       either the operator adds the requested value to the Printer's "xxx-supported"          */
            /*       attribute or the user or operator modifies the job to contain a value that is in the   */
            /*       Printer's "xxx-supported" attribute; then releases the job using the Release-Job       */
            /*       operation (see [RFC2911] section 3.3.6).                                               */
            /*                                                                                              */
            /*    2. Add the 'resources-are-not-supported' value (see section 6.1) to the Job's             */
            /*       "job-state-reasons" attribute but keep the job in the 'pending' state and start to     */
            /*       process the job as if the requested media were ready, but stop the job ("job-state" =  */
            /*       'processing-stopped') and the Printer ("printer-state" = 'stopped') and request        */
            /*       immediate operator intervention.  The operator loads the requested media and continues */
            /*       the Printer, using the Resume-Printer operation (see [RFC2911] section 3.2.8).         */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                              Internet Printing Protocol(IPP): Production Printing            */
            /*                                  Attributes - Set1                                           */
            /*      §6.3 [page 68-70] Additional values for the IPP "media" Job Template and "media-key"    */
            /*                        member attributeS                                                     */
            /* -----------------                                                                            */
            /* This section defines additional values for the "media" (type3 keyword | name(MAX)) Job       */
            /* Template attribute (see [RFC2911] section 4.2.11), the "media" member attribute defined in   */
            /* this document in a number of the collection attributes, and the "media-key" member attribute */
            /* defined in section 3.13.1.                                                                   */
            /*                                                                                              */
            /* If the Printer implementation supports the use of tray name keywords to identify media,      */
            /* there SHOULD be one and only one keyword assigned for each input tray on the printer.  If    */
            /* multiple keywords for the same tray exist in "media-supported", the client UI could          */
            /* potentially become very confusing to the user because the Printer would appear to have more  */
            /* input trays than it actually has.  However, see the discussion in the Printer MIB [RFC1759]  */
            /* about a manual input tray that uses the same input slot as a regular input tray.  Also, if   */
            /* using tray names, it is RECOMMENDED that the printer implementation use the most descriptive */
            /* keyword for a logical tray in order to assist the user or operator to recognize the matching */
            /* physical tray at the printer.  There are three methods to choose the keyword: 1) If the      */
            /* printer trays aren't physically labeled, the keyword SHOULD best match the physical location */
            /* of the tray (e.g. 'top', 'bottom').  2) If the printer trays are physically labeled, the     */
            /* keyword SHOULD best match the label of the tray (e.g. 'tray-1', tray-2'),   3) If more than  */
            /* one keyword matches the label of the tray, the keyword SHOULD be used that best              */
            /* distinguishes the tray from the Printer's other trays.                                       */
            /*                                                                                              */
            /* If a Printer allows the media to be specified by tray name keyword, the Printer              */
            /* implementation MUST NOT use the 'name(MAX)' attribute syntax to create custom tray names,    */
            /* but rather MUST use the most appropriate tray name keyword value.  This ensures              */
            /* interoperability among clients that submit jobs to multiple types of printers.               */
            /*                                                                                              */
            /* These are additional standard keyword values defined for input-trays.                        */
            /*                                                                                              */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'bypass-tray'  | The specified tray is used for handling odd or special paper.  This  | */
            /*    |                | paper tray usually has a small capacity and is physically located    | */
            /*    |                | such that the paper travels through a shorter paper path.  In some   | */
            /*    |                | printer implementations, the 'bypass-tray' may also be used to       | */
            /*    |                | bypass any marking device and be used for insert sheets.  See the    | */
            /*    |                | "insert-sheet" definition in section 3.5.                            | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'tray-N'       | The input tray that is best specified as a tray with values          | */
            /*    |                | 'tray-1', 'tray-2'....  The correspondence between the 'tray-N'      | */
            /*    |                | keyword and the actual input-tray is implementation dependent, as is | */
            /*    |                | the number of input trays.  If this group of 'tray-N' values is      | */
            /*    |                | supported, at least the 'tray-1' value MUST be supported.            | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*                                                                                              */
            /* These additional keyword values are provided for use in implementations that don't support   */
            /* the "media-col" attribute, since they represent some of the more important "media-col"       */
            /* member attributes:                                                                           */
            /*                                                                                              */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'plain'        | The plain media as specified by the output device.                   | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'pre-punched'  | The pre-punched media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'transparency' | The transparent media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'letterhead'   | The pre-printed letterhead media as specified by the output device.  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'heavyweight'  | The heavyweight media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'recycled'     | The recycled media as specified by the output device.                | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'bond'         | The bonded media as specified by the output device.                  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'labels'       | The labels media as specified by the output device.                  | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'pre-printed'  | The pre-printed media as specified by the output device.             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*    | 'customN'      | A custom type of media understood by the user and the operator.  It  | */
            /*    |                | is simply specified to the Printer as the keyword values 'custom1',  | */
            /*    |                | 'custom2',...,'custom7'.                                             | */
            /*    |----------------|----------------------------------------------------------------------| */
            /*                                                                                              */
            /* These additional keyword values are the same as the "media-type" keywords (see               */
            /* section 3.13.2), except 'other', for use in implementations that don't support the           */
            /* "media-col" attribute:                                                                       */
            /*                                                                                              */
            /*    stationery                                                                                */
            /*    envelope                                                                                  */
            /*    envelope-plain                                                                            */
            /*    envelope-window                                                                           */
            /*    continuous                                                                                */
            /*    continuous-long                                                                           */
            /*    continuous-short                                                                          */
            /*    tab-stock                                                                                 */
            /*    pre-cut-tab                                                                               */
            /*    full-cut-tab                                                                              */
            /*    multi-part-form                                                                           */
            /*    multi-layer                                                                               */
            /*    screen                                                                                    */
            /*    screen-paged                                                                              */
            /*    photographic                                                                              */
            /*    cardstock                                                                                 */
            /*                                                                                              */
            /* These are additional standard keyword values which are used by the implementation for        */
            /* specifying a pre-defined media size:                                                         */
            /*                                                                                              */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'iso-a4-wide'       | Specifies the iso A4 cover size: 223 mm x 297 mm                | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'na-letter-cover'   | Specifies the letter cover size:  9 in x 11 in                  | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'jp-reply-postcard' | Specifies the Ofuku-Hagaki postcard size: 148 mm x 200 mm       | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'na-postcard'       | Specifies the North American postcard size: 4.5 in x 6 in       | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'taiwan-815'        | Specifies the 815 Taiwan size: 267 mm x 388 mm                  | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*    | 'iso-220x330'       | Specifies the 220 mm x 330 mm size                              | */
            /*    |---------------------|-----------------------------------------------------------------| */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                              Internet Printing Protocol(IPP): Production Printing            */
            /*                                  Attributes - Set1                                           */
            /*      §2.4 [page 14-15] Coordinate System                                                     */
            /* -----------------                                                                            */
            /* Some of the attribute extensions defined in this document refer to specific edges of a sheet */
            /* of printed media.  Specifying that a staple be placed in the upper left corner of a printed  */
            /* document is an example.  To resolve ambiguity the following coordinate system is used        */
            /* throughout this document:                                                                    */
            /*                                                                                              */
            /*    The specified edge is always with respect to the document as if the document were a       */
            /*    portrait document.  If the document is actually a landscape or a reverse-landscape        */
            /*    document, the client (which may include a user) supplies the appropriate transformed      */
            /*    value.  For example, to position a staple in the upper left hand corner of a landscape    */
            /*    document when held for reading, the client supplies the 'staple-bottom-left' value (since */
            /*    landscape is defined as a +90 degree rotation from portrait, i.e., anti-clockwise).  On   */
            /*    the other hand, to position a staple in the upper left hand corner of a reverse-landscape */
            /*    document when held for reading, the client supplies the 'staple-top-right' value (since   */
            /*    reverse-landscape is defined as a –90 degree rotation from portrait, i.e., clockwise).    */
            /*                                                                                              */
            /*    The x-axis is defined to be along the bottom edge, with positive values extending in the  */
            /*    direction of the right edge.                                                              */
            /*                                                                                              */
            /*    The y-axis is defined to be along the left edge, with positive values extending toward    */
            /*    the top edge.                                                                             */
            /*                                                                                              */
            /*    The origin (0,0) is the bottom-left corner.                                               */
            /*                                                                                              */
            /* Some other attribute extensions defined in this document refer to edges of the               */
            /* Finished-Page-Image Cell and to axes relative to the Finished-Page-Image Cell. For example,  */
            /* there is an attribute that shifts a Finished-Page Image along the x-axis and another that    */
            /* shifts it to a left edge.                                                                    */
            /*                                                                                              */
            /* When imposition is not applied, the Finished-Page-Image Cell coincides to the surface of a   */
            /* medium. The rules cited in the above paragraphs of this section apply.                       */
            /*                                                                                              */
            /* When imposition is applied, the Finished-Page-Image Cell acts like the surface of a medium   */
            /* with regard to the co-ordinate system. That is, the edges and axes are as if the             */
            /* Finished-Page-Image Cell were in portrait orientation.  The x-axis is along the bottom of    */
            /* the Finished-Page-Image Cell, the y-axis is along the left edge of the Finished-Page-Image   */
            /* Cell, and the origin at the bottom-left corner of the Finished-Page-Image Cell.              */
            /*                                                                                              */
            /* ============================================================================================ */
typedef struct {
    pwgMediaCoatingEnum       backCoating;  /* The coating of the back of the media.                        */
    pwgMediaColorEnum         color;        /* Indicates the desired color of the media being specified.    */
    pwgMediaCoatingEnum       frontCoating; /* The coating of the front of the media.                       */
    pwgMediaGrainEnum         grain;        /* Indicates the grain of the media.                            */
    pwgBIT32                  holeCount;    /* Indicates number of pre-drilled holes in the desired media.  */
    pwgCHAR                   info[255];    /* Information that helps describe the media instance.          */
    pwgMediaKeyEnum           key;          /* Unique name for instance of MediaCol elements and values.    */
    pwgBIT32                  orderCount;   /* Repeat count of sheets in an ordered sequence                */
    pwgMediaPrePrintedEnum    prePrinted;   /* Indicates pre-printed characteristics of the desired media.  */
    pwgMediaRecycledEnum      recycled;     /* Indicates the recycled characteristics of the media.         */
    pwgMediaSize              size;         /* X-Dim and Y-Dim of media in 1/100 of a mm.                   */
    pwgMediaSizeNameEnum      sizeName;     /* Index of Media Size as a Self-Describing Name                */
    pwgMediaSourceEnum        source;       /* The input tray, slot, roll, or other source for the media.   */
    pwgBIT32                  thickness;    /* Thickness of media in units of one hundredth of a millimeter.*/
    pwgMediaToothEnum         tooth;        /* The tooth (or roughness) of the media.                       */
    pwgMediaTypeEnum          type;         /* The medium type used for impressions.                        */
    pwgBIT32                  weightMetric; /* Media Weight to the nearest grams/square meter.              */
    pwgMediaMargins           margin;       /* Physical margin for media in hundredths of millimeters.      */

    VND_MEDIA_COL_STRUCT

} pwgMediaCollecton;


typedef struct {
    pwgNUM_RNG_DEF*     mediaBackCoating;         /* Coating of the back of the media.                      */
    pwgNUM_RNG_DEF*     mediaColor;               /* Color of the media being specified.                    */
    pwgNUM_RNG_DEF*     mediaFrontCoating;        /* Coating of the front of the media.                     */
    pwgNUM_RNG_DEF*     mediaGrain;               /* Indicates the grain of the media.                      */
    pwgNUM_DEF*         mediaHoleCount;           /* Number of pre-drilled holes                            */
    pwgINFO_DEF*        mediaInfo;                /* Information to helps describe  media                   */
    pwgNUM_RNG_DEF*     mediaKey;                 /* Unique name of MediaCol                                */
    pwgNUM_DEF*         orderCount;               /* Repeat count of sheets                                 */
    pwgNUM_RNG_DEF*     mediaPrePrinted;          /* Indicates pre-printed                                  */
    pwgNUM_RNG_DEF*     mediaRecycled;            /* Indicates the recycled                                 */
    pwgSTRUCT_DEF*      mediaSize;                /* X-Dim, Y-Dim in 1/100 of a mm.                         */
    pwgNUM_RNG_DEF*     mediaSizeName;            /* Index Media Size Self-Describing Name                  */
    pwgNUM_RNG_DEF*     mediaSource;              /* The input source for the media.                        */
    pwgNUM_DEF*         mediaThickness;           /* Thickness in units of /100 mm                          */
    pwgNUM_RNG_DEF*     mediaTooth;               /* Tooth (or roughness) of the media                      */
    pwgNUM_RNG_DEF*     mediaType;                /* The medium type                                        */
    pwgNUM_DEF*         mediaWeightMetric;        /* Media Weight nearest grams/m^2                         */
    pwgSTRUCT_DEF*      mediaMargins;             /* Physical margin 1/100 mm                               */

               VND_MEDIA_COL_DEF_STRUCT

    pwgVOID*            last;
} pwgMediaColDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern  pwgCHAR*  pwgMediaCoating_Keywords[];
extern  pwgCHAR*  pwgMediaCoating_KWVAlues[];
extern  pwgBIT8   pwgMediaCoating_KWVLevel[];
extern  pwgBOOL   pwgMediaCoating_KWVSupported[];

extern  pwgNUM_RNG_DEF pwgDef_MediaCoating;

extern  pwgCHAR*  pwgMediaColor_Keywords[];
extern  pwgCHAR*  pwgMediaColor_KWVAlues[];
extern  pwgBIT8   pwgMediaColor_KWVLevel[];
extern  pwgBOOL   pwgMediaColor_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaColorType;

extern  pwgCHAR*  pwgMediaGrain_Keywords[];
extern  pwgCHAR*  pwgMediaGrain_KWVAlues[];
extern  pwgBIT8   pwgMediaGrain_KWVLevel[];
extern  pwgBOOL   pwgMediaGrain_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaGrain;

extern  pwgCHAR*  pwgMediaKey_Keywords[];
extern  pwgCHAR*  pwgMediaKey_KWVAlues[];
extern  pwgBIT8   pwgMediaKey_KWVLevel[];
extern  pwgBOOL   pwgMediaKey_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaKey;

extern  pwgCHAR*  pwgMediaPrePrinted_Keywords[];
extern  pwgCHAR*  pwgMediaPrePrinted_KWVAlues[];
extern  pwgBIT8   pwgMediaPrePrinted_KWVLevel[];
extern  pwgBOOL   pwgMediaPrePrinted_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaPrePrinted;

extern  pwgCHAR*  pwgMediaRecycled_Keywords[];
extern  pwgCHAR*  pwgMediaRecycled_KWVAlues[];
extern  pwgBIT8   pwgMediaRecycled_KWVLevel[];
extern  pwgBOOL   pwgMediaRecycled_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaRecycled;

extern  pwgCHAR*  pwgMediaDescType_Keywords[];
extern  pwgCHAR*  pwgMediaDescType_KWVAlues[];
extern  pwgBIT8   pwgMediaDescType_KWVLevel[];
extern  pwgBOOL   pwgMediaDescType_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaDescType;

extern  pwgMediaSizeDefLst pwgMediaSizeDefElem;
extern  pwgSTRUCT_DEF      pwgDef_MediaSize;

extern  pwgCHAR*  pwgMediaSizeName_Keywords[];
extern  pwgCHAR*  pwgMediaSizeName_KWVAlues[];
extern  pwgBIT8   pwgMediaSizeName_KWVLevel[];
extern  pwgBOOL   pwgMediaSizeName_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaSizeName;

extern  pwgCHAR*  pwgMediaSource_Keywords[];
extern  pwgCHAR*  pwgMediaSource_KWVAlues[];
extern  pwgBIT8   pwgMediaSource_KWVLevel[];
extern  pwgBOOL   pwgMediaSource_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaSource;

extern  pwgCHAR*  pwgMediaInputTrayCheck_Keywords[];
extern  pwgCHAR*  pwgMediaInputTrayCheck_KWVAlues[];
extern  pwgBIT8   pwgMediaInputTrayCheck_KWVLevel[];
extern  pwgBOOL   pwgMediaInputTrayCheck_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaInputTrayCheck;

extern  pwgCHAR*  pwgMediaTooth_Keywords[];
extern  pwgCHAR*  pwgMediaTooth_KWVAlues[];
extern  pwgBIT8   pwgMediaTooth_KWVLevel[];
extern  pwgBOOL   pwgMediaTooth_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaTooth;

extern  pwgCHAR*  pwgMediaType_Keywords[];
extern  pwgCHAR*  pwgMediaType_KWVAlues[];
extern  pwgBIT8   pwgMediaType_KWVLevel[];
extern  pwgBOOL   pwgMediaType_KWVSupported[];
extern  pwgNUM_RNG_DEF pwgDef_MediaType;

extern  pwgINFO_DEF pwgDef_MediaInfo;
extern  pwgNUM_DEF  pwgDef_MediaHoleCount;
extern  pwgNUM_DEF  pwgDef_MediaOrderCount;
extern  pwgNUM_DEF  pwgDef_MediaThickness;
extern  pwgNUM_DEF  pwgDef_MediaWeightMetric;

extern  pwgMediaMarginsDefLst pwgMediaMarginsDefElem;
extern  pwgSTRUCT_DEF         pwgDef_MediaMargins;

extern  pwgMediaColDefLst pwgMediaColDefElem;
extern  pwgSTRUCT_DEF     pwgDef_MediaCollection;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_XXX_N_MEDIA_H__                                                                        */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ====================================== pwg.pjt.xxx.N.media.h =========================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
